<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class AboutInfoController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

     public function about_info(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',                     
        ],[ 
            'user_id.required'   => 'Id is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
             $functions = new Functions();
                                         
                   /* $res=DB::table('users')
                        ->leftJoin('categories','users.cat_id','=','categories.cat_id')
                        ->select(DB::raw('user_id,username,first_name,last_name,categories.category as cat_name,categories.cat_id as cat_id,email,state,city,country,language,dob,mobile1,address1,active,views,profile_pic,education,active,bio,zipcode,user_type'))
                        ->where('users.user_id',$request->user_id)
                        ->first();*/
                 $follower_res=DB::table('followers')
		                ->where('user_id',$request->user_id)
		                ->count();
		            
		            $following_res=DB::table('followers')
		                ->where('following_id',$request->user_id)
		                ->count();
		            
		           $likes_res=DB::table('post_likes as l')
		            	->leftJoin('posts as p','p.post_id','=','l.post_id')
		                ->where('p.user_id',$request->user_id)
		                ->count();
		                
		            $views_res=DB::table('post_views as v')
		            	->leftJoin('posts as p','p.post_id','=','v.post_id')
		                ->where('p.user_id',$request->user_id)
		                ->count(); 
                                         
                $res = \DB::table("users")
				        ->select(DB::raw('user_id,username,round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) as age,email,education,zipcode,active,mobile1,show_age,app_token,gender,city,state,country,address1,can_move_abroad,user_type,first_name,last_name,bio,language, profile_pic,GROUP_CONCAT(categories.category) as cat_name,GROUP_CONCAT(categories.cat_id) as cat_id'))
				        ->leftjoin("categories",\DB::raw("FIND_IN_SET(categories.cat_id,users.cat_id)"),">",\DB::raw("'0'"))
				        ->where("users.user_id",$request->user_id)
				        ->groupBy("users.user_id")
				        ->first();
    
                   // $data=array();
                
                        if($res->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$res->user_id."/".$res->profile_pic);
						}
						if($res->gender=='M'){
							$gender='Male';
						}else{
							$gender='Female';
						}
						if($res->user_type!='V'){
							if($res->can_move_abroad==1){
								$move='Yes';
							}else{
								$move='No';
							}
						}else{
							$move='';
						}
						
						if($res->user_type=='C'){
							$type='Candidate';
						}else if($res->user_type=='P'){
							$type='Film Maker';
						}else{
							$type='User';
						}
						if($res->show_age==1){
							$age=$res->age;
						}else{
							$age='';
						}
                        $data = array('user_id'=>$res->user_id,'first_name'=>$res->first_name,'last_name'=>$res->last_name,'username'=>$res->username,'bio'=>$res->bio,'cat_name'=>$res->cat_name,'cat_id'=>$res->cat_id,'email'=>$res->email,'active'=>$res->active,'profile_pic' => $p,'state'=>$res->state,'city'=>$res->city,'country'=>$res->country,'mobile1'=>$res->mobile1 ,'address1'=>$res->address1,'gender'=>$gender,'age'=>$age,'education'=>$res->education,'bio'=>$res->bio,'language'=>$res->language,'zipcode'=>$res->zipcode,"user_type"=>$type,"can_move_abroad"=>$move,'followers'=>$follower_res,'followings'=>$following_res,'likes'=>$likes_res,'views'=>$views_res);
                       // array_push($data,$s);
                 
              
                    $response = array("status" => "success",'msg'=>'Candidate Profile View' ,'content' => $data);
                
                return response()->json($response); 
            }  
            
        }

}   