<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class AccountDeleteController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

        public function delete_account(Request $request){
    
        $validator = Validator::make($request->all(), [ 
            // 'user_id'          => 'required',              
            // 'app_token'        => 'required',    
            'password'          => 'required',              
            
            
        ],[ 
            // 'user_id.required'   => 'Id is required',
            // 'app_token.required'   => 'App Token is required',
            'password.required'		  	=> 'Password is required',         

        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
           $functions = new Functions();
            // $token_res= $functions->validate_token($request->user_id,$request->app_token);
             if(auth()->guard('api')->user()){
                $login_id=auth()->guard('api')->user()->user_id;
              
                // if($token_res>0){
                $res=DB::table('users')
                		->select(DB::raw("email,password"))
                        ->where('user_id',$login_id)
                        ->first();
               
               if(Hash::check($request->password,$res->password)){
    		   	$c_date=date('Y-m-d h:i:s');
            //         DB::table('users')
    		      //      	->where('user_id',$login_id)     
    		      //      	->update(['deleted' => '1','deleted_on' => $c_date]);
    		            	
    		      //  DB::table('posts')
    		      //  ->where('user_id',$login_id)
    		      //  ->update(['active' => '0']);
    		        
    		        $comments=DB::table('post_comments')->select(DB::raw('post_id, group_concat(comment_id) as comment_ids'))->where('user_id',$login_id)->groupBy('post_id')->get();
    		      
    		        foreach($comments as $comm){
    		            $post_id=$comm->post_id;
    		            $comment_arr=explode(',',$comm->comment_ids);
    		            $com_count=count($comment_arr);
    		            
    		            $post = DB::table('posts')->where('post_id',$post_id)->first();
                        if($post){
                            if($post->comments>0){
                                $comTotal=$post->comments - $com_count;
                                $comTotal=($comTotal<0) ? 0 : $comTotal;
                                DB::table('posts')->where('post_id',$post_id)->update(['comments'=>$comTotal]);
                            }
                        }
                        DB::table('post_comments')->where('post_id',$post_id)->whereIn('comment_id',$comment_arr)->delete();
    		        }
    		            		        
    		        $likes=DB::table('post_likes')->select(DB::raw('post_id, group_concat(like_id) as like_ids'))->where('user_id',$login_id)->groupBy('post_id')->get();
    		        foreach($likes as $lk){
    		            $post_id=$lk->post_id;
    		            $like_arr=explode(',',$lk->like_ids);
    		            $lk_count=count($like_arr);
    		            
    		            $post = DB::table('posts')->where('post_id',$post_id)->first();
                        if($post){
                            if($post->likes>0){
                                $likeTotal=$post->likes - $lk_count;
                                $likeTotal=($likeTotal<0) ? 0 : $likeTotal;
                                DB::table('posts')->where('post_id',$post_id)->update(['likes'=>$likeTotal]);
                            }
    		            }
                        DB::table('post_likes')->where('post_id',$post_id)->whereIn('like_id',$like_arr)->delete();
    		        }
    		        
                    DB::table('users')
                         	->where('user_id',$login_id)->delete(); 
		        $response = array("status" => true,'msg'=>'Account deleted Successfully');
    		   }else{
    		   	$response = array("status" => false,'msg'=>'Invalid Password');
    		   }  
                
            }  else{
                $response = array("status" => false,'msg'=>'Unauthorized access');
            }   
            return response()->json($response); 
        }
    }

    public function recover_account(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',   
            
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
        
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token);
            if($token_res>0){
    		   	$c_date=date('Y-m-d h:i:s');
                    DB::table('users')
    		            	->where('user_id',$request->user_id)     
    		            	->update(['deleted' => '0','deleted_on' => $c_date]);
    		        $response = array("status" => "success",'msg'=>'Account activated Successfully');
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   
            return response()->json($response); 
        }
    }

}   