<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class AgeFilterController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function age_filter(Request $request){
        
            $functions = new Functions();
            	$user_id=$request->user_id;
	                     
                   if($request->gender==""){
                        $gender="";
                    }else{
                        $gender=$request->gender;
                    }
                    if($request->location==""){
                        $location="";
                    }else{
                        $location=$request->location;
                    }
                    if($request->language==""){
                        $language="";
                    }else{
                        $language=$request->language;
                    }
                    if($request->category==""){
                        $category="";
                    }else{
                        $category=$request->category;
                    }
                    
                       
                            $label=array();
                            $v=array();
                    
                            $age_res=$this->get_age_res(00,05,$gender,$location,$language,$category,$user_id);
                            if($age_res->user_count>0){
                                $v['label']='00-05';
                                $v['value']='00-05';
                                $v['count']=$age_res->user_count;
                                if(strpos(",".$request->age.",", ",00-05,")!==false){
									$v['checked']="true";
								}else{
									$v['checked']="false";
								}
                                
                                array_push($label,$v);
                            }
                          
                            $age_res2=$this->get_age_res(06,10,$gender,$location,$language,$category,$user_id);
                            if($age_res2->user_count>0){
                                 $v['label']='06-10';
                                 $v['value']='06-10';
                                $v['count']=$age_res2->user_count;
                                if(strpos(",".$request->age.",", ",06-10,")!==false){
									$v['checked']="true";
								}else{
									$v['checked']="false";
								}
                                array_push($label,$v);
                            }
                           
                            $age_res3=$this->get_age_res(11,20,$gender,$location,$language,$category,$user_id);
                            if($age_res3->user_count>0){
                                $v['label']='11-20';
                                $v['value']='11-20';
                                $v['count']=$age_res3->user_count;
                                if(strpos(",".$request->age.",", ",11-20,")!==false){
									$v['checked']="true";
								}else{
									$v['checked']="false";
								}
                                array_push($label,$v);
                            }
                         
                            $age_res4=$this->get_age_res(21,30,$gender,$location,$language,$category,$user_id);
                            if($age_res4->user_count>0){
                                $v['label']='21-30';
                                $v['value']='21-30';
                                $v['count']=$age_res4->user_count;
                                if(strpos(",".$request->age.",", ",21-30,")!==false){
									$v['checked']="true";
								}else{
									$v['checked']="false";
								}
                                array_push($label,$v);
                            }
                            $age_res5=$this->get_age_res(31,50,$gender,$location,$language,$category,$user_id);
                            if($age_res5->user_count>0){
                                $v['label']='31-50';
                                $v['value']='31-50';
                                $v['count']=$age_res5->user_count;
                                if(strpos(",".$request->age.",", ",31-50,")!==false){
									$v['checked']="true";
								}else{
									$v['checked']="false";
								}
                                array_push($label,$v);
                            }
                            $age_res6=$this->get_age_res(51,70,$gender,$location,$language,$category,$user_id);
                            if($age_res6->user_count>0){
                                $v['label']='51-70';
                                $v['value']='51-70';
                                $v['count']=$age_res6->user_count;
                                if(strpos(",".$request->age.",", ",51-70,")!==false){
									$v['checked']="true";
								}else{
									$v['checked']="false";
								}
                                array_push($label,$v);
                            }
                            $age_res7=$this->get_age_res(71,100,$gender,$location,$language,$category,$user_id);
                            if($age_res7->user_count>0){
                                $v['label']='71-100';
                                $v['value']='71-100';
                                $v['count']=$age_res7->user_count;
                                if(strpos(",".$request->age.",", ",71-100,")!==false){
									$v['checked']="true";
								}else{
									$v['checked']="false";
								}
                                 
                                array_push($label,$v);
                            }
                          
             
                    $response = array("status" => "success",'msg'=>'Age filtered successfully' ,'content' => $label);
                
             
            return response()->json($response); 
        
    }

    public function get_age_res($min,$max,$gender,$location,$language,$category,$user_id){
        $user = DB::table("users")
			        ->select(DB::raw("count(user_id) as user_count"))
			        ->where('active','1')
			        ->where('deleted','0')
			        ->where('user_id','!=',$user_id);
       
        $blocked_user_res=DB::table('blocked_users')
	                     ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
	                     ->where('blocked_by',$user_id)
	                     ->first(); 
	    $blocked_user_res2=DB::table('blocked_users')
	                     ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
	                     ->where('user_id',$user_id)
	                     ->first();
       $where_gender="";
                    if(isset($gender) && $gender!=""){
                        $gender=substr($gender,1);
                        $where_gender= $where_gender." or gender='".$gender."'";
                        $where_gender=$user->whereRaw(substr($where_gender,3));
                        $user=$where_gender;
                    }
        $where_loc="";
                    if(isset($location) && $location!=""){
                        $location=substr($location,1);
                        $loc_arr=explode(",",$location);
                        foreach ($loc_arr as $val){
                        $where_loc=$where_loc.' or (country ="'.$val.'")';
                        }
                       
                        $where_loc=$user->whereRaw("(".substr($where_loc,3).")");
                        $user=$where_loc;
                    }
        $where_lan="";
                    if(isset($language) && $language!=""){
                        $language=substr($language,1);
                        $lan_arr=explode(",",$language);
                        foreach ($lan_arr as $val){
                        $where_lan=$where_lan.' or (language like "%'.$val.'%")';
                        }
                        $where_lan=$user->whereRaw("(".substr($where_lan,3).")");
                        $user=$where_lan;
                    }
          $where_cat="";
                    /*if(isset($category) && $category!=""){
                        $category=substr($category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
                        }
                        $where_cat=$user->whereRaw("(".substr($where_cat,3).")");
                        $user=$where_cat;
                       
                    }*/
                     if(isset($category) && $category!=""){
                        $category=substr($category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        	$where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
                        }
                        $where_cat=$user->whereRaw("(".substr($where_cat,3).")");
                        $user=$where_cat;   
                    }
        if($blocked_user_res->user_id==0){
		   
		   }else{
			   $blocked_res=$blocked_user_res->user_id;
			   $blocked_res=explode(',',$blocked_res);
			   $user=$user->whereNotIn('user_id', $blocked_res);
		   
		   }
		if($blocked_user_res2->user_id==0){
		   
		   }else{
		   	$blocked_res2=$blocked_user_res2->user_id;
		   $blocked_res2=explode(',',$blocked_res2);
		   $user=$user->whereNotIn('user_id', $blocked_res2);
		   
		   }
        $user = $user->whereRaw('round(DATEDIFF(CURRENT_DATE(),dob) / 365) between '. $min .' and '. $max)
       				 ->first();
        return $user;
    }

}   