<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class BlockUserController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function block(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            
                    
        ],[ 
            'user_id.required'   => 'User Id  is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
            if (auth()->guard('api')->user()) {
                $login_id = auth()->guard('api')->user()->user_id;
        	    $res=DB::table('blocked_users')
                    ->select(DB::raw('block_id'))
                    ->where('user_id',$request->user_id)
                    ->where('blocked_by',$login_id)
                    ->get();
                    if($res->isEmpty()){
                        $data =array(
                            'user_id' => $request->user_id,
                            'report' => $request->report==null ? 0 : $request->report,
                            'blocked_by' => $login_id,
                        ); 
                        DB::table('blocked_users')->insert($data);
                        $response = array( "status" => "success", "msg" => "blocked","block"=>'1');
                        //followers
                        DB::table('followers')->where('user_id', $request->user_id)->where('following_id', $login_id)->delete();
                        DB::table('followers')->where('user_id', $login_id)->where('following_id', $request->user_id)->delete();
                        //exit();
                     }else{
        			 	DB::table('blocked_users')->where('user_id', $request->user_id)->where('blocked_by', $login_id)->delete();
        			 	$response = array( "status" => "success", "msg" => "unblocked","block"=>'0');
        			 }
                return response()->json($response); 
            }else{
                return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
            }
        }
    }
    
    public function blocked_list(Request $request){
        $validator = Validator::make($request->all(), [          
            'user_id'         => 'required',           
           
        ],[         
        	'user_id.required'	  	=> 'User Id is required',
        ]);

    	if (!auth()->guard('api')->user()) {
            return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
        }else{
            $login_id=auth()->guard('api')->user()->user_id;
            
    //  dd($login_id);
                $res=DB::table('users as u')
                    //->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                    ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
                    ->join('blocked_users as b', function ($join)use ($request,$login_id){
			                        $join->on('b.user_id','=','u.user_id')
			                            ->where('b.blocked_by',$login_id);
			                            
			                        })
                    ->select(DB::raw('u.user_id as user_id,u.username as username,GROUP_CONCAT(c.category) as cat,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic'))
                    ->where('u.active','1');
                    
                    if(!isset($request->page) && $request->page==""){
                        $page=1;
                    }else{
                        $page=$request->page;
                    }
                    $limit=10;
                    $offset=($page-1)*$limit;
                $where_key="";
                if(isset($request->keyword) && $request->keyword!=""){
                    $key_arr=explode(",",$request->keyword);
                    foreach ($key_arr as $val){
                    $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                    }
                    $where_key=$res->whereRaw("(".substr($where_key,3).")");
                    $res=$where_key;
                }
                 $res=$res->groupBy('u.user_id','u.username','u.dob','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic')->orderBy('user_id','desc')
                		 ->paginate($limit);
	            $total_records=$res->total();
                    
                
                $data=array();
                if (!$res->isEmpty()){
                    foreach($res as $r){
                        if($r->profile_pic==""){
							if($r->gender=="M"){
                     	        $p=secure_asset('assets/images/avatar-man.png');    
                     	    }else if($r->gender=="F"){
                     	        $p=secure_asset('assets/images/avatar-woman.png');    
                     	    }else{
                     	        $p=secure_asset('assets/images/profile.png');
                     		}
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
						}
						if($r->gender=='F'){
							$gender='Female';
						}else{
							$gender='Male';
						}
                        $s = array('id'=>$r->user_id,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>$r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p);
                        array_push($data,$s);
                    }
                }else{
                    $response = array("status" => true,'data' => [],'total_records'=> 0);
                }
                
                    $response = array("status" => true,'data' => $data,'total_records'=> $total_records);
               
           /* }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   */ 
            return response()->json($response); 
        }
    }

        
}   