<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateAudiosController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }

    public function audios(Request $request){
       
        $validator = Validator::make($request->all(), [ 
            'audio'          => 'required|mimes:mpga',              
        ],[ 
            'audio.required'   => 'Audio is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $res= $functions->validate_token($request->user_id,$request->app_token,'C');
            if($request->title==""){
                $title="";
            }else{
                $title=$request->title;
            }
            if($res>0){

                $path = $functions->_getUserFolderName($request->user_id, "audios");
                $filenametostore = $request->file('audio')->store($path);  
                                
                Storage::setVisibility($filenametostore, 'public');
                $fileArray = explode('/',$filenametostore);  
                $fileName = array_pop($fileArray); 
               
                $file_path = Storage::url("audios/".$request->user_id."/".$fileName);

                $data =array(
                    'user_id'   => $request->user_id,
                    'audio'     => $fileName,
                    'title'     => $title,
                                                       
                ); 
                DB::table('user_audios')->insert($data);
       
                $data  = array( 'user_id' => $request->user_id, 'audio' => $file_path, 'title' => $title);
                $response = array("status" => "success",'msg'=>'Audio Uploaded successfully');
            }else{
                $response = array( "status" => "error", "msg" => "Invalid Token" );
            }
            
            return response()->json($response); 
        
        }
    }

    public function audio_delete(Request $request){
        $functions = new Functions();
        $res = $functions->validate_token($request->user_id,$request->app_token,'C');
        if($res>0){
            $user_id   = $request->user_id;
            $audio_id  = $request->audio_id;
            DB::table('user_audios')->where('audio_id', $audio_id)->where('user_id', $user_id)->delete();
            
            $response = array("status" => "success",'msg'=>'Audio Deleted successfully');
        }else{
            $response = array( "status" => "error", "msg" => "Invalid Token");
        }
        return response()->json($response);
    }


}   