<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use App\Mail\Admin\SendMail;
use App\User;
use PHPOpenSourceSaver\JWTAuth\Facades\JWTAuth;


use Auth;
use Mail;
use Illuminate\Support\Facades\URL;

class CandidateAuthController extends Controller
{   
    
    // public function __construct()
    // {
    //     $this->middleware('auth:api', ['except' => ['socialLogin']]);
    // }
    
	private function _error_string($errArray)
	{
		$error_string = '';
		foreach ($errArray as $key) {
			$error_string .= $key . "\n";
		}
		return $error_string;
	}

	// public function login(Request $request)
	// {

	// 	$validator = Validator::make($request->all(), [
	// 		'email'          => 'required|email',
	// 		'password'       => 'required'
	// 	], [
	// 		'email.required'	  	=> 'Email is required',
	// 		'email.email'		  	=> 'Email id is not valid',
	// 		'password.required'	    => 'Password is required',

	// 	]);

	// 	if (!$validator->passes()) {
	// 		return response()->json(['status' => 'error', 'msg' => $this->_error_string($validator->errors()->all())]);
	// 	} else {

	// 		if (Auth::attempt(['email' => $request->email, 'password' => $request->password])) {
	// 			/*$user_details = DB::table('users')
    //         		->leftJoin('categories','categories.cat_id','=','users.cat_id')
    //         		->select(DB::raw("user_id,first_name,last_name,username,email,app_token,profile_pic,views,categories.category as category,user_type as type,active,deleted"))
    //                 ->where('user_id',Auth::user()->user_id)
    //                 //->where('deleted','0')
    //                 ->first();*/
	// 			$user_details = \DB::table("users")
	// 				->select("users.*", \DB::raw("GROUP_CONCAT(categories.category) as cat_name"))
	// 				->leftjoin("categories", \DB::raw("FIND_IN_SET(categories.cat_id,users.cat_id)"), ">", \DB::raw("'0'"))
	// 				->where("users.user_id", Auth::user()->user_id)
	// 				->groupBy("users.user_id")
	// 				->first();

	// 			if ($user_details != "") {

	// 				if ($user_details->app_token == '') {
	// 					$functions = new Functions();
	// 					$user_token = Hash::make($functions->_password_generate(20));
	// 					DB::table('users')
	// 						->where('user_id', Auth::user()->user_id)
	// 						->update(['app_token' => $user_token]);

	// 					$app_token = $user_token;
	// 				} else {
	// 					$app_token = $user_details->app_token;
	// 				}

	// 				if ($user_details->profile_pic == "") {
	// 					$profile = '../../assets/imgs/profile.png';
	// 				} else {
	// 					$profile = Storage::url("profile_pic/" . Auth::user()->user_id . "/" . $user_details->profile_pic);
	// 				}

	// 				$first_name = $user_details->first_name;
	// 				$last_name = $user_details->last_name;

	// 				$data  = array('user_id' => $user_details->user_id, 'app_token' => $app_token, 'first_name' => $first_name, 'last_name' => $last_name, 'username' => $first_name . ' ' . $last_name, 'email' => $request->email, 'profile_pic' => $profile, 'category' => $user_details->cat_name, 'views' => $user_details->views, 'type' => $user_details->user_type, 'active' => $user_details->active, 'deleted' => $user_details->deleted, 'time_zone' => $user_details->time_zone);

	// 				$response = array("status" => "success", "msg" => "User logged in successfully", 'content' => $data);
	// 			} else {
	// 				$response = array("status" => "error", "msg" => "Candidate is not active");
	// 			}
	// 		} else {
	// 			$response = array("status" => "error", "msg" => "Invalid login details");
	// 		}
	// 		return response()->json($response);
	// 	}
	// }
    
    public function updateFcmToken(Request $request) {
        if (auth()->guard('api')->user()) {
             $validator = Validator::make($request->all(), [
                'fcm_token'          => 'required',
            ], [
                'fcm_token.required'    => 'FCM Token is required',
            ]);

            if (!$validator->passes()) {
                return response()->json(['status' => 'error', 'msg' => $this->_error_string($validator->errors()->all())]);
            } else {
                $user_id = auth()->guard('api')->user()->user_id;
                $fcm_token = $request->fcm_token;
                DB::table('users')->where('user_id', $user_id)
                    ->update([
                        'fcm_token' => $fcm_token
                    ]);
                return response()->json(['status' => 'success', 'msg' => 'FCM Token updated!']);
            }
        }
    }
    
	public function login(Request $request)
    {
        $validator = Validator::make(
            $request->all(),
            [
                'email'          => 'required|email',
                'password'       => 'required',
            ],
            [
                'email.required'   => 'Email is required',
                'email.email'      => 'Email id is not valid',
            ]
        );

        if (!$validator->passes()) {
            return response()->json(['status' => 'error', 'msg' => $this->_error_string($validator->errors()->all())]);
        } else {
            $functions = new Functions();

            $credentials = request(['email', 'password']);

            if (!$token = auth('api')->attempt($credentials)) {
                return response()->json(['status' => false, 'msg' => 'Invalid Username or Password'], 200);
            }
            
            $data = auth('api')->user();
            
            // if($data->deleted==1){
            //     return response()->json(['status' => false, 'msg' => 'Account does not exist'], 200);
            // }
            $data->fcm_token = $request->fcm_token;
            $data->new_app_user = 1;
            $data->save();
            $uniques_user_id_res = DB::table("unique_users_ids")->select("unique_id","user_id","unique_token")->where('unique_token',$request->unique_id)->first();
            if($uniques_user_id_res){
                DB::table('unique_users_ids')
                ->where('unique_token',$request->unique_id)
                ->update(['user_id'=>$data->user_id]);
                DB::table('post_views')
                ->where('unique_id',$uniques_user_id_res->unique_id)
                ->where('user_id',0)
                ->update(['user_id'=>$data->user_id]);
            }else{
                DB::table('unique_users_ids')->insert(['unique_token'=>$request->unique_id,'user_id'=>$data->user_id]);   
            }
            
            
            
            
            // $existingRecord = DB::table('users')
            // ->select(DB::raw("user_id,password,username,fname,lname,email,user_dp"))
            // ->whereRaw(DB::raw("email = '".$request->email."'"))
            // ->first();
            // if($existingRecord) {
            // $checkIfActive = DB::table('users')
            // ->select(DB::raw("user_id,app_token,active"))
            // ->whereRaw(DB::raw("email = '".$request->email."' and email_verified= 1 "))
            // ->first();
            // if ($data->email_verified == 1) {
            //     if ($data->active == 1) {
                    // if(Hash::check($request->password, $existingRecord->password)) {
                    // $user_token = Hash::make($functions->_password_generate(20));
                    // $now  = date("Y-m-d H:i:s");
                    // $data2 = array(
                    //     // 'app_token'         => $token,
                    //     'time_zone'         => $request->time_zone,
                    //     'updated_at'        => $now
                    // );
                    // DB::table('users')
                    //     ->where('user_id', $data->user_id)
                    //     ->update($data2);
                    //     if(stripos($data->user_dp,'https://')!==false){
                    //     $file_path=$data->user_dp;
                    //     $small_file_path=$data->user_dp;
                    // }else{
                    //     $file_path = asset(Storage::url('public/profile_pic/'.$data->user_id."/".$data->user_dp));
                    //         $small_file_path = asset(Storage::url('public/profile_pic/'.$data->user_id."/small/".$data->user_dp));
                    //         if($file_path==""){
                    //             $file_path=asset('default/default.png');
                    //         }
                    //         if($small_file_path==""){
                    //             $small_file_path=asset('default/default.png');
                    //         }
                    // }
                    $new = $request->new==null ? "false" : "true";
                    return $this->respondWithToken($token,$new);

                    // $data  = array( 'user_id' => $data->user_id, 'app_token' => $token,'username' =>$data->username,'email'=>$data->email,'fname'=>$data->fname,'lname'=>$data->lname,'user_dp'=>$file_path );
                    // }else{
                    //     $msg = "Invalid password.";
                    //     $response = array("status" => "error",'msg'=>$msg );      
                    //     return response()->json($response); 
                    // }
            //     } else {
            //         $msg = "this account is deactivated";
            //         $response = array("status" => "error", 'msg' => $msg);
            //         return response()->json($response);
            //     }
            // } else {
            //     $data = DB::table('users')
            //         ->select(DB::raw("user_id,app_token"))->where('email', $request->email)->first();
            //     $msg = "You have not verified your registered email for the account.";
            //     $response = array("status" => "email_not_verified", 'msg' => $msg, 'content' => $data);
            //     return response()->json($response);
            // }
            // }else{
            //     $msg = "Your Account does not exist";
            //     $response = array("status" => "error",'msg'=>$msg );      
            //     return response()->json($response); 
            // }

            $msg = "User logged in successfully";
            $response = array("status" => true, 'msg' => $msg, 'content' => $data);
            return response()->json($response);
        }
    }

	public function me()
    {
        return response()->json(auth('api')->user());
    }

    public function refresh(Request $request)
    {   
        $new = $request->new == null ? "false" : "true";
        try{
            return $this->respondWithToken(auth('api')->refresh(),$new);
        }catch (TokenInvalidException $e) {
            return response()->json([
                'status' => false
            ]);
        }
    }
    public function register(Request $request){
    	//exit;
         $validator = Validator::make($request->all(), [ 
            'first_name'      => 'required',           
            // 'last_name'       => 'required',
            'email'           => 'required|email|unique:users',
            'password'        => 'required',
            // 'mobile1'         => 'required',
            //'address1'        => 'required',
            //'category'        => 'required',
            'country'         => 'required',
            'state'           => 'required',
            'city'            => 'required',
            //'zipcode'         => 'required',
            'gender'         => 'required',           
            'language'       => 'required',
            //'time_zone'      => 'required',
            // 'dob'            => 'required',
            
                                     
        ],[ 
            'first_name.required'   => 'First Name is required',
            // 'last_name.required'    => 'Last Name is required', 
            'email.required'        => 'Email is required',
            'email.email'		  	=> 'Email id is not valid',
            'password.required'     => 'Password is required',
            'mobile1'               => 'Phone is required',
            //'address1.required'     => 'Address is required',
            //'category.required'     => 'Category is required',
            'country.required'      => 'Country is required',
            'state.required'        => 'State is required',
            'city.required'         => 'City is required',
            'language.required'         => 'Language is required',
            'gender.required'         => 'Gender is required',
            // 'dob.required'         => 'DOB is required',
            //'zipcode.required'      => 'Zipcode is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>false, 'msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $user_token= Hash::make($functions->_password_generate(20));
            $can_move_abroad=$request->can_move_abroad ? 1:0;
            $cat= $request->category;
           
            $category="";
            if(is_array($cat)){
	            if(count($cat)>0){
					foreach($cat as $val){
						$category.=",".$val;
					}
					$category=substr($category,1);
				}
			}else{
				$category=$cat;
			}
			if($category==null){
			    $category=0;
			}
			$languages = $request->language;
            if(isset($languages) && !empty($languages)){
                $langs = DB::table("languages")
                ->select(\DB::raw("GROUP_CONCAT(lang) as languages"))
                ->whereIn("id", explode(",",$languages))
                ->first();
                if($langs->languages!=""){
                    $languages=$langs->languages;
                }
            }
            $data =array(
                'first_name'        => $request->first_name,
                'last_name'         => $request->last_name !=null ? $request->last_name : "",
                'username'          => $request->first_name.($request->last_name !=null ? " ".$request->last_name : ""),
                'email'             => $request->email,
                'password'          => Hash::make($request->password),
                'mobile1'           => $request->mobile1!=null ?$request->mobile1 : "",
                //'mobile2'         => $request->mobile2,
                //'address1'        => $request->address1,
                'cat_id'        	=> $category,
                'country'           => $request->country,
                'state'             => $request->state,
                'city'              => $request->city,
                //'zipcode'         => $request->zipcode,
                'user_type'         => $request->user_type,
                'active'            => '1',
                // 'app_token'      => $user_token,
                'can_move_abroad'   => $can_move_abroad,
                'gender'            => $request->gender,
                'language'          => $languages,
                'dob'               => date("Y-m-d",strtotime($request->dob)),
                'bio'               => $request->bio ,
                'active'            => '1',
                'new_app_user'      => 1
            ); 
            $id = DB::table('users')->insertGetId($data);
            $username=$request->first_name." ".$request->last_name;
            // $id=DB::getPdo()->lastInsertId();
    
            // mail
    
    
            $can_data = DB::table("users")
                ->leftjoin("categories", \DB::raw("FIND_IN_SET(categories.cat_id,users.cat_id)"), ">", \DB::raw("'0'"))
                //->leftJoin('categories','categories.cat_id','=','users.cat_id')
                //->select(DB::raw("user_id,first_name,last_name,username,email,app_token,profile_pic,gender,dob,mobile1,city,state,country,language,bio,views,categories.category as category,user_type as type,active"))
                ->select(\DB::raw("users.username,users.user_id,users.email,users.dob,users.mobile1,users.city,
                        users.state,users.country,users.gender,users.language,users.bio,GROUP_CONCAT(categories.category) as category"))
                ->where('users.user_id',  $id)
                ->groupBy(\DB::raw("users.username,users.user_id,users.email,users.dob,users.mobile1,users.city,users.state,users.country,users.gender,users.language,users.bio"))
                ->first();
                
            if ($can_data->gender == 'F') {
                $gender = 'Female';
            } else {
                $gender = 'Male';
            }

            $mailBody = '<b>Dear ' . $can_data->username . '<b><br /><br /> 
                        Register Successfully. Thank you for your valuable time. Your Details are: <br /><br />
                        Username  : ' . $can_data->username . '<br />
                        Email : ' . $can_data->email . ' <br />
                        DOB : ' . $can_data->dob . ' <br />
                        Mobile : ' . $can_data->mobile1 . ' <br />
                        City : ' . $can_data->city . ' <br />
                        State : ' . $can_data->state . ' <br />
                        Country : ' . $can_data->country . ' <br />
                        Gender : ' . $gender . ' <br />
                        Language : ' . $languages . ' <br />
                        Bio : ' . $can_data->bio . ' <br />
                        <br />
                        <br />
                        Thanks <br />' . env('COMPANY_NAME');
            $array = array('subject' => ' Registration Confirmation at Films Dream', 'view' => 'emails.email', 'body' => $mailBody);
            Mail::to($can_data->email)->send(new SendMail($array));

            $mailBody = '<b>Hi Admin<b><br /><br /> 
                        A new candidate has been registered on app and waiting for approval. Please check all the details.Details are following:
                        Username  : ' . $can_data->username . '<br />
                        Email : ' . $can_data->email . ' <br />
                        DOB : ' . $can_data->dob . ' <br />
                        Mobile : ' . $can_data->mobile1 . ' <br />
                        City : ' . $can_data->city . ' <br />
                        State : ' . $can_data->state . ' <br />
                        Country : ' . $can_data->country . ' <br />
                        Gender : ' . $gender . ' <br />
                        Language : ' . $languages . ' <br />
                        Bio : ' . $can_data->bio . ' <br />
                        <br />
                        <br />
                        <a href="https://www.filmsdream.com/secureAdminArea/candidates/active/"' . $can_data->user_id . '>click here to activate the account</a>';
            $array = array('subject' => 'New Candidate Registration', 'view' => 'emails.email', 'body' => $mailBody);
            Mail::to('pawanbollywood@gmail.com')->send(new SendMail($array));
            
    // end mail
            $path = $functions->_getUserFolderName($id, "videos");
            $path2 = $functions->_getUserFolderName($id, "photos");
            $path3 = $functions->_getUserFolderName($id, 'profile_pic');
            $t_path = "videos/".$id."/thumb";        
            $folderExists = Storage::exists($t_path);
            if(!$folderExists){
                Storage::makeDirectory($t_path);
            }
            $data  = array('user_id' => $id, 'username' =>$username);
            $response = array("status" => true, 'msg'=>'Candidate Register STEP 1  successfully' ,'content' => $data);
            return response()->json($response);
        }
    }
    
    public function socialLogin(Request $request){
        
        $email = $request->email;
        $functions = new Functions();
        $isRecord = false;
        if($request->login_type == "A") {
            if(isset($request->ios_uuid)) {
                    //$user = DB::table("users")->where("ios_uuid",$request->ios_uuid)->first();
                $user = User::where("ios_uuid",$request->ios_uuid)->first();
                if($user) {
                    DB::table("users")->where('user_id',$user->user_id)->update(['login_type'=>$request->login_type]);
                    $isRecord = true;
                }elseif(isset($request->email)){
                    $user = DB::table("users")->where("email",$request->email)->first();
                    if($user) {
                        DB::table("users")->where('user_id',$user->user_id)->update(['ios_uuid'=>$request->ios_uuid,'login_type'=>$request->login_type]);
                        $isRecord = true;
                    }else{
                        $isRecord=false;
                    }
                } else {
                    $isRecord = false;
                }
            }
        }else{
            $user = User::whereRaw(DB::raw("(email='".$email."') and email<>''"))->first();
                // $user = DB::table("users")->whereRaw(DB::raw("(email='".$email."') and email<>''"))->first();
            if($user){
                $isRecord = true;  
            } else {
                $isRecord = false; 
            }
        }
        if($isRecord){
            // if($user->deleted==1){
            //     return response()->json(['status' => false, 'msg' => 'Account does not exist'], 200);
            // }
            if($user->active==1){
                $userId= $user->user_id;
                
                $ios_uuid = "";
                if($request->login_type == "A") {
                    $ios_uuid = $request->ios_uuid;    
                }
                $uniques_user_id_res = DB::table("unique_users_ids")->select("unique_id","user_id","unique_token")->where('unique_token',$request->unique_id)->first();
                if($uniques_user_id_res){
                    DB::table('unique_users_ids')
                    ->where('unique_token',$request->unique_id)
                    ->update(['user_id'=>$user->user_id]);
                    DB::table('post_views')
                    ->where('unique_id',$uniques_user_id_res->unique_id)
                    ->where('user_id',0)
                    ->update(['user_id'=>$user->user_id]);
                }else{
                    DB::table('unique_users_ids')->insert(['unique_token'=>$request->unique_id,'user_id'=>$user->user_id]);   
                }
                // $accessToken = $this->getAccessTokenBasedOnUserEmail($user->email);
                
                // if ($accessToken=="") {
                //     return response()->json(['status'=>false,'msg'=> 'Some error occur in our server. please try again.']);
                // }
                            // $data=auth('api')->user();
                            // print_r($data);
                            // exit;
    
                $now  = date("Y-m-d H:i:s");
                
                $data2=array();
                $file_path="";
                if($user->profile_pic==''){
                    if(stripos($request->user_dp,'https://')!==false){
                       $file_path=$request->user_dp;
                       $small_file_path=$request->user_dp;
                       $data2['profile_pic'] = $file_path;
                    } else {
                    //   $file_path = asset(Storage::url('public/profile_pic/'.$user->user_id."/".$request->user_dp));
                    //   $small_file_path = asset(Storage::url('public/profile_pic/'.$request->user_id."/small/".$request->user_dp));
                    //   if($file_path==""){
                    //     $file_path=asset('default/default.png');
                    //     }
                    //     if($small_file_path==""){
                    //         $small_file_path=asset('default/default.png');
                    //     }
                    $data2['profile_pic'] = "";
                    }
                }
                // $data2 = array(
                //     // 'profile_pic'  => $file_path,
                //     // 'profile_pic'  => $file_path,
                //     'login_type'   => $request->login_type,
                //     'fcm_token'    => $request->fcm_token,
                //     'new_app_user' => 1,
                //     'deleted'      => 0
                // );
                $data2['login_type'] = $request->login_type;
                $data2['fcm_token'] = $request->fcm_token;
                $data2['new_app_user'] = 1;
                $data2['deleted'] = 0;
                
                
                DB::table('users')
                ->where('user_id', $user->user_id)
                ->update($data2);
                
                $userInfo = User::find($userId);
                $userInfo->fcm_token = $request->fcm_token;
                $userInfo->save();
                // print_r($user);exit;
                $accessToken = Auth::login($userInfo);
                $new = $request->new==null ? "false" : "true";
                return $this->respondWithToken($accessToken,$new);
            }else{
                $response = array("status" => false,'msg'=>'Account Deactivated'); 
            }
        }
        else{
            
            $now  = date("Y-m-d H:i:s");
            $ios_uuid = "";
            if($request->login_type == "A") {
                $ios_uuid = $request->ios_uuid;    
            }
            $gender = "";
            if($request->gender != null && $request->gender != "") {
                if(strtolower($request->gender) == "male" || strtolower($request->gender) == "m") {
                    $gender = "M";
                } else if(strtolower($request->gender) == "female" || strtolower($request->gender) == "f") {
                    $gender = "F";
                } else {
                    $gender = "OT";
                }
            }
            $data = array(
                'username'          => $request->first_name." ".$request->last_name,
                'first_name'        => strip_tags($request->first_name),
                'first_name'        => strip_tags($request->first_name),
                'email'             =>  $request->email,
                'active'            => '1',
                'gender'            => $gender,
                'added_date'        => $now,
                'profile_pic'       => $request->user_dp ==null ?"":$request->user_dp,
                'fcm_token'         => $request->fcm_token,
                'login_type'        => $request->login_type,
                // 'updated_at'     => $now,
                'ios_uuid'          => $ios_uuid,
                'new_app_user'      => 1
                // 'email_verified' => 1
            );
        
            $apple_user_id = DB::table("users")->insertGetId($data);
            $data['user_id'] = $apple_user_id;
            $id = $apple_user_id;
            // mail
            $can_data = DB::table("users")
                    ->leftjoin("categories", \DB::raw("FIND_IN_SET(categories.cat_id,users.cat_id)"), ">", \DB::raw("'0'"))
                    //->leftJoin('categories','categories.cat_id','=','users.cat_id')
                    //->select(DB::raw("user_id,first_name,last_name,username,email,app_token,profile_pic,gender,dob,mobile1,city,state,country,language,bio,views,categories.category as category,user_type as type,active"))
                    ->select(\DB::raw("users.username,users.user_id,users.email,users.dob,users.mobile1,users.city,
                            users.state,users.country,users.gender,users.language,users.bio,GROUP_CONCAT(categories.category) as category"))
                    ->where('users.user_id',  $id)
                    ->groupBy(\DB::raw("users.username,users.user_id,users.email,users.dob,users.mobile1,users.city,users.state,users.country,users.gender,users.language,users.bio"))
                    ->first();
            if ($can_data->gender == 'F') {
                $gender = 'Female';
            } else {
                $gender = 'Male';
            }

            $mailBody = '<b>Dear ' . $can_data->username . '<b><br /><br /> 
                        Register Successfully. Thank you for your valuable time. Your Details are: <br /><br />
                        Username  : ' . $can_data->username . '<br />
                        Email : ' . $can_data->email . ' <br />
                        DOB : ' . $can_data->dob . ' <br />
                        Mobile : ' . $can_data->mobile1 . ' <br />
                        City : ' . $can_data->city . ' <br />
                        State : ' . $can_data->state . ' <br />
                        Country : ' . $can_data->country . ' <br />
                        Gender : ' . $gender . ' <br />
                        Language : ' . $can_data->language . ' <br />
                        Bio : ' . $can_data->bio . ' <br />
                        <br />
                        <br />
                        Thanks <br />' . env('COMPANY_NAME');
            $array = array('subject' => ' Registration Confirmation at Films Dream', 'view' => 'emails.email', 'body' => $mailBody);
            Mail::to($can_data->email)->send(new SendMail($array));

            $mailBody = '<b>Hi Admin<b><br /><br /> 
                        A new candidate has been registered on app and waiting for approval. Please check all the details.Details are following:
                        Username  : ' . $can_data->username . '<br />
                        Email : ' . $can_data->email . ' <br />
                        DOB : ' . $can_data->dob . ' <br />
                        Mobile : ' . $can_data->mobile1 . ' <br />
                        City : ' . $can_data->city . ' <br />
                        State : ' . $can_data->state . ' <br />
                        Country : ' . $can_data->country . ' <br />
                        Gender : ' . $gender . ' <br />
                        Language : ' . $can_data->language . ' <br />
                        Bio : ' . $can_data->bio . ' <br />
                        <br />
                        <br />
                        <a href="https://www.filmsdream.com/secureAdminArea/candidates/active/"' . $can_data->user_id . '>click here to activate the account</a>';
            $array = array('subject' => 'New Candidate Registration', 'view' => 'emails.email', 'body' => $mailBody);
            Mail::to('pawanbollywood@gmail.com')->send(new SendMail($array));
            // end mail
            
            $accessToken = $this->getAccessTokenBasedOnUserEmail($request->email);
            $path = $functions->_getUserFolderName($apple_user_id, "videos");
            $path2 = $functions->_getUserFolderName($apple_user_id, "photos");
            $path3 = $functions->_getUserFolderName($apple_user_id, 'profile_pic');
            $t_path = "videos/".$apple_user_id."/thumb";        
            $folderExists = Storage::exists($t_path);
            if(!$folderExists){
                Storage::makeDirectory($t_path);
            }
            if($accessToken == "") {
                return response()->json(['status'=>false,'msg'=> 'Some error occur in our server. please try again.']);
            }
            $new = $request->new==null ? "false" : "true";
            return $this->respondWithToken($accessToken,$new);
        }
    }
    
    
    public function getAccessTokenBasedOnUserEmail($email) {
        
        $accessToken = '';
        $user = User::whereEmail($email)->first();
        if($user) {
            if ( !$userToken=JWTAuth::fromUser($user) ) {
                $accessToken = '';
            } else {
                $accessToken = $userToken;
                // print_r($accessToken);exit;
                JWTAuth::setToken($accessToken)->toUser();
                // print_r(auth('api')->user());die;
            }
        }
        return $accessToken;
        
    }
    protected function respondWithToken($token,$new="false")
    {
        $user_data = array();
        $user_data = auth('api')->user();
        $user_data = User::find($user_data->user_id);
        $file_path = '';
        $small_file_path = '';
        if ($user_data->profile_pic != '' && $user_data->profile_pic != null) {
            if (stripos($user_data->profile_pic, 'https://') !== false) {
                $file_path = $user_data->profile_pic;
                $small_file_path = $user_data->profile_pic;
            } else {
                $file_path = asset(Storage::url('profile_pic/' . $user_data->user_id . "/" . $user_data->profile_pic));
                $small_file_path = asset(Storage::url('profile_pic/' . $user_data->user_id . "/small/" . $user_data->profile_pic));
                if ($file_path == "") {
                    $file_path = asset('default/default.png');
                }
                if ($small_file_path == "") {
                    $small_file_path = asset('default/default.png');
                }
            }
        }
        $follower_res=DB::table('followers')
		                ->where('user_id',$user_data->user_id)
		                ->count();
		            
            $following_res=DB::table('followers')
                ->where('following_id',$user_data->user_id)
                ->count();
            
            $likes_res=DB::table('post_likes as l')
            	->leftJoin('posts as p','p.post_id','=','l.post_id')
                ->where('p.user_id',$user_data->user_id)
                ->count();
                
            $views_res=DB::table('post_views as v')
            	->leftJoin('posts as p','p.post_id','=','v.post_id')
                ->where('p.user_id',$user_data->user_id)
                ->count();
        $categories = \DB::table("categories")
					->select(\DB::raw("GROUP_CONCAT(category) as cat_name,GROUP_CONCAT(cat_id) as cat_ids"))
					->whereIn("cat_id", explode(",",$user_data->cat_id))
					->first();
    	$videoStoragePath = asset(Storage::url('videos'));
    	$photoStoragePath = asset(Storage::url('photos'));
        ini_set("serialize_precision", 1);
        if (auth()->guard('api')->user()) {
            $login_id = auth()->guard('api')->user()->user_id;
        } else {
            $login_id = 0;
        }
    
        /*$posts = DB::table('users as u')
        ->select(DB::raw("l.like_id as like_id, u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,p.aspect_ratio,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type"))
         ->join('posts as p', function ($join) use ($login_id){
            $join->on('u.user_id','p.user_id'); 
            $join->where('p.user_id','=',$login_id); 
            })
        ->leftJoin('post_likes as l', function ($join) use ($login_id){
            $join->on('l.post_id','=','p.post_id'); 
            $join->where('l.user_id','=',$login_id); 
            })
        ->leftJoin('posts as p2','p2.post_id','p.shared_post_id')
        ->leftJoin('users as u2','p2.user_id','u2.user_id')
        ->leftJoin('categories as c', function($join){
            $join->on(DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"), ">",DB::raw("0"));
         })
         ->where('u.deleted',0)
         ->where('p.type','!=','S')
         ->where('p.active',1)
         ->where('p.show_on_wall',1);
        $posts=$posts->groupBy(DB::raw('u2.user_id, u2.username, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio'));
        $posts=$posts->orderBy("post_id","desc");
        $posts=$posts->paginate(21);
        $total_records = $posts->total();
        /*if (!isset($request->page) && $request->page == "") {
            $page = 1;
        } else {
            $page = $request->page;
        }
    */
        // $page=1;
        // // $total_records = 0;
        // $data = array();
        // if ($posts) {
            
        //     $i = 0;
        //     foreach ($posts as $r) {
                
        //             $i++;
        //             if ($r->profile_pic == "") {
        //                 $p = secure_asset('assets/images/profile.png');
        //             } else {
                        
        //                 if (stripos($r->profile_pic, 'https://') !== false) {
		// 						$p=$r->profile_pic;
		// 					}else{
		// 						$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
		// 					}
							
        //                // $p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
        //             }
        //             $p2 = "";
        //             if ($r->shared_post_id > 0) {
        //                 if ($r->profile_pic2 == "") {
        //                     $p2 = secure_asset('assets/images/profile.png');
        //                 } else {
        //                     if (stripos($r->profile_pic2, 'https://') !== false) {
		// 						$p2=$r->profile_pic2;
		// 					}else{
		// 						$p2=Storage::url("profile_pic/".$r->user_id2."/".$r->profile_pic2);
		// 					}
							
        //                     //$p2 = Storage::url("profile_pic/" . $r->user_id2 . "/" . $r->profile_pic2);
        //                 }
        //             }
        //             if ($r->type == "V") {
        //                 $thumb = explode(".", $r->file);
        //                 $thum = $thumb[0] . ".jpg";
        //                 //$thum=substr($r->file, 0, -3)."jpg";
        //                 $file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
        //                 $thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
        //             } else {
        //                 $file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
        //                 $thumb_file = "";
        //             }
        //             $file2 = "";
        //             $thumb_file2 = "";
        //             if ($r->shared_post_id > 0) {
        //                 if ($r->type2 == "V") {
        //                     $thumb2 = explode(".", $r->file2);
        //                     $thum2 = $thumb2[0] . ".jpg";
        //                     //$thum=substr($r->file, 0, -3)."jpg";
        //                     $file2 = Storage::url("videos/" . $r->user_id2 . "/" . $r->file2);
        //                     $thumb_file2 = Storage::url("videos/" . $r->user_id2 . "/thumb/" . $thum2);
        //                 } else {
        //                     $file2 = Storage::url("photos/" . $r->user_id2 . "/" . $r->file2);
        //                     $thumb_file2 = "";
        //                 }
        //             }
    
        //             $added_on = $r->added_on;
    
    
        //             $data_liked_users['users'] = array();
    
        //             if ($r->likes > 0) {
        //                 $rs_liked_users = DB::table('post_likes as l')
        //                     ->Join('users as u', 'l.user_id', '=', 'u.user_id')
        //                     ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
        //                     ->where('l.post_id', $r->post_id);
        //                 // ->orderBy('comment_id','desc');
    
        //                 $rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
        //                     //->skip($offset) 
        //                     ->paginate(2);
        //                 //->get();
        //                 //print_r($res);
        //                 $total_liked_users = $rs_liked_users->total();
    
        //                 if (!$rs_liked_users->isEmpty()) {
    
        //                     foreach ($rs_liked_users as $l) {
        //                         if ($l->profile_pic == "") {
        //                             $p_liked = asset('assets/images/profile.png');
        //                         } else {
        //                             $p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
        //                         }
    
        //                         $liked_on = ($l->like_on);
    
        //                         $data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
        //                     }
        //                 }
        //             }
    
        //             $data_comment['comment'] = array();
    
        //             if ($r->comments > 0) {
    
        //                 $rs_comments = DB::table('post_comments as c')
        //                     ->Join('users as u', 'c.user_id', '=', 'u.user_id')
        //                     ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
        //                     ->where('c.post_id', $r->post_id)
        //                     ->where('c.parent_id', 0);
        //                 // ->orderBy('comment_id','desc');
    
        //                 $rs_comments = $rs_comments->orderBy('comment_id', 'desc')
        //                     ->offset(0)
        //                     ->limit(2)
        //                     ->get();
        //                 //->get();
        //                 //print_r($res);
    
        //                 foreach ($rs_comments as $c) {
        //                     if ($c->profile_pic == "") {
        //                         $p_comment = "secure_asset('assets/images/profile.png')";
        //                     } else {
        //                         $p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
        //                     }
    
        //                     $comment_on = $c->comment_on;
    
    
        //                     $data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id);
        //                 }
        //             }
        //             $data_comment['comment'] = array_reverse($data_comment['comment']);
        //             $s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'user_id' => $r->user_id, 'user_id2' => $r->user_id2, 'file1' => $r->file, 'username' => $r->username, 'username2' => $r->username2, 'file' => $file, 'file2' => $file2, 'thumb' => $thumb_file, 'thumb2' => $thumb_file2, 'title' => $r->title, 'title2' => $r->title2, 'added_on' => $added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'profile_pic2' => $p2, 'type' => $r->type, 'type2' => $r->type2, 'cat_id' => $r->cat_id, 'cat_name' => $r->cat_name, 'post_id' => $r->post_id, 'post_id2' => $r->post_id2, 'sig' => md5($r->post_id . "*FilmsDream@1290"), 'aspect_ratio' => number_format($r->aspect_ratio, 1));
        //             array_push($data, $s);
        //             /*if ($i == 3 || $i == 10) {
    
        //                 if ($login_id > 0) {
        //                     $user = DB::table("users")
        //                         ->select(DB::raw('*'))
        //                         ->where("user_id", $login_id)
        //                         ->first();
        //                     $country = $user->country;
        //                     $state = $user->state;
        //                     if (strtolower($country) == "usa") {
        //                         $country = "United States";
        //                     }
        //                 } else {
        //                     $country = "United States";
        //                     $state = '';
        //                 }
    
        //                 $res = DB::table("wall_ads")
        //                     ->select(DB::raw('*'))
        //                     ->where("active", 1)
        //                     ->whereRaw(DB::raw(" (countries like '%" . $country . "%' or countries like '%All Countries%')"))
        //                     ->whereRaw(DB::raw(" (states like '%" . $state . "%' or IFNULL(states,'')='')"))
        //                     ->whereRaw(DB::raw("active=1 and '" . date("Y-m-d") . "' between start_date and expiry_date"))
        //                     //->whereRaw(DB::raw("ad_type in ('M', 'M') "))
        //                     ->orderBy(DB::raw("rand()"))
        //                     ->first();
    
        //                 if ($res) {
    
        //                     $ad_type = $res->ad_type;
        //                     $ad_title1 = $res->title1;
        //                     $ad_description1 = $res->description1;
        //                     $ad_link1 = $res->link1;
        //                     $ad_file1 = "";
        //                     if ($res->file1 != "") {
        //                         $ad_file1 = Storage::url("banners/" . $res->file1);
        //                     }
    
        //                     $ad_title2 = $res->title2;
        //                     $ad_description2 = $res->description2;
        //                     $ad_link2 = $res->link2;
        //                     $ad_file2 = "";
        //                     if ($res->file2 != "") {
        //                         $ad_file2 = Storage::url("banners/" . $res->file2);
        //                     }
    
        //                     $ad_title3 = $res->title3;
        //                     $ad_description3 = $res->description3;
        //                     $ad_link3 = $res->link3;
        //                     $ad_file3 = "";
        //                     if ($res->file3 != "") {
        //                         $ad_file3 = Storage::url("banners/" . $res->file3);
        //                     }
    
        //                     $ad_title4 = $res->title4;
        //                     $ad_description4 = $res->description4;
        //                     $ad_link4 = $res->link4;
        //                     $ad_file4 = "";
        //                     if ($res->file4 != "") {
        //                         $ad_file4 = Storage::url("banners/" . $res->file4);
        //                     }
    
        //                     $ad_title5 = $res->title5;
        //                     $ad_description5 = $res->description5;
        //                     $ad_link5 = $res->link5;
        //                     $ad_file5 = "";
        //                     if ($res->file5 != "") {
        //                         $ad_file5 = Storage::url("banners/" . $res->file5);
        //                     }
    
        //                     $views = $res->views + 1;
        //                     $up_data = array("views" => $views);
    
        //                     DB::table('wall_ads')
        //                         ->where('ad_id', $res->ad_id)
        //                         ->update($up_data);
    
        //                     $s = array('type' => 'A', 'post_id' => "999" . $r->post_id, 'ad_type' => $ad_type, 'ad_title1' => $ad_title1, 'ad_description1' => $ad_description1, 'ad_link1' => $ad_link1, 'ad_file1' => $ad_file1, 'ad_title2' => $ad_title2, 'ad_description2' => $ad_description2, 'ad_link2' => $ad_link2, 'ad_file2' => $ad_file2, 'ad_title3' => $ad_title3, 'ad_description3' => $ad_description3, 'ad_link3' => $ad_link3, 'ad_file3' => $ad_file3, 'ad_title4' => $ad_title4, 'ad_description4' => $ad_description4, 'ad_link4' => $ad_link4, 'ad_file4' => $ad_file4, 'ad_title5' => $ad_title5, 'ad_description5' => $ad_description5, 'ad_link5' => $ad_link5, 'ad_file5' => $ad_file5);
        //                     array_push($data, $s);
        //                 }
        //             }*/
                
        //     }
        // } else {
        //     $data = array('warning' => 'Sorry..! No record found.');
        // }
    
        // $response = array("status" => "success", 'msg' => 'Wall Post List', 'content' => $data, 'total_records' => $total_records);
        
        $data=null;
        $videos_data=null;
        $photos_data=null;
        
        if($new=="true"){
            $videos_data = array();
            $photos_data = array();
            $video_posts = DB::table('users as u')
            ->select(DB::raw("l.like_id as like_id, u.user_id as user_id, u.gender,u.username as username,u.profile_pic as profile_pic,p.show_on_wall,p.aspect_ratio,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type,case when f.follower_id IS NULL then 0 else 1 end as isFollowing"))
            ->join('posts as p', function ($join) use ($login_id){
                $join->on('u.user_id','p.user_id'); 
                $join->where('p.user_id','=',$login_id); 
                $join->where('p.type','=',"V"); 
            })
            ->leftJoin('followers as f', function ($join)use ($login_id){
                $join->on('f.following_id','=','u.user_id')
                ->where('f.user_id',$login_id);
            })
            ->leftJoin('post_likes as l', function ($join) use ($login_id){
                $join->on('l.post_id','=','p.post_id'); 
                $join->where('l.user_id','=',$login_id); 
            })
            ->leftJoin('posts as p2','p2.post_id','p.shared_post_id')
            ->leftJoin('users as u2','p2.user_id','u2.user_id')
            ->leftJoin('categories as c', function($join){
                $join->on(DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"), ">",DB::raw("0"));
            })
            
            ->leftJoin('reports as rp', function ($join)use ($login_id){
                $join->on('p.post_id','=','rp.post_id');
                $join->whereRaw(DB::raw(" ( rp.user_id=".$login_id." )" ));
            })
            ->whereRaw( DB::Raw(' rp.id is null '))
            ->where('u.deleted',0)
            //  ->where('p.show_on_wall',1)
            ->where('p.active',1)
            ->where('p.type','!=','S');
            $video_posts=$video_posts->groupBy(DB::raw('u2.user_id, u2.username,u.gender, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, f.follower_id, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio,p.show_on_wall'));
            $video_posts=$video_posts->orderBy("post_id","desc");
            $video_posts=$video_posts->paginate(21);
            // dd($video_posts);
            $total_records = $video_posts->total();
            $page=1;
            // $total_records = 0;
            
            if ($video_posts) {
                $i = 0;
                foreach ($video_posts as $r) {
                    $i++;
                    if ($r->profile_pic == "") {
                        if($r->gender=="M"){
                            $p=secure_asset('assets/images/avatar-man.png');    
                        }else if($r->gender=="F"){
                            $p=secure_asset('assets/images/avatar-woman.png');    
                        }else{
                            $p=secure_asset('assets/images/profile.png');
                        }
                    } else {
                        
                        if (stripos($r->profile_pic, 'https://') !== false) {
                            $p=$r->profile_pic;
                        }else{
                            $p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
                        }
                        
                        //$p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
                    }
                    $p2 = "";
                    if ($r->shared_post_id > 0) {
                        if ($r->profile_pic2 == "") {
                            $p2 = secure_asset('assets/images/profile.png');
                        } else {
                            
                            if (stripos($r->profile_pic2, 'https://') !== false) {
                                $p=$r->profile_pic2;
                            }else{
                                $p=Storage::url("profile_pic/".$r->user_id2."/".$r->profile_pic2);
                            }
                            
                            //$p2 = Storage::url("profile_pic/" . $r->user_id2 . "/" . $r->profile_pic2);
                        }
                    }
                    if ($r->type == "V") {
                        $thumb = explode(".", $r->file);
                        $thum = $thumb[0] . ".jpg";
                        //$thum=substr($r->file, 0, -3)."jpg";
                        $file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
                        $thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
                    } else {
                        $file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
                        $thumb_file = "";
                    }
                    $file2 = "";
                    $thumb_file2 = "";
                    if ($r->shared_post_id > 0) {
                        if ($r->type2 == "V") {
                            $thumb2 = explode(".", $r->file2);
                            $thum2 = $thumb2[0] . ".jpg";
                            //$thum=substr($r->file, 0, -3)."jpg";
                            $file2 = Storage::url("videos/" . $r->user_id2 . "/" . $r->file2);
                            $thumb_file2 = Storage::url("videos/" . $r->user_id2 . "/thumb/" . $thum2);
                        } else {
                            $file2 = Storage::url("photos/" . $r->user_id2 . "/" . $r->file2);
                            $thumb_file2 = "";
                        }
                    }
                    
                    $added_on = $r->added_on;
                    
                    
                    $data_liked_users['users'] = array();
                    
                    if ($r->likes > 0) {
                        $rs_liked_users = DB::table('post_likes as l')
                        ->Join('users as u', 'l.user_id', '=', 'u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
                        ->where('l.post_id', $r->post_id);
                        // ->orderBy('comment_id','desc');
                        
                        $rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
                        //->skip($offset) 
                        ->paginate(2);
                        //->get();
                        //print_r($res);
                        $total_liked_users = $rs_liked_users->total();
                        
                        if (!$rs_liked_users->isEmpty()) {
                            
                            foreach ($rs_liked_users as $l) {
                                if ($l->profile_pic == "") {
                                    $p_liked = asset('assets/images/profile.png');
                                } else {
                                    
                                    if (stripos($l->profile_pic, 'https://') !== false) {
                                        $p_liked=$l->profile_pic;
                                    }else{
                                        $p_liked=Storage::url("profile_pic/".$l->user_id."/".$l->profile_pic);
                                    }
                                    
                                    // $p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
                                }
                                
                                $liked_on = ($l->like_on);
                                
                                $data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
                            }
                        }
                    }
                    
                    $data_comment['comment'] = array();
                    
                    if ($r->comments > 0) {
                        
                        $rs_comments = DB::table('post_comments as c')
                        ->Join('users as u', 'c.user_id', '=', 'u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
                        ->where('c.post_id', $r->post_id)
                        ->where('c.parent_id', 0);
                        // ->orderBy('comment_id','desc');
                        
                        $rs_comments = $rs_comments->orderBy('comment_id', 'desc')
                        ->offset(0)
                        ->limit(2)
                        ->get();
                        //->get();
                        //print_r($res);
                        
                        foreach ($rs_comments as $c) {
                            if ($c->profile_pic == "") {
                                $p_comment =  asset('assets/images/profile.png');
                            } else {
                                
                                if (stripos($c->profile_pic, 'https://') !== false) {
                                    $p_comment=$c->profile_pic;
                                }else{
                                    $p_comment=Storage::url("profile_pic/".$c->user_id."/".$c->profile_pic);
                                }
                                
                                // $p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
                            }
                            
                            $comment_on = $c->comment_on;
                            
                            $data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id,"post_id"=>$r->post_id);
                        }
                    }
                    $data_comment['comment'] = array_reverse($data_comment['comment']);
                    $s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'user_id' => $r->user_id, 'user_id2' => $r->user_id2, 'file1' => $r->file, 'username' => $r->username, 'username2' => $r->username2, 'file' => $file, 'file2' => $file2, 'thumb' => $thumb_file, 'thumb2' => $thumb_file2, 'title' => $r->title, 'title2' => $r->title2, 'added_on' => $added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'profile_pic2' => $p2, 'type' => $r->type, 'type2' => $r->type2, 'cat_id' => $r->cat_id, 'cat_name' => $r->cat_name, 'post_id' => $r->post_id, 'post_id2' => $r->post_id2, 'sig' => md5($r->post_id . "*FilmsDream@1290"), 'aspect_ratio' => number_format($r->aspect_ratio, 1),'show_on_wall' => $r->show_on_wall);
                    array_push($videos_data, $s);
                }
                
                $photo_posts = DB::table('users as u')
                ->select(DB::raw("l.like_id as like_id, u.user_id as user_id,u.gender,u.username as username,u.profile_pic as profile_pic,p.aspect_ratio,p.show_on_wall,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type,case when f.follower_id IS NULL then 0 else 1 end as isFollowing"))
                ->join('posts as p', function ($join) use ($login_id){
                    $join->on('u.user_id','p.user_id'); 
                    $join->where('p.type','=',"P"); 
                    $join->where('p.user_id','=',$login_id); 
                })
                ->leftJoin('followers as f', function ($join)use ($login_id){
                    $join->on('f.following_id','=','u.user_id')
                    ->where('f.user_id',$login_id);
                })
                ->leftJoin('post_likes as l', function ($join) use ($login_id){
                    $join->on('l.post_id','=','p.post_id'); 
                    $join->where('l.user_id','=',$login_id); 
                })
                ->leftJoin('posts as p2','p2.post_id','p.shared_post_id')
                ->leftJoin('users as u2','p2.user_id','u2.user_id')
                ->leftJoin('categories as c', function($join){
                    $join->on(DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"), ">",DB::raw("0"));
                })
                
                ->leftJoin('reports as rp', function ($join)use ($login_id){
                    $join->on('p.post_id','=','rp.post_id');
                    $join->whereRaw(DB::raw(" ( rp.user_id=".$login_id." )" ));
                })
                ->whereRaw( DB::Raw(' rp.id is null '))
                ->where('u.deleted',0)
                //  ->where('p.show_on_wall',1)
                ->where('p.active',1)
                ->where('p.type','!=','S');
                $photo_posts=$photo_posts->groupBy(DB::raw('u2.user_id, u2.username,u.gender, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, f.follower_id, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio,p.show_on_wall'));
                $photo_posts=$photo_posts->orderBy("post_id","desc");
                $photo_posts=$photo_posts->paginate(21);
                // dd($photo_posts);
                $total_records = $photo_posts->total();
            }
            $page=1;
            // $total_records = 0;
            if ($photo_posts) {
                $i = 0;
                foreach ($photo_posts as $r) {
                    $i++;
                    if ($r->profile_pic == "") {
                        if($r->gender=="M"){
                            $p=secure_asset('assets/images/avatar-man.png');    
                        }else if($r->gender=="F"){
                            $p=secure_asset('assets/images/avatar-woman.png');    
                        }else{
                            $p=secure_asset('assets/images/profile.png');
                        }
                    } else {
                        
                        if (stripos($r->profile_pic, 'https://') !== false) {
                            $p=$r->profile_pic;
                        }else{
                            $p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
                        }
                        
                        //$p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
                    }
                    $p2 = "";
                    if ($r->shared_post_id > 0) {
                        if ($r->profile_pic2 == "") {
                            $p2 = secure_asset('assets/images/profile.png');
                        } else {
                            
                            if (stripos($r->profile_pic2, 'https://') !== false) {
                                $p=$r->profile_pic2;
                            }else{
                                $p=Storage::url("profile_pic/".$r->user_id2."/".$r->profile_pic2);
                            }
                            
                            //$p2 = Storage::url("profile_pic/" . $r->user_id2 . "/" . $r->profile_pic2);
                        }
                    }
                    if ($r->type == "V") {
                        $thumb = explode(".", $r->file);
                        $thum = $thumb[0] . ".jpg";
                        //$thum=substr($r->file, 0, -3)."jpg";
                        $file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
                        $thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
                    } else {
                        $file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
                        $thumb_file = "";
                    }
                    $file2 = "";
                    $thumb_file2 = "";
                    if ($r->shared_post_id > 0) {
                        if ($r->type2 == "V") {
                            $thumb2 = explode(".", $r->file2);
                            $thum2 = $thumb2[0] . ".jpg";
                            //$thum=substr($r->file, 0, -3)."jpg";
                            $file2 = Storage::url("videos/" . $r->user_id2 . "/" . $r->file2);
                            $thumb_file2 = Storage::url("videos/" . $r->user_id2 . "/thumb/" . $thum2);
                        } else {
                            $file2 = Storage::url("photos/" . $r->user_id2 . "/" . $r->file2);
                            $thumb_file2 = "";
                        }
                    }
                    
                    $added_on = $r->added_on;
                    
                    $data_liked_users['users'] = array();
                    
                    if ($r->likes > 0) {
                        $rs_liked_users = DB::table('post_likes as l')
                        ->Join('users as u', 'l.user_id', '=', 'u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
                        ->where('l.post_id', $r->post_id);
                        // ->orderBy('comment_id','desc');
                        $rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
                        //->skip($offset) 
                        ->paginate(2);
                        //->get();
                        //print_r($res);
                        
                        $total_liked_users = $rs_liked_users->total();
                        
                        if (!$rs_liked_users->isEmpty()) {
                            
                            foreach ($rs_liked_users as $l) {
                                if ($l->profile_pic == "") {
                                    $p_liked = asset('assets/images/profile.png');
                                } else {
                                    
                                    if (stripos($l->profile_pic, 'https://') !== false) {
                                        $p_liked=$l->profile_pic;
                                    }else{
                                        $p_liked=Storage::url("profile_pic/".$l->user_id."/".$l->profile_pic);
                                    }
                                    
                                    // $p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
                                }
                                
                                $liked_on = ($l->like_on);
                                
                                $data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
                            }
                        }
                    }
                    
                    $data_comment['comment'] = array();
                    
                    if ($r->comments > 0) {
                        
                        $rs_comments = DB::table('post_comments as c')
                        ->Join('users as u', 'c.user_id', '=', 'u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
                        ->where('c.post_id', $r->post_id)
                        ->where('c.parent_id', 0);
                        // ->orderBy('comment_id','desc');
                        
                        $rs_comments = $rs_comments->orderBy('comment_id', 'desc')
                        ->offset(0)
                        ->limit(2)
                        ->get();
                        //->get();
                        //print_r($res);
                        
                        foreach ($rs_comments as $c) {
                            if ($c->profile_pic == "") {
                                $p_comment =  asset('assets/images/profile.png');
                            } else {
                                
                                if (stripos($c->profile_pic, 'https://') !== false) {
                                    $p_comment=$c->profile_pic;
                                }else{
                                    $p_comment=Storage::url("profile_pic/".$c->user_id."/".$c->profile_pic);
                                }
                                
                                // $p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
                            }
                            
                            $comment_on = $c->comment_on;
                            
                            
                            $data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id,"post_id"=>$r->post_id);
                        }
                    }
                    $data_comment['comment'] = array_reverse($data_comment['comment']);
                    $s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'user_id' => $r->user_id, 'user_id2' => $r->user_id2, 'file1' => $r->file, 'username' => $r->username, 'username2' => $r->username2, 'file' => $file, 'file2' => $file2, 'thumb' => $thumb_file, 'thumb2' => $thumb_file2, 'title' => $r->title, 'title2' => $r->title2, 'added_on' => $added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'profile_pic2' => $p2, 'type' => $r->type, 'type2' => $r->type2, 'cat_id' => $r->cat_id, 'cat_name' => $r->cat_name, 'post_id' => $r->post_id, 'post_id2' => $r->post_id2, 'sig' => md5($r->post_id . "*FilmsDream@1290"), 'aspect_ratio' => number_format($r->aspect_ratio, 1),'show_on_wall' => $r->show_on_wall);
                    array_push($photos_data, $s);
                }
            }
        }else{
            $data = array();
            $posts = DB::table('users as u')
            ->select(DB::raw("l.like_id as like_id, u.user_id as user_id,u.gender,u.username as username,u.profile_pic as profile_pic,p.aspect_ratio,p.show_on_wall,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type,case when f.follower_id IS NULL then 0 else 1 end as isFollowing"))
            ->join('posts as p', function ($join) use ($login_id){
                $join->on('u.user_id','p.user_id'); 
                $join->where('p.user_id','=',$login_id); 
            })
            ->leftJoin('followers as f', function ($join)use ($login_id){
                $join->on('f.following_id','=','u.user_id')
                ->where('f.user_id',$login_id);
            })
            ->leftJoin('post_likes as l', function ($join) use ($login_id){
                $join->on('l.post_id','=','p.post_id'); 
                $join->where('l.user_id','=',$login_id); 
            })
            ->leftJoin('posts as p2','p2.post_id','p.shared_post_id')
            ->leftJoin('users as u2','p2.user_id','u2.user_id')
            ->leftJoin('categories as c', function($join){
                $join->on(DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"), ">",DB::raw("0"));
            })
            
            ->leftJoin('reports as rp', function ($join)use ($login_id){
                $join->on('p.post_id','=','rp.post_id');
                $join->whereRaw(DB::raw(" ( rp.user_id=".$login_id." )" ));
            })
            ->whereRaw( DB::Raw(' rp.id is null '))
            ->where('u.deleted',0)
            //  ->where('p.show_on_wall',1)
            ->where('p.active',1)
            ->where('p.type','!=','S');
            $posts=$posts->groupBy(DB::raw('u2.user_id, u2.username,u.gender, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, f.follower_id, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio,p.show_on_wall'));
            $posts=$posts->orderBy("post_id","desc");
            $posts=$posts->paginate(21);
            // dd($posts);
            $total_records = $posts->total();
            
            $page=1;
            // $total_records = 0;
            if ($posts) {
                $i = 0;
                foreach ($posts as $r) {
                    $i++;
                    if ($r->profile_pic == "") {
                        if($r->gender=="M"){
                            $p=secure_asset('assets/images/avatar-man.png');    
                        }else if($r->gender=="F"){
                            $p=secure_asset('assets/images/avatar-woman.png');    
                        }else{
                            $p=secure_asset('assets/images/profile.png');
                        }
                    } else {
                        
                        if (stripos($r->profile_pic, 'https://') !== false) {
                            $p=$r->profile_pic;
                        }else{
                            $p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
                        }
                        
                        //$p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
                    }
                    $p2 = "";
                    if ($r->shared_post_id > 0) {
                        if ($r->profile_pic2 == "") {
                            $p2 = secure_asset('assets/images/profile.png');
                        } else {
                            
                            if (stripos($r->profile_pic2, 'https://') !== false) {
                                $p=$r->profile_pic2;
                            }else{
                                $p=Storage::url("profile_pic/".$r->user_id2."/".$r->profile_pic2);
                            }
                            
                            //$p2 = Storage::url("profile_pic/" . $r->user_id2 . "/" . $r->profile_pic2);
                        }
                    }
                    if ($r->type == "V") {
                        $thumb = explode(".", $r->file);
                        $thum = $thumb[0] . ".jpg";
                        //$thum=substr($r->file, 0, -3)."jpg";
                        $file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
                        $thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
                    } else {
                        $file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
                        $thumb_file = "";
                    }
                    $file2 = "";
                    $thumb_file2 = "";
                    if ($r->shared_post_id > 0) {
                        if ($r->type2 == "V") {
                            $thumb2 = explode(".", $r->file2);
                            $thum2 = $thumb2[0] . ".jpg";
                            //$thum=substr($r->file, 0, -3)."jpg";
                            $file2 = Storage::url("videos/" . $r->user_id2 . "/" . $r->file2);
                            $thumb_file2 = Storage::url("videos/" . $r->user_id2 . "/thumb/" . $thum2);
                        } else {
                            $file2 = Storage::url("photos/" . $r->user_id2 . "/" . $r->file2);
                            $thumb_file2 = "";
                        }
                    }
                    
                    $added_on = $r->added_on;
                    
                    $data_liked_users['users'] = array();
                    
                    if ($r->likes > 0) {
                        $rs_liked_users = DB::table('post_likes as l')
                        ->Join('users as u', 'l.user_id', '=', 'u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
                        ->where('l.post_id', $r->post_id);
                        // ->orderBy('comment_id','desc');
                        
                        $rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
                        //->skip($offset) 
                        ->paginate(2);
                        //->get();
                        //print_r($res);
                        $total_liked_users = $rs_liked_users->total();
                        
                        if (!$rs_liked_users->isEmpty()) {
                            
                            foreach ($rs_liked_users as $l) {
                                if ($l->profile_pic == "") {
                                    $p_liked = asset('assets/images/profile.png');
                                } else {
                                    
                                    if (stripos($l->profile_pic, 'https://') !== false) {
                                        $p_liked=$l->profile_pic;
                                    }else{
                                        $p_liked=Storage::url("profile_pic/".$l->user_id."/".$l->profile_pic);
                                    }
                                    
                                    // $p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
                                }
                                
                                $liked_on = ($l->like_on);
                                
                                $data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
                            }
                        }
                    }
                    
                    $data_comment['comment'] = array();
                    
                    if ($r->comments > 0) {
                        
                        $rs_comments = DB::table('post_comments as c')
                        ->Join('users as u', 'c.user_id', '=', 'u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
                        ->where('c.post_id', $r->post_id)
                        ->where('c.parent_id', 0);
                        // ->orderBy('comment_id','desc');
                        
                        $rs_comments = $rs_comments->orderBy('comment_id', 'desc')
                        ->offset(0)
                        ->limit(2)
                        ->get();
                        //->get();
                        //print_r($res);
                        
                        foreach ($rs_comments as $c) {
                            if ($c->profile_pic == "") {
                                $p_comment =  asset('assets/images/profile.png');
                            } else {
                                
                                if (stripos($c->profile_pic, 'https://') !== false) {
                                    $p_comment=$c->profile_pic;
                                }else{
                                    $p_comment=Storage::url("profile_pic/".$c->user_id."/".$c->profile_pic);
                                }
                                
                                // $p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
                            }
                            
                            $comment_on = $c->comment_on;
                            
                            
                            $data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id,"post_id"=>$r->post_id);
                        }
                    }
                    $data_comment['comment'] = array_reverse($data_comment['comment']);
                    $s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'user_id' => $r->user_id, 'user_id2' => $r->user_id2, 'file1' => $r->file, 'username' => $r->username, 'username2' => $r->username2, 'file' => $file, 'file2' => $file2, 'thumb' => $thumb_file, 'thumb2' => $thumb_file2, 'title' => $r->title, 'title2' => $r->title2, 'added_on' => $added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'profile_pic2' => $p2, 'type' => $r->type, 'type2' => $r->type2, 'cat_id' => $r->cat_id, 'cat_name' => $r->cat_name, 'post_id' => $r->post_id, 'post_id2' => $r->post_id2, 'sig' => md5($r->post_id . "*FilmsDream@1290"), 'aspect_ratio' => number_format($r->aspect_ratio, 1),'show_on_wall' => $r->show_on_wall);
                    array_push($data, $s);
                    
                }
            }
            
        }
        return response()->json([
            'status' =>true,
            'msg' => 'User login successfully!',
            'data' => array(
                'user_id'           => $user_data->user_id,
                'username'          => $user_data->username,
                'fname'             => $user_data->first_name,
                'lname'             => $user_data->last_name,
                'email'             => $user_data->email,
                'mobile'            => $user_data->mobile1,
                'dob'               => $user_data->dob,
                'gender'            => $user_data->gender,
                'city'           => $user_data->city,
                'state'           => $user_data->state,
                'country'           => $user_data->country,
                'challenge_term'    => $user_data->challenge_term,
                'user_dp'     => $file_path,
                'bio'        => ($user_data->bio == null) ? '' : $user_data->bio,
                'categories' => $categories->cat_name,
                'cat_id' => $categories->cat_ids,
                'posts' => $data,
                'videos' => $videos_data,
                'photos' => $photos_data,
                'total_posts'=>$total_records,
                "views"=>$user_data->views,
                "type"=> $user_data->user_type,
                "active"=> $user_data->active,
                "deleted"=> $user_data->deleted,
                'total_followers'=>$follower_res,
                'total_following'=>$following_res,
                'total_likes'=>$likes_res,
                'total_views'=>$views_res,
                'can_move_abroad' => $user_data->can_move_abroad ==1 ? true:false,
                'app_token' => $token,
                'expires_in' => strtotime(date("Y-m-d", strtotime('+' . auth('api')->factory()->getTTL() . ' minutes')))
            ),
        ]);
    }
    
    public function forgot_password(Request $request){
       
        $validator = Validator::make($request->all(), [ 
            'email'          => 'required|email',  
            //'user_type'            => 'required'
        ],[ 
           'email.required'	  	=> 'Email is required',
        	'email.email'		  	=> 'Email id is not valid',   
            //'user_type.required'   => 'User Type is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>false,'msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $res = DB::table("users")
            ->select(DB::raw("user_id,email,username"))
            ->where('email',$request->email)
            //->where('user_type',$request->user_type)
            ->first();
            
            if($res!=""){
                $functions = new Functions();
                $verify_code= rand(111111,999999);
                $data =array(
                    'verification_code' => $verify_code,
                ); 
                DB::table('users')
                ->where('user_id',$res->user_id)     
                ->update($data);
                
                $mailBody ='<b>Hi '.$res->username.',<b><br /> 
                We have received your request to reset the password of your account. <br />
				Verification Code is:  :<b>'.$verify_code.'<br />
				Use this verification code to reset your password. ignore this email if you have not requested for this <br />
				<br />
				<br />
				Thanks <br />'.env('COMPANY_NAME');
				$array = array('subject'=>'Verification Code','view'=>'emails.email','body' => $mailBody);
				
				Mail::to($res->email)->send(new SendMail($array)); 
				
                $data  = array( 'user_id' => $res->user_id);
                $response = array("status" => true,'msg'=>'We have sent you a verification code on your email , Please check your inbox and fill the verification code' ,'content' => $data);
            }else{
                $response = array( "status" => false, "msg" => "Invalid Username");
            }
            
            return response()->json($response); 
        
        }
    }
    public function verify_code_reset_password(Request $request){
        $validator = Validator::make($request->all(), [
            'email'       => 'required',
            'verify_code'          => 'required',              
            'new_password'          => 'required',              
        ],[ 
            'verify_code.required'   => 'Verification code field is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>false,'msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $res = DB::table("users")
            ->select(DB::raw("user_id,verification_code"))
            ->where('email',$request->email)
            ->where('verification_code',$request->verify_code)
            ->first();
            //if($res !=""){
                if($res){
                    DB::table('users')
                    ->where('user_id',$res->user_id)
                    ->update(['password'=>Hash::make($request->new_password),'verification_code'=>null]);
                    $response = array("status" => true,'msg'=>'Password reset successfully');
                }else{
                    $response = array("status" => false,"msg" => "Invalid verification code");
                }
                
            return response()->json($response); 
        
        }
    }
    public function change_password(Request $request){
        
    	$validator = Validator::make($request->all(), [       
    	    'old_password'           => 'required',            
            'new_password'           => 'required|same:confirm_password',
            'confirm_password'       => 'required'
        ],[         
           	'old_password.required'	    	=> 'Old Password is required',
        	'new_password.email'		  	=> 'New Password is not valid',         
        	'confirm_password.required'	    => 'Confirm Password is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
                if(auth('api')->user()){
                    $login_id = auth('api')->user()->user_id;
                    $user = DB::table('users')
                        ->select(DB::raw("*"))
                        ->where('user_id',$login_id)
                        ->first();
    
                    if (Hash::check($request->old_password, $user->password)) { 
                        
                        DB::table('users')
                            ->where('user_id',$login_id)
                            ->update(['password'=>Hash::make($request->new_password)]);
                           
                        $response = array("status" => true,'msg'=>'Password changed successfully');
                    } else {                    
                        $response = array("status" =>false,"msg"=>"Old password is incorrect");
                    }  
                }  else{
                    $response = array("status" => true,'msg'=>'Invalid Token');
                }   
           
                return response()->json($response);   
        }
    }

}