<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateDetailController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_detail(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'id'          => 'required',   
            'user_id' => 'required',
            'app_token' =>'required'
        ],[ 
            'id.required'   => 'Id is required',
            'user_id.required' => 'User Id required',
            'app_token.required' => 'app token required'
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){
                $user_res= $functions->valid_candidate($request->id,'C');
                if($user_res==0){
                    $response = array("status" => "error",'msg'=>'Invalid User');
                }else{
                $views=DB::table('users')
                        ->select(DB::raw('views'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->first();
                        $view=$views->views+1;
                
                DB::table('users')->where('user_id',$request->id)->update(["views"=>$view]);
                $data=array();
                
                $bio_res=DB::table('users')
                        ->Join('categories','users.cat_id','=','categories.cat_id')
                        ->select(DB::raw('bio,username,first_name,categories.category,views,profile_pic'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->first();
                        
                 $prod_res=DB::table('users')
                        ->select(DB::raw('username as producer_name,user_id as producer_id'))
                        ->where('users.user_type','P')
                        ->where('users.user_id',$request->user_id)
                        ->first();
                        
                         if($bio_res->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$request->id."/".$bio_res->profile_pic);
						}
                        $data=array("bio"=>$bio_res->bio,"first_name"=>$bio_res->first_name,"username"=>$bio_res->username,"candidate_id"=>$request->id,"category"=>$bio_res->category,"views"=>$bio_res->views,"profile_pic" => $p,"producer_name"=>$prod_res->producer_name,"producer_id"=>$prod_res->producer_id);
    
              
                $photos_res=DB::table('users')
                        ->Join('user_photos','users.user_id','=','user_photos.user_id')
                        ->select(DB::raw('user_photos.photo as photo'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->limit(4)    
                        ->orderBy('photo_id','DESC')               
                        ->get();
               
                    foreach($photos_res as $r){
                        $data['photos'][] = array("photo"=>Storage::url("photos/".$request->id."/".$r->photo));
                     }
                
                $videos_res=DB::table('users')
                        ->Join('user_videos','users.user_id','=','user_videos.user_id')
                        ->select(DB::raw('user_videos.video as video'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->limit(4)    
                        ->orderBy('video_id','DESC')               
                        ->get();
               
                foreach($videos_res as $r){
                    $thumb=explode(".",$r->video);
                    $thumb=$thumb[0].'.jpg';
                    $data['videos'][] = array("video"=>Storage::url("videos/".$request->id."/".$r->video),"thumb" => Storage::url("videos/".$request->id."/thumb/".$thumb));
                    }
                
                $audios_res=DB::table('users')
                        ->Join('user_audios','users.user_id','=','user_audios.user_id')
                        ->select(DB::raw('user_audios.audio as audio'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->limit(4)    
                        ->orderBy('audio_id','DESC')               
                        ->get();
               
                foreach($audios_res as $r){
                    $data['audios'][] = array("audio"=>Storage::url("audios/".$request->id."/".$r->audio));
                }
                
                $response = array("status" => "success",'msg'=>'Candidate Detail' ,'content' => $data);
            }
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
        
            return response()->json($response); 
        }
    }

}   