<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateGetProfileController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_get_profile(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'          => 'required',              
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
             $functions = new Functions();
                $token_res= $functions->validate_token($request->user_id,$request->app_token);
                if($token_res>0){
                           
                   /* $res=DB::table('users')
                        ->leftJoin('categories','users.cat_id','=','categories.cat_id')
                        ->select(DB::raw('user_id,username,first_name,last_name,categories.category as cat_name,categories.cat_id as cat_id,email,state,city,country,language,dob,mobile1,address1,active,views,profile_pic,education,active,bio,zipcode,user_type'))
                        ->where('users.user_id',$request->user_id)
                        ->first();*/
                                         
                $res = \DB::table("users")
			        ->select("users.*",\DB::raw("GROUP_CONCAT(categories.category) as cat_name"))
			        ->leftjoin("categories",\DB::raw("FIND_IN_SET(categories.cat_id,users.cat_id)"),">",\DB::raw("'0'"))
			        ->where("users.user_id",$request->user_id)
			        ->groupBy("users.user_id")
			        ->first();
    
                    $data=array();
                
                        if($res->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$res->user_id."/".$res->profile_pic);
						}
                        $s = array('user_id'=>$res->user_id,'first_name'=>$res->first_name,'last_name'=>$res->last_name,'username'=>$res->username,'bio'=>$res->bio,'cat_name'=>$res->cat_name,'cat_id'=>$res->cat_id,'email'=>$res->email,'active'=>$res->active,'views'=>$res->views,'profile_pic' => $p,'state'=>$res->state,'city'=>$res->city,'country'=>$res->country,'mobile1'=>$res->mobile1 ,'address1'=>$res->address1,'views'=>$res->views,'dob'=>$res->dob,'education'=>$res->education,'bio'=>$res->bio,'zipcode'=>$res->zipcode,"user_type"=>$res->user_type,"can_move_abroad"=>$res->can_move_abroad);
                        array_push($data,$s);
                 
              
                    $response = array("status" => "success",'msg'=>'Candidate Profile View' ,'content' => $data);
                }  else{
                    $response = array("status" => "error",'msg'=>'Invalid Token');
                } 
                return response()->json($response); 
            }  
            
        }

}   