<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Intervention\Image\ImageManagerStatic as Image;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateIdProofController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function ids(Request $request){
       
        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'app_token'          => 'required', 
            // 'id_proof'      =>'required',
            'id_proof_file'          => 'required|image|mimes:jpeg,png,jpg,gif,svg', 
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $res= $functions->validate_token($request->user_id,$request->app_token,'C');
               
            if($res>0){

                    $path = $functions->_getUserFolderName($request->user_id, "ids");
                    if($request->hasFile('id_proof_file')) {
                    $filenametostore = $request->file('id_proof_file')->store($path);  
                     
                    Storage::setVisibility($filenametostore, 'public');
                    $fileArray = explode('/',$filenametostore);  
                    $fileName = array_pop($fileArray); 
                   // $functions->_createThumb(Storage::url($filenametostore),400,300,$path.'/small',$fileName);
                   // $functions->_createThumb(Storage::url($filenametostore),1200,900,$path.'/',$fileName);
                    $file_path = Storage::url("ids/".$request->user_id."/".$fileName);
                    }else{
                        $fileName="";
                        $file_path="";
                    }
                   
                    $data =array(
                       
                        'id_proof_file'    => $fileName,
                        // 'id_proof'          => $id_proof,
                       
                                                           
                    ); 
                    DB::table('users')->where('user_id',$request->user_id)->update($data);
               
                $data  = array( 'user_id' => $request->user_id, 'id_proof_file' => $file_path);
                $response = array("status" => "success" ,'content' => $data);
            }else{
                $response = array( "status" => "error", "msg" => "Invalid Token");
            }
            
            return response()->json($response); 
        
        }
    }

    
    public function photo_delete(Request $request){
        $functions = new Functions();
        $res = $functions->validate_token($request->user_id,$request->app_token,'C');
        if($res>0){
            $user_id   = $request->user_id;
            $photo_id  = $request->photo_id;
            DB::table('user_photos')->where('photo_id', $photo_id)->where('user_id', $user_id)->delete();
            
            $response = array("status" => "success",'msg'=>'Photo Deleted successfully');
        }else{
            $response = array( "status" => "error", "msg" => "Invalid Token");
        }
        return response()->json($response);
    }

    
}   