<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateIdsListController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_ids_list(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'          => 'required',              
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'C');
            $string="";
            if($token_res>0){
               
                    $res=DB::table('users')
                        ->Join('categories','users.cat_id','=','categories.cat_id')
                        ->select(DB::raw('user_id,username,categories.category as cat_name,email,active,views,profile_pic,id_proof,id_proof_file,address_proof,address_proof_file'))
                       // ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->user_id)
                        ->get();
        
                    $data=array();
                    foreach($res as $r){
                    	if($r->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/small/".$r->profile_pic);
						}
						if($r->id_proof_file==""){
							$id_proof_file='';
						}else{
							$id_proof_file=Storage::url("ids/".$r->user_id."/".$r->id_proof_file);
						}
						if($r->address_proof_file==""){
							$address_proof_file='';
						}else{
							$address_proof_file=Storage::url("ids/".$r->user_id."/".$r->address_proof_file);
						}
                        $s = array('user_id'=>$r->user_id,'username'=>$r->username,'category'=>$r->cat_name,'email'=>$r->email,'active'=>$r->active,'views'=>$r->views,"profile_pic" => $p,"id_proof"=>$r->id_proof,"id_proof_file"=>$id_proof_file,"address_proof"=>$r->address_proof,"address_proof_file"=>$address_proof_file);
                        array_push($data,$s);
                    }  
              
                    $response = array("status" => "success",'msg'=>'Candidate Profile View' ,'content' => $data);
            
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
            return response()->json($response); 
        }
    }

}   