<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateListController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_list(Request $request){
        
        $validator = Validator::make($request->all(), [          
            'user_id'         => 'required',           
            'app_token'       => 'required',
           
        ],[         
        	'user_id.required'	  	=> 'User Id is required',
        	'app_token.required'	=> 'App Token is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
           /* $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){*/
              $blocked_user_res=DB::table('blocked_users')
	                     ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
	                     ->where('blocked_by',$request->user_id)
	                     ->first();
	         $blocked_user_res2=DB::table('blocked_users')
	                     ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
	                     ->where('user_id',$request->user_id)
	                     ->first();
               
                /*$res=DB::table('users')
                    ->leftJoin('categories','users.cat_id','=','categories.cat_id')
                    ->select(DB::raw('user_id,username,categories.category as cat,round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) as age,gender,city,state,country,address1,profile_pic'))
                    ->where('users.active','1')
                    ->where('users.deleted','0')
                    ->where('users.user_id','!=',$request->user_id);*/
                $res=DB::table('users')
                    ->leftjoin("categories",\DB::raw("FIND_IN_SET(categories.cat_id, users.cat_id)"),">",\DB::raw("'0'"))
                    ->select(DB::raw('user_id,username,round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) as age,show_age,app_token,gender,city,state,country,address1,profile_pic,GROUP_CONCAT(categories.category) as cat'))
                    ->where('users.active','1')
                    ->where('users.deleted','0')
                    ->where('users.user_id','!=',$request->user_id);
                    
                    if(!isset($request->page) && $request->page==""){
                        $page=1;
                    }else{
                        $page=$request->page;
                    }
                    $limit=10;
                    $offset=($page-1)*$limit;
                    $where_gender="";
                    if(isset($request->gender) && $request->gender!=""){
                        $gender=substr($request->gender,1);
                        $where_gender= $where_gender." or users.gender='".$gender."'";
                        $where_gender=$res->whereRaw(substr($where_gender,3));
                        $res=$where_gender;
                    }

                    $where_cat="";
                    if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        
                        $cat_arr=explode(",",$category);
                       
                        foreach ($cat_arr as $val){
                        	$where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
                        	//$where_cat=$where_cat." or (users.cat_id =".$val.")";
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;
                       
                    }

                    $where_age = "";
                    if(isset($request->age) && $request->age!=""){
                        $age=substr($request->age,1);
                        $age_arr=explode(",",$age);
                        foreach ($age_arr as $val){
                        	$val_arr = explode("-", $val);
							$where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
                        }
                       
                        $where_age=$res->whereRaw("(".substr($where_age,3).")");
                       $res=$where_age;
                    }

                    $where_loc="";
                    if(isset($request->location) && $request->location!=""){
                        $location=substr($request->location,1);
                        $loc_arr=explode(",",$location);
                        foreach ($loc_arr as $val){
                        $where_loc=$where_loc.' or (users.country ="'.$val.'")';
                        }
                       
                        $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
                        $res=$where_loc;
                    }
                    
                    $where_lan="";
                    if(isset($request->language) && $request->language!=""){
                        $language=substr($request->language,1);
                        $lan_arr=explode(",",$language);
                        foreach ($lan_arr as $val){
                        $where_lan=$where_lan.' or (users.language like "%'.$val.'%")';
                        }
                        $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
                        $res=$where_lan;
                    }

                    $where_key="";
                    if(isset($request->keyword) && $request->keyword!=""){
                        $key_arr=explode(",",$request->keyword);
                        foreach ($key_arr as $val){
                        $where_key=$where_key.' or (users.first_name like "%'.$val.'%") or (users.last_name like "%'.$val.'%") or (categories.category like "%'.$val.'%") or (users.state like "%'.$val.'%") or (users.country like "%'.$val.'%")';
                        }
                        $where_key=$res->whereRaw("(".substr($where_key,3).")");
                        $res=$where_key;
                    }
                    
                    if($blocked_user_res->user_id==0){
					   
					   }else{
					   	$blocked_res=$blocked_user_res->user_id;
					   $blocked_res=explode(',',$blocked_res);
					   $res=$res->whereNotIn('user_id', $blocked_res);
					   
					   }
					if($blocked_user_res2->user_id==0){
					   
					   }else{
					   	$blocked_res2=$blocked_user_res2->user_id;
					   $blocked_res2=explode(',',$blocked_res2);
					   $res=$res->whereNotIn('user_id', $blocked_res2);
					   
					   }
               /* $total_records=$res->count();
                    $res=$res->skip($offset) 
                        ->take($limit)
                        ->get();*/
                 $res=$res->groupBy('user_id','username','gender','city','state','country','show_age','address1','profile_pic','app_token')
                 		->orderBy('user_id','desc')
                		 ->paginate($limit);
                		 /*->toSql();
                		 dd($res);
                		 exit;*/
	            $total_records=$res->total();
                    
                
                $data=array();
                if (!$res->isEmpty()){
                    foreach($res as $r){
                     if($r->profile_pic==""){
							$p='../../assets/imgs/profile.jpg';
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
						}
						if($r->gender=='F'){
							$gender='Female';
						}else{
							
							$gender='Male';
						}
                    $s = array('producer_id'=>$request->user_id,'candidate_id'=>$r->user_id,'candidate_name'=>$r->username,'producer_name'=>$request->producer_name,'category'=>$r->cat,'app_token'=>$r->app_token,'age'=>$r->age,'show_age'=>$r->show_age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p);
                    array_push($data,$s);
                    } 
                    
        
                }else{
                   $data=array('warning'=>'Sorry..! No record found.');
                }
                
                    $response = array("status" => "success",'msg'=>'Candidate List filtered successfully' ,'content' => $data,'total_records'=> $total_records);
               
           /* }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   */ 
            return response()->json($response); 
        }
    }

}   