<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateMessagesListController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_messages_list(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',    
            'candidate_id'       => 'required',    
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
            'candidate_id.required'  => 'Candidate id is required'
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            if(!isset($request->page) && $request->page==""){
                $page=1;
            }else{
                $page=$request->page;
            }
             $limit=20;
            $offset=($page-1)*$limit;
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token);
            if($token_res>0){
                $user_res=DB::table('message')
                        ->select(DB::raw('msg,from_id,to_id,sent_on'))
                        ->whereIn('from_id', [$request->user_id,$request->candidate_id])
                        ->whereIn('to_id', [$request->user_id,$request->candidate_id]);
                $total_records=$user_res->count();
                $user_res=$user_res->orderBy('msg_id','desc')
                        ->skip($offset) 
                        ->take($limit)
                        ->get();
               $m=array();
                  $data=array("candidate_id"=>$request->candidate_id,"user_id" => $request->user_id);
                 foreach($user_res as $r){
                      $sent_on=date('h:i A', strtotime($r->sent_on));
                        $m['msgs'][] = array("msg" => $r->msg,"from_id"=>$r->from_id,"to_id"=>$r->to_id,"sent_on"=>$sent_on);
                      
                     }
               if(!empty($m['msgs'])){
			   	$data['messages'] =array_reverse($m['msgs']);
			   }else{
			   	$data['messages'] =array_reverse($m);
			   }
                 
                 $data1 =array(
                        'is_read'       => '1',
                    
                    ); 
                    DB::table('message')->where('to_id',$request->user_id)->where('from_id',$request->candidate_id)->update($data1);
                $response = array("status" => "success",'msg'=>'Candidate Photos list' ,'content' => $data, 'total_records'=>$total_records);
           
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   
        
            return response()->json($response); 
        }
    }

}   