<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidatePhotosController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function photos(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'app_token'          => 'required', 
            'photo'          => 'required|image|mimes:jpeg,png,jpg,gif,svg',              
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'app_token.required'   => 'App Token is required.',
            'photo.required'   => 'Photo is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            
                $functions = new Functions();             
                if($request->hasFile('photo')) {
                    $path = "photos/".$request->user_id;
                    $filenametostore = $request->file('photo')->store($path);  
                  
                    Storage::setVisibility($filenametostore, 'public');
                    $fileArray = explode('/',$filenametostore);  
                    $fileName = array_pop($fileArray); 
                   
                    $functions->_createThumb(Storage::url($filenametostore),400,300,$path.'/small',$fileName);
                    $functions->_createThumb(Storage::url($filenametostore),1200,900,$path.'/',$fileName);
                    $file_path = Storage::url("photos/".$request->user_id."/".$fileName);
                     
                    //Storage::delete($filenametostore);  
                    /*$data =array(
                        'user_id' => $request->user_id,
                        'photo'    => $fileName,
                        'title'     => $title,
                                                           
                    ); 
                    DB::table('user_photos')->insert($data);*/
                    if($request->title==''){
						$title='';
					}else{
						$title=$request->title;
					}

                    if(!isset($request->show_on_wall)){
						$show_on_wall=1;
					}else{
						$show_on_wall=$request->show_on_wall;
					}

                    $data =array(
                        'user_id' => $request->user_id,
                        'file'    => $fileName,
                        'title'   => $title,
                        'type' 	  => 'P',
                        'show_on_wall' 	  => $show_on_wall,
                        'added_on' => date('Y-m-d H:i:s') 
                                                           
                    ); 
                    DB::table('posts')->insert($data);
                    $id=DB::getPdo()->lastInsertId();
                    $response = array( "status" => "success", "msg" => "Post Uploaded Successfully","file"=>$file_path,"post_id"=>$id);
                }
                //$response = $file_path;
              //echo $response;
               
                //exit();
                           
            return response()->json($response); 
        
        }
    }

    
    public function photo_delete(Request $request){
        $functions = new Functions();
        $res = $functions->validate_token($request->user_id,$request->app_token,'C');
        if($res>0){
            $user_id   = $request->user_id;
            $photo_id  = $request->photo_id;
            DB::table('user_photos')->where('photo_id', $photo_id)->where('user_id', $user_id)->delete();
            
            $response = array("status" => "success",'msg'=>'Photo Deleted successfully');
        }else{
            $response = array( "status" => "error", "msg" => "Invalid Token");
        }
        return response()->json($response);
    }

    
}   