<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidatePhotosListController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_photos_list(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'          => 'required',              
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'C');
            $string="";
            if($token_res>0){
                    if(!isset($request->page) && $request->page==""){
                        $page=1;
                    }else{
                        $page=$request->page;
                    }
                $limit=10;
                $offset=($page-1)*$limit;
               
                $user_res=DB::table('users')
                        ->Join('categories','categories.cat_id','=','users.cat_id')
                        ->select(DB::raw('users.username as username,users.profile_pic as profile_pic,users.gender,users.views as views,categories.category as category'))
                        //->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->user_id)
                        ->first();
                        if($user_res->profile_pic==""){
    						if($user_res->gender=="M"){
                     	        $p=secure_asset('assets/images/avatar-man.png');    
                     	    }else if($user_res->gender=="F"){
                     	        $p=secure_asset('assets/images/avatar-woman.png');    
                     	    }else{
                     	        $p=secure_asset('assets/images/profile.png');
                     		}
						}else{
							$p=Storage::url("profile_pic/".$request->user_id."/".$user_res->profile_pic);
						}
                $data=array("username"=>$user_res->username,"category"=>$user_res->category,"views"=>$user_res->views,"profile_pic"=>$p);
                $photos_res=DB::table('users')
                        ->Join('user_photos','users.user_id','=','user_photos.user_id')
                        ->select(DB::raw('user_photos.photo as photo,user_photos.photo_id as photo_id'))
                        //->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->user_id)
                        ->orderBy('photo_id','desc');
                $total_records=$photos_res->count();
                     $photos_res=$photos_res->skip($offset) 
                        ->take($limit)
                        ->get();
               if($photos_res->isEmpty()){
                   $data['warning'] = '<br/><br/><br/><br/><br/>You have not uploaded any photo(s) yet.<br/><br/<br/><b><span class="upload_span">Click here to upload.</span></b>';
               }else{
                   foreach($photos_res as $r){
                        $data['photos'][] = array("photo"=>Storage::url("photos/".$request->user_id."/".$r->photo),"photo_id"=>$r->photo_id);
                     }
               }
              
                $response = array("status" => "success",'msg'=>'Candidate Photos list' ,'content' => $data , 'total_records'=>$total_records);
           
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
        
            return response()->json($response); 
        }
    }

}   