<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateProfileController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_profile(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'id'          => 'required',              
        ],[ 
            'id.required'   => 'Id is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){
                $user_res= $functions->valid_candidate($request->id,'C');
                if($user_res==0){
                    $response = array("status" => "error",'msg'=>'Invalid User');
                }else{
                    $res=DB::table('users')
                        ->Join('categories','users.cat_id','=','categories.cat_id')
                        ->select(DB::raw('user_id,username,categories.category as cat,gender,city,state,country,email,mobile1,dob,address1,education,bio,profile_pic,active,views'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->get();
        
                    $data=array();
                    foreach($res as $r){
                        $s = array('user_id'=>$r->user_id,'username'=>$r->username,'category'=>$r->cat,'email'=>$r->email,'mobile'=>$r->mobile1,'dob'=>$r->dob,'address'=>$r->address1,'gender'=>$r->gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'education'=>$r->education,'bio'=>$r->bio,'profile_pic'=>$r->profile_pic,'active'=>$r->active,'views'=>$r->views);
                        array_push($data,$s);
                    }  
              
                    $response = array("status" => "success",'msg'=>'Candidate Profile' ,'content' => $data);
            }
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
            return response()->json($response); 
        }
    }

}   