<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Intervention\Image\ImageManagerStatic as Image;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateProfilePicController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function profile_pic(Request $request){
       
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',
            'profile_pic'          => 'required|image|mimes:jpeg,png,jpg,gif,svg',             
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
            'profile_pic.required'		  	=> 'profile_pic is required',         

        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            // $user_status = $functions->_user_check($request->user_id, $request->app_token,$request->user_type); 
            // if($user_status == 1){

                $user = DB::table('users')
                    ->select(DB::raw("*"))
                    ->where('user_id',$request->user_id)
                    ->first();
               
                $path = 'profile_pic/'.$request->user_id;
                $filenametostore = $request->file('profile_pic')->store($path);  
                                
                Storage::setVisibility($filenametostore, 'public');
                $fileArray = explode('/',$filenametostore);  
                $fileName = array_pop($fileArray); 
                $functions->_cropImage(Storage::url($filenametostore),500,500,0,0,$path.'/small',$fileName);
                $functions->_cropImage(Storage::url($filenametostore),500,500,0,0,$path.'/',$fileName);
                //$functions->_createThumb(Storage::url($filenametostore),400,300,$path.'/small',$fileName);
               // $functions->_createThumb(Storage::url($filenametostore),400,710,$path.'/',$fileName);
                $file_path = Storage::url("profile_pic/".$request->user_id."/".$fileName);

                    $data =array(
                        'user_id'       => $request->user_id,
                        'image'         => $fileName
                                                
                    ); 
                    DB::table('user_profile_pics')->insert($data);

                    DB::table('users')
                        ->where('user_id',$request->user_id)
                        ->update(['profile_pic'=>$fileName]);
                       
                    $response = array("status" => "success",'msg'=>'Profile pic uploaded successfully' , 'profile_pic' => $file_path );
                                                        
            // } else{
            //     $response = array("status" => "error","msg"=>"Invalid Token");
            // }
            return response()->json($response); 
        
        }
    }
    
    public function remove_profile_pic(Request $request){
       
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required'  
            
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required'
            
        ]);


        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
           
            DB::table('users')
                ->where('user_id', $request->user_id)
                ->update(['profile_pic' => '']);
            $response = array("status" => "success",'msg'=>'Profile picture removed successfully');
           
            return response()->json($response); 
        }
    }
    
}   