<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateRegisterBasicController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function register_basic(Request $request){
    	//exit;
         $validator = Validator::make($request->all(), [ 
            'first_name'      => 'required',           
            'last_name'       => 'required',
            'email'           => 'required|email|unique:users',
            'password'        => 'required',
            'mobile1'         => 'required',
            //'address1'        => 'required',
            //'category'        => 'required',
            'country'         => 'required',
            'state'           => 'required',
            'city'            => 'required',
            //'zipcode'         => 'required',
            
                                     
        ],[ 
            'first_name.required'   => 'First Name is required',
            'last_name.required'    => 'Last Name is required', 
            'email.required'        => 'Email is required',
            'email.email'		  	=> 'Email id is not valid',
            'password.required'     => 'Password is required',
            'mobile1'               => 'Phone is required',
            //'address1.required'     => 'Address is required',
            //'category.required'     => 'Category is required',
            'country.required'      => 'Country is required',
            'state.required'        => 'State is required',
            'city.required'         => 'City is required',
            //'zipcode.required'      => 'Zipcode is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $user_token= Hash::make($functions->_password_generate(20));
            $can_move_abroad=$request->can_move_abroad;
            $cat= $request->category;
           
            $category="";
            if(is_array($cat)){
	            if(count($cat)>0){
					foreach($cat as $val){
						$category.=",".$val;
					}
					$category=substr($category,1);
				}
			}else{
				$category=$cat;
			}
			
            $data =array(
            'first_name'    => $request->first_name,
            'last_name'     => $request->last_name,
            'username'      => $request->first_name." ".$request->last_name,
            'email'         => $request->email,
            'password'      => Hash::make($request->password),
            'mobile1'       => $request->mobile1,
            //'mobile2'       => $request->mobile2,
            //'address1'      => $request->address1,
            'cat_id'      	=> $category,
            'country'       => $request->country,
            'state'         => $request->state,
            'city'          => $request->city,
            //'zipcode'       => $request->zipcode,
            'user_type'     => $request->user_type,
            'active'        => '1',
            'app_token'     => $user_token,
            'can_move_abroad' => $can_move_abroad
            
        ); 
        DB::table('users')->insert($data);
        $username=$request->first_name." ".$request->last_name;
        $id=DB::getPdo()->lastInsertId();

        $path = $functions->_getUserFolderName($id, "videos");
        $path2 = $functions->_getUserFolderName($id, "photos");
        $path3 = $functions->_getUserFolderName($id, 'profile_pic');
        $t_path = "videos/".$id."/thumb";        
        $folderExists = Storage::exists($t_path);
        if(!$folderExists){
            Storage::makeDirectory($t_path);
        }

        $data  = array( 'user_id' => $id, 'app_token' => $user_token,'username' =>$username );
            $response = array("status" => "success",'msg'=>'Candidate Register STEP 1  successfully' ,'content' => $data);
              
            return response()->json($response); 
        }
    }

}   