<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use App\Mail\Admin\SendMail;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateUpdateProfileStep2Controller extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }


    public function update_profile_step2(Request $request){
       
                $validator = Validator::make($request->all(), [ 
                    'user_id'        => 'required',           
                    'app_token'      => 'required',           
                    'gender'         => 'required',           
                    'language'       => 'required',
                    //'time_zone'      => 'required',
                    'dob'            => 'required',
                    
                ],[ 
                    'user_id.required'        => 'User id is required',
                    'app_token.required'        => 'App Token is required',
                    'gender.required'        => 'Gender is required',
                    'language.required'      => 'Language is required', 
                    //'time_zone.required'     => 'Time Zone field is required',
                    'dob.required'           => 'DOB is required',
                    
                ]);
        
                if (!$validator->passes()) {
                    return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
                }else{
                    $functions = new Functions();
                    //$res= $functions->validate_token($request->user_id,$request->app_token,'C');
                     /*$count=count($request->language);
                     $lang="";
                  for($i=0;$i<$count;$i++){
                      $lang=$lang.",".$request->language[$i];
                  }
                  $langs=substr($lang,1);*/
                  $langs=$request->language;
                  if($request->time_zone==""){
                      $time_zone='';
                  }else{
                      $time_zone=$request->time_zone;
                  }
                  
                    //if($res>0){
                        $data =array(
                            'gender'        => $request->gender,
                            'language'      => $langs,
                            'time_zone'     => $time_zone,
                            'dob'           => date("Y-m-d",strtotime($request->dob)),
                             'bio'          => $request->bio ,
                             'active'  => '1'    
                        ); 
                        DB::table('users')
                        ->where('user_id',$request->user_id)     
                        ->update($data);
                        $can_data= DB::table("users")
                        	->leftjoin("categories",\DB::raw("FIND_IN_SET(categories.cat_id,users.cat_id)"),">",\DB::raw("'0'"))
                            //->leftJoin('categories','categories.cat_id','=','users.cat_id')
				            //->select(DB::raw("user_id,first_name,last_name,username,email,app_token,profile_pic,gender,dob,mobile1,city,state,country,language,bio,views,categories.category as category,user_type as type,active"))
				            ->select("users.*",\DB::raw("GROUP_CONCAT(categories.category) as category"))
				            ->where('users.user_id',$request->user_id)
				            ->where('users.app_token',$request->app_token)
				            ->groupBy("users.user_id")
				            ->first();
				       if($can_data->gender=='F'){
					   	$gender='Female';
					   }else{
					   	$gender='Male';
					   }
                        
                        $mailBody ='<b>Dear '.$can_data->username.'<b><br /><br /> 
                        Register Successfully. Thank you for your valuable time. Your Details are: <br /><br />
						Username  : '.$can_data->username.'<br />
						Email : '.$can_data->email.' <br />
						DOB : '.$can_data->dob.' <br />
						Mobile : '.$can_data->mobile1.' <br />
						City : '.$can_data->city.' <br />
						State : '.$can_data->state.' <br />
						Country : '.$can_data->country.' <br />
					    Gender : '.$gender .' <br />
						Language : '.$can_data->language.' <br />
						Bio : '.$can_data->bio.' <br />
						<br />
						<br />
						Thanks <br />'.env('COMPANY_NAME');
						$array = array('subject'=>' Registration Confirmation at Films Dream','view'=>'emails.email','body' => $mailBody);
               			Mail::to($can_data->email)->send(new SendMail($array)); 
                        
                        $mailBody ='<b>Hi Admin<b><br /><br /> 
                        A new candidate has been registered on app and waiting for approval. Please check all the details.Details are following:
                        Username  : '.$can_data->username.'<br />
						Email : '.$can_data->email.' <br />
						DOB : '.$can_data->dob.' <br />
						Mobile : '.$can_data->mobile1.' <br />
						City : '.$can_data->city.' <br />
						State : '.$can_data->state.' <br />
						Country : '.$can_data->country.' <br />
					    Gender : '.$gender .' <br />
						Language : '.$can_data->language.' <br />
						Bio : '.$can_data->bio.' <br />
						<br />
						<br />
					    <a href="https://www.filmsdream.com/secureAdminArea/candidates/active/"'.$can_data->user_id.'>click here to activate the account</a>';
						$array = array('subject'=>'New Candidate Registration','view'=>'emails.email','body' => $mailBody);
               			Mail::to('pawanbollywood@gmail.com')->send(new SendMail($array)); 
                        if($can_data->profile_pic==""){
							$profile='../../assets/imgs/profile.png';
						}else{
							$profile=Storage::url("profile_pic/".$can_data->user_id."/".$can_data->profile_pic);
						}
                        
                        $data  = array( 'user_id' => $request->user_id, 'app_token' => $request->app_token, 'first_name' => $can_data->first_name,'last_name' => $can_data->last_name,'username'=>$can_data->first_name.' '.$can_data->last_name , 'email' => $can_data->email,'profile_pic'=>$profile,'category'=>$can_data->category,'views'=>$can_data->views,'type'=>$can_data->user_type,'active'=>$can_data->active);
                        $response = array("status" => "success",'msg'=>'Profile updated successfully' ,'content' => $data);
                    //}else{
                     //   $response = array( "status" => "error", "msg" => "Invalid login details" );
                    }
                    
                    return response()->json($response); 
                
                
        }
    

}   