<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use VideoThumbnail;
use App\Mail\Admin\SendMail;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 
use FFMpeg;

class CandidateVideosController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }

    public function videos(Request $request){
    
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'          => 'required', 
            'video'          => 'required|mimes:mp4,mov,ogg,qt',              
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'app_token.required'   => 'App Token is required.',
            'video.required'   => 'Video is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{

        	
            $functions = new Functions();
           

                $path = "videos/".$request->user_id;
              
                $t_path = "videos/".$request->user_id."/thumb";        
                
                $filenametostore = $request->file('video')->store($path);  
                       
                Storage::setVisibility($filenametostore, 'public');
                $fileArray = explode('/',$filenametostore);  
                
                $fileName = array_pop($fileArray); 
               $thumb= explode(".",$fileName);
               $thumb_name=$thumb[0].".jpg";
               $file_path = Storage::url("videos/".$request->user_id."/".$fileName);
              
                //$thumb_path = Storage::url("videos/".$request->user_id."/thumb");
             
                $thumb_path=storage_path("thumb");
                 
                 $thumb_storage_path=$thumb_path.'/'.$thumb_name;
                 $ffmpeg = FFMpeg\FFMpeg::create();
                 $video = $ffmpeg->open($file_path);
                 $frame = $video->frame(FFMpeg\Coordinate\TimeCode::fromSeconds(0));
				 $frame->save($thumb_storage_path);

				 
                /* try{
                    $thumbnail=VideoThumbnail::createThumbnail($file_path, $thumb_path, $thumb_name, 2, 1000, 1000);
                    
                 }catch(Exception $e){
                     dd($e);
                 }*/
                 try{
                    Storage::put("videos/".$request->user_id."/thumb/".$thumb_name, file_get_contents($thumb_storage_path));
                 }catch(Exception $e){
                     dd($e);
                 }
                 
                 unlink(storage_path("thumb/".$thumb_name));
                 $thumb= Storage::url("videos/".$request->user_id."/thumb/".$thumb_name);
                /* Storage::setVisibility($tnumb, 'public');*/
                /*$data =array(
                    'user_id'    => $request->user_id,
                    'video'      => $fileName,
                    'title'      => $title,
                                                       
                ); 
                DB::table('user_videos')->insert($data);*/
                if($request->title==''){
						$title='';
					}else{
						$title=$request->title;
					}
                $data =array(
                    'user_id'    => $request->user_id,
                    'file'      => $fileName,
                    'title'      => $title,
                    'type' 	 	 => 'V',
                    'added_on' => date('Y-m-d H:i:s')                                   
                ); 
                DB::table('posts')->insert($data);
				$array = array('subject'=>'Video file uploading Step6','view'=>'emails.email','body' => "Video file uploading Step6");
                $id=DB::getPdo()->lastInsertId();
                //$data  = array( 'user_id' => $request->user_id, 'video' => $file_path, 'title' => $title);
                $response = array("status" => "success",'msg'=>'Post Uploaded successfully','file'=>$file_path,"post_id"=>$id,"thumb"=>$thumb);
	            return response()->json($response); 
        
        }
    }

    public function video_delete(Request $request){
        $functions = new Functions();
        $res = $functions->validate_token($request->user_id,$request->app_token,'C');
        if($res>0){
            $user_id   = $request->user_id;
            $video_id  = $request->video_id;
            DB::table('user_videos')->where('video_id', $video_id)->where('user_id', $user_id)->delete();
            
            $response = array("status" => "success",'msg'=>'Video Deleted successfully');
        }else{
            $response = array( "status" => "error", "msg" => "Invalid Token");
        }
        return response()->json($response);
    }

    
}   