<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CandidateVideosListController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function candidate_videos_list(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'          => 'required',              
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
        ]);
        
        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'C');
            $string="";
            if($token_res>0){

                  
                        $page=$request->page;
                   
                $limit=10;
                $offset=($page-1)*$limit;
               
                $user_res=DB::table('users')
                        ->Join('categories','categories.cat_id','=','users.cat_id')
                        ->select(DB::raw('users.username as username,users.profile_pic as profile_pic,users.views as views,categories.category as category'))
                       // ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->user_id)
                        ->first();
                       
                        if($user_res->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$request->user_id."/".$user_res->profile_pic);
						}
                        $data=array("username"=>$user_res->username,"category"=>$user_res->category,"views"=>$user_res->views,"profile_pic"=>$p);
                $videos_res=DB::table('users')
                        ->Join('user_videos','users.user_id','=','user_videos.user_id')
                        ->select(DB::raw('user_videos.video as video,user_videos.title as title,user_videos.video_id as video_id'))
                       // ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->user_id)
                         ->orderBy('video_id','desc');
                   $total_records=$videos_res->count();
                   $videos_res=$videos_res->skip($offset) 
                        ->take($limit)
                                
                        ->get();
            
             if($videos_res->isEmpty()){
                   $data['warning'] = '<br/><br/><br/><br/><br/>You have not uploaded any video(s) yet.<br/><br/<br/><b><span class="upload_span">Click here to upload.</span></b>';
               }else{
                    foreach($videos_res as $r){
                        $thumb=explode(".",$r->video);
                        $thumb_name=$thumb[0].".jpg";
                        $data['videos'][] = array("video"=>Storage::url("videos/".$request->user_id."/".$r->video),"video_id"=>$r->video_id,"thumb"=>Storage::url("videos/".$request->user_id."/thumb/".$thumb_name),"title"=>$r->title);
                     }
               }
                $response = array("status" => "success",'msg'=>'Candidate Videos List' ,'content' => $data,'total_records'=>$total_records);
            
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
        
            return response()->json($response); 
        }
    }

}   