<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class CategoryController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function category_list(Request $request){
     $validator = Validator::make($request->all(), [ 
            'type'      => 'required',           
                                                 
        ],[ 
            'type.required'   => 'Type is required',

        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
        	 $data=array();
        	if($request->type=='V'){
        	    $data=array('cat_id'=>0,'cat_name'=>'');
				$response = array("status" => "success",'msg'=>'category listed successfully' ,'content' => $data);
			}else{
                $res=   DB::table('categories')
                 ->select(DB::raw('cat_id,category'))
                 ->where('type',$request->type)
                ->orderBy('rank','ASC')
                ->get();
               
                foreach($res as $r){
                    $s = array('cat_id'=>$r->cat_id,'cat_name'=>$r->category);
                    array_push($data,$s);
                }
               $response = array("status" => true, 'msg'=>'category listed successfully' ,'content' => $data);
			}
            
            return response()->json($response); 
        
        }
    }
    public function getCategory(Request $request){
    
       /* $res=   DB::table('categories')
         ->select(DB::raw('category'))
         ->where('cat_id',$request->cat_id)
        ->first();*/
        $cat=explode(",",$request->cat_id);
    $res=   DB::table('categories')
         ->select(DB::raw("GROUP_CONCAT(category) as cat_name"))
         ->whereIn('cat_id',$cat)
         ->first();

   
   $response = array("status" => "success",'msg'=>'category selected successfully' ,'cat_name'=>$res->cat_name);

return response()->json($response); 

}

}   