<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ChangePasswordController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }  


    public function change_password(Request $request){
        
    	$validator = Validator::make($request->all(), [       
    	     'user_id'         => 'required',           
            'app_token'       => 'required',
            'old_password'           => 'required',           
            'new_password'           => 'required|same:confirm_password',
            'confirm_password'       => 'required'
        ],[         
             'user_id.required'	  	=> 'User Id is required',
        	'app_token.required'	=> 'App Token is required',
        	'old_password.required'	    	=> 'Old Password is required',
        	'new_password.email'		  	=> 'New Password is not valid',         
        	'confirm_password.required'	    => 'Confirm Password is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
                $token_res= $functions->validate_token($request->user_id,$request->app_token);
                if($token_res>0){
                    $user = DB::table('users')
                        ->select(DB::raw("*"))
                        ->where('user_id',$request->user_id)
                        ->first();
    
                    if (Hash::check($request->old_password, $user->password)) { 
                        
                        DB::table('users')
                            ->where('user_id',$request->user_id)
                            ->update(['password'=>Hash::make($request->new_password)]);
                           
                        $response = array("status" => "success",'msg'=>'Password changed successfully');
                    } else {                    
                        $response = array("status" => "error","msg"=>"Old password is incorrect");
                    }  
                }  else{
                    $response = array("status" => "error",'msg'=>'Invalid Token');
                }   
           
                return response()->json($response);   
        }
    }
    

}   