<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Events\ConversationEvent;
use App\Helpers\Common\Functions;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;
use App\Http\Resources\ApiConversationResource;
use App\User;
use App\Models\Conversation;
use Notification;
use App\Notifications\UserNotification;
class ConversationController extends Controller
{

    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string .= $key . "\n";
        }
        return $error_string;
    }

    public function checkIfExist(Request $request)
    {
        $validator = Validator::make($request->all(), [
            'user_id'          => 'required'
        ], [
            // 'login_id.required' => 'Login Id is required',
            'user_id.required' => 'User Id is required',
            // 'app_token.required' => 'app token is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status' => 'error', 'msg' => $this->_error_string($validator->errors()->all())]);
        } else {
            if (auth()->guard('api')->user()) {
                $user_to = $request->user_id;
                $user_from = auth()->guard('api')->user()->user_id;
                // dd($user_to);
                $chkIfExist = DB::table('chat_conversations')
                    ->whereRaw(DB::raw("((user_from= $user_from and user_to= $user_to ) or (user_from=$user_to and user_to= $user_from ) )"))
                    ->first();
                
                if (!$chkIfExist) {
                    $chkChatRequest = DB::table('chat_requests')
                    ->whereRaw(DB::raw("((from_id= $user_from and to_id= $user_to ) or (from_id=$user_to and to_id= $user_from ) )"))
                    ->orderBy("request_id","desc")
                    ->first();
                    if($chkChatRequest){
                        $status = $chkChatRequest->status;
                        if($status=="P" && $chkChatRequest->from_id==$user_from){
                            $respStatus = "P";
                            return response()->json(['status'=>false,'status_type'=>$respStatus]);
                        }elseif($status=="A"){
                            $conversation_id = DB::table('chat_conversations')->insertGetId([
                                'user_from' => $chkChatRequest->from_id,
                                'user_to' => $user_from,
                                'created_at' => date('Y-m-d H:i:s'),
                                'updated_at' => date('Y-m-d H:i:s'),
                            ]);
        
                            $con = Conversation::/*whereHas('chats',function($q) use($login_id){
                                $q->whereHas('message',function($q) use($login_id){
                                    $q->where('user_id',$login_id);
                                });
                            })*/with(array('messages_list' => function ($q) {
                                $q->orderBy('created_at', 'DESC');
                                $q->limit(1);
                            }))
                            ->withCount('messages_list')
                            ->select(DB::raw("chat_conversations.*,(SELECT COUNT(IFNULL(chat_chats.read_at,0)) from chat_chats where IFNULL(chat_chats.read_at,0)=0 and chat_chats.type=0 and chat_chats.user_id!=$user_from and chat_conversations.id=chat_chats.conversation_id) as isRead,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on"))
                            // ->selectRaw("chat_conversations.*, (SELECT chat_chats.read_at from chat_chats where chat_chats.user_id!=$user_id and chat_conversations.id=chat_chats.conversation_id) as count,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on")
                            ->where("chat_conversations.id",$conversation_id)
                            ->orderBy("latest_message_on", "DESC")->first();
                            
                            $conversation = [];
                            
                            $user_from = $con->user_from;
                            $user_to = $con->user_to;
                            if ($user_from == auth()->guard('api')->user()->user_id) {
                                $from_user = $user_to;
                            } else {
                                $from_user = $user_from;
                            }
        
                            $userDpPath = asset(Storage::url('profile_pic'));
                            $user = DB::table('users')->select(DB::raw("*,case when profile_pic !='' THEN case when INSTR(profile_pic,'https://') > 0 THEN profile_pic ELSE concat('" . $userDpPath . "/',user_id,'/small/',profile_pic)  END ELSE '' END as profile_pic"))
                                    ->where('user_id', $from_user);
                            $user=$user->first();
                            if($user){
                                $conversation['id'] = $con->id;
                                $conversation['user_id'] = $user->user_id;
                                $conversation['person_name'] = $user->first_name . ' ' . $user->last_name;
                                $conversation['username'] = $user->username;
                                $conversation['user_dp'] = $user->profile_pic;
                                $conversation['message'] = $con->messages_list->first() !=null ? $con->messages_list->first()->msg : "";
                                $conversation['messages'] = [];
                                $conversation['total_messages'] = $con->messages_list_count;
                                $conversation['isRead'] = $con->isRead;
                                $conversation['time '] = "";
                            }
                            return response()->json(['status'=>true,'conversation'=>$conversation]);
                            
                        }elseif($status=="R"){
                            return response()->json(['status'=>false,'status_type'=>'R']);
                        }else{
                            // show request
                            $respStatus = "SR";
                            $r=DB::table('users as u')
                            // ->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                            ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
                            ->join('chat_requests as r', 'r.from_id', 'u.user_id')
                            ->select(DB::raw('u.user_id as user_id,u.username as username,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,GROUP_CONCAT(c.category) as cat,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic,r.request_id as request_id,r.request_on'))
                            ->where('r.status','P')
                            ->where('r.to_id',$user_from)
                            ->where('r.from_id',$request->user_id);
                            $where_key="";
                            $r=$r->groupBy('u.user_id','u.username','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic','u.dob','r.request_id','r.request_on')
                            ->orderBy('r.request_id','desc')
                            ->first();
                            
                            
    	                     if($r->profile_pic==""){
    								if($r->gender=="M"){
	                     	            $p=secure_asset('assets/images/avatar-man.png');    
    	                     	    }else if($r->gender=="F"){
    	                     	        $p=secure_asset('assets/images/avatar-woman.png');    
    	                     	    }else{
    	                     	        $p=secure_asset('assets/images/profile.png');
    	                     		}
							}else{
								$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
							}
							if($r->gender=='F'){
								$gender='Female';
							}else{
								$gender='Male';
							}
            	                $chat_request = array('id'=>$r->user_id,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>(int) $r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p,'request_id'=>$r->request_id,'request_on'=>$r->request_on);
            	                return response()->json(['status'=>false,'status_type'=>$respStatus,'chat_request'=>$chat_request]);
                            }
                        
                    }else{
                        // request not sent
                        $respStatus="N";
                        return response()->json(['status'=>false,'status_type'=>$respStatus]);
                    }

                    // broadcast(new ConversationEvent($modifiedConversation, $user_from));
                } else {
                    $conversation_id = $chkIfExist->id;

                    $con = Conversation::/*whereHas('chats',function($q) use($user_from){
                        $q->whereHas('message',function($q) use($user_from){
                            $q->where('user_id',$user_from);
                        });
                    })->*/with(array('messages_list' => function ($q) {
                        $q->orderBy('created_at', 'DESC');
                        $q->limit(1);
                    }))->
                    withCount('messages_list')
                    ->selectRaw("chat_conversations.*,(SELECT COUNT(IFNULL(chat_chats.read_at,0)) from chat_chats where IFNULL(chat_chats.read_at,0)=0 and chat_chats.type=0 and chat_chats.user_id!=$user_from and chat_conversations.id=chat_chats.conversation_id) as isRead,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on")
                    // ->selectRaw("chat_conversations.*, (SELECT chat_chats.read_at from chat_chats where chat_chats.user_id!=$user_id and chat_conversations.id=chat_chats.conversation_id) as count,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on")
                    ->where("chat_conversations.id",$conversation_id)
                    ->orderBy("latest_message_on", "DESC")->first();
                    
                    $conversation = [];
                    
                    $user_from = $con->user_from;
                    $user_to = $con->user_to;
                    if ($user_from == auth()->guard('api')->user()->user_id) {
                        $from_user = $user_to;
                    } else {
                        $from_user = $user_from;
                    }

                    $userDpPath = asset(Storage::url('profile_pic'));
                    $user = DB::table('users')->select(DB::raw("*,case when profile_pic !='' THEN case when INSTR(profile_pic,'https://') > 0 THEN profile_pic ELSE concat('" . $userDpPath . "/',user_id,'/small/',profile_pic)  END ELSE '' END as profile_pic"))
                            ->where('user_id', $from_user);
                    $user=$user->first();
                    if($user){
                        $conversation['id'] = $con->id;
                        $conversation['user_id'] = $user->user_id;
                        $conversation['person_name'] = $user->first_name . ' ' . $user->last_name;
                        $conversation['username'] = $user->username;
                        $conversation['user_dp'] = $user->profile_pic;
                        $conversation['message'] = "";
                        $conversation['message'] = $con->messages_list->first() !=null ? $con->messages_list->first()->msg : "";
                        $conversation['total_messages'] =$con->messages_list_count;
                        $conversation['isRead'] = $con->isRead;
                        $conversation['time '] = "";
                    }
                    return response()->json(['status'=>true,'conversation'=>$conversation]);
                }
                
            }else{
                return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
            }
            // return $modifiedConversation;
        }
    }

    public function getConversations(Request $request)
    {
            if (auth()->guard('api')->user()) {
            $user_id=auth()->guard('api')->user()->user_id;
                
            //   $conversations = DB::table('chat_conversations')
            //                     ->select(DB::raw('chat_conversations.id as id,CASE WHEN IFNULL(cc.read_at,0) <> 0 THEN 1 ELSE 0 END as isRead ,chat_conversations.user_from as user_from,chat_conversations.user_to as user_to,max(chat_messages.id) as last_msg,chat_messages.msg as msg,chat_messages.created_at as time'))
            //                     ->leftJoin('chat_messages', function ($join) {
            //                         $join->on('chat_conversations.id', '=', 'chat_messages.conversation_id')
            //                         ->orderBy('chat_messages.id','desc');
            //                       // ->having(DB::raw('max(chat_messages.id)'));
            //                         // ->orderBy(DB::raw('max(chat_messages.id)'))
            //                         // ->first();
            //                     })
            //                     ->leftJoin('chat_chats as cc','cc.message_id','chat_messages.id')
            //                     ->orderBy('chat_messages.id','desc')
            //                     // ->groupBy('chat_messages.conversation_id')
            //                     ->whereRaw(DB::raw("chat_conversations.user_from= $user_id or chat_conversations.user_to= $user_id"));
            //                 $count = $conversations->count();
            //                 $conversations = $conversations->paginate(10);
        
            $conversations = Conversation::/*whereHas('chats',function($q) use($user_id){
                    $q->whereHas('message',function($q) use($user_id){
                        $q->where('user_id',$user_id);
                    });
                })*/with(array('messages_list' => function ($q) {
                    $q->orderBy('created_at', 'DESC');
                    $q->limit(1);
                }))
                // ->withCount('messages_list')
                ->selectRaw("chat_conversations.*,(SELECT COUNT(IFNULL(chat_chats.read_at,0)) from chat_chats where IFNULL(chat_chats.read_at,0)=0 and chat_chats.type=0 and chat_chats.user_id!=$user_id and chat_conversations.id=chat_chats.conversation_id) as isRead,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on")
                // ->selectRaw("chat_conversations.*, (SELECT chat_chats.read_at from chat_chats where chat_chats.user_id!=$user_id and chat_conversations.id=chat_chats.conversation_id) as count,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on")
                ->whereRaw(DB::raw("(chat_conversations.user_from=$user_id or chat_conversations.user_to=$user_id)"))
                ->orderBy("latest_message_on", "DESC");
            $count = $conversations->count();
             if($request->search !="") {
                 $conversations = $conversations->get();
             }else{
                 $conversations = $conversations->paginate(10);
             }
        
            // dd($conversations);

            $conversation = [];
            $conver =[];
            foreach ($conversations as $con) {
                // $conversation=$con;
                
                // print_r($con->all());
                // print_r($con->messages_list_count);
                // print_r($con->messages_list->all());
                // echo "<br/>";
                $user_from = $con->user_from;
                $user_to = $con->user_to;
                if ($user_from == $user_id) {
                    $from_user = $user_to;
                } else {
                    $from_user = $user_from;
                }

                $userDpPath = asset(Storage::url('public/profile_pic'));
                $user = DB::table('users')->select(DB::raw("*,case when profile_pic !='' THEN case when INSTR(profile_pic,'https://') > 0 THEN profile_pic ELSE concat('" . $userDpPath . "/',user_id,'/small/',profile_pic)  END ELSE '' END as profile_pic"))
                            ->where('user_id', $from_user);
                    if($request->search !="") {
					    $searchString = $request->search;
					    $user=$user->whereRaw(DB::raw("( ( username like '%".$searchString."%' ) or ( concat(first_name,' ',last_name) like '%".$searchString."%') )" ));
					}
                            $user=$user->first();
                // $custom = collect(['user' => $user]);
                if($user){
                    
                    $conversation['id'] = $con->id;
                    $conversation['user_id'] = $user->user_id;
                    $conversation['person_name'] = $user->first_name . ' ' . $user->last_name;
                    $conversation['username'] = $user->username;
                    $conversation['user_dp'] = $user->profile_pic;
                    $conversation['message'] = $con->messages_list->first() !=null ? $con->messages_list->first()->msg : "";
                    $conversation['isRead'] = $con->isRead;
                    $conversation['total_messages'] = $con->messages_list_count;
                    // $conversation['time '] = \Carbon\Carbon::parse($con->time)->diffForHumans();
                    $conversation['time '] = $con->messages_list->first() !=null ?$con->messages_list->first()->created_at :"";
                    // $conversation['time '] = (!empty($con->messages_list)) ? \Carbon\Carbon::parse($con->messages_list->first()->created_at)->diffForHumans(): "";
                    // $conversation = $custom->merge($conversation);
                    $conver[]=$conversation;
                }
            }
            
            
            return response()->json(['status' => true, 'data' => $conver, 'totalRecords' => $count]);
            // dd(ConversationListResource::collection($conversation));
        }else{
		        $response = array("status" => false,'msg'=>'Sorry! Unauthorized access');
		        return response()->json($response);
        }
    }
    
    public function getOnlineUsers(Request $request){
        if(auth()->guard('api')->user()){
            $ids=explode(',',$request->ids);
            $user_ids=array_slice($ids, 0, 20);
            $user_id=auth()->guard('api')->user()->user_id;
            $users= User::whereIn('user_id',$user_ids)
                        ->where('user_id','!=',$user_id)
                        ->get();
            $data=array();
              
           foreach($users as $user){
                 $res=array();
                 if($user->user_dp!=""){
                    if(stripos($user->user_dp,'https://')!==false){
        				$file_path=$user->user_dp;
        				$small_file_path=$user->user_dp;
        			}else{
        				$file_path = asset(Storage::url('public/profile_pic/'.$user->user_id."/".$user->user_dp));
        				$small_file_path = asset(Storage::url('public/profile_pic/'.$user->user_id."/small/".$user->user_dp));
        				
        				if($file_path==""){
        					$file_path=asset('default/default.png');
        				}
        				if($small_file_path==""){
        					$small_file_path=asset('default/default.png');
        				}
        			}
                 }else{
                     $file_path="";
                 }
			
               $res['id']=$user->user_id;
               $res['name']=$user->fname.' '.$user->lname;
               $res['user_dp']=$file_path;
               array_push($data,$res);
           }
           $response = array( "status" => "success", "data" => $data );
        //   dd($data);
        }else{
            $response = array( "status" => "failed", "msg" => "Invalid user!" );
        }
        return response()->json($response); 
    } 
    
    public function chatUsers(Request $request){
		
			if(auth()->guard('api')->user()){
			    $login_id=auth()->guard('api')->user()->user_id;
			    $userDpPath = asset(Storage::url('public/profile_pic'));
				$limit = 10;
				$user=User::find($login_id);
			
				if($user->chat_with=='FL'){
    				//following
    				$users = DB::table("users as u")
    				->select(DB::raw("u.user_id,
    					case when u.user_dp !='' THEN case when INSTR(u.user_dp,'https://') > 0 THEN u.user_dp ELSE concat('".$userDpPath."/',u.user_id,'/small/',u.user_dp)  END ELSE '' END as user_dp,
    					concat('@',u.username) as username,u.fname,u.lname"))
    					->leftJoin('follow as f', function ($join) use ($request,$login_id){
    						$join->on('u.user_id','=','f.follow_to')
    						->where('f.follow_by',$login_id);
    					})
    					->leftJoin('follow as f2', function ($join) use ($request,$login_id){
    						$join->on('u.user_id','=','f2.follow_by')
    						->where('f2.follow_to',$login_id);
    					});
    					$users = $users->whereRaw( DB::Raw(' f.follow_id is NOT null or f2.follow_id is NOT null '));
    					if($login_id > 0) {
    						$users = $users->leftJoin('blocked_users as bu', function ($join)use ($request,$login_id){
    							$join->on('u.user_id','=','bu.user_id');
    							$join->whereRaw(DB::raw(" ( bu.blocked_by=".$login_id." )" ));
    						});
    	
    						$users = $users->leftJoin('blocked_users as bu2', function ($join)use ($request,$login_id){
    							$join->on('u.user_id','=','bu2.blocked_by');
    							$join->whereRaw(DB::raw(" (  bu2.user_id=".$login_id." )" ));
    						});
    	
    						$users = $users->whereRaw( DB::Raw(' bu.block_id is null and bu2.block_id is null '));
    					}
    					
    					if($request->search !="") {
    					    $searchString = $request->search;
    					    $users=$users->whereRaw(DB::raw("( ( u.username like '%".$searchString."%' ) or ( concat(u.fname,' ',u.lname) like '%".$searchString."%') )" ));
    					}
    				
    				// 	$users=$users->where('f.follow_to','<>', $login_id);
    				// 	$users=$users->where('f.follow_by', $login_id);
    					$users=$users->where("u.deleted",0)
    					->where("u.active",1);
    				
    			
    				$users = $users->orderBy('u.user_id','desc')->groupBy('u.user_id');
    				$users= $users->paginate($limit);   
    				// dd($users);
				}else{
    				//followers
    				$users = DB::table("users as u")->select(DB::raw("u.user_id,
    					case when u.user_dp !='' THEN case when INSTR(u.user_dp,'https://') > 0 THEN u.user_dp ELSE concat('".$userDpPath."/',u.user_id,'/small/',u.user_dp)  END ELSE '' END as user_dp,
    					concat('@',u.username) as username,u.fname,u.lname"))
    				->leftJoin('follow as f', function ($join) use ($request){
    					$join->on('u.user_id','=','f.follow_by');
    				// 	->where('f.follow_to',$request->login_id);
    				});
    				// ->leftJoin('follow as f2', function ($join) use ($request,$login_id){
    				// 		$join->on('u.user_id','=','f2.follow_to')
    				// 		->where('f2.follow_by',$login_id);
    				// 	});
    				if($login_id > 0) {
                        $users = $users->leftJoin('blocked_users as bu', function ($join)use ($request,$login_id){
                            $join->on('u.user_id','=','bu.user_id');
                            $join->whereRaw(DB::raw(" ( bu.blocked_by=".$login_id." )" ));
                        });
    
                        $users = $users->leftJoin('blocked_users as bu2', function ($join)use ($request,$login_id){
                            $join->on('u.user_id','=','bu2.blocked_by');
                            $join->whereRaw(DB::raw(" (  bu2.user_id=".$login_id." )" ));
                        });
    
                        $users = $users->whereRaw( DB::Raw(' bu.block_id is null and bu2.block_id is null '));
                    }
                    if($request->search !="") {
    					    $searchString = $request->search;
    					    $users=$users->whereRaw(DB::raw("( ( u.username like '%".$searchString."%' ) or ( concat(u.fname,' ',u.lname) like '%".$searchString."%') )" ));
    					}
                    $users=$users->where('f.follow_by','<>', $login_id);
    				$users=$users->where('f.follow_to', $login_id);
    				$users=$users->where("u.deleted",0)
    				->where("u.active",1);
    				
    				$users = $users->orderBy('u.user_id','desc');
    				$users= $users->paginate($limit);
				}
				$total_records=$users->total();   
				
				$response = array("status" => "success",'data' => $users,'total_records'=>$total_records);
			}else{
			    return response()->json([
                    "status" => "error", "msg" => "Unauthorized user!"
                ]);
			}
		
		
		return response()->json($response); 
	
	}
	
	
	// chat request
	public function show_interest(Request $request){
        $validator = Validator::make($request->all(), [
            'candidate_id'     => 'required', 
        ],[ 
            'candidate_id.required'  => 'Candidate id is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
            
            if(auth()->guard('api')->user()){
			    $login_id=auth()->guard('api')->user()->user_id;
    			$ins_data['request_on'] = date("Y-m-d H:i:s");
    			$ins_data['from_id'] = $login_id;
    			$ins_data['to_id'] = $request->candidate_id;
    			$ins_data['status'] = "P";
    			DB::table('chat_requests')->insert($ins_data);

                $res=DB::table('users')
                    ->select(DB::raw('fcm_token'))
                    ->where('user_id', $request->candidate_id)
                    ->first();
    			

                $res_from=DB::table('users')
                    ->select(DB::raw('username'))
                    ->where('user_id', $login_id)
                    ->first();

    			
                $not_data['created_on'] = date("Y-m-d H:i:s");
                $not_data['sent_to'] = $request->candidate_id;
                $not_data['title'] = $res_from->username." showed interest in your profile";
                $not_data['page_name'] = "chat-requests";
                $not_data['post_id'] = "0";
                $not_data['sent_by'] = $login_id;
                DB::table('notifications')->insert($not_data);
                try{
                    $param=array();
                    $param = ['type' => 'chat-request'];
                    if($res->fcm_token!=""){
                        $title="NEW INTEREST RECEIVED";
                        $message=$res_from->username." showed interest in your profile";
                        $image='';
                        // Notification::send(null,new UserNotification("NEW INTEREST RECEIVED",$res_from->username." showed interest in your profile",null,$param,[$res->fcm_token]));
                        $user=User::where('user_id',$res->user_id)->first();  
                        $user->notify(new UserNotification($title, $message, $image, $param));
                    }
                } catch (\Exception $e) {
                }
            //     if($res->player_id!=""){
	           //     $functions = new Functions();
	           //     $functions->send_notification_both($res->player_id, $res_from->username." showed interest in your profile","NEW INTEREST RECEIVED");
	           // }
	            $response = array("status" => true,'msg'=>'Request sent successfully');
		        return response()->json($response);
    		}else{
		        $response = array("status" => false,'msg'=>'Sorry! Unauthorized access');
		        return response()->json($response);
			}
    	}
	}

	public function update_request_status(Request $request){
        $validator = Validator::make($request->all(), [     
            'request_id'         => 'required',           
            'status'       => 'required',
           
        ],[
        	
        	'status.required'	=> 'Status is required',
        	'request_id.required'	=> 'Request ID is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            
            if(auth()->guard('api')->user()){
			    $login_id=auth()->guard('api')->user()->user_id;
    		
    			$up_data['status'] = $request->status;
    			$up_data['action_on'] = date("Y-m-d H:i:s");
    			DB::table('chat_requests')->where('to_id',$login_id)->where('request_id',$request->request_id)->update($up_data);
    			$chatReq = DB::table('chat_requests')->where('request_id',$request->request_id)->first();
    			if($request->status=="R"){
					$action_label = "rejected";
				}else{
					$action_label = "accepted";
				}

                $res=DB::table('users as u')
                	->join("chat_requests as r", "r.from_id","u.user_id")
                    ->select(DB::raw('u.player_id, u.user_id,u.fcm_token'))
                    ->where('r.request_id', $request->request_id)
                    ->first();
    			
                $res_from=DB::table('users')
                    ->select(DB::raw('username,user_id'))
                    ->where('user_id', $login_id)
                    ->first();
				
                
            //     if($res->player_id!=""){
	           //     $functions = new Functions();
	           //     $functions->send_notification_both($res->player_id, $res_from->username." $action_label your chat request","CHAT REQUEST ".strtoupper($action_label));
	           // }				
				if($request->status=="A"){
				    $conversation_id = DB::table('chat_conversations')->insertGetId([
                        'user_from' => $chatReq->from_id,
                        'user_to' => $login_id,
                        'created_at' => date('Y-m-d H:i:s'),
                        'updated_at' => date('Y-m-d H:i:s'),
                    ]);
                    
                    $not_data['created_on'] = date("Y-m-d H:i:s");
                    $not_data['sent_to'] = $res->user_id;
                    $not_data['title'] = $res_from->username." $action_label your chat request";
                    $not_data['page_name'] = "sent-requests";
                    $not_data['post_id'] = "0";
                    $not_data['sent_by'] = $login_id;
                    DB::table('notifications')->insert($not_data);
                    try{
                        $param=array();
                        $param = ['id' => strval($conversation_id), 'type' => 'chat','user_id' => strval($res_from->user_id)];
                        if($res->fcm_token!=""){
                            $title="CHAT REQUEST ".strtoupper($action_label);
                            $message=$res_from->username." $action_label your chat request";
                            $image='';
                            // Notification::send(null,new UserNotification("CHAT REQUEST ".strtoupper($action_label),$res_from->username." $action_label your chat request",null,$param,[$res->fcm_token]));
                            $user=User::where('user_id',$res->user_id)->first();  
                            $user->notify(new UserNotification($title, $message, $image, $param));
                        }
                    } catch (\Exception $e) {
                    }
                    $con = Conversation::/*whereHas('chats',function($q) use($login_id){
                        $q->whereHas('message',function($q) use($login_id){
                            $q->where('user_id',$login_id);
                        });
                    })->*/with(array('messages_list' => function ($q) {
                        $q->orderBy('created_at', 'DESC');
                        $q->limit(30);
                    }))
                    ->select(DB::raw("chat_conversations.*,(SELECT COUNT(IFNULL(chat_chats.read_at,0)) from chat_chats where IFNULL(chat_chats.read_at,0)=0 and chat_chats.type=0 and chat_chats.user_id!=$login_id and chat_conversations.id=chat_chats.conversation_id) as isRead,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on"))
                    // ->selectRaw("chat_conversations.*, (SELECT chat_chats.read_at from chat_chats where chat_chats.user_id!=$user_id and chat_conversations.id=chat_chats.conversation_id) as count,(SELECT MAX(created_at) from chat_messages WHERE chat_messages.conversation_id=chat_conversations.id) as latest_message_on")
                    ->where("chat_conversations.id",$conversation_id)
                    ->orderBy("latest_message_on", "DESC")->first();
                    
                    $conversation = [];
                    
                    $user_from = $con->user_from;
                    $user_to = $con->user_to;
                    if ($user_from == auth()->guard('api')->user()->user_id) {
                        $from_user = $user_to;
                    } else {
                        $from_user = $user_from;
                    }

                    $userDpPath = asset(Storage::url('profile_pic'));
                    $user = DB::table('users')->select(DB::raw("*,case when profile_pic !='' THEN case when INSTR(profile_pic,'https://') > 0 THEN profile_pic ELSE concat('" . $userDpPath . "/',user_id,'/small/',profile_pic)  END ELSE '' END as profile_pic"))
                            ->where('user_id', $from_user);
                    $user=$user->first();
                    if($user){
                        $conversation['id'] = $con->id;
                        $conversation['user_id'] = $user->user_id;
                        $conversation['person_name'] = $user->first_name . ' ' . $user->last_name;
                        $conversation['username'] = $user->username;
                        $conversation['user_dp'] = $user->profile_pic;
                    $conversation['message'] = $con->messages_list->first() !=null ? $con->messages_list->first()->msg : "";
                        $conversation['messages'] = [];
                        $conversation['total_messages'] = 0;
                        $conversation['isRead'] = $con->isRead;
                        $conversation['time '] = "";
                    }
                    return response()->json(['status'=>true,'conversation'=>$conversation]);
                    
				}else{
				    return response()->json(['status'=>false]);
				}
				
    		}else{
		        $response = array("status" => false,'msg'=>'Sorry! Unauthorized access');
		        return response()->json($response);
			}
        }
		
	}
    public function chat_request_list(Request $request){
        if (!auth()->guard('api')->user()) {
            return response()->json([
                "status" => false, "msg" => "Unauthorized user!"
            ]);
        }else{
            $login_id = auth()->guard('api')->user()->user_id;
            $res=DB::table('users as u')
            //->leftJoin('categories as c','u.cat_id','=','c.cat_id')
            ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
            ->join('chat_requests as r', 'r.from_id', 'u.user_id')
            ->select(DB::raw('u.user_id as user_id,u.username as username,GROUP_CONCAT(c.category) as cat,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic,r.request_id as request_id'))
            ->where('r.status','P')
            ->where('r.to_id',$login_id);
            if(!isset($request->page) && $request->page==""){
                $page=1;
            }else{
                $page=$request->page;
            }
            $limit=10;
            $offset=($page-1)*$limit;
            $where_key="";
            if(isset($request->keyword) && $request->keyword!=""){
                $key_arr=explode(",",$request->keyword);
                foreach ($key_arr as $val){
                $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                }
                $where_key=$res->whereRaw("(".substr($where_key,3).")");
                $res=$where_key;
            }
            $res=$res->groupBy('u.user_id','u.username','u.dob','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic','r.request_id')->orderBy('r.request_id','desc')
            ->paginate($limit);
            $total_records=$res->total();
            $data=array();
            if (!$res->isEmpty()){
                foreach($res as $r){
                    if($r->profile_pic==""){
							if($r->gender=="M"){
							    $p=secure_asset('assets/images/avatar-man.png');
							}else if($r->gender=="F"){
							    $p=secure_asset('assets/images/avatar-woman.png');
							}else{
							    $p=secure_asset('assets/images/profile.png');
							}
					}else{
					    if (stripos($r->profile_pic, 'https://') !== false) {
                            $p = $r->profile_pic;
                        } else {
                            $p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
                        }
						
					}
					if($r->gender=='F'){
						$gender='Female';
					}else{
						$gender='Male';
					}
                    $s = array('id'=>$r->user_id,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>$r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p,'request_id'=>$r->request_id);
                    array_push($data,$s);
            	}
            }else{
               $data=array();
            }
            $response = array("status" => true,'msg'=>'Chat Request List filtered successfully' ,'data' => $data,'total_records'=> $total_records);
            return response()->json($response); 
        }		
	}
    public function sent_requests(Request $request){
        if (!auth()->guard('api')->user()) {
            return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
        }else{
            $login_id=auth()->guard('api')->user()->user_id;
            $res=DB::table('users as u')
                //->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
                ->join('chat_requests as r', 'r.to_id', 'u.user_id')
                ->select(DB::raw('u.user_id as user_id,u.username as username,GROUP_CONCAT(c.category) as cat,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic,r.request_id as request_id, r.status'))
                ->where('r.from_id',$login_id);
                
                if(!isset($request->page) && $request->page==""){
                    $page=1;
                }else{
                    $page=$request->page;
                }
                $limit=10;
                $offset=($page-1)*$limit;
            $where_key="";
            if(isset($request->keyword) && $request->keyword!=""){
                $key_arr=explode(",",$request->keyword);
                foreach ($key_arr as $val){
                $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                }
                $where_key=$res->whereRaw("(".substr($where_key,3).")");
                $res=$where_key;
            }
             $res=$res->groupBy('u.user_id','u.dob','u.username','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic','r.request_id','r.status');
             if(isset($request->src)){
                 $res=$res->orderByRaw(DB::raw("r.action_on desc, r.request_id desc"));
             }else{
				$res=$res->orderByRaw(DB::raw("r.request_id desc"));
			 }
             $res=$res->paginate($limit);
             
            $total_records=$res->total();
                
            
            $data=array();
            if (!$res->isEmpty()){
                foreach($res as $r){
                     if($r->profile_pic==""){
						if($r->gender=="M"){
						    $p=secure_asset('assets/images/avatar-man.png');
						}else if($r->gender=="F"){
						    $p=secure_asset('assets/images/avatar-woman.png');
						}else{
						    $p=secure_asset('assets/images/profile.png');
						}
					}else{
						if (stripos($r->profile_pic, 'https://') !== false) {
                            $p = $r->profile_pic;
                        } else {
                            $p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
                        }
					}
					if($r->gender=='F'){
						$gender='Female';
					}else{
						$gender='Male';
					}
					if($r->status=='P'){
						$status='P';
					}elseif($r->status=='A'){
						$status='A';
					}else{
						$status='R';
					}
                    $s = array('id'=>$r->user_id,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>$r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p,'request_id'=>$r->request_id, 'status'=>$status);
                    array_push($data,$s);
            	}
            }else{
               $data=array();
            }
            
            $response = array("status" => true,'msg'=>'Chat Request List filtered successfully' ,'data' => $data,'total_records'=> $total_records);
           
           /* }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   */ 
            return response()->json($response); 
        
        }		
	}
    public function chat_request(Request $request){
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',    
            'candidate_id'               => 'required', 
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
            'candidate_id.required'  => 'Candidate id is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res = $functions->validate_token($request->user_id, $request->app_token);
    		if($token_res>0){
				$res=DB::table('chat_requests')
		            ->select(DB::raw('status'))
	            	->where("to_id", $request->candidate_id)
	            	->where("from_id", $request->user_id)
		        	->first();
		        if($res){
					$response = array("status" => "success",'chat_status'=>$res->status);
				}else{
					$response = array("status" => "success",'chat_status'=>'');
				}
		        return response()->json($response);    			
    		}else{
		        $response = array("status" => "error",'msg'=>'Sorry! Unauthorized access');
		        return response()->json($response);
			}
        }
	}
	
}
