<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class FilterController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    
    
    public function language_filter(Request $request){
        if(auth()->guard('api')->user()){
            $login_id=auth()->guard('api')->user()->user_id;
        }else{
            $login_id=0;
        }
        $functions = new Functions();
        $blocked_user_res=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
        ->where('blocked_by',$login_id)
        ->first();  
        
        $blocked_user_res2=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
        ->where('user_id',$login_id)
        ->first();        
        
        $res=DB::table('users')
        ->join("languages",\DB::raw("FIND_IN_SET(languages.lang, users.language)"),">",\DB::raw("'0'"))
        ->select(DB::raw('count(languages.id) as total,languages.lang as lang,id'))
        ->where('users.active','1')
        ->where('users.deleted','0')
        ->where('users.user_id','!=',$login_id);
        
        $where_gender="";
        if(isset($request->gender) && $request->gender!=""){
            $gender=substr($request->gender,1);
            $where_gender= $where_gender." or users.gender='".$gender."'";
            $where_gender=$res->whereRaw(substr($where_gender,3));
            $res=$where_gender;
        }
        
        $where_cat="";
        /*if(isset($request->category) && $request->category!=""){
            $category=substr($request->category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
            }
            $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
            $res=$where_cat;
            
        }*/
        if(isset($request->category) && $request->category!=""){
            $category=substr($request->category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
            }
            $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
            $res=$where_cat;   
        }
        
        $where_age = "";
        if(isset($request->age) && $request->age!=""){
            $age=substr($request->age,1);
            $age_arr=explode(",",$age);
            foreach ($age_arr as $val){
                $val_arr = explode("-", $val);
                $where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
            }
            $where_age=$res->whereRaw("(".substr($where_age,3).")");
            $res=$where_age;
        }
        
        $where_loc="";
        
        if(isset($request->location) && $request->location!=""){
            $location=substr($request->location,1);
            $loc_arr=explode(",",$location);
            foreach ($loc_arr as $val){
                $where_loc=$where_loc.' or (users.country ="'.$val.'")';
            }
            $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
            $res=$where_loc;
        }
        if($blocked_user_res->user_id==0){
            
        }else{
            $blocked_res=$blocked_user_res->user_id;
            $blocked_res=explode(',',$blocked_res);
            $res=$res->whereNotIn('users.user_id', $blocked_res);
            
        }
        if($blocked_user_res2->user_id==0){
            
        }else{
            $blocked_res2=$blocked_user_res2->user_id;
            $blocked_res2=explode(',',$blocked_res2);
            $res=$res->whereNotIn('users.user_id', $blocked_res2);
            
        }
        $res=$res->groupBy('languages.lang');
        $res=$res->groupBy('languages.id')
        ->get();
        
        $data=array();
        foreach($res as $r){
            if(strpos(",".$request->language.",", ",".$r->lang.",")!==false){
                $v="true";
            }else{
                $v="false";
            }
            // $s = array('count'=>$r->total,'language'=>$r->lang,'checked' => $v,'id'=>0);
            $s = array('count'=>$r->total,'language'=>$r->lang,'checked' => $v,'id'=>$r->id);
            array_push($data,$s);
        }  
        
        $response = array("status" => true,'msg'=>'Languages filtered successfully' ,'content' => $data);
        
        return response()->json($response); 
        
    }
    public function location_filter(Request $request){
        if(auth()->guard('api')->user()){
            $login_id=auth()->guard('api')->user()->user_id;
        }else{
            $login_id=0;
        }
        $functions = new Functions();
        $blocked_user_res=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
        ->where('blocked_by',$login_id)
        ->first(); 
        $blocked_user_res2=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
        ->where('user_id',$login_id)
        ->first();  
        
        $res=   DB::table('users')
        ->select(DB::raw('count(user_id) as total,country'))
        ->where('active','1')
        ->where('deleted','0')
        ->where('country',"<>",'')
        ->where('user_id','!=',$login_id);
        
        $where_gender="";
        if(isset($request->gender) && $request->gender!=""){
            $gender=substr($request->gender,1);
            $where_gender= $where_gender." or users.gender='".$gender."'";
            $where_gender=$res->whereRaw(substr($where_gender,3));
            $res=$where_gender;
        }
        
        $where_cat="";
        /*if(isset($request->category) && $request->category!=""){
            $category=substr($request->category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
            }
            $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
            $res=$where_cat;
            
        }*/
        if(isset($request->category) && $request->category!=""){
            $category=substr($request->category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
            }
            $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
            $res=$where_cat;   
        }
        
        $where_age = "";
        if(isset($request->age) && $request->age!=""){
            $age=substr($request->age,1);
            $age_arr=explode(",",$age);
            foreach ($age_arr as $val){
                $val_arr = explode("-", $val);
                $where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
            }
            
            $where_age=$res->whereRaw("(".substr($where_age,3).")");
            $res=$where_age;
        }
        
        $where_lan="";
        if(isset($request->language) && $request->language!=""){
            $language=substr($request->language,1);
            $lan_arr=explode(",",$language);
            foreach ($lan_arr as $val){
                $where_lan=$where_lan.' or (users.language like "%'.$val.'%")';
            }
            $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
            $res=$where_lan;
        }
        if($blocked_user_res->user_id==0){
            
        }else{
            $blocked_res=$blocked_user_res->user_id;
            $blocked_res=explode(',',$blocked_res);
            $res=$res->whereNotIn('user_id', $blocked_res);
            
        }
        if($blocked_user_res2->user_id==0){
            
        }else{
            $blocked_res2=$blocked_user_res2->user_id;
            $blocked_res2=explode(',',$blocked_res2);
            $res=$res->whereNotIn('user_id', $blocked_res2);
            
        }
        $res=$res->groupBy('country')
        ->get();
        
        $data=array();
        foreach($res as $r){
            if(strpos(",".$request->location.",", ",".$r->country.",")!==false){
                $v="true";
            }else{
                $v="false";
            }
            $s = array('count'=>$r->total,'country'=>$r->country,'checked'=>$v,'id'=>0);
            array_push($data,$s);
        }  
        
        $response = array("status" => true,'msg'=>'Location filtered successfully' ,'content' => $data);
        
        
        return response()->json($response); 
        
    }
    
    public function age_filter(Request $request){
        if(auth()->guard('api')->user()){
            $login_id=auth()->guard('api')->user()->user_id;
        }else{
            $login_id=0;
        }
        $functions = new Functions();
        $user_id=$login_id;
        
        if($request->gender==""){
            $gender="";
        }else{
            $gender=$request->gender;
        }
        if($request->location==""){
            $location="";
        }else{
            $location=$request->location;
        }
        if($request->language==""){
            $language="";
        }else{
            $language=$request->language;
        }
        if($request->category==""){
            $category="";
        }else{
            $category=$request->category;
        }
        
        
        $label=array();
        $v=array();
        
        $age_res=$this->get_age_res(00,05,$gender,$location,$language,$category,$user_id);
        if($age_res->user_count>0){
            $v['label']='00-05';
            $v['value']='00-05';
            $v['count']=$age_res->user_count;
            if(strpos(",".$request->age.",", ",00-05,")!==false){
                $v['checked']="true";
            }else{
                $v['checked']="false";
            }
            
            array_push($label,$v);
        }
        
        $age_res2=$this->get_age_res(06,10,$gender,$location,$language,$category,$user_id);
        if($age_res2->user_count>0){
            $v['label']='06-10';
            $v['value']='06-10';
            $v['count']=$age_res2->user_count;
            if(strpos(",".$request->age.",", ",06-10,")!==false){
                $v['checked']="true";
            }else{
                $v['checked']="false";
            }
            array_push($label,$v);
        }
        
        $age_res3=$this->get_age_res(11,20,$gender,$location,$language,$category,$user_id);
        if($age_res3->user_count>0){
            $v['label']='11-20';
            $v['value']='11-20';
            $v['count']=$age_res3->user_count;
            if(strpos(",".$request->age.",", ",11-20,")!==false){
                $v['checked']="true";
            }else{
                $v['checked']="false";
            }
            array_push($label,$v);
        }
        
        $age_res4=$this->get_age_res(21,30,$gender,$location,$language,$category,$user_id);
        if($age_res4->user_count>0){
            $v['label']='21-30';
            $v['value']='21-30';
            $v['count']=$age_res4->user_count;
            if(strpos(",".$request->age.",", ",21-30,")!==false){
                $v['checked']="true";
            }else{
                $v['checked']="false";
            }
            array_push($label,$v);
        }
        $age_res5=$this->get_age_res(31,50,$gender,$location,$language,$category,$user_id);
        if($age_res5->user_count>0){
            $v['label']='31-50';
            $v['value']='31-50';
            $v['count']=$age_res5->user_count;
            if(strpos(",".$request->age.",", ",31-50,")!==false){
                $v['checked']="true";
            }else{
                $v['checked']="false";
            }
            array_push($label,$v);
        }
        $age_res6=$this->get_age_res(51,70,$gender,$location,$language,$category,$user_id);
        if($age_res6->user_count>0){
            $v['label']='51-70';
            $v['value']='51-70';
            $v['count']=$age_res6->user_count;
            if(strpos(",".$request->age.",", ",51-70,")!==false){
                $v['checked']="true";
            }else{
                $v['checked']="false";
            }
            array_push($label,$v);
        }
        $age_res7=$this->get_age_res(71,100,$gender,$location,$language,$category,$user_id);
        if($age_res7->user_count>0){
            $v['label']='71-100';
            $v['value']='71-100';
            $v['count']=$age_res7->user_count;
            if(strpos(",".$request->age.",", ",71-100,")!==false){
                $v['checked']="true";
            }else{
                $v['checked']="false";
            }
            
            array_push($label,$v);
        }
        
        
        $response = array("status" => true,'msg'=>'Age filtered successfully' ,'content' => $label);
        
        
        return response()->json($response); 
        
    }
    
    public function get_age_res($min,$max,$gender,$location,$language,$category,$user_id){
        $user = DB::table("users")
        ->select(DB::raw("count(user_id) as user_count"))
        ->where('active','1')
        ->where('deleted','0')
        ->where('user_id','!=',$user_id);
        
        $blocked_user_res=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
        ->where('blocked_by',$user_id)
        ->first(); 
        $blocked_user_res2=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
        ->where('user_id',$user_id)
        ->first();
        $where_gender="";
        if(isset($gender) && $gender!=""){
            $gender=substr($gender,1);
            $where_gender= $where_gender." or gender='".$gender."'";
            $where_gender=$user->whereRaw(substr($where_gender,3));
            $user=$where_gender;
        }
        $where_loc="";
        if(isset($location) && $location!=""){
            $location=substr($location,1);
            $loc_arr=explode(",",$location);
            foreach ($loc_arr as $val){
                $where_loc=$where_loc.' or (country ="'.$val.'")';
            }
            
            $where_loc=$user->whereRaw("(".substr($where_loc,3).")");
            $user=$where_loc;
        }
        $where_lan="";
        if(isset($language) && $language!=""){
            $language=substr($language,1);
            $lan_arr=explode(",",$language);
            foreach ($lan_arr as $val){
                $where_lan=$where_lan.' or (language like "%'.$val.'%")';
            }
            $where_lan=$user->whereRaw("(".substr($where_lan,3).")");
            $user=$where_lan;
        }
        $where_cat="";
        /*if(isset($category) && $category!=""){
            $category=substr($category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
            }
            $where_cat=$user->whereRaw("(".substr($where_cat,3).")");
            $user=$where_cat;
            
        }*/
        if(isset($category) && $category!=""){
            $category=substr($category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
            }
            $where_cat=$user->whereRaw("(".substr($where_cat,3).")");
            $user=$where_cat;   
        }
        if($blocked_user_res->user_id==0){
            
        }else{
            $blocked_res=$blocked_user_res->user_id;
            $blocked_res=explode(',',$blocked_res);
            $user=$user->whereNotIn('user_id', $blocked_res);
            
        }
        if($blocked_user_res2->user_id==0){
            
        }else{
            $blocked_res2=$blocked_user_res2->user_id;
            $blocked_res2=explode(',',$blocked_res2);
            $user=$user->whereNotIn('user_id', $blocked_res2);
            
        }
        $user = $user->whereRaw('round(DATEDIFF(CURRENT_DATE(),dob) / 365) between '. $min .' and '. $max)
        ->first();
        return $user;
    }
    
    public function category_filter(Request $request){
        if(auth()->guard('api')->user()){
            $login_id=auth()->guard('api')->user()->user_id;
        }else{
            $login_id=0;
        }
        $functions = new Functions();
        $blocked_user_res=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
        ->where('blocked_by',$login_id)
        ->first();  
        $blocked_user_res2=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
        ->where('user_id',$login_id)
        ->first();    
        
        /*$res=   DB::table('users')
        ->leftJoin('categories','users.cat_id','=','categories.cat_id')
        ->select(DB::raw('count(users.user_id) as total,users.cat_id as c_id,categories.category as cat'))
        ->where('users.active','1')
        ->where('users.deleted','0')
        ->where('users.cat_id','>','0')
        ->where('users.user_id','!=',$login_id);*/
        $res=   DB::table('users')
        ->leftjoin("categories",\DB::raw("FIND_IN_SET(categories.cat_id, users.cat_id)"),">",\DB::raw("'0'"))
        ->select(DB::raw('count(categories.category) as total,categories.category as cat,categories.cat_id as c_id'))
        ->where('users.active','1')
        ->where('users.deleted','0')
        ->where('users.cat_id','>','0')
        ->where('users.user_id','!=',$login_id);
        
        $where_gender="";
        if(isset($request->gender) && $request->gender!=""){
            $gender=substr($request->gender,1);
            $where_gender= $where_gender." or users.gender='".$gender."'";
            $where_gender=$res->whereRaw(substr($where_gender,3));
            $res=$where_gender;
        }
        
        $where_age = "";
        if(isset($request->age) && $request->age!=""){
            $age=substr($request->age,1);
            $age_arr=explode(",",$age);
            foreach ($age_arr as $val){
                $val_arr = explode("-", $val);
                $where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
            }
            
            $where_age=$res->whereRaw("(".substr($where_age,3).")");
            $res=$where_age;
        }
        
        $where_loc="";
        if(isset($request->location) && $request->location!=""){
            $location=substr($request->location,1);
            $loc_arr=explode(",",$location);
            foreach ($loc_arr as $val){
                $where_loc=$where_loc.' or (users.country ="'.$val.'")';
            }
            
            $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
            $res=$where_loc;
        }
        
        $where_lan="";
        if(isset($request->language) && $request->language!=""){
            $language=substr($request->language,1);
            $lan_arr=explode(",",$language);
            foreach ($lan_arr as $val){
                $where_lan=$where_lan.' or (users.language like "%'.$val.'%")';
            }
            $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
            $res=$where_lan;
        }
        
        if($blocked_user_res->user_id==0){
            
        }else{
            $blocked_res=$blocked_user_res->user_id;
            $blocked_res=explode(',',$blocked_res);
            $res=$res->whereNotIn('users.user_id', $blocked_res);
            
        }
        if($blocked_user_res2->user_id==0){
            
        }else{
            $blocked_res2=$blocked_user_res2->user_id;
            $blocked_res2=explode(',',$blocked_res2);
            $res=$res->whereNotIn('users.user_id', $blocked_res2);
            
        }
        /*$res=$res->groupBy('c_id','cat')
        ->orderBy('c_id','ASC')
        ->get();*/
        $res=$res->groupBy('categories.category','categories.cat_id')
        ->get();
        
        $data=array();
        foreach($res as $r){
            if(isset($request->category) && strpos(",".$request->category.",", ",".$r->c_id.",")!==false){
                $v="true";
            }else{
                $v="false";
            }
            
            $s = array('count'=>$r->total,'cat_id'=>$r->c_id,'cat_name'=>$r->cat,'checked'=>$v);
            array_push($data,$s);
        }
        $response = array("status" => true,'msg'=>'category filtered successfully' ,'content' => $data);
        
        return response()->json($response); 
        
    }
    public function gender_filter(Request $request){
        if(auth()->guard('api')->user()){
            $login_id=auth()->guard('api')->user()->user_id;
        }else{
            $login_id=0;
        }
        $functions = new Functions();
        $blocked_user_res=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
        ->where('blocked_by',$login_id)
        ->first();
        $blocked_user_res2=DB::table('blocked_users')
        ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
        ->where('user_id',$login_id)
        ->first();
        
        $res= DB::table('users')
        ->select(DB::raw('count(user_id) as total,gender'))
        ->where('active','1')
        ->where('deleted','0')
        ->where('user_id','!=',$login_id);
        
        $where_cat="";
        /*if(isset($request->category) && $request->category!=""){
            $category=substr($request->category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
            }
            $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
            $res=$where_cat;
            
        }*/
        if(isset($request->category) && $request->category!=""){
            $category=substr($request->category,1);
            $cat_arr=explode(",",$category);
            foreach ($cat_arr as $val){
                $where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
            }
            $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
            $res=$where_cat;   
        }
        
        $where_age = "";
        if(isset($request->age) && $request->age!=""){
            $age=substr($request->age,1);
            $age_arr=explode(",",$age);
            foreach ($age_arr as $val){
                $val_arr = explode("-", $val);
                $where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
            }
            
            $where_age=$res->whereRaw("(".substr($where_age,3).")");
            $res=$where_age;
        }
        
        $where_lan="";
        if(isset($request->language) && $request->language!=""){
            $language=substr($request->language,1);
            $lan_arr=explode(",",$language);
            foreach ($lan_arr as $val){
                $where_lan=$where_lan.' or (language like "%'.$val.'%")';
            }
            $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
            $res=$where_lan;
        }
        $where_loc="";
        if(isset($request->location) && $request->location!=""){
            $location=substr($request->location,1);
            $loc_arr=explode(",",$location);
            foreach ($loc_arr as $val){
                $where_loc=$where_loc.' or (country ="'.$val.'")';
            }
            
            $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
            $res=$where_loc;
        }
        if($blocked_user_res->user_id==0){
            
        }else{
            $blocked_res=$blocked_user_res->user_id;
            $blocked_res=explode(',',$blocked_res);
            $res=$res->whereNotIn('user_id', $blocked_res);
            
        }
        if($blocked_user_res2->user_id==0){
            
        }else{
            $blocked_res2=$blocked_user_res2->user_id;
            $blocked_res2=explode(',',$blocked_res2);
            $res=$res->whereNotIn('user_id', $blocked_res2);
            
        }
        $res=$res->groupBy('gender')
        ->get();
        
        $data=array();
        foreach($res as $r){
            if($r->gender!=""){
                if(strpos(",".$request->gender.",", ",".$r->gender.",")!==false){
                    $v="true";
                }else{
                    $v="false";
                }
                if($r->gender=='F'){
                    $gender='Female';
                }else if($r->gender=='M'){
                    $gender='Male';
                }
                $s = array('count'=>$r->total,'gender'=>$gender,'gender_value'=>$r->gender,'checked'=>$v,'id'=>0);
                array_push($data,$s);
            }
        }  
        if(empty($data)){
            $response = array("status" => true,'msg'=>'No Record');
        }else{
            $response = array("status" => true,'msg'=>'Location filtered successfully' ,'content' => $data);
        }               
        
        return response()->json($response); 
        
    }
    public function candidate_list(Request $request){
        
        /*$validator = Validator::make($request->all(), [          
            'user_id'         => 'required',           
            'app_token'       => 'required',
           
        ],[         
        	'user_id.required'	  	=> 'User Id is required',
        	'app_token.required'	=> 'App Token is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{*/
            $functions = new Functions();
           /* $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){*/
            if(auth()->guard('api')->user()){
            $login_id=auth()->guard('api')->user()->user_id;
        }else{
            $login_id=0;
        }
        $blocked_user_res=DB::table('blocked_users')
                 ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
                 ->where('blocked_by',$login_id)
                 ->first();
	    $blocked_user_res2=DB::table('blocked_users')
             ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
             ->where('user_id',$login_id)
             ->first();
        
        /*$res=DB::table('users')
            ->leftJoin('categories','users.cat_id','=','categories.cat_id')
            ->select(DB::raw('user_id,username,categories.category as cat,round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) as age,gender,city,state,country,address1,profile_pic'))
            ->where('users.active','1')
            ->where('users.deleted','0')
            ->where('users.user_id','!=',$request->user_id);*/
        
        $res=DB::table('users')
            ->leftjoin("categories",\DB::raw("FIND_IN_SET(categories.cat_id, users.cat_id)"),">",\DB::raw("'0'"))
            ->select(DB::raw('user_id,username,first_name,last_name,round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) as age,show_age,gender,city,state,country,address1,profile_pic,GROUP_CONCAT(categories.category) as cat'))
            ->where('users.active','1')
            ->where('users.deleted','0')
            ->where('users.user_id','!=',$login_id);
            
            if(!isset($request->page) && $request->page==""){
                $page=1;
            }else{
                $page=$request->page;
            }
            $limit=30;
            $offset=($page-1)*$limit;
            $where_gender="";
            if(isset($request->gender) && $request->gender!=""){
                $gender=substr($request->gender,1);
                $where_gender= $where_gender." or users.gender='".$gender."'";
                $where_gender=$res->whereRaw(substr($where_gender,3));
                $res=$where_gender;
            }

            $where_cat="";
            if(isset($request->category) && $request->category!=""){
                $category=substr($request->category,1);
                
                $cat_arr=explode(",",$category);
               
                foreach ($cat_arr as $val){
                	$where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
                	//$where_cat=$where_cat." or (users.cat_id =".$val.")";
                }
                $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                $res=$where_cat;
               
            }

            $where_age = "";
            if(isset($request->age) && $request->age!=""){
                $age=substr($request->age,1);
                $age_arr=explode(",",$age);
                foreach ($age_arr as $val){
                	$val_arr = explode("-", $val);
					$where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
                }
               
                $where_age=$res->whereRaw("(".substr($where_age,3).")");
               $res=$where_age;
            }

            $where_loc="";
            if(isset($request->location) && $request->location!=""){
                $location=substr($request->location,1);
                $loc_arr=explode(",",$location);
                foreach ($loc_arr as $val){
                $where_loc=$where_loc.' or (users.country ="'.$val.'")';
                }
               
                $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
                $res=$where_loc;
            }
            
            $where_lan="";
            if(isset($request->language) && $request->language!=""){
                $language=substr($request->language,1);
                $lan_arr=explode(",",$language);
                foreach ($lan_arr as $val){
                $where_lan=$where_lan.' or (users.language like "%'.$val.'%")';
                }
                $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
                $res=$where_lan;
            }

            $where_key="";
            if(isset($request->keyword) && $request->keyword!=""){
                $key_arr=explode(",",$request->keyword);
                foreach ($key_arr as $val){
                $where_key=$where_key.' or (users.username like "%'.$val.'%")  or (users.first_name like "%'.$val.'%") or (users.last_name like "%'.$val.'%") or (categories.category like "%'.$val.'%") or (users.state like "%'.$val.'%") or (users.country like "%'.$val.'%")';
                }
                $where_key=$res->whereRaw("(".substr($where_key,3).")");
                $res=$where_key;
            }
            
            if($blocked_user_res->user_id==0){
			   
			   }else{
			   	$blocked_res=$blocked_user_res->user_id;
			   $blocked_res=explode(',',$blocked_res);
			   $res=$res->whereNotIn('user_id', $blocked_res);
			   
			   }
			if($blocked_user_res2->user_id==0){
			   
			   }else{
			   	$blocked_res2=$blocked_user_res2->user_id;
			   $blocked_res2=explode(',',$blocked_res2);
			   $res=$res->whereNotIn('user_id', $blocked_res2);
			   
			   }
       /* $total_records=$res->count();
            $res=$res->skip($offset) 
                ->take($limit)
                ->get();*/
         $res=$res->groupBy('user_id','username','gender','city','state','country','show_age','address1','profile_pic','dob','first_name','last_name')
         		->orderBy('user_id','desc')
        		 ->paginate($limit);
        		 /*->toSql();
        		 dd($res);
        		 exit;*/
        $total_records=$res->total();
            
        
        $data=array();
        if (!$res->isEmpty()){
            foreach($res as $r){
             if($r->profile_pic==""){
					if($r->gender=="M"){
         	            $p=secure_asset('assets/images/avatar-man.png');    
             	    }else if($r->gender=="F"){
             	        $p=secure_asset('assets/images/avatar-woman.png');    
             	    }else{
             	        $p=secure_asset('assets/images/profile.png');
             		}
				}else{
				    if (stripos($r->profile_pic, 'https://') !== false) {
                        $p = $r->profile_pic;
                    } else {
                        $p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
                    }
				}
				if($r->gender=='F'){
				    $gender='Female';
				}elseif($r->gender=='M'){
				    $gender='Male';
				}else{
					$gender='NA';
				}
                $s = array('producer_id'=>$request->user_id,'user_id'=>$r->user_id,'username'=>$r->username,'first_name'=>$r->first_name,'last_name'=>$r->last_name,'producer_name'=>$request->producer_name,'cat_name'=>$r->cat,'age'=>$r->age,'show_age'=>$r->show_age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p);
                array_push($data,$s);
            }
        }else{
        //   $data=array('status'=>false,'warning'=>'Sorry..! No record found.');
            $data=array();
        }
        
            $response = array("status" => true,'msg'=>'Candidate List filtered successfully' ,'data' => $data,'total_records'=> $total_records);
               
           /* }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   */ 
            return response()->json($response); 
        // }
    }

}   