<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class FollowController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }

    public function favorite_user_list(Request $request){
        
        if (!auth()->guard('api')->user()) {
            return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
        }else{
            $login_id=auth()->guard('api')->user()->user_id;
     
                $res=DB::table('users as u')
                    //->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                    ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
                    ->join('favorite_users as b', function ($join)use ($login_id){
			                        $join->on('b.user_id','=','u.user_id')
			                            ->where('b.added_by',$login_id);
			                            
			                        })
                    ->select(DB::raw('u.user_id as user_id,u.username as username,GROUP_CONCAT(c.category) as cat,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic'))
                    ->where('u.active','1');
                    
                    if(!isset($request->page) && $request->page==""){
                        $page=1;
                    }else{
                        $page=$request->page;
                    }
                    $limit=10;
                    $offset=($page-1)*$limit;
                $where_key="";
                if(isset($request->keyword) && $request->keyword!=""){
                    $key_arr=explode(",",$request->keyword);
                    foreach ($key_arr as $val){
                    $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                    }
                    $where_key=$res->whereRaw("(".substr($where_key,3).")");
                    $res=$where_key;
                }
                 $res=$res->groupBy('u.user_id','u.dob','u.username','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic')->orderBy('user_id','desc')
                		 ->paginate($limit);
	            $total_records=$res->total();
                    
                
                $data=array();
                if (!$res->isEmpty()){
                    foreach($res as $r){
                     if($r->profile_pic==""){
							if($r->gender=="M"){
                     	        $p=secure_asset('assets/images/avatar-man.png');    
                     	    }else if($r->gender=="F"){
                     	        $p=secure_asset('assets/images/avatar-woman.png');    
                     	    }else{
                     	        $p=secure_asset('assets/images/profile.png');
                     		}
						}else{
							if (stripos($r->profile_pic, 'https://') !== false) {
                                $p = $r->profile_pic;
                            } else {
                                $p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
                            }
						}
						if($r->gender=='F'){
							$gender='Female';
						}else{
							$gender='Male';
						}
                    $s = array('id'=>$r->user_id,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>$r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p);
                    array_push($data,$s);
                    } 
                    
        
                }else{
                   $data=array('warning'=>'Sorry..! No record found.');
                }
                
                    $response = array("status" => true,'msg'=>'Favorite List filtered successfully' ,'data' => $data,'total_records'=> $total_records);
               
           /* }  else{
                $response = array("status" => false,'msg'=>'Invalid Token');
            }   */ 
            return response()->json($response); 
        }
    }
    
/*   	public function add_favorite(Request $request){
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'blocked_by'          => 'required', 
                    
        ],[ 
            'user_id.required'   => 'User Id is required.',
            'blocked_by.required'   => 'Added by is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
			$res=DB::table('favorite_users')
			        ->select(DB::raw('fav_id'))
			        ->where('user_id',$request->user_id)
			        ->where('added_by',$request->blocked_by)
			        ->get();
		    if($res->isEmpty()){

		        $data =array(
		            'user_id' => $request->user_id,
		            'added_by' => $request->blocked_by,
		            'added_on' => date("Y-m-d H:i:s"),
		                                                                   
		        ); 
		    DB::table('favorite_users')->insert($data);
		                  
		    $response = array( "status" => true, "msg" => "saved","saved"=>1);
		    //exit();
			}else{
				$response = array( "status" => true, "msg" => "saved","saved"=>1);
			}
		    return response()->json($response); 
        }   		
   	}
   	public function remove_favorite(Request $request){
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'blocked_by'          => 'required', 
                    
        ],[ 
            'user_id.required'   => 'User Id is required.',
            'blocked_by.required'   => 'Added by is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
			$res=DB::table('favorite_users')
			        ->select(DB::raw('fav_id'))
			        ->where('user_id',$request->user_id)
			        ->where('added_by',$request->blocked_by)
			        ->get();
		    if(!$res->isEmpty()){

		    DB::table('favorite_users')->where('user_id',$request->user_id)->where('added_by',$request->blocked_by)->delete();
		                  
		    $response = array( "status" => true, "msg" => "saved","saved"=>1);
		    //exit();
			}else{
				$response = array( "status" => true, "msg" => "saved","saved"=>1);
			}
		    return response()->json($response); 
        }   		
   	}  */ 	
   	
    public function follow(Request $request){

        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',
        ],[ 
            'user_id.required'   => 'User Id is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
            if (auth()->guard('api')->user()) {
                $login_id = auth()->guard('api')->user()->user_id;
            	$res=DB::table('followers')
                        ->select(DB::raw('follower_id'))
                        ->where('user_id',$request->user_id)
                        ->where('following_id',$login_id)
                        ->get();
                if($res->isEmpty()){
                    $data =array(
                        'user_id' => $request->user_id,
                        'following_id' => $login_id,
                    );
                    DB::table('followers')->insert($data);
                    $response = array( "status" => true, "msg" => "followed","follow"=>1);
                    
                 }else{
    			 	DB::table('followers')->where('user_id',$request->user_id)->where('following_id',  $login_id)->delete();
    			 	$response = array( "status" => true, "msg" => "unfollowed","follow"=>0);
    			 }          
                return response()->json($response); 
            }else{ 
                return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
            }
        }
    }
    public function favorite(Request $request){
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',
        ],[ 
            'user_id.required'   => 'User Id is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
            
            if (auth()->guard('api')->user()) {
                $login_id = auth()->guard('api')->user()->user_id;
            	$res=DB::table('favorite_users')
			        ->select(DB::raw('fav_id'))
			        ->where('user_id',$request->user_id)
			        ->where('added_by',$login_id)
			        ->get();
                
                     if($res->isEmpty()){
                     $data =array(
		            'user_id' => $request->user_id,
		            'added_by' => $login_id,
		            'added_on' => date("Y-m-d H:i:s"),
		                                                                   
		        ); 
		        DB::table('favorite_users')->insert($data);
                    $response = array( "status" => true, "msg" => "added to favorite","fav"=>1);
                    
                 }else{
		         DB::table('favorite_users')->where('user_id',$request->user_id)->where('added_by',$login_id)->delete();
    			 	$response = array( "status" => true, "msg" => "removed from favorite","fav"=>0);
    			 }          
                return response()->json($response); 
                
            } else{ 
                return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
            }
        }
    }
    public function followers_list(Request $request){
        
        

    	if (!auth()->guard('api')->user()) {
            return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
        }else{
            $login_id=auth()->guard('api')->user()->user_id;
            
            $res=DB::table('users as u')
                //->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
                ->join('followers as f', function ($join)use ($login_id){
		                        $join->on('f.following_id','=','u.user_id')
		                            ->where('f.user_id',$login_id);
		                            
		                        })
		       ->leftJoin('followers as fl', function ($join)use ($login_id){
		                        $join->on('u.user_id','=','fl.user_id')
		                            ->where('fl.following_id', $login_id);
		                        })
                ->select(DB::raw('u.user_id as user_id,u.username as username,GROUP_CONCAT(c.category) as cat,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic,fl.follower_id as follower_id'))
                ->where('u.active','1');
                
                if(!isset($request->page) && $request->page==""){
                    $page=1;
                }else{
                    $page=$request->page;
                }
                $limit=10;
                $offset=($page-1)*$limit;
            $where_key="";
            if(isset($request->keyword) && $request->keyword!=""){
                $key_arr=explode(",",$request->keyword);
                foreach ($key_arr as $val){
                $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                }
                $where_key=$res->whereRaw("(".substr($where_key,3).")");
                $res=$where_key;
            }
             $res=$res->groupBy('u.user_id','u.dob','u.username','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic','fl.follower_id')->orderBy('user_id','desc')
            		 ->paginate($limit);
            $total_records=$res->total();
                
            
            $data=array();
            if (!$res->isEmpty()){
                foreach($res as $r){
                 if($r->profile_pic==""){
						if($r->gender=="M"){
                 	        $p=secure_asset('assets/images/avatar-man.png');    
                 	    }else if($r->gender=="F"){
                 	        $p=secure_asset('assets/images/avatar-woman.png');    
                 	    }else{
                 	        $p=secure_asset('assets/images/profile.png');
                 		}
					}else{
						$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
					}
					if($r->gender=='F'){
						$gender='Female';
					}else{
						$gender='Male';
					}
                $s = array('id'=>$r->user_id,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>$r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p,'isFollowing'=>$r->follower_id >0 ? 1:0);
                array_push($data,$s);
                } 
                
            }else{
               $data=array();
            }
            
                $response = array("status" => true,'msg'=>'Follower List filtered successfully' ,'data' => $data,'total_records'=> $total_records);
           
            /* }  else{
                $response = array("status" => false,'msg'=>'Invalid Token');
            }   */ 
            return response()->json($response); 
        }
    }

    public function following_list(Request $request){
        
        if (!auth()->guard('api')->user()) {
            return response()->json([
                    "status" => false, "msg" => "Unauthorized user!"
                ]);
        }else{
            $login_id=auth()->guard('api')->user()->user_id;
            
            $res=DB::table('users as u')
                //->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
                ->join('followers as f', function ($join)use ($login_id){
		                        $join->on('f.user_id','=','u.user_id')
		                            ->where('f.following_id',$login_id);
		                            
		                        })
		    
                ->select(DB::raw('u.user_id as user_id,u.username as username,GROUP_CONCAT(c.category) as cat,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic,f.follower_id as follower_id'))
                ->where('u.active','1');
                
                if(!isset($request->page) && $request->page==""){
                    $page=1;
                }else{
                    $page=$request->page;
                }
                $limit=10;
                $offset=($page-1)*$limit;
            $where_key="";
            if(isset($request->keyword) && $request->keyword!=""){
                $key_arr=explode(",",$request->keyword);
                foreach ($key_arr as $val){
                $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                }
                $where_key=$res->whereRaw("(".substr($where_key,3).")");
                $res=$where_key;
            }
             $res=$res->groupBy('u.user_id','u.dob','u.username','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic','f.follower_id')->orderBy('user_id','desc')
            		 ->paginate($limit);
            $total_records=$res->total();
                
            
            $data=array();
            if (!$res->isEmpty()){
                foreach($res as $r){
                 if($r->profile_pic==""){
						if($r->gender=="M"){
                 	        $p=secure_asset('assets/images/avatar-man.png');    
                 	    }else if($r->gender=="F"){
                 	        $p=secure_asset('assets/images/avatar-woman.png');    
                 	    }else{
                 	        $p=secure_asset('assets/images/profile.png');
                 		}
					}else{
						$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
					}
					if($r->gender=='F'){
						$gender='Female';
					}else{
						$gender='Male';
					}
                $s = array('id'=>$r->user_id,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>$r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p,'isFollowing'=>$r->follower_id > 0 ? 1: 0);
                array_push($data,$s);
                } 
                
            }else{
               $data=array();
            }
                $response = array("status" => true,'msg'=>'Following users List filtered successfully' ,'data' => $data,'total_records'=> $total_records);
            return response()->json($response); 
        }
    }
}   