<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class FollowerController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }

    public function favorite_user_list(Request $request){
        
        $validator = Validator::make($request->all(), [          
            'user_id'         => 'required',           
            'app_token'       => 'required',
           
        ],[         
        	'user_id.required'	  	=> 'User Id is required',
        	'app_token.required'	=> 'App Token is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
     
                $res=DB::table('users as u')
                    //->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                    ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
                    ->join('favorite_users as b', function ($join)use ($request){
			                        $join->on('b.user_id','=','u.user_id')
			                            ->where('b.added_by',$request->user_id);
			                            
			                        })
                    ->select(DB::raw('u.user_id as user_id,u.app_token as app_token,u.username as username,GROUP_CONCAT(c.category) as cat,round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) as age,u.gender as gender,u.city as city,u.state as state,u.country as country,u.address1 as address1,u.profile_pic as profile_pic'))
                    ->where('u.active','1');
                    
                    if(!isset($request->page) && $request->page==""){
                        $page=1;
                    }else{
                        $page=$request->page;
                    }
                    $limit=10;
                    $offset=($page-1)*$limit;
                $where_key="";
                if(isset($request->keyword) && $request->keyword!=""){
                    $key_arr=explode(",",$request->keyword);
                    foreach ($key_arr as $val){
                    $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                    }
                    $where_key=$res->whereRaw("(".substr($where_key,3).")");
                    $res=$where_key;
                }
                 $res=$res->groupBy('u.user_id','u.app_token','u.username','u.gender','u.city','u.state','u.country','u.address1','u.profile_pic')->orderBy('user_id','desc')
                		 ->paginate($limit);
	            $total_records=$res->total();
                    
                
                $data=array();
                if (!$res->isEmpty()){
                    foreach($res as $r){
                     if($r->profile_pic==""){
							$p='../../assets/imgs/profile.jpg';
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
						}
						if($r->gender=='F'){
							$gender='Female';
						}else{
							$gender='Male';
						}
                    $s = array('id'=>$r->user_id,'app_token'=>$r->app_token,'username'=>$r->username,'cat_name'=>$r->cat,'age'=>$r->age,'gender'=>$gender,'city'=>$r->city,'state'=>$r->state,'country'=>$r->country,'address'=>$r->address1,'profile_pic' => $p);
                    array_push($data,$s);
                    } 
                    
        
                }else{
                   $data=array('warning'=>'Sorry..! No record found.');
                }
                
                    $response = array("status" => "success",'msg'=>'Blocked List filtered successfully' ,'content' => $data,'total_records'=> $total_records);
               
           /* }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   */ 
            return response()->json($response); 
        }
    }
    
   	public function add_favorite(Request $request){
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'blocked_by'          => 'required', 
                    
        ],[ 
            'user_id.required'   => 'User Id is required.',
            'blocked_by.required'   => 'Added by is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
			$res=DB::table('favorite_users')
			        ->select(DB::raw('fav_id'))
			        ->where('user_id',$request->user_id)
			        ->where('added_by',$request->blocked_by)
			        ->get();
		    if($res->isEmpty()){

		        $data =array(
		            'user_id' => $request->user_id,
		            'added_by' => $request->blocked_by,
		            'added_on' => date("Y-m-d H:i:s"),
		                                                                   
		        ); 
		    DB::table('favorite_users')->insert($data);
		                  
		    $response = array( "status" => "success", "msg" => "saved","saved"=>1);
		    //exit();
			}else{
				$response = array( "status" => "success", "msg" => "saved","saved"=>1);
			}
		    return response()->json($response); 
        }   		
   	}
   	public function remove_favorite(Request $request){
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'blocked_by'          => 'required', 
                    
        ],[ 
            'user_id.required'   => 'User Id is required.',
            'blocked_by.required'   => 'Added by is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
			$res=DB::table('favorite_users')
			        ->select(DB::raw('fav_id'))
			        ->where('user_id',$request->user_id)
			        ->where('added_by',$request->blocked_by)
			        ->get();
		    if(!$res->isEmpty()){

		    DB::table('favorite_users')->where('user_id',$request->user_id)->where('added_by',$request->blocked_by)->delete();
		                  
		    $response = array( "status" => "success", "msg" => "saved","saved"=>1);
		    //exit();
			}else{
				$response = array( "status" => "success", "msg" => "saved","saved"=>1);
			}
		    return response()->json($response); 
        }   		
   	}   	
    public function follow(Request $request){

        $validator = Validator::make($request->all(), [ 
             'id'          => 'required',              
            'following_id'          => 'required', 
                    
        ],[ 
            'id.required'   => 'User Id  is required.',
            'following_id.required'   => 'Following Id is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all())]);
        }else{
        	 $res=DB::table('followers')
                    ->select(DB::raw('follower_id'))
                    ->where('user_id',$request->id)
                    ->where('following_id',$request->following_id)
                    ->get();
                if($res->isEmpty()){
            
                    $data =array(
                        'user_id' => $request->id,
                        'following_id' => $request->following_id,
                        
                                                                               
                    ); 
                DB::table('followers')->insert($data);
                              
                $response = array( "status" => "success", "msg" => "followed","follow"=>1);
                //exit();
                 }else{
				 	DB::table('followers')->where('user_id', $request->id)->where('following_id', $request->following_id)->delete();
				 	$response = array( "status" => "success", "msg" => "unfollowed","follow"=>0);
				 }          
            return response()->json($response); 
        
        }
    }

        
}   