<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class GenderFilterController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function gender_filter(Request $request){
        
            $functions = new Functions();
           $blocked_user_res=DB::table('blocked_users')
                 ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
                 ->where('blocked_by',$request->user_id)
                 ->first();
        	$blocked_user_res2=DB::table('blocked_users')
                 ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
                 ->where('user_id',$request->user_id)
                 ->first();
                              
            $res= DB::table('users')
                    ->select(DB::raw('count(user_id) as total,gender'))
                    ->where('active','1')
                    ->where('deleted','0')
                    ->where('user_id','!=',$request->user_id);
                   
                     $where_cat="";
                    /*if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;
                       
                    }*/
                     if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        	$where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;   
                    }
                    
                    $where_age = "";
                    if(isset($request->age) && $request->age!=""){
                        $age=substr($request->age,1);
                        $age_arr=explode(",",$age);
                        foreach ($age_arr as $val){
                        	$val_arr = explode("-", $val);
							$where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
                        }
                       
                        $where_age=$res->whereRaw("(".substr($where_age,3).")");
                       $res=$where_age;
                    }

                    $where_lan="";
                    if(isset($request->language) && $request->language!=""){
                        $language=substr($request->language,1);
                        $lan_arr=explode(",",$language);
                        foreach ($lan_arr as $val){
                        $where_lan=$where_lan.' or (language like "%'.$val.'%")';
                        }
                        $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
                        $res=$where_lan;
                    }
                    $where_loc="";
                    if(isset($request->location) && $request->location!=""){
                        $location=substr($request->location,1);
                        $loc_arr=explode(",",$location);
                        foreach ($loc_arr as $val){
                        $where_loc=$where_loc.' or (country ="'.$val.'")';
                        }
                       
                        $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
                        $res=$where_loc;
                    }
				if($blocked_user_res->user_id==0){
				   
				   }else{
					   $blocked_res=$blocked_user_res->user_id;
					   $blocked_res=explode(',',$blocked_res);
					   $res=$res->whereNotIn('user_id', $blocked_res);
				   
				   }
				if($blocked_user_res2->user_id==0){
				   
				   }else{
					   $blocked_res2=$blocked_user_res2->user_id;
					   $blocked_res2=explode(',',$blocked_res2);
					   $res=$res->whereNotIn('user_id', $blocked_res2);
				   
				   }
                    $res=$res->groupBy('gender')
                    ->get();
            
                $data=array();
                foreach($res as $r){
                    if($r->gender!=""){
                        if(strpos(",".$request->gender.",", ",".$r->gender.",")!==false){
                            $v="true";
                        }else{
                            $v="false";
                        }
                        if($r->gender=='F'){
                            $gender='Female';
                        }else if($r->gender=='M'){
                            $gender='Male';
                        }
                        $s = array('count'=>$r->total,'gender'=>$gender,'gender_value'=>$r->gender,'checked'=>$v,'id'=>0);
                        array_push($data,$s);
                    }
                }  
                if(empty($data)){
                    $response = array("status" => "success",'msg'=>'No Record');
                }else{
                    $response = array("status" => "success",'msg'=>'Location filtered successfully' ,'content' => $data);
                }               
                 
            return response()->json($response); 
        
    }

}   