<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class GetSlidesController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function get_slides(Request $request){
        
        $validator = Validator::make($request->all(), [ 
        	'user_id'         => 'required',           
            'post_id'       => 'required',
            'type'       => 'required',
           
        ],[         
        	'user_id.required'	  	=> 'User Id is required',
        	'post_id.required'	=> 'Post Id is required',
        	'type.required'	=> 'Type is required',

        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
             $functions = new Functions();

		        	$post_view=DB::table('post_views')
				                ->where('user_id',$request->user_id)
				                ->where('post_id',$request->post_id)
				                ->count();
		            if($post_view>0){
					}else{
						$data =array(
		                        'post_id' => $request->post_id,
		                        'user_id' => $request->user_id,
		                                                                               
		                    ); 
		                DB::table('post_views')->insert($data);
		                
		                DB::table('posts')
		                        ->where('post_id',$request->post_id)
		                        ->update(['views' => DB::raw('views + 1')]);
		                //$response = $file_path;
		              
		                $response = array( "status" => "success", "msg" => "viewed");
					}

                   
        			$current_res=DB::table('posts as p')
    	                        ->select(DB::raw('p.post_id,p.file,p.title,p.likes,p.views,p.comments,p.shares,l.like_id'))
			                     ->leftJoin('post_likes as l', function ($join)use ($request){
				                        $join->on('l.post_id','=','p.post_id')
				                            ->where('l.user_id',$request->user_id);
				                        })
    	                        
    	                        ->where('p.user_id',$request->user_id)
    	                        ->where('p.post_id',$request->post_id)
    	                        ->where('p.type',$request->type)
    	                        ->orderBy('p.post_id','asc')
    	                        ->first();
    	                       
    	                        if($request->type=='P'){
									$file=Storage::url("photos/".$request->user_id."/".$current_res->file);
								}else{
									$file=Storage::url("videos/".$request->user_id."/".$current_res->file);
								}
    	            
    	            $data['current'] = array("post_id" => $current_res->post_id,"title"=>$current_res->title,'file'=>$file,'likes'=>$current_res->likes,'comments'=>$current_res->comments,'shares'=>$current_res->shares,'like_id'=>$current_res->like_id,'views'=>$current_res->views,'sig'=>md5($current_res->post_id."*FilmsDream@1290"));
    	            $pre_res=DB::table('posts')
    	                        ->select(DB::raw('post_id,file,title'))
    	                        ->where('user_id',$request->user_id)
    	                        ->where('post_id','>',$request->post_id)
    	                        ->where('type',$request->type)
    	                        ->orderBy('post_id','asc')
    	                        ->first();
    	            if ($pre_res){
                     	if($request->type=='P'){
							$pre_file=Storage::url("photos/".$request->user_id."/".$pre_res->file);
						}else{
							$pre_file=Storage::url("videos/".$request->user_id."/".$pre_res->file);
						}
    	            
    	            $data['pre'] = array("post_id" => $pre_res->post_id,"title"=>$pre_res->title,'file'=>$pre_file);  
    	            }else{
						$data['pre']=array();
					}
    	            $next_res=DB::table('posts')
    	                        ->select(DB::raw('post_id,file,title'))
    	                        ->where('user_id',$request->user_id)
    	                        ->where('post_id','<',$request->post_id)
    	                        ->where('type',$request->type)
    	                        ->orderBy('post_id','desc')
    	                        ->first();
                 if ($next_res){
                        if($request->type=='P'){
							$next_file=Storage::url("photos/".$request->user_id."/".$next_res->file);
						}else{
							$next_file=Storage::url("videos/".$request->user_id."/".$next_res->file);
						}
    	            
    	            $data['next'] = array("post_id" => $next_res->post_id,"title"=>$next_res->title,'file'=>$next_file);
    	             }else{
						$data['next']=array();
					}  
                        $response = array("status" => "success",'msg'=>'slides result successfully fetched' ,'content' => $data);
               
            return response()->json($response); 
        }
    }
    
   
    


}   