<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class LanguageFilterController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function language_filter(Request $request){
        
            $functions = new Functions();
                   $blocked_user_res=DB::table('blocked_users')
                         ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
                         ->where('blocked_by',$request->user_id)
                         ->first();  
                    
                    $blocked_user_res2=DB::table('blocked_users')
                         ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
                         ->where('user_id',$request->user_id)
                         ->first();        
                    
                    $res=DB::table('users')
                        ->join("languages",\DB::raw("FIND_IN_SET(languages.lang, users.language)"),">",\DB::raw("'0'"))
                        ->select(DB::raw('count(languages.id) as total,languages.lang as lang'))
                        ->where('users.active','1')
                        ->where('users.deleted','0')
                        ->where('users.user_id','!=',$request->user_id);

                    $where_gender="";
                    if(isset($request->gender) && $request->gender!=""){
                        $gender=substr($request->gender,1);
                        $where_gender= $where_gender." or users.gender='".$gender."'";
                        $where_gender=$res->whereRaw(substr($where_gender,3));
                        $res=$where_gender;
                    }

                    $where_cat="";
                    /*if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;
                       
                    }*/
                    if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        	$where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;   
                    }

                    $where_age = "";
                    if(isset($request->age) && $request->age!=""){
                        $age=substr($request->age,1);
                        $age_arr=explode(",",$age);
                        foreach ($age_arr as $val){
                        	$val_arr = explode("-", $val);
							$where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
                        }
                       
                        $where_age=$res->whereRaw("(".substr($where_age,3).")");
                       $res=$where_age;
                    }

                    $where_loc="";
                    if(isset($request->location) && $request->location!=""){
                        $location=substr($request->location,1);
                        $loc_arr=explode(",",$location);
                        foreach ($loc_arr as $val){
                        $where_loc=$where_loc.' or (users.country ="'.$val.'")';
                        }
                       
                        $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
                        $res=$where_loc;
                    }
				if($blocked_user_res->user_id==0){
				   
				   }else{
					   $blocked_res=$blocked_user_res->user_id;
					   $blocked_res=explode(',',$blocked_res);
					   $res=$res->whereNotIn('users.user_id', $blocked_res);
				   
				   }
				if($blocked_user_res2->user_id==0){
				   
				   }else{
					   $blocked_res2=$blocked_user_res2->user_id;
					   $blocked_res2=explode(',',$blocked_res2);
					   $res=$res->whereNotIn('users.user_id', $blocked_res2);
				   
				   }
                    $res=$res->groupBy('languages.lang')
                    ->get();
            
                $data=array();
                foreach($res as $r){
                    if(strpos(",".$request->language.",", ",".$r->lang.",")!==false){
						$v="true";
					}else{
						$v="false";
					}
                    $s = array('count'=>$r->total,'language'=>$r->lang,'checked' => $v,'id'=>0);
                    array_push($data,$s);
                }  
             
                    $response = array("status" => "success",'msg'=>'Languages filtered successfully' ,'content' => $data);
               
             
            return response()->json($response); 
        
    }

}   