<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class LocationFilterController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function location_filter(Request $request){
        
            $functions = new Functions();
                  $blocked_user_res=DB::table('blocked_users')
                     ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
                     ->where('blocked_by',$request->user_id)
                     ->first(); 
                $blocked_user_res2=DB::table('blocked_users')
                     ->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
                     ->where('user_id',$request->user_id)
                     ->first();  
                      
                    $res=   DB::table('users')
                    ->select(DB::raw('count(user_id) as total,country'))
                    ->where('active','1')
                    ->where('deleted','0')
                    ->where('user_id','!=',$request->user_id);
                   
                    $where_gender="";
                    if(isset($request->gender) && $request->gender!=""){
                        $gender=substr($request->gender,1);
                        $where_gender= $where_gender." or users.gender='".$gender."'";
                        $where_gender=$res->whereRaw(substr($where_gender,3));
                        $res=$where_gender;
                    }
                   
                    $where_cat="";
                    /*if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        $where_cat=$where_cat.' or (users.cat_id ='.$val.')';
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;
                       
                    }*/
                     if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        	$where_cat=$where_cat." or (CONCAT(',',users.cat_id,',') like '%,".$val.",%')";
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;   
                    }
                    
                    $where_age = "";
                    if(isset($request->age) && $request->age!=""){
                        $age=substr($request->age,1);
                        $age_arr=explode(",",$age);
                        foreach ($age_arr as $val){
                        	$val_arr = explode("-", $val);
							$where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),users.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
                        }
                       
                        $where_age=$res->whereRaw("(".substr($where_age,3).")");
                       $res=$where_age;
                    }

                    $where_lan="";
                    if(isset($request->language) && $request->language!=""){
                        $language=substr($request->language,1);
                        $lan_arr=explode(",",$language);
                        foreach ($lan_arr as $val){
                        $where_lan=$where_lan.' or (users.language like "%'.$val.'%")';
                        }
                        $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
                        $res=$where_lan;
                    }
				if($blocked_user_res->user_id==0){
				   
				   }else{
					   $blocked_res=$blocked_user_res->user_id;
					   $blocked_res=explode(',',$blocked_res);
					   $res=$res->whereNotIn('user_id', $blocked_res);
				   
				   }
				if($blocked_user_res2->user_id==0){
				   
				   }else{
					   $blocked_res2=$blocked_user_res2->user_id;
					   $blocked_res2=explode(',',$blocked_res2);
					   $res=$res->whereNotIn('user_id', $blocked_res2);
				   
				   }
                    $res=$res->groupBy('country')
                    ->get();
            
                $data=array();
                foreach($res as $r){
                      if(strpos(",".$request->location.",", ",".$r->country.",")!==false){
						$v="true";
					}else{
						$v="false";
					}
                    $s = array('count'=>$r->total,'country'=>$r->country,'checked'=>$v,'id'=>0);
                    array_push($data,$s);
                }  
             
                    $response = array("status" => "success",'msg'=>'Location filtered successfully' ,'content' => $data);
               
             
            return response()->json($response); 
        
    }

}   