<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use App\Mail\Admin\SendMail;
use Intervention\Image\ImageManagerStatic as Image;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PasswordRecoverController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function recover_password(Request $request){
       
        $validator = Validator::make($request->all(), [ 
            'email'          => 'required|email',  
            //'user_type'            => 'required'
        ],[ 
           'email.required'	  	=> 'Email is required',
        	'email.email'		  	=> 'Email id is not valid',   
            //'user_type.required'   => 'User Type is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $res = DB::table("users")
            ->select(DB::raw("user_id,app_token,email,username"))
            ->where('email',$request->email)
            //->where('user_type',$request->user_type)
            ->first();
            
            if($res!=""){
                $functions = new Functions();
                $verify_code= rand(111111,999999);
                $data =array(
                    'verification_code'        => $verify_code,
                ); 
                DB::table('users')
                ->where('user_id',$res->user_id)     
                ->update($data);
                
                $mailBody ='<b>Hi '.$res->username.',<b><br /> 
                We have received your request to reset the password of your account. <br />
				Verification Code is:  :<b>'.$verify_code.'<br />
				Use this verification code to reset your password. ignore this email if you have not requested for this <br />
				<br />
				<br />
				Thanks <br />'.env('COMPANY_NAME');
				$array = array('subject'=>'Verification Code','view'=>'emails.email','body' => $mailBody);
				
				Mail::to($res->email)->send(new SendMail($array)); 
				
                $data  = array( 'user_id' => $res->user_id ,'app_token' =>$res->app_token , 'verification_code' => $verify_code);
                $response = array("status" => "success",'msg'=>'We have sent you a verification code on your email , Please check your inbox and fill the verification code' ,'content' => $data);
            }else{
                $response = array( "status" => "error", "msg" => "Invalid Username");
            }
            
            return response()->json($response); 
        
        }
    }

}   