<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PaymentController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function payment(Request $request){
        
    
        $payment_details = DB::table('payments')
                        ->select(DB::raw("invoice_no"))
                        ->orderBy('payment_id','desc')
                        ->limit(1)
                        ->first();
            
            if(!empty($payment_details)){
                $invoice_no=$payment_details->invoice_no;
            }else{
                $setting_details = DB::table('settings')
                                ->select(DB::raw("invoice_start_from as invoice_no"))
                                ->first();
                $invoice_no=$setting_details->invoice_no;
            }
            $invoice_no=$invoice_no+1;
          if($request->status=="approved"){
              $status="S";
          }else{
              $status='F';
          }
            $data =array(
                'invoice_no'    => $invoice_no,
                'payment_date'     => date('Y-m-d H:i:s'),
                'user_id'      => $request->producer_id,
                'amount'         => $request->amount,
                'payment_status'      => $status,
                'payment_msg'       => $request->payment_msg,
                'pg_transaction_id'      => $request->id,
                'payment_mode'       => 'Paypal',
                
            ); 
            DB::table('payments')->insert($data);

            $id=DB::getPdo()->lastInsertId();
    if( $id!=""){
            $data  = array( 'payment_id' => $id);
                $response = array("status" => "success",'msg'=>'Payment successfully' ,'content' => $data);
    }else{
         $response = array("status" => "error",'msg'=>'Payment unsuccessfully');
    }      
                return response()->json($response); 
            }
            
}   