<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PopoverDataController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function data(Request $request){
        
        $validator = Validator::make($request->all(), [          
            'following_id'         => 'required',           
            'id'       => 'required',
           
        ],[         
        	'following_id.required'	  	=> 'User Id is required',
        	'id.required'	=> 'id is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
        	
                 $functions = new Functions();  
                         
                    $res=DB::table('users as  u')
		                    ->leftJoin('followers as f', function ($join)use ($request){
			                        $join->on('f.user_id','=','u.user_id')
			                            ->where('f.following_id',$request->following_id)
			                            ->where('f.user_id',$request->id);
			                        })
			                ->leftJoin('blocked_users as b', function ($join)use ($request){
			                        $join->on('b.user_id','=','u.user_id')
			                            ->where('b.blocked_by',$request->following_id)
			                            ->where('b.user_id',$request->id);
			                        })
			                ->leftJoin('favorite_users as fv', function ($join)use ($request){
			                        $join->on('fv.user_id','=','u.user_id')
			                            ->where('fv.added_by',$request->following_id)
			                            ->where('fv.user_id',$request->id);
			                        })
		                    ->select(DB::raw('ifnull(fv.fav_id,0) as fav_id,ifnull(f.follower_id,0) as follower_id,ifnull(b.block_id,0) as block_id'))
		                    ->first();
		       
                            
                   	$response=array('status'=>'success','msg'=>'unfollow','follow'=>$res->follower_id,'saved'=>$res->fav_id,'block' =>$res->block_id);
                  
                 
             
                
            return response()->json($response); 
        }
    }
    

}   