<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PostCommentController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function comment(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'post_id'          => 'required',
            'comment'			=> 'required', 
            'parent_id'      => 'required'
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'post_id.required'   => 'Post Id is required.',
            'comment.required'   => 'Comment is required.',
           'parent_id.required'   => 'Parent Id is required.',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            
                    $data =array(
                        'post_id' => $request->post_id,
                        'user_id' => $request->user_id,
                        'comment' => $request->comment,                                                      
                        'parent_id' => $request->parent_id,
                        'comment_on' => date('Y-m-d H:i:s')                                                       
                    ); 
                    DB::table('post_comments')->insert($data);

						$rs_user = 	DB::table('users')
			                    ->select(DB::raw('username'))
			                    ->where('user_id',$request->user_id)
			                    ->first();	

                
	                 DB::table('posts')
                        ->where('post_id',$request->post_id)
                        ->update(['comments' => DB::raw('comments + 1')]);

					$rs_post = 	DB::table('posts as p')
							->join("users as u", "u.user_id","=","p.user_id")
		                    ->select(DB::raw('u.player_id, u.user_id, u.username'))
		                    ->where('p.post_id',$request->post_id)
		                    ->first();	                
		            if($rs_post){
						
		                $not_data['created_on'] = date("Y-m-d H:i:s");
		                $not_data['sent_to'] = $rs_post->user_id;
		                $not_data['title'] = $rs_user->username." commented your post";
		                $not_data['page_name'] = "post-detail";
		                $not_data['post_id'] = $request->post_id;
		                $not_data['sent_by'] = $request->user_id;
		                DB::table('notifications')->insert($not_data);
		                if($rs_post->player_id!=""){
			                $functions = new Functions();
			                $functions->send_notification_both($rs_post->player_id, $rs_user->username." commented your post","NEW COMMENT ON POST");
			            }
		            }
                        
                //$response = $file_path;
                $response = array( "status" => "success", "msg" => "upload comment successfully",'content'=>$data);
                //exit();
                           
            return response()->json($response); 
        
        }
    }

	 public function comments_list(Request $request){
	 	 $validator = Validator::make($request->all(), [ 
             'post_id'          => 'required',              
        ],[ 
            'post_id.required'   => 'Post Id is required.',
        
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
        
            if(!isset($request->page) && $request->page==""){
                $page=1;
            }else{
                $page=$request->page;
            }
            $limit=10;
            $offset=($page-1)*$limit;
        	  $user_details = DB::table("users")
			        ->select("time_zone")
			        ->where("user_id",$request->user_id)
			        ->first();
			
				$time2 = substr($user_details->time_zone,3);
				$symbol= substr($time2, 0, 1);
				$time2 =substr($user_details->time_zone,4);
        	$post_res=DB::table('posts')
                        ->select(DB::raw('post_id,user_id,file,type,comments,views,shares,likes,shared_post_id'))
                        ->where('post_id',$request->post_id)
                        ->first();
                if($post_res->shared_post_id>0){
	        		$post_res2=DB::table('posts')
	                        ->select(DB::raw('post_id,user_id,file,type,comments,views,shares,likes,shared_post_id'))
	                        ->where('post_id',$post_res->shared_post_id)
	                        ->first();
	                        
		                if($post_res2->type=="V"){
		                	$thum=substr($post_res2->file, 0, -3).".jpg";
							$file=Storage::url("videos/".$post_res2->user_id."/".$post_res2->file);
							$thumb_file=Storage::url("videos/".$post_res2->user_id."/thumb/".$thum);
						}else{
							$file=Storage::url("photos/".$post_res2->user_id."/".$post_res2->file);
							$thumb_file="";
						}

				}else{
	                if($post_res->type=="V"){
	                	$thum=substr($post_res->file, 0, -3)."jpg";
						$file=Storage::url("videos/".$post_res->user_id."/".$post_res->file);
						$thumb_file=Storage::url("videos/".$post_res->user_id."/thumb/".$thum);
					}else{
						$file=Storage::url("photos/".$post_res->user_id."/".$post_res->file);
						$thumb_file="";
					}
				}
            $data=array("post_id"=>$post_res->post_id,"sig"=>md5($post_res->post_id."*FilmsDream@1290"),"user_id"=>$post_res->user_id,"file"=>$file,'thumb'=>$thumb_file,"views"=>$post_res->views,"comments"=>$post_res->comments,"shares"=>$post_res->shares,"likes"=>$post_res->likes,"type"=>($post_res->type=="S")?$post_res2->type:$post_res->type);
             
            $reply_res=DB::table('post_comments as c')
                        ->Join('users as u','c.user_id','=','u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
                        ->where('c.post_id',$request->post_id)   
                        ->where('c.parent_id','!=',0)  
                		->get();
                		$functions = new Functions();
            if (!$reply_res->isEmpty()){
                foreach($reply_res as $r){
                      if($r->profile_pic==""){
							$p="../../assets/imgs/profile.jpg";
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
						}
                    $comment_on=$functions->date_time($r->comment_on);
                     $reply[$r->parent_id][] = array("comment_id"=>$r->comment_id,"user_id"=>$r->user_id,"username"=>$r->username,"comment"=>$r->comment,"comment_on"=>$comment_on,"profile_pic"=>$p,"parent_id"=>$r->parent_id);
						
                }
                
            }
        	$res=DB::table('post_comments as c')
                        ->Join('users as u','c.user_id','=','u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
                        ->where('c.post_id',$request->post_id)
                        ->where('c.parent_id',0);
                       // ->orderBy('comment_id','desc');
                    
                    $res=$res->orderBy('comment_id','desc')
                    	//->skip($offset) 
                        ->paginate($limit);
                        //->get();
                        //print_r($res);
                    $total_records=$res->total();
           
                if (!$res->isEmpty()){
                	
	                foreach($res as $r){
	                 if($r->profile_pic==""){
							$p="../../assets/imgs/profile.jpg";
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
						}
					$fetch_time=explode(":",$time2);
						
					if($symbol=='+'){
						//$time=strtotime($r->added_on)+strtotime($time2);
						$time = date("Y-m-d H:i", strtotime('+'.$fetch_time[0].' hour +'.$fetch_time[1].' minutes', strtotime($r->comment_on)));
					}elseif($symbol=='-'){
						$time = date("Y-m-d H:i", strtotime('-'.$fetch_time[0].' hour -'.$fetch_time[1].' minutes', strtotime($r->comment_on)));
					}else{
						$time='';
					}
					
					if($time==''){
                        $comment_on=$functions->date_time($r->comment_on);
                    }else{
                        //$time = date("Y-m-d H:i:s",$time);
                        $comment_on=$functions->date_time($time);
                    }	
					//$comment_on=$functions->date_time($r->comment_on);
				    if(isset($reply[$r->comment_id])){
				        $cmt_id=$reply[$r->comment_id];
				    }else{
				        $cmt_id=[];
				    }
				
	                $data['comment'][] = array("comment_id"=>$r->comment_id,"user_id"=>$r->user_id,"username"=>$r->username,"comment"=>$r->comment,"comment_on"=>$comment_on,"profile_pic"=>$p,"parent_id"=>$r->parent_id,'replies'=>$cmt_id);
	                
	                } 
                 
                }else{
                   $data['warning']=array('warning'=>'Sorry..! No record found.');
                }
                
            $response = array("status" => "success",'msg'=>'comments' ,'content' => $data, 'total_records'=>$total_records);
            return response()->json($response); 
        }
	 }

    public function comment_delete(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'post_id'          => 'required',
            'comment_id'			=> 'required' 
            
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'post_id.required'   => 'Post Id is required.',
            'comment.required'   => 'Comment is required.'
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            
                DB::table('post_comments')->where('post_id', $request->post_id)->where('user_id', $request->user_id)->where('comment_id', $request->comment_id)->delete();
            if($request->parent_id==0){
             DB::table('posts')
                        ->where('post_id',$request->post_id)
                        ->update(['comments' => DB::raw('comments - 1')]);
            }
                //$response = $file_path;
                $response = array( "status" => "success", "msg" => "delete comment successfully");
                //exit();
                           
            return response()->json($response); 
        
        }
    }  
}   
