<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PostLikeController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function like(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'post_id'          => 'required', 
                    
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'post_id.required'   => 'Post Id is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
        	   $res=DB::table('post_likes')
                    ->select(DB::raw('like_id'))
                    ->where('post_id',$request->post_id)
                    ->where('user_id',$request->user_id)
                    ->get();
                    if($res->isEmpty()){
						$data =array(
		                        'post_id' => $request->post_id,
		                        'user_id' => $request->user_id,
		                                                                               
		                    ); 
		                 DB::table('post_likes')->insert($data);
		                
		                 DB::table('posts')
		                        ->where('post_id',$request->post_id)
		                        ->update(['likes' => DB::raw('likes + 1')]);


						
						$rs_user = 	DB::table('users')
			                    ->select(DB::raw('username'))
			                    ->where('user_id',$request->user_id)
			                    ->first();	
						
						$rs_post = 	DB::table('posts as p')
								->join("users as u", "u.user_id","=","p.user_id")
			                    ->select(DB::raw('u.player_id, u.user_id, u.username'))
			                    ->where('p.post_id',$request->post_id)
			                    ->first();	                
			            if($rs_post){
							
			                $not_data['created_on'] = date("Y-m-d H:i:s");
			                $not_data['sent_to'] = $rs_post->user_id;
			                $not_data['title'] = $rs_user->username." liked your post";
			                $not_data['page_name'] = "post-detail";
			                $not_data['post_id'] = $request->post_id;
			                $not_data['sent_by'] = $request->user_id;
			                DB::table('notifications')->insert($not_data);
			                if($rs_post->player_id!=""){
				                $functions = new Functions();
				                $functions->send_notification_both($rs_post->player_id, $rs_user->username." liked your post","NEW LIKE ON POST");
				            }
			            }
		                
		                $response = array( "status" => "success", "msg" => "Liked","like"=>'1');
					}else{
						DB::table('post_likes')->where('post_id', $request->post_id)->where('user_id',$request->user_id)->delete();
						DB::table('posts')
		                        ->where('post_id',$request->post_id)
		                        ->update(['likes' => DB::raw('likes - 1')]);
		                
		                $response = array( "status" => "success", "msg" => "Unliked","like"=>'0');
					}
            //print_r($res);
           //exit;
                
                //exit();
                //DB::table('user_photos')->where('photo_id', $photo_id)->where('user_id', $user_id)->delete();          
            return response()->json($response); 
        
        }
    }
    
}   