<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PostRepliesController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function reply(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'post_id'          => 'required',
            'comment'			=> 'required', 
            'parent_id'      => 'required'
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'post_id.required'   => 'Post Id is required.',
            'comment.required'   => 'Comment is required.',
           'parent_id.required'   => 'Parent Id is required.',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            
                    $data =array(
                        'post_id' => $request->post_id,
                        'user_id' => $request->user_id,
                        'comment' => $request->comment,                                                      
                        'parent_id' => $request->parent_id,
                        'comment_on' => date('Y-m-d H:i:s')                                                       
                    ); 
                    DB::table('post_comments')->insert($data);
                
                //  DB::table('posts')
                //         ->where('post_id',$request->post_id)
                //         ->update(['comments' => DB::raw('comments + 1')]);
                //$response = $file_path;
                $response = array( "status" => "success", "msg" => "upload comment successfully",'content'=>$data);
                //exit();
                           
            return response()->json($response); 
        
        }
    }

	 public function replies_list(Request $request){
	 	 $validator = Validator::make($request->all(), [ 
             'post_id'          => 'required',              
             'comment_id'          => 'required',              
        ],[ 
            'post_id.required'   => 'Post Id is required.',
            'comment_id.required'   => 'Comment Id is required.',
        
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
        
            if(!isset($request->page) && $request->page==""){
                $page=1;
            }else{
                $page=$request->page;
            }
            $limit=10;
            $offset=($page-1)*$limit;
            if($request->user_id!=""){
				 $user_details = DB::table("users")
			        ->select("time_zone")
			        ->where("user_id",$request->user_id)
			        ->first();
			
				$time2 = substr($user_details->time_zone,3);
				$symbol= substr($time2, 0, 1);
				$time2 =substr($user_details->time_zone,4);
			}
        	
        	/*$post_res=DB::table('posts')
                        ->select(DB::raw('post_id,user_id,file,type,comments,views,shares,likes'))
                        ->where('post_id',$request->post_id)
                        ->first();
                if($post_res->type=="V"){
					$file=Storage::url("videos/".$post_res->user_id."/".$post_res->file);
				}else{
					$file=Storage::url("photos/".$post_res->user_id."/".$post_res->file);
				}
            $data=array("post_id"=>$post_res->post_id,"file"=>$file,"views"=>$post_res->views,"comments"=>$post_res->comments,"shares"=>$post_res->shares,"likes"=>$post_res->likes,"type"=>$post_res->type);
              */  
        	$res=DB::table('post_comments as c')
                        ->Join('users as u','c.user_id','=','u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
                        ->where('c.post_id',$request->post_id)
                        ->where('c.comment_id',$request->comment_id)
                        ->first();
                  
                   /* $res=$res->orderBy('comment_id','desc')
                    	//->skip($offset) 
                        ->paginate($limit);
                        //->get();
                        //print_r($res);
                    $total_records=$res->total();*/
             $functions = new Functions(); 
                if ($res!=""){
                	
	               // foreach($res as $r){
	                 if($res->profile_pic==""){
							$p="../../assets/imgs/profile.jpg";
						}else{
							$p=Storage::url("profile_pic/".$res->user_id."/".$res->profile_pic);
						}
						if($request->user_id!=""){
							$fetch_time=explode(":",$time2);
						
							if($symbol=='+'){
								//$time=strtotime($r->added_on)+strtotime($time2);
								$time = date("Y-m-d H:i", strtotime('+'.$fetch_time[0].' hour +'.$fetch_time[1].' minutes', strtotime($res->comment_on)));
							}elseif($symbol=='-'){
								$time = date("Y-m-d H:i", strtotime('-'.$fetch_time[0].' hour -'.$fetch_time[1].' minutes', strtotime($res->comment_on)));
							}else{
								$time='';
							}
							
							if($time==''){
		                        $comment_on=$functions->date_time($res->comment_on);
		                    }else{
		                        //$time = date("Y-m-d H:i:s",$time);
		                        $comment_on=$functions->date_time($time);
		                    }
							
						}else{
							$comment_on=$functions->date_time($res->comment_on);
						}
											
	                $data = array("comment_id"=>$res->comment_id,"user_id"=>$res->user_id,"username"=>$res->username,"comment"=>$res->comment,"comment_on"=>$comment_on,"profile_pic"=>$p,"parent_id"=>$res->parent_id);
	                
	               
              $rep_res=DB::table('post_comments as c')
                        ->Join('users as u','c.user_id','=','u.user_id')
                        ->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
                        ->where('c.post_id',$request->post_id)
                        ->where('c.parent_id',$request->comment_id)
                        ->get();  
             if (!$rep_res->isEmpty()){
                	
	                foreach($rep_res as $r){
	                 if($r->profile_pic==""){
							$p="../../assets/imgs/profile.jpg";
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/".$r->profile_pic);
						}
						if($request->user_id!=""){
							$fetch_time1=explode(":",$time2);
						
							if($symbol=='+'){
								//$time=strtotime($r->added_on)+strtotime($time2);
								$time = date("Y-m-d H:i", strtotime('+'.$fetch_time1[0].' hour +'.$fetch_time1[1].' minutes', strtotime($r->comment_on)));
							}elseif($symbol=='-'){
								$time = date("Y-m-d H:i", strtotime('-'.$fetch_time1[0].' hour -'.$fetch_time1[1].' minutes', strtotime($r->comment_on)));
							}else{
								$time='';
							}
							
							if($time==''){
		                        $comment_on=$functions->date_time($r->comment_on);
		                    }else{
		                        //$time = date("Y-m-d H:i:s",$time);
		                        $comment_on=$functions->date_time($time);
		                    }		
						}else{
							$comment_on=$functions->date_time($r->comment_on);
						}
										
	                	$data['reply'][] = array("comment_id"=>$r->comment_id,"user_id"=>$r->user_id,"username"=>$r->username,"comment"=>$r->comment,"comment_on"=>$comment_on,"profile_pic"=>$p,"parent_id"=>$r->parent_id);
	                
	                	} 
                	} 
        
                }else{
                   $data['warning']=array('warning'=>'Sorry..! No record found.');
                }
                
                    $response = array("status" => "success",'msg'=>'comments' ,'content' => $data);
               
                
            return response()->json($response); 
        }
	 }

    
}   