<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PostShareController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   public function share_post(Request $request){
        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'post_id'          => 'required', 
            'user_token'       => 'required',
                    
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'post_id.required'   => 'Post Id is required.',
            'user_token.required'	=> 'App Token is required',
           
        ]);
        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->user_token,'C');
            $string="";
            if($token_res>0){
            	
            	
	            $data =array(
	                'post_id' => $request->post_id,
	                'user_id' => $request->user_id,
	                                                                       
	            ); 
	            DB::table('post_shares')->insert($data);
	            
	             DB::table('posts')
	                    ->where('post_id',$request->post_id)
	                    ->update(['shares' => DB::raw('shares + 1')]);
				
				$post_data['user_id'] = $request->user_id;
				$post_data['type'] = "S";
				$post_data['added_on'] = date("Y-m-d H:i:s");
				$post_data['title'] = $request->title;
				$post_data['shared_post_id'] = $request->post_id;
				DB::table('posts')->insert($post_data);
	            //$response = $file_path;

						$rs_user = 	DB::table('users')
			                    ->select(DB::raw('username'))
			                    ->where('user_id',$request->user_id)
			                    ->first();	

				$rs_post = 	DB::table('posts as p')
						->join("users as u", "u.user_id","=","p.user_id")
	                    ->select(DB::raw('u.player_id, u.user_id, u.username'))
	                    ->where('p.post_id',$request->post_id)
	                    ->first();	                
	            if($rs_post){
					
	                $not_data['created_on'] = date("Y-m-d H:i:s");
	                $not_data['sent_to'] = $rs_post->user_id;
	                $not_data['title'] = $rs_user->username." shared your post";
	                $not_data['page_name'] = "post-detail";
	                $not_data['post_id'] = $request->post_id;
	                $not_data['sent_by'] = $request->user_id;
	                DB::table('notifications')->insert($not_data);
	                if($rs_post->player_id!=""){
		                $functions = new Functions();
		                $functions->send_notification_both($rs_post->player_id, $rs_user->username." shared your post","NEW SHARING ON POST");
		            }
	            }
	          
	            $response = array( "status" => "success", "msg" => "shared");
	                           
	            return response()->json($response); 
	        }else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
			}
		}        
   }
    public function share(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'post_id'          => 'required', 
                    
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'post_id.required'   => 'Post Id is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            
                    $data =array(
                        'post_id' => $request->post_id,
                        'user_id' => $request->user_id,
                                                                               
                    ); 
                    DB::table('post_shares')->insert($data);
                
                 DB::table('posts')
                        ->where('post_id',$request->post_id)
                        ->update(['shares' => DB::raw('shares + 1')]);
                //$response = $file_path;

				$rs_post = 	DB::table('posts as p')
						->join("users as u", "u.user_id","=","p.user_id")
	                    ->select(DB::raw('u.player_id, u.user_id, u.username'))
	                    ->where('p.post_id',$request->post_id)
	                    ->first();	                
	            if($rs_post){
					
	                $not_data['created_on'] = date("Y-m-d H:i:s");
	                $not_data['sent_to'] = $rs_post->user_id;
	                $not_data['title'] = $rs_post->username." shared your post";
	                $not_data['page_name'] = "post-detail";
	                $not_data['post_id'] = $request->post_id;
	                $not_data['sent_by'] = $request->user_id;
	                DB::table('notifications')->insert($not_data);
	                if($rs_post->player_id!=""){
		                $functions = new Functions();
		                $functions->send_notification_both($rs_post->player_id, $rs_post->username." shared your post","NEW SHARING ON POST");
		            }
	            }

              
                $response = array( "status" => "success", "msg" => "shared");
                //exit();
                           
            return response()->json($response); 
        
        }
    }

    

}   