<?php
namespace App\Http\Controllers\API;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use Intervention\Image\ImageManagerStatic as Image;
use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class PostViewController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function view(Request $request){

        $validator = Validator::make($request->all(), [ 
             'user_id'          => 'required',              
            'post_id'          => 'required', 
                    
        ],[ 
            'user_id.required'   => 'User Id  is required.',
            'post_id.required'   => 'Post Id is required.',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
        	$post_view=DB::table('post_views')
		                ->where('user_id',$request->user_id)
		                ->where('post_id',$request->post_id)
		                ->count();
            if($post_view>0){
				$response = array( "status" => "warning", "msg" => "already viewed");
			}else{
				$data =array(
                        'post_id' => $request->post_id,
                        'user_id' => $request->user_id,
                                                                               
                    ); 
                DB::table('post_views')->insert($data);
                
                DB::table('posts')
                        ->where('post_id',$request->post_id)
                        ->update(['views' => DB::raw('views + 1')]);
                //$response = $file_path;
              
                $response = array( "status" => "success", "msg" => "viewed");
			}
                //exit();
                           
            return response()->json($response); 
        
        }
    }

    
}   