<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ProducerConversationController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function producer_conversation(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',    
               
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
            
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){
                $user_res= $functions->valid_candidate($request->user_id,'P');
                if($user_res==0){
                    $response = array("status" => "error",'msg'=>'Invalid Candidate');
                }else{
                   
                /*$user_res=DB::table('message as m')
                        ->Join('users as u','u.user_id','=','m.from_id')
                        ->select(DB::raw('max(m.sent_on) as sent_on, u.username as candidate_name, m.from_id as from_id, u.profile_pic as profile_pic, min(m.is_read) as is_read'))
                        ->orWhere('m.to_id',$request->user_id)
                        ->orWhere('m.from_id',$request->user_id)
                        ->orderByRaw('min(is_read)','asc')
                        ->orderByRaw('m.sent_on','desc')
                        ->groupBy('u.username','u.profile_pic','m.from_id')
                        ->get();*/
                          $where_key=""; 
                     if(isset($request->keyword) && $request->keyword!=""){
                       
                        $where_key=" and username like '%".$request->keyword."%' ";
                        
                    }else{
                        $where_key="";
                    }
                
                         $user_res=  DB::select( DB::raw('select max(sent_on) as sent_on, candidate_name, from_id, profile_pic, min(is_read) as is_read,cat_id,cat_name from ( SELECT max(m.sent_on) as sent_on,u.username as candidate_name,m.from_id as from_id,u.profile_pic as profile_pic,min(m.is_read) as is_read,u.cat_id as cat_id,c.category as cat_name from message as m join users as u on u.user_id = m.from_id join categories as c on u.cat_id=c.cat_id where m.to_id='.$request->user_id.' '.$where_key.' group by username,profile_pic,from_id,cat_id,cat_name union all SELECT max(m1.sent_on) as sent_on,u.username as candidate_name,m1.to_id as from_id,u.profile_pic as profile_pic,1 as is_read,u.cat_id as cat_id,c.category as cat_name from message as m1 join users as u on u.user_id = m1.to_id join categories as c on u.cat_id=c.cat_id where m1.from_id='.$request->user_id.' '.$where_key.' group by username,profile_pic,to_id,cat_id,cat_name ) t group by candidate_name,profile_pic,from_id,cat_id,cat_name order by min(is_read), sent_on DESC ')); 
                  
                  if(!empty($user_res)){   
                 foreach($user_res as $r){
                     if($r->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$r->from_id."/small/".$r->profile_pic);
						}
						$sent_on=date('d/m/Y', strtotime($r->sent_on));
                        $data['messages'][] = array("candidate_id"=>$r->from_id,"candidate_name"=>$r->candidate_name,"producer_id" => $request->user_id,"producer_name"=>$request->producer_name,"profile_pic" => $p,"is_read"=>$r->is_read,'sent_on'=>$sent_on,'cat_name'=>$r->cat_name);
                     }
               
              
                $response = array("status" => "success",'msg'=>'Candidate Photos list' ,'content' => $data);
                  }else{
                         $response = array("status" => "warning",'msg'=>'No Chat available');
                    }
            }
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
        
            return response()->json($response); 
        }
    }

}   