<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ProducerEditProfileController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function edit_profile(Request $request){
         $validator = Validator::make($request->all(), [ 
            'first_name'          => 'required',           
            'last_name'           => 'required',
            'email'               => 'required|email',
            'mobile1'             => 'required',
            //'address1'            => 'required',
            'country'             => 'required',
            'state'               => 'required',
            'city'                => 'required',
            //'zipcode'             => 'required',
                                     
        ],[ 
            'first_name.required'   => 'First Name is required',
            'last_name.required'    => 'Last Name is required', 
            'email.required'        => 'Email is required',
            'email.email'		  	=> 'Email id is not valid',
            'mobile1.min'           => 'Phone is required',
            //'address1.required'     => 'Address is required',
            'country.required'      => 'Country is required',
            'state.required'        => 'State is required',
            'city.required'         => 'City is required',
            //'zipcode.required'      => 'Zipcode is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $res= $functions->validate_token($request->user_id,$request->app_token,'P');
            if($res>0){
            $data =array(
            'first_name'    => $request->first_name,
            'last_name'     => $request->last_name,
            'username'      => $request->first_name." ".$request->last_name,
            'email'         => $request->email,
            'mobile1'       => $request->mobile1,
            //'address1'      => $request->address1,
            'country'       => $request->country,
            'state'         => $request->state,
            'city'          => $request->city,
            //'zipcode'       => $request->zipcode            
            ); 
            DB::table('users')->where('user_id',$request->user_id)->update($data);
            $data  = array( 'user_id' => $request->user_id, 'app_token' => $request->app_token);
                $response = array("status" => "success",'msg'=>'Detail Updated successfully' ,'content' => $data);
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
            return response()->json($response); 
        }
    }

}   