<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ProducerGetProfileController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function producer_get_profile(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'          => 'required',              
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){
                
                    $res=DB::table('users')
                        ->Join('film_maker_categories as c','users.cat_id','=','c.film_maker_cat_id')
                        ->select(DB::raw('user_id,username,first_name,last_name,c.cat_name as cat_name,c.film_maker_cat_id as cat_id,email,state,city,country,language,dob,mobile1,address1,active,views,profile_pic,education,active,bio,zipcode'))
                        //->where('users.active','1')
                        ->where('users.user_type','P')
                        ->where('users.user_id',$request->user_id)
                        ->get();
        
                    $data=array();
                    foreach($res as $r){
                        if($r->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$r->user_id."/small/".$r->profile_pic);
						}
                        $s = array('user_id'=>$r->user_id,'first_name'=>$r->first_name,'last_name'=>$r->last_name,'username'=>$r->username,'bio'=>$r->bio,'cat_name'=>$r->cat_name,'cat_id'=>$r->cat_id,'email'=>$r->email,'active'=>$r->active,'views'=>$r->views,'profile_pic' => $p,'state'=>$r->state,'city'=>$r->city,'country'=>$r->country,'mobile1'=>$r->mobile1 ,'address1'=>$r->address1,'views'=>$r->views,'dob'=>$r->dob,'education'=>$r->education,'bio'=>$r->bio,'zipcode'=>$r->zipcode);
                        array_push($data,$s);
                    }  
              
                    $response = array("status" => "success",'msg'=>'Producer Profile View' ,'content' => $data);
            
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
            return response()->json($response); 
        }
    }

}   