<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ProducerLoginController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }

    public function login(Request $request){

    	$validator = Validator::make($request->all(), [          
            'email'          => 'required|email',           
            'password'       => 'required'
        ],[         
        	'email.required'	  	=> 'Email is required',
        	'email.email'		  	=> 'Email id is not valid',         
        	'password.required'	    => 'Password is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
        	if (Auth::attempt(['email' => $request->email, 'password' => $request->password , 'user_type' => 'P'])) 
            {
            	$user_details = DB::table('users')
            		->select(DB::raw("user_id,first_name,last_name,username,email,app_token"))
                    ->where('user_id',Auth::user()->user_id)
                    ->where('active','1')
                    ->first();
            if($user_details!=""){
            	if($user_details->app_token == ''){
                    $functions = new Functions();
                    $user_token= Hash::make($functions->_password_generate(20));
	            	DB::table('users')
                        ->where('user_id',Auth::user()->user_id)   
		            	->update(['app_token' => $user_token]);

		            $app_token = $user_token;
            	}else{
            		$app_token = $user_details->app_token;
            	}
                 

                $first_name = $user_details->first_name;
                $last_name = $user_details->last_name;
                $username=$first_name." ".$last_name;
		        $data  = array( 'user_id' => Auth::user()->user_id, 'app_token' => $app_token, 'first_name' => $first_name,'last_name' => $last_name, 'email' => $request->email,'username' => $username);

		        $response = array( "status" => "success", "msg" => "User logged in successfully", 'content' => $data );
                }else{
        				$response = array( "status" => "error", "msg" => "Producer is not active" );
        			}
            }else{
            	$response = array( "status" => "error", "msg" => "Invalid login details" );
            }
        	return response()->json($response);   
        }
    }

}   