<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ProducerMessageController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function producer_message(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',    
            'id'               => 'required',
            'candidate_name'    => 'required',
            'msg'              => 'required',    
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
            'id.required'  => 'Candidate is id required',
            'candidate_name.required'  => 'Candidate name is id required',
            'msg.required'  => 'Cannot send empty message '
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){
               
                    $data =array(
                        'from_id'       => $request->user_id,
                        'to_id'         => $request->id,
                        'msg'           => $request->msg,
                      
                    ); 
                    DB::table('message')->insert($data);
              $res=DB::table('users')
                        ->select(DB::raw('player_id'))
                        ->where('user_id', $request->id)
                        ->first();
                  
               $functions = new Functions();
                    $res= $functions->send_notification($res->player_id,$request->msg,env('APP_ID'),"",$request->producer_name,"candidate-message","c_id,c_name,p_id,p_name",$request->id.",".$request->candidate_name.",".$request->user_id.",".$request->producer_name);
                $response = array("status" => "success",'msg'=>'message sent' ,'content' => $data);
            
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
        
            return response()->json($response); 
        }
    }

}   