<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Intervention\Image\ImageManagerStatic as Image;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ProducerProfilePicController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function profile_pic(Request $request){
       
        $validator = Validator::make($request->all(), [ 
            'profile_pic'          => 'required|image|mimes:jpeg,png,jpg,gif,svg',             
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $user_status = $functions->_user_check($request->user_id, $request->app_token,$request->user_type); 
            if($user_status == 1){

                $user = DB::table('users')
                    ->select(DB::raw("*"))
                    ->where('user_id',$request->user_id)
                    ->first();
               
                $path = $functions->_getUserFolderName($request->user_id, 'profile_pic');
                $filenametostore = $request->file('profile_pic')->store($path);  
                                
                Storage::setVisibility($filenametostore, 'public');
                $fileArray = explode('/',$filenametostore);  
                $fileName = array_pop($fileArray); 
                $functions->_createThumb(Storage::url($filenametostore),400,300,$path.'/small',$fileName);
                $functions->_createThumb(Storage::url($filenametostore),400,710,$path.'/',$fileName);
                $file_path = Storage::url("profile_pic/".$request->user_id."/".$fileName);

                    $data =array(
                        'user_id'       => $request->user_id,
                        'image'         => $fileName
                                                
                    ); 
                    DB::table('user_profile_pics')->insert($data);

                    DB::table('users')
                        ->where('user_id',$request->user_id)
                        ->update(['profile_pic'=>$fileName]);
                       
                    $response = array("status" => "success",'msg'=>'Profile pic uploaded successfully' , 'profile_pic' => $file_path );
                                                        
            } else{
                $response = array("status" => "error","msg"=>"Invalid Token");
            }
            return response()->json($response); 
        
        }
    }
    
}   