<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;
use App\Mail\Admin\SendMail;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ProducerRegisterBasicController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }  

    public function register_basic(Request $request){
         $validator = Validator::make($request->all(), [ 
            'first_name'         => 'required',           
            'last_name'          => 'required',
            'email'              => 'required|email|unique:users,email,C,user_type',
            'password'           => 'required',
            'mobile1'            => 'required',
            'category'            => 'required',
           // 'address1'           => 'required',
            'country'            => 'required',
            'state'              => 'required',
            'city'               => 'required',
            //'zipcode'            => 'required',
                                     
        ],[ 
            'first_name.required'   => 'First Name is required',
            'last_name.required'    => 'Last Name is required', 
            'email.required'        => 'Email is required',
            'password.required'     => 'Password is required',
            'mobile1.min'           => 'Phone is required',
            'category.required'     => 'Category is required',
           // 'address1.required'     => 'Address is required',
            'country.required'      => 'Country is required',
            'state.required'        => 'State is required',
            'city.required'         => 'City is required',
           // 'zipcode.required'      => 'Zipcode is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $user_token= Hash::make($functions->_password_generate(20));
           $data =array(
            'first_name'    => $request->first_name,
            'last_name'     => $request->last_name,
            'username'      => $request->first_name." ".$request->last_name,
            'email'         => $request->email,
            'password'      => Hash::make($request->password),
            'mobile1'       => $request->mobile1,
            'cat_id'      	=> $request->category,
            //'address1'      => $request->address1,
            'country'       => $request->country,
            'state'         => $request->state,
            'city'          => $request->city,
           // 'zipcode'       => $request->zipcode,
            'user_type'     => 'P',
            'active'        => '1',
            'app_token'     => $user_token
            
        ); 
        DB::table('users')->insert($data);
    
        $id=DB::getPdo()->lastInsertId();
            $username= $request->first_name." ". $request->last_name;
                    $mailBody ='<b>Dear '.$username.'<b><br /><br /> 
                        Thank you for your value able time. We have received your request. Our team will review your data and activate your account if your information is relevant to our APP. You will get email confirmation when your account will be active. Your Details are: <br /><br />
						Username  : '.$request->first_name.'<br />
						Email : '. $request->email.' <br />
						Mobile : '.$request->mobile1.' <br />
						City : '.$request->city.' <br />
						State : '.$request->state.' <br />
						Country : '.$request->country.'
						<br />
						<br />
						Thanks <br />'.env('COMPANY_NAME');
						$array = array('subject'=>' Registration Confirmation at Films Dreams','view'=>'emails.email','body' => $mailBody);
               			Mail::to($request->email)->send(new SendMail($array)); 
                        
                        $mailBody ='<b>Hi Admin<b><br /><br /> 
                        A new producer has been registered on app and waiting for approval. Please check all the details and activate the account.Details are following:
						Username  : '.$username.'<br />
						Email : '. $request->email.' <br />
						Mobile : '.$request->mobile1.' <br />
						City : '.$request->city.' <br />
						State : '.$request->state.' <br />
						Country : '.$request->country.'
						<br />
						<br />
					    <a href="https://bollywood.newlondonlife.com/secureAdminArea/producers/active/"'.$request->user_id.'>click here to activate the account</a>';
						$array = array('subject'=>'New Candidate Registration','view'=>'emails.email','body' => $mailBody);
               			Mail::to('pawanbollywood@gmail.com')->send(new SendMail($array)); 
        
        $data  = array( 'user_id' => $id, 'app_token' => $user_token,'username' => $username);
            $response = array("status" => "success",'msg'=>'Candidate Register successfully' ,'content' => $data);
              
            return response()->json($response); 
        }
    }


}   