<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ShowAgeController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function age_setting(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',    
                       
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
           $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token);
            if($token_res>0){
                $res=DB::table('users')
                		->select(DB::raw("show_age"))
                        ->where('user_id',$request->user_id)
                        ->first();
               
               if($res->show_age==1){
                    DB::table('users')
    		            	->where('user_id',$request->user_id)     
    		            	->update(['show_age' => '0']);
    		            	$data=array("value"=>"0");
		        $response = array("status" => "success",'msg'=>'hide','content'=>$data);
    		   }else{
    		    DB::table('users')
    		            	->where('user_id',$request->user_id)     
    		            	->update(['show_age' => '1']);
    		            	$data=array("value"=>"1");
		        $response = array("status" => "success",'msg'=>'show','content'=>$data);
    		   }  
                
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   
            return response()->json($response); 
        }
    }
    
    public function show_age(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',    
                       
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
           
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
           $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token);
            if($token_res>0){
                $res=DB::table('users')
                		->select(DB::raw("show_age"))
                        ->where('user_id',$request->user_id)
                        ->first();
               
            	$data=array("age"=>$res->show_age);
		        $response = array("status" => "success",'msg'=>'hide','content'=>$data);
    		                   
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }   
            return response()->json($response); 
        }
    }

}   