<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class UpdatePlayerIdController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function update_player_id(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',  
            'app_token'        => 'required',
            'player_id'        => 'required',     
            
        ],[ 
            'user_id.required'   => 'Id is required',
             'app_token.required'   => 'App Token is required',
            'player_id.required'  => 'Player Id is id required',
            
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
           $functions = new Functions();
                $token_res= $functions->validate_token($request->user_id,$request->app_token);
                if($token_res>0){
                    $data =array(
                        'player_id'       => $request->player_id,
                    
                    ); 
                    DB::table('users')->where('user_id',$request->user_id)->update($data);
              
                    $response = array("status" => "success",'msg'=>'message sent' ,'content' => $data);
                }else{
                    $response = array("status" => "error",'msg'=>'Invalid Token');
                }  
           
            return response()->json($response); 
        }
    }
}