<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Intervention\Image\ImageManagerStatic as Image;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class VerificationCodeController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }
   
    public function verify_code(Request $request){
       
        $validator = Validator::make($request->all(), [ 
             'user_id'         => 'required',           
            'app_token'       => 'required',
            'verify_code'          => 'required',              
        ],[ 
            'user_id.required'	  	=> 'User Id is required',
        	'app_token.required'	=> 'App Token is required',
            'verify_code.required'   => 'Verification code field is required',
        ]);

        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
             $functions = new Functions();
                $token_res= $functions->validate_token($request->user_id,$request->app_token);
                if($token_res>0){
                $res = DB::table("users")
                ->select(DB::raw("user_id,app_token,verification_code"))
                ->where('user_id',$request->user_id)
                //->where('user_type',$request->user_type)
                ->where('app_token',$request->app_token)
                ->first();
                //if($res !=""){
                    if($res->verification_code == $request->verify_code){
                        $data  = array( 'user_id' => $res->user_id ,'app_token' => $request->app_token , 'verification_code' => $request->verify_code);
                        $response = array("status" => "success",'msg'=>'Code verified' ,'content' => $data);
                    }else{
                        $response = array( "status" => "error", "msg" => "Invalid Verification Code");
                    }
                }else{
                    $response = array( "status" => "error", "msg" => "Invalid User");
                }
            return response()->json($response); 
        
        }
    }

}   