<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL; 

class ViewCandidateVideosController extends Controller
{
    private function _error_string($errArray)
    {
        $error_string = '';
        foreach ($errArray as $key) {
            $error_string.= $key."\n";
        }
        return $error_string;
    }    

    public function view_candidate_videos(Request $request){
        
        $validator = Validator::make($request->all(), [ 
            'user_id'          => 'required',              
            'app_token'        => 'required',  
            'id'             => 'required',  
        ],[ 
            'user_id.required'   => 'Id is required',
            'app_token.required'   => 'App Token is required',
            'id.required'  => 'Id is required'
        ]);
        
        if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{
            $functions = new Functions();
            $token_res= $functions->validate_token($request->user_id,$request->app_token,'P');
            $string="";
            if($token_res>0){
                $user_res= $functions->valid_candidate($request->id,'C');
                if($user_res==0){
                    $response = array("status" => "error",'msg'=>'Invalid User');
                }else{
                    $page=$request->page;
                   
                $limit=10;
                $offset=($page-1)*$limit;
               
                $user_res=DB::table('users')
                        ->Join('categories','categories.cat_id','=','users.cat_id')
                        ->select(DB::raw('users.username as username,users.profile_pic as profile_pic,users.views as views,categories.category as category'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->first();
                        
                    $prod_res=DB::table('users')
                        ->select(DB::raw('username as producer_name,user_id as producer_id'))
                        ->where('users.user_type','P')
                        ->where('users.user_id',$request->user_id)
                        ->first();
                        
                        if($user_res->profile_pic==""){
							$p='../../assets/imgs/profile.png';
						}else{
							$p=Storage::url("profile_pic/".$request->id."/".$user_res->profile_pic);
						}
                        $data=array("username"=>$user_res->username,"candidate_id"=>$request->id,"category"=>$user_res->category,"views"=>$user_res->views,"profile_pic"=>$p,"producer_name"=>$prod_res->producer_name,"producer_id"=>$prod_res->producer_id);
                $videos_res=DB::table('users')
                        ->Join('user_videos','users.user_id','=','user_videos.user_id')
                        ->select(DB::raw('user_videos.video as video,user_videos.title as title'))
                        ->where('users.active','1')
                        ->where('users.user_type','C')
                        ->where('users.user_id',$request->id)
                        ->orderBy('video_id','desc');
                    $total_records=$videos_res->count();
                    $videos_res=$videos_res->skip($offset) 
                        ->take($limit)
                        ->get();
               
             if($videos_res->isEmpty()){
                   $data['warning'] = 'No video uploaded yet.';
               }else{
                    foreach($videos_res as $r){
                        $thumb=explode(".",$r->video);
                        $thumb_name=$thumb[0].".jpg";
                        $data['videos'][] = array("video"=>Storage::url("videos/".$request->id."/".$r->video),"thumb"=>Storage::url("videos/".$request->id."/thumb/".$thumb_name),"title"=>$r->title);
                     }
               }
                $response = array("status" => "success",'msg'=>'Candidate Videos List' ,'content' => $data,'total_records'=>$total_records);
            }
            }  else{
                $response = array("status" => "error",'msg'=>'Invalid Token');
            }    
        
            return response()->json($response); 
        }
    }

}   