<?php

namespace App\Http\Controllers\API;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Hash;
use App\Helpers\Common\Functions;

use Auth;
use Mail;
use Illuminate\Support\Facades\URL;

class WallController extends Controller
{
	private function _error_string($errArray)
	{
		$error_string = '';
		foreach ($errArray as $key) {
			$error_string .= $key . "\n";
		}
		return $error_string;
	}
	public function updateInvalidAspectRatio(Request $request)
	{
		if (auth()->guard('api')->user()) {
			$login_id = auth()->guard('api')->user()->user_id;
		} else {
			$login_id = 0;
		}
		if ($login_id == 0) {
			return;
		}
		$aspectRatio = $request->aspectRatio;
		$postId = $request->postId;
		$upData = ['aspect_ratio' => $aspectRatio];
		DB::table('posts')
			->where('post_id', $postId)
			->update($upData);
		$response = array("status" => true);

		return response()->json($response);
	}

	public function download_file(Request $request)
	{
		$validator = Validator::make($request->all(), [
			'user_id'         => 'required',
			'app_token'       => 'required',
			'file'       => 'required',
		], [
			'user_id.required'	  	=> 'User Id is required',
			'app_token.required'	=> 'App Token is required',
			'file.required'	=> 'File URL is required',
		]);
		if (!$validator->passes()) {
			return response()->json(['status' => 'error', 'msg' => $this->_error_string($validator->errors()->all())]);
		} else {
			$handle = fopen($request->file, "rb");
			$contents = stream_get_contents($handle);
			$response = array("status" => "success", 'file_data' => base64_encode($contents));
			fclose($handle);
			return response()->json($response);
		}
	}
	public function wall_info(Request $request)
	{
		ini_set("serialize_precision", 1);
		/*$validator = Validator::make($request->all(), [          
            'user_id'         => 'required',           
            'app_token'       => 'required',
           
        ],[         
        	'user_id.required'	  	=> 'User Id is required',
        	'app_token.required'	=> 'App Token is required',
        	
        ]);

    	if (!$validator->passes()) {
            return response()->json(['status'=>'error','msg'=> $this->_error_string($validator->errors()->all()) ]);
        }else{*/

		$functions = new Functions();
		/*$user_details = DB::table("users")
			        ->select("time_zone")
			        ->where("user_id",$request->user_id)
			        ->first();*/

		/*$time2 = substr($user_details->time_zone,3);
				$symbol= substr($time2, 0, 1);
				$time2 =substr($user_details->time_zone,4);*/

		$blocked_user_res = DB::table('blocked_users')
			->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
			->where('blocked_by', $request->user_id)
			->first();
		$blocked_user_res2 = DB::table('blocked_users')
			->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
			->where('user_id', $request->user_id)
			->first();

		/* echo $blocked_res;
					  exit;*/
		/* $res=DB::table('users as  u')
		                    ->Join('posts as p','u.user_id','=','p.user_id')
		                     ->leftJoin('post_likes as l', function ($join)use ($request){
			                        $join->on('l.post_id','=','p.post_id')
			                            ->where('l.user_id',$request->user_id);
			                        })
		                    ->leftJoin('categories as c','u.cat_id','=','c.cat_id')
		                    ->select(DB::raw('l.like_id as like_id,u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.cat_id as cat_id,c.category as cat_name,p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type'))
		                    ->where('deleted','0');*/
		$res = DB::table('users as  u')
			->Join('posts as p', 'u.user_id', '=', 'p.user_id')
			->leftJoin('post_likes as l', function ($join) use ($request) {
				$join->on('l.post_id', '=', 'p.post_id')
					->where('l.user_id', $request->user_id);
			})
			->leftjoin("categories as c", \DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"), ">", \DB::raw("'0'"))
			->select(DB::raw('l.like_id as like_id,p.aspect_ratio,u.user_id as user_id,u.app_token as app_token,u.username as username,u.profile_pic as profile_pic,GROUP_CONCAT(DISTINCT c.cat_id) as cat_id,GROUP_CONCAT(DISTINCT c.category) as cat_name,p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type'))
			->where('p.shared_post_id', '0')
			->where('p.likes', '>', '1')
			->where('p.comments', '>', '1')
			->where('p.type', '!=', 'S')
			->where('p.show_on_wall', '1')
			->where('u.deleted', '0');

		if (!isset($request->page) && $request->page == "") {
			$page = 1;
		} else {
			$page = $request->page;
		}
		$limit = 20;
		$offset = ($page - 1) * $limit;
		$where_gender = "";
		if (isset($request->gender) && $request->gender != "") {
			$gender = substr($request->gender, 1);
			$where_gender = $where_gender . " or u.gender='" . $gender . "'";
			$where_gender = $res->whereRaw(substr($where_gender, 3));
			$res = $where_gender;
		}

		$where_cat = "";
		/*if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                       
                        $cat_arr=explode(",",$category);
                        foreach ($cat_arr as $val){
                        $where_cat=$where_cat.' or (u.cat_id ='.$val.')';
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;
                       
                    }*/
		if (isset($request->category) && $request->category != "") {
			$category = substr($request->category, 1);

			$cat_arr = explode(",", $category);

			foreach ($cat_arr as $val) {
				$where_cat = $where_cat . " or (CONCAT(',',u.cat_id,',') like '%," . $val . ",%')";
				//$where_cat=$where_cat." or (users.cat_id =".$val.")";
			}
			$where_cat = $res->whereRaw("(" . substr($where_cat, 3) . ")");
			$res = $where_cat;
		}

		$where_age = "";
		if (isset($request->age) && $request->age != "") {
			$age = substr($request->age, 1);
			$age_arr = explode(",", $age);
			foreach ($age_arr as $val) {
				$val_arr = explode("-", $val);
				$where_age = $where_age . " or (round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) between " . $val_arr[0] . " and " . $val_arr[1] . ")";
			}

			$where_age = $res->whereRaw("(" . substr($where_age, 3) . ")");
			$res = $where_age;
		}

		$where_loc = "";
		if (isset($request->location) && $request->location != "") {
			$location = substr($request->location, 1);
			$loc_arr = explode(",", $location);
			foreach ($loc_arr as $val) {
				$where_loc = $where_loc . ' or (u.country ="' . $val . '")';
			}

			$where_loc = $res->whereRaw("(" . substr($where_loc, 3) . ")");
			$res = $where_loc;
		}

		$where_lan = "";
		if (isset($request->language) && $request->language != "") {
			$language = substr($request->language, 1);
			$lan_arr = explode(",", $language);
			foreach ($lan_arr as $val) {
				$where_lan = $where_lan . ' or (u.language like "%' . $val . '%")';
			}
			$where_lan = $res->whereRaw("(" . substr($where_lan, 3) . ")");
			$res = $where_lan;
		}

		$where_key = "";
		if (isset($request->keyword) && $request->keyword != "") {
			$key_arr = explode(",", $request->keyword);
			foreach ($key_arr as $val) {
				$where_key = $where_key . ' or (u.first_name like "%' . $val . '%") or (u.last_name like "%' . $val . '%") or (c.category like "%' . $val . '%") or (u.state like "%' . $val . '%") or (u.country like "%' . $val . '%")';
			}
			$where_key = $res->whereRaw("(" . substr($where_key, 3) . ")");
			$res = $where_key;
		}
		//$total_records=$res->count();
		if ($blocked_user_res->user_id == 0) {
		} else {
			$blocked_res = $blocked_user_res->user_id;
			//$blocked_res=explode(',',$blocked_res);
			$strSql = $strSql . " and p2.user_id not in(" . $blocked_res . ")" . " and p.user_id not in(" . $blocked_res . ")";
		}
		if ($blocked_user_res2->user_id == 0) {
		} else {
			$blocked_res2 = $blocked_user_res2->user_id;
			//$blocked_res2=explode(',',$blocked_res2);
			$strSql = $strSql . " and p2.user_id not in(" . $blocked_res2 . ")" . " and p.user_id not in(" . $blocked_res2 . ")";
		}
		$res2 = array();
		if (isset($request->follow) && $request->follow != "") {
			$following_user_res = DB::table('followers')
				->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
				->where('following_id', $request->user_id)
				->first();
			if ($following_user_res->user_id == '') {
				$data = array('warning' => 'Sorry..! No record found.');
				$response = array("status" => "success", 'msg' => 'Candidate List filtered successfully', 'content' => $data);
				return response()->json($response);
			} else {
				$following_res = $following_user_res->user_id;
				$res2 = explode(',', $following_res);

				$res = $res->whereIn('p.user_id', $res2);
			}
		}

		$res = $res->groupBy('like_id', 'u.user_id', 'u.app_token', 'username', 'profile_pic', 'p.post_id', 'p.aspect_ratio', 'p.file', 'p.title', 'p.added_on', 'p.likes', 'p.views', 'p.comments', 'p.shares', 'p.type')
			->orderBy('post_id', 'desc')
			->paginate($limit);
		$total_records = $res->total();


		$data = array();
		if (!$res->isEmpty()) {
			foreach ($res as $r) {
				if (stripos($r->profile_pic, 'https://') !== false) {

					$p = $r->profile_pic;
				} else {
					if ($r->profile_pic == "") {
						$p = asset('assets/images/profile.png');
					} else {
						$p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
					}
				}
				if ($r->type == "V") {
					$thumb = explode(".", $r->file);
					$thum = $thumb[0] . ".jpg";
					//$thum=substr($r->file, 0, -3)."jpg";
					$file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
					$thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
				} else {
					$file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
					$thumb_file = "";
				}
				// 		$fetch_time=explode(":",$time2);

				/*if($symbol=='+'){
						//$time=strtotime($r->added_on)+strtotime($time2);
						$time = date("Y-m-d H:i", strtotime('+'.$fetch_time[0].' hour +'.$fetch_time[1].' minutes', strtotime($r->added_on)));
					}elseif($symbol=='-'){
						$time = date("Y-m-d H:i", strtotime('-'.$fetch_time[0].' hour -'.$fetch_time[1].' minutes', strtotime($r->added_on)));
					}else{
						$time='';
					}
					
					if($time==''){*/
				$added_on = ($r->added_on);
				/*}else{
                        //$time = date("Y-m-d H:i:s",$time);
                        $added_on=($time);
                    }*/

				$data_liked_users['users'] = array();

				if ($r->likes > 0) {
					$rs_liked_users = DB::table('post_likes as l')
						->Join('users as u', 'l.user_id', '=', 'u.user_id')
						->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
						->where('l.post_id', $r->post_id);
					// ->orderBy('comment_id','desc');

					$rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
						//->skip($offset) 
						->paginate(2);
					//->get();
					//print_r($res);
					$total_records_comments = $rs_liked_users->total();

					if (!$rs_liked_users->isEmpty()) {

						foreach ($rs_liked_users as $l) {
							if ($l->profile_pic == "") {
								$p_liked = asset('assets/images/profile.png');
							} else {
								$p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
							}

							$liked_on = ($l->like_on);

							$data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
						}
					}
				}
				$data_comment['comment'] = array();
				if ($r->comments > 0) {
					$rs_comments = DB::table('post_comments as c')
						->Join('users as u', 'c.user_id', '=', 'u.user_id')
						->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.post_id,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
						->where('c.post_id', $r->post_id)
						->where('c.parent_id', 0);
					// ->orderBy('comment_id','desc');

					$rs_comments = $rs_comments->orderBy('comment_id', 'desc')
						//->skip($offset) 
						->paginate(2);
					//->get();
					//print_r($res);
					$total_records_comments = $rs_comments->total();

					if (!$rs_comments->isEmpty()) {

						foreach ($rs_comments as $c) {
							if ($c->profile_pic == "") {
								$p_comment = asset('assets/images/profile.png');
							} else {
								$p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
							}

							$comment_on = ($c->comment_on);

							$data_comment['comment'][] = array("post_id" => $l->post_id, "comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id);
						}
					}
				}
				$data_comment['comment'] = array_reverse($data_comment['comment']);

				$s = array('user_comments' => $data_comment['comment'], 'liked_users' => $data_liked_users['users'], 'like_id' => $r->like_id == null ? 0 : $r->like_id, 'user_id' => $r->user_id, 'app_token' => $r->app_token, 'file1' => $r->file, 'username' => $r->username, 'file' => $file, 'thumb' => $thumb_file, 'title' => $r->title, 'added_on' => $added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'type' => $r->type, 'cat_id' => $r->cat_id == null ? "0" : $r->cat_id, 'cat_name' => $r->cat_name == null ? '' : $r->cat_name, 'post_id' => $r->post_id, 'aspect_ratio' => number_format($r->aspect_ratio, 1), 'sig' => md5($r->post_id . "*FilmsDream@1290"));
				array_push($data, $s);
			}
		} else {
			$data = array('warning' => 'Sorry..! No record found.');
		}

		$response = array("status" => "success", 'msg' => 'Wall Post List', 'content' => $data, 'total_records' => $total_records);


		return response()->json($response);
	}

	public function wall_info_with_share_post(Request $request)
	{

		$validator = Validator::make($request->all(), [
			'user_id'         => 'required',
			'app_token'       => 'required',

		], [
			'user_id.required'	  	=> 'User Id is required',
			'app_token.required'	=> 'App Token is required',

		]);

		if (!$validator->passes()) {
			return response()->json(['status' => 'error', 'msg' => $this->_error_string($validator->errors()->all())]);
		} else {

			$functions = new Functions();
			$user_details = DB::table("users")
				->select("time_zone")
				->where("user_id", $request->user_id)
				->first();

			$time2 = substr($user_details->time_zone, 3);
			$symbol = substr($time2, 0, 1);
			$time2 = substr($user_details->time_zone, 4);

			$blocked_user_res = DB::table('blocked_users')
				->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
				->where('blocked_by', $request->user_id)
				->first();
			$blocked_user_res2 = DB::table('blocked_users')
				->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
				->where('user_id', $request->user_id)
				->first();

			/* echo $blocked_res;
					  exit;*/
			/* $res=DB::table('users as  u')
		                    ->Join('posts as p','u.user_id','=','p.user_id')
		                     ->leftJoin('post_likes as l', function ($join)use ($request){
			                        $join->on('l.post_id','=','p.post_id')
			                            ->where('l.user_id',$request->user_id);
			                        })
		                    ->leftJoin('categories as c','u.cat_id','=','c.cat_id')
		                    ->select(DB::raw('l.like_id as like_id,u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.cat_id as cat_id,c.category as cat_name,p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type'))
		                    ->where('deleted','0');*/

			$strSql = " select * from ( select l.like_id as like_id, u.user_id as user_id,u.app_token as app_token,u.username as username,u.profile_pic as profile_pic,GROUP_CONCAT(DISTINCT c.cat_id) as cat_id,GROUP_CONCAT(DISTINCT c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type 
							from users as u
							join posts as p on u.user_id = p.user_id 
							left join post_likes as l on l.post_id = p.post_id and l.user_id = " . $request->user_id . "
							left join followers as f on f.following_id=u.user_id and f.user_id = " . $login_id . "
							left join posts as p2 on p2.post_id  = p.shared_post_id
							left join users as u2 on p2.user_id = u2.user_id
							left join categories as c on FIND_IN_SET(c.cat_id, u.cat_id) > 0
							where u.deleted = 0 and p.show_on_wall=1 ";

			if (isset($request->post_ids)) {
				if ($request->post_ids != "") {
					$post_ids = trim($request->post_ids, ",");
					$strSql = $strSql . " and p.post_id not in (" . $post_ids . ")";
				}
			}

			$where_gender = "";
			if (isset($request->gender) && $request->gender != "") {
				$gender = substr($request->gender, 1);
				$strSql = $strSql . " and u.gender ='" . $gender . "'";
			}

			$where_cat = "";

			if (isset($request->category) && $request->category != "") {
				$category = substr($request->category, 1);
				$cat_arr = explode(",", $category);
				foreach ($cat_arr as $val) {
					$where_cat = $where_cat . " or (CONCAT(',',u.cat_id,',') like '%," . $val . ",%')";
				}
				$strSql = $strSql . " and (" . substr($where_cat, 3) . ")";
			}

			$where_age = "";
			if (isset($request->age) && $request->age != "") {
				$age = substr($request->age, 1);
				$age_arr = explode(",", $age);
				foreach ($age_arr as $val) {
					$val_arr = explode("-", $val);
					$where_age = $where_age . " or (round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) between " . $val_arr[0] . " and " . $val_arr[1] . ")";
				}
				$strSql = $strSql . " and (" . substr($where_age, 3) . ")";
			}

			$where_loc = "";
			if (isset($request->location) && $request->location != "") {
				$location = substr($request->location, 1);
				$loc_arr = explode(",", $location);
				foreach ($loc_arr as $val) {
					$where_loc = $where_loc . ' or (u.country ="' . $val . '")';
				}
				$strSql = $strSql . " and (" . substr($where_loc, 3) . ")";
			}

			$where_lan = "";
			if (isset($request->language) && $request->language != "") {
				$language = substr($request->language, 1);
				$lan_arr = explode(",", $language);
				foreach ($lan_arr as $val) {
					$where_lan = $where_lan . ' or (u.language like "%' . $val . '%")';
				}
				$strSql = $strSql . " and (" . substr($where_lan, 3) . ")";
			}

			$where_key = "";
			if (isset($request->keyword) && $request->keyword != "") {
				$key_arr = explode(",", $request->keyword);
				foreach ($key_arr as $val) {
					$where_key = $where_key . ' or (u.first_name like "%' . $val . '%") or (u.last_name like "%' . $val . '%") or (c.category like "%' . $val . '%") or (u.state like "%' . $val . '%") or (u.country like "%' . $val . '%")';
				}
				$strSql = $strSql . " and (" . substr($where_key, 3) . ")";
			}
			//$total_records=$res->count();
			if ($blocked_user_res->user_id == 0) {
			} else {
				$blocked_res = $blocked_user_res->user_id;
				//$blocked_res=explode(',',$blocked_res);
				$strSql = $strSql . " and p.user_id not in(" . $blocked_res . ")";
			}
			if ($blocked_user_res2->user_id == 0) {
			} else {
				$blocked_res2 = $blocked_user_res2->user_id;
				//$blocked_res2=explode(',',$blocked_res2);
				$strSql = $strSql . " and p.user_id not in(" . $blocked_res2 . ")";
			}
			$res2 = array();
			if (isset($request->follow) && $request->follow != "") {
				$following_user_res = DB::table('followers')
					->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
					->where('following_id', $request->user_id)
					->first();
				if ($following_user_res->user_id == '') {
					$data = array('warning' => 'Sorry..! No record found.');
					$response = array("status" => "success", 'msg' => 'Candidate List filtered successfully', 'content' => $data);
					return response()->json($response);
				} else {
					$following_res = $following_user_res->user_id;
					//$res2=explode(',',$following_res);
					$strSql = $strSql . " and p.user_id in(" . $following_res . ")";
				}
			}
			$strSql = $strSql . " group by u2.user_id, u2.username, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, like_id, u.user_id, u.app_token, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p.likes, p.views, p.comments, p.shares, p.type";
			$strSql = $strSql . " order by p.post_id desc";
			$strSql = $strSql . " limit 200 ) as T1 order by rand() limit 20";

			/*
					
		            $res=DB::table('users as  u')
		                    ->Join('posts as p','u.user_id','=','p.user_id')
		                    ->leftJoin('post_likes as l', function ($join)use ($request){
			                        $join->on('l.post_id','=','p.post_id')
			                            ->where('l.user_id',$request->user_id);
			                        })
		                    ->leftJoin('posts as p2', 'p2.post_id','=','p.shared_post_id')
		                    ->leftJoin('users as u2', 'p2.user_id','=','u2.user_id')
		                    ->leftjoin("categories as c",\DB::raw("FIND_IN_SET(c.cat_id, u.cat_id)"),">",\DB::raw("'0'"))
		                    ->select(DB::raw('l.like_id as like_id, u.user_id as user_id,u.app_token as app_token,u.username as username,u.profile_pic as profile_pic,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type'))
		                    ->where('u.deleted','0')
		                    ->where('p.show_on_wall','1');
		       		
		       		if(isset($request->post_ids)){
						if($request->post_ids!=""){
							$post_ids = trim($request->post_ids,",");
							$res = $res->where('p.post_id',"<>",$post_ids);
						}
					}
		       		
                    if(!isset($request->page) && $request->page==""){
                        $page=1;
                    }else{
                        $page=$request->page;
                    }
                    $limit=20;
                    $offset=($page-1)*$limit;
                    $where_gender="";
                    if(isset($request->gender) && $request->gender!=""){
                        $gender=substr($request->gender,1);
                        $where_gender= $where_gender." or u.gender='".$gender."'";
                        $where_gender=$res->whereRaw(substr($where_gender,3));
                        $res=$where_gender;
                    }

                      $where_cat="";

                    if(isset($request->category) && $request->category!=""){
                        $category=substr($request->category,1);
                        
                        $cat_arr=explode(",",$category);
                       
                        foreach ($cat_arr as $val){
                        	$where_cat=$where_cat." or (CONCAT(',',u.cat_id,',') like '%,".$val.",%')";
                        	//$where_cat=$where_cat." or (users.cat_id =".$val.")";
                        }
                        $where_cat=$res->whereRaw("(".substr($where_cat,3).")");
                        $res=$where_cat;
                       
                    }

                    $where_age = "";
                    if(isset($request->age) && $request->age!=""){
                        $age=substr($request->age,1);
                        $age_arr=explode(",",$age);
                        foreach ($age_arr as $val){
                        	$val_arr = explode("-", $val);
							$where_age = $where_age." or (round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) between ". $val_arr[0] ." and ". $val_arr[1].")";
                        }
                       
                        $where_age=$res->whereRaw("(".substr($where_age,3).")");
                       $res=$where_age;
                    }

                    $where_loc="";
                    if(isset($request->location) && $request->location!=""){
                        $location=substr($request->location,1);
                        $loc_arr=explode(",",$location);
                        foreach ($loc_arr as $val){
                        $where_loc=$where_loc.' or (u.country ="'.$val.'")';
                        }
                       
                        $where_loc=$res->whereRaw("(".substr($where_loc,3).")");
                        $res=$where_loc;
                    }
                    
                    $where_lan="";
                    if(isset($request->language) && $request->language!=""){
                        $language=substr($request->language,1);
                        $lan_arr=explode(",",$language);
                        foreach ($lan_arr as $val){
                        $where_lan=$where_lan.' or (u.language like "%'.$val.'%")';
                        }
                        $where_lan=$res->whereRaw("(".substr($where_lan,3).")");
                        $res=$where_lan;
                    }

                    $where_key="";
                    if(isset($request->keyword) && $request->keyword!=""){
                        $key_arr=explode(",",$request->keyword);
                        foreach ($key_arr as $val){
                        $where_key=$where_key.' or (u.first_name like "%'.$val.'%") or (u.last_name like "%'.$val.'%") or (c.category like "%'.$val.'%") or (u.state like "%'.$val.'%") or (u.country like "%'.$val.'%")';
                        }
                        $where_key=$res->whereRaw("(".substr($where_key,3).")");
                        $res=$where_key;
                    }
                //$total_records=$res->count();
                 if($blocked_user_res->user_id==0){
					   
					   }else{
					   	$blocked_res=$blocked_user_res->user_id;
					   $blocked_res=explode(',',$blocked_res);
					   $res=$res->whereNotIn('p.user_id', $blocked_res);
					   
					   }
				 if($blocked_user_res2->user_id==0){
					   
					   }else{
					   	$blocked_res2=$blocked_user_res2->user_id;
					   $blocked_res2=explode(',',$blocked_res2);
					   $res=$res->whereNotIn('p.user_id', $blocked_res2);
					   
					   }
					   $res2=array();
					if(isset($request->follow) && $request->follow!=""){
						$following_user_res=DB::table('followers')
	                     ->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
	                     ->where('following_id',$request->user_id)
	                     ->first(); 
						if($following_user_res->user_id==''){
						   $data=array('warning'=>'Sorry..! No record found.');
						   $response = array("status" => "success",'msg'=>'Candidate List filtered successfully' ,'content' => $data);
						   return response()->json($response);
						   }else{
						   	$following_res=$following_user_res->user_id;
						    $res2=explode(',',$following_res);
						 
						   $res=$res->whereIn('p.user_id', $res2);
					   
					   	}
						
					}
				
                $res=$res->groupBy('u2.user_id', 'u2.username', 'u2.profile_pic','p.shared_post_id','p2.post_id','p2.type','p2.file','p2.title','like_id','u.user_id','u.app_token','u.username','u.profile_pic','p.post_id','p.file','p.title','p.added_on','p.likes','p.views','p.comments','p.shares','p.type')
                		->orderByRaw('rand(), (p.likes+p.comments+p.shares+p.views) desc, p.post_id desc')
                		 ->paginate($limit);
	            $total_records=$res->total();
				*/
			$res = DB::select(DB::raw($strSql));
			if (!isset($request->page) && $request->page == "") {
				$page = 1;
			} else {
				$page = $request->page;
			}

			$total_records = 0;
			$data = array();
			if ($res) {
				$total_records = count($res);
				$i = 0;
				foreach ($res as $r) {
					if ($i > 2 || $page > 1 || $r->type != "V") {
						$i++;
						if (stripos($r->profile_pic, 'https://') !== false) {

							$p = $r->profile_pic;
						} else {
							if ($r->profile_pic == "") {
								$p = asset('assets/images/profile.png');
							} else {
								$p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
							}
						}
						$p2 = "";
						if ($r->shared_post_id > 0) {
							if (stripos($r->profile_pic, 'https://') !== false) {

								$p2 = $r->profile_pic2;
							} else {
								if ($r->profile_pic2 == "") {
									$p2 = asset('assets/images/profile.png');
								} else {
									$p2 = Storage::url("profile_pic/" . $r->user_id2 . "/" . $r->profile_pic2);
								}
							}
						}
						if ($r->type == "V") {
							$thumb = explode(".", $r->file);
							$thum = $thumb[0] . ".jpg";
							//$thum=substr($r->file, 0, -3)."jpg";
							$file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
							$thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
						} else {
							$file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
							$thumb_file = "";
						}
						$file2 = "";
						$thumb_file2 = "";
						if ($r->shared_post_id > 0) {
							if ($r->type2 == "V") {
								$thumb2 = explode(".", $r->file2);
								$thum2 = $thumb2[0] . ".jpg";
								//$thum=substr($r->file, 0, -3)."jpg";
								$file2 = Storage::url("videos/" . $r->user_id2 . "/" . $r->file2);
								$thumb_file2 = Storage::url("videos/" . $r->user_id2 . "/thumb/" . $thum2);
							} else {
								$file2 = Storage::url("photos/" . $r->user_id2 . "/" . $r->file2);
								$thumb_file2 = "";
							}
						}
						$fetch_time = explode(":", $time2);

						if ($symbol == '+') {
							//$time=strtotime($r->added_on)+strtotime($time2);
							$time = date("Y-m-d H:i", strtotime('+' . $fetch_time[0] . ' hour +' . $fetch_time[1] . ' minutes', strtotime($r->added_on)));
						} elseif ($symbol == '-') {
							$time = date("Y-m-d H:i", strtotime('-' . $fetch_time[0] . ' hour -' . $fetch_time[1] . ' minutes', strtotime($r->added_on)));
						} else {
							$time = '';
						}

						if ($time == '') {
							$added_on = ($r->added_on);
						} else {
							//$time = date("Y-m-d H:i:s",$time);
							$added_on = ($time);
						}
						$data_comment['comment'] = array();

						if ($r->comments > 0) {

							$rs_comments = DB::table('post_comments as c')
								->Join('users as u', 'c.user_id', '=', 'u.user_id')
								->select(DB::raw('u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
								->where('c.post_id', $r->post_id)
								->where('c.parent_id', 0);
							// ->orderBy('comment_id','desc');

							$rs_comments = $rs_comments->orderBy('comment_id', 'desc')
								->offset(0)
								->limit(2)
								->get();
							//->get();
							//print_r($res);

							foreach ($rs_comments as $c) {
								if ($c->profile_pic == "") {
									$p_comment = asset('assets/images/profile.png');
								} else {
									$p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
								}
								$fetch_time = explode(":", $time2);

								if ($symbol == '+') {
									//$time=strtotime($r->added_on)+strtotime($time2);
									$time_comment = date("Y-m-d H:i", strtotime('+' . $fetch_time[0] . ' hour +' . $fetch_time[1] . ' minutes', strtotime($c->comment_on)));
								} elseif ($symbol == '-') {
									$time_comment = date("Y-m-d H:i", strtotime('-' . $fetch_time[0] . ' hour -' . $fetch_time[1] . ' minutes', strtotime($c->comment_on)));
								} else {
									$time_comment = '';
								}

								if ($time_comment == '') {
									$comment_on = ($c->comment_on);
								} else {
									//$time = date("Y-m-d H:i:s",$time);
									$comment_on = ($time);
								}

								$data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id);
							}
						}
						$data_comment['comment'] = array_reverse($data_comment['comment']);
						if ($r->shared_post_id == 0) {
							$sig = md5($r->post_id . "*FilmsDream@1290");
						} else {
							$sig = md5($r->post_id2 . "*FilmsDream@1290");
						}
						$s = array('shared_post_id' => $r->shared_post_id, 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'user_id' => $r->user_id, 'user_id2' => $r->user_id2, 'app_token' => $r->app_token, 'file1' => $r->file, 'username' => $r->username, 'username2' => $r->username2, 'file' => $file, 'file2' => $file2, 'thumb' => $thumb_file, 'thumb2' => $thumb_file2, 'title' => $r->title, 'title2' => $r->title2, 'added_on' => $added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'profile_pic2' => $p2, 'type' => $r->type, 'type2' => $r->type2, 'cat_id' => $r->cat_id, 'cat_name' => $r->cat_name, 'post_id' => $r->post_id, 'post_id2' => $r->post_id2, 'sig' => $sig);
						array_push($data, $s);
					}
				}
			} else {
				$data = array('warning' => 'Sorry..! No record found.');
			}

			$response = array("status" => "success", 'msg' => 'Wall Post List', 'content' => $data, 'total_records' => $total_records);


			return response()->json($response);
		}
	}

	// Main List method
// 	public function wall_info_with_ad_post(Request $request)
// 	{
// 		ini_set("serialize_precision", 1);
// 		if (auth()->guard('api')->user()) {
// 			$login_id = auth()->guard('api')->user()->user_id;
// 		} else {
// 			$login_id = 0;
// 		}
// 		$blocked_user_res = DB::table('blocked_users')
// 			->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
// 			->where('blocked_by', $login_id)
// 			->first();
// 		$blocked_user_res2 = DB::table('blocked_users')
// 			->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
// 			->where('user_id', $login_id)
// 			->first();

// 		/* echo $blocked_res;
// 			  exit;*/
// 		/* $res=DB::table('users as  u')
//                     ->Join('posts as p','u.user_id','=','p.user_id')f
//                      ->leftJoin('post_likes as l', function ($join)use ($request){
// 	                        $join->on('l.post_id','=','p.post_id')
// 	                            ->where('l.user_id',$request->user_id);
// 	                        })
//                     ->leftJoin('categories as c','u.cat_id','=','c.cat_id')
//                     ->select(DB::raw('l.like_id as like_id,u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.cat_id as cat_id,c.category as cat_name,p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type'))
//                     ->where('deleted','0');*/

// 		// 		$strSql = " select * from ( select l.like_id as like_id,rp.id as rp_id, u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,p.aspect_ratio,p2.aspect_ratio as aspect_ratio2,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p2.added_on as shared_added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type ,case when f.follower_id IS NULL then 0 else 1 end as isFollowing,case when fav.fav_id IS NULL then 0 else 1 end as isFav
// 		//         		from users as u
// 		//         		join posts as p on u.user_id = p.user_id 
// 		//         		left join post_likes as l on l.post_id = p.post_id and l.user_id = " . $login_id . "
// 		//         		left join followers as f on f.user_id=u.user_id and f.following_id = " . $login_id . "
// 		//         		left join favorite_users as fav on fav.user_id=u.user_id and fav.added_by = " . $login_id . "
// 		//         		left join posts as p2 on p2.post_id  = p.shared_post_id
// 		//         		left join users as u2 on p2.user_id = u2.user_id
// 		//         		left join categories as c on FIND_IN_SET(c.cat_id, u.cat_id) > 0
// 		//         		left join reports as rp on p.post_id = rp.post_id and rp.user_id = " . $login_id . "
// 		//         		where  rp.id is null and  u.deleted = 0 and p.show_on_wall=1  and p.active=1 and p.type!='A'";
// 		config()->set('database.connections.mysql.strict', false);
// 		DB::reconnect();
// 		$strSql = " select * from ( select l.like_id as like_id,rp.id as rp_id, u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,p.aspect_ratio,
// 					p2.aspect_ratio as aspect_ratio2,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2,
// 					u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2,
// 					p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p2.added_on as shared_added_on,p.likes as likes,p.views as views,
// 					p.comments as comments,p.shares as shares,p.type as type ,case when f.follower_id IS NULL then 0 else 1 end as isFollowing,
// 					case when fav.fav_id IS NULL then 0 else 1 end as isFav,
// 					lpl.user_id as lkuser_id,lplu.username as lkusername,
// 					lpc.user_id as cuser_id,lpcu.username as cusername,lpc.comment_id as ccomment_id,lpc.comment_on as ccomment_on,
// 					lpc.comment as ccomment,lpcu.profile_pic as cprofile_pic,lpcu.gender as cgender,
// 					ch.tag as challenge_tag,p.challenge_id
//         		from users as u
//         		join posts as p on u.user_id = p.user_id 
// 				left join last_post_likes as lpl on lpl.post_id = p.post_id
// 				left join users as lplu on lplu.user_id = lpl.user_id
// 				left join last_post_comments as lpc on lpc.post_id = p.post_id
// 				left join users as lpcu on lpcu.user_id = lpc.user_id
//         		left join post_likes as l on l.post_id = p.post_id and l.user_id = " . $login_id . "
//         		left join followers as f on f.user_id=u.user_id and f.following_id = " . $login_id . "
//         		left join favorite_users as fav on fav.user_id=u.user_id and fav.added_by = " . $login_id . "
//         		left join posts as p2 on p2.post_id  = p.shared_post_id
//         		left join users as u2 on p2.user_id = u2.user_id
//         		left join categories as c on FIND_IN_SET(c.cat_id, u.cat_id) > 0
//         		left join reports as rp on p.post_id = rp.post_id and rp.user_id = " . $login_id . "
// 				left join challenges as ch on ch.id = p.challenge_id and p.challenge_approved=1
//         		where  rp.id is null and u.deleted = 0 and p.show_on_wall=1 and p.active=1 and p.type!='A'";
// 		// dd($strSql);
// 		if ($request->shared) {
// 			// $strSql = $strSql." and p.shared_post_id > 0";
// 		} else {
// 			$strSql = $strSql . " and p.type!='S'";
// 		}
// 		if (isset($request->post_ids)) {
// 			if ($request->post_ids != "") {
// 				$post_ids = trim($request->post_ids, ",");
// 				$strSql = $strSql . " and p.post_id not in (" . $post_ids . ")";
// 			}
// 		}


// 		$where_gender = "";
// 		if (isset($request->gender) && $request->gender != "") {
// 			$gender = substr($request->gender, 1);
// 			$strSql = $strSql . " and u.gender ='" . $gender . "'";
// 		}

// 		$where_cat = "";

// 		if (isset($request->category) && $request->category != "") {
// 			$category = substr($request->category, 1);
// 			$cat_arr = explode(",", $category);
// 			foreach ($cat_arr as $val) {
// 				$where_cat = $where_cat . " or (CONCAT(',',u.cat_id,',') like '%," . $val . ",%')";
// 			}
// 			$strSql = $strSql . " and (" . substr($where_cat, 3) . ")";
// 		}

// 		$where_age = "";
// 		if (isset($request->age) && $request->age != "") {
// 			$age = substr($request->age, 1);
// 			$age_arr = explode(",", $age);
// 			foreach ($age_arr as $val) {
// 				$val_arr = explode("-", $val);
// 				$where_age = $where_age . " or (round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) between " . $val_arr[0] . " and " . $val_arr[1] . ")";
// 			}
// 			$strSql = $strSql . " and (" . substr($where_age, 3) . ")";
// 		}

// 		$where_loc = "";
// 		if (isset($request->location) && $request->location != "") {
// 			$location = substr($request->location, 1);
// 			$loc_arr = explode(",", $location);
// 			foreach ($loc_arr as $val) {
// 				$where_loc = $where_loc . ' or (u.country ="' . $val . '")';
// 			}
// 			$strSql = $strSql . " and (" . substr($where_loc, 3) . ")";
// 		}

// 		$where_lan = "";
// 		if (isset($request->language) && $request->language != "") {
// 			$language = substr($request->language, 1);
// 			$lan_arr = explode(",", $language);
// 			foreach ($lan_arr as $val) {
// 				$where_lan = $where_lan . ' or (u.language like "%' . $val . '%")';
// 			}
// 			$strSql = $strSql . " and (" . substr($where_lan, 3) . ")";
// 		}

// 		$where_key = "";
// 		if (isset($request->keyword) && $request->keyword != "") {
// 			$key_arr = explode(",", $request->keyword);
// 			foreach ($key_arr as $val) {
// 				$where_key = $where_key . ' or (u.first_name like "%' . $val . '%") or (u.last_name like "%' . $val . '%") or (c.category like "%' . $val . '%") or (u.state like "%' . $val . '%") or (u.country like "%' . $val . '%")';
// 			}
// 			$strSql = $strSql . " and (" . substr($where_key, 3) . ")";
// 		}
// 		//$total_records=$res->count();
// 		if ($blocked_user_res->user_id == 0) {
// 		} else {
// 			$blocked_res = $blocked_user_res->user_id;
// 			//$blocked_res=explode(',',$blocked_res);
// 			$strSql = $strSql . " and p.user_id not in(" . $blocked_res . ")";
// 		}
// 		if ($blocked_user_res2->user_id == 0) {
// 		} else {
// 			$blocked_res2 = $blocked_user_res2->user_id;
// 			//$blocked_res2=explode(',',$blocked_res2);
// 			$strSql = $strSql . " and p.user_id not in(" . $blocked_res2 . ")";
// 		}
// 		$res2 = array();
// 		if (isset($request->follow) && $request->follow == "true") {
// 			$following_user_res = DB::table('followers')
// 				->select(DB::raw('ifnull(group_concat(following_id),0) as user_id'))
// 				->where('user_id', $login_id)
// 				->first();
// 			if ($following_user_res->user_id == '') {
// 				$data = array('warning' => 'Sorry..! No record found.');
// 				$response = array("status" => "success", 'msg' => 'Candidate List filtered successfully', 'content' => $data);
// 				return response()->json($response);
// 			} else {
// 				$following_res = $following_user_res->user_id;
// 				//$res2=explode(',',$following_res);
// 				$strSql = $strSql . " and p.user_id in(" . $following_res . ")";
// 			}
// 		}
// 		//$strSql = $strSql . " group by fav.fav_id,f.follower_id,u2.user_id,rp.id, u2.gender,u.gender,u2.username, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p2.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio,p2.aspect_ratio,lpl.user_id,lplu.username,lpc.user_id,lpcu.username,lpc.comment_id,lpc.comment_on,lpc.comment,lpcu.profile_pic,lpcu.gender ";
// 		$strSql = $strSql . " group by fav.fav_id,f.follower_id,u2.user_id,rp.id, u2.gender,u.gender,u2.username, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p2.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio,p2.aspect_ratio";
// 		// 			$strSql = $strSql." order by p.comments desc";
// 		$strSql = $strSql . " order by p.post_id desc";
// 		$strSql = $strSql . " limit 200 ) as T1 order by rand() limit 20";

// 		// 		dd($strSql);
// 		$res = DB::select(DB::raw($strSql));
// 		if (!isset($request->page) && $request->page == "") {
// 			$page = 1;
// 		} else {
// 			$page = $request->page;
// 		}
// 		config()->set('database.connections.mysql.strict', true);
// 		DB::reconnect();
// 		$total_records = 0;
// 		$data = array();
// 		if ($res) {
// 			$total_records = count($res);
// 			$i = 0;
// 			foreach ($res as $r) {
// 				// if($i>2 || $page>1 || $r->type!="V"){
// 				$i++;
// 				if ($r->profile_pic == "") {
// 					if ($r->gender == "M") {
// 						$p = secure_asset('assets/images/avatar-man.png');
// 					} else if ($r->gender == "F") {
// 						$p = secure_asset('assets/images/avatar-woman.png');
// 					} else {
// 						$p = secure_asset('assets/images/profile.png');
// 					}
// 				} else {
// 					if (stripos($r->profile_pic, 'https://') !== false) {
// 						$p = $r->profile_pic;
// 					} else {
// 						$p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
// 					}
// 				}
// 				$p2 = "";
// 				if ($r->shared_post_id > 0) {
// 					if ($r->profile_pic2 == "") {
// 						if ($r->gender2 == "M") {
// 							$p2 = secure_asset('assets/images/avatar-man.png');
// 						} else if ($r->gender2 == "F") {
// 							$p2 = secure_asset('assets/images/avatar-woman.png');
// 						} else {
// 							$p2 = secure_asset('assets/images/profile.png');
// 						}
// 					} else {
// 						if (stripos($r->profile_pic2, 'https://') !== false) {
// 							$p2 = $r->profile_pic2;
// 						} else {
// 							$p2 = Storage::url("profile_pic/" . $r->user_id2 . "/" . $r->profile_pic2);
// 						}
// 					}
// 				}
// 				if ($r->type == "V") {
// 					$thumb = explode(".", $r->file);
// 					$thum = $thumb[0] . ".jpg";
// 					//$thum=substr($r->file, 0, -3)."jpg";
// 					$file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
// 					$thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
// 				} else {
// 					$file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
// 					$thumb_file = "";
// 				}
// 				$file2 = "";
// 				$thumb_file2 = "";
// 				if ($r->shared_post_id > 0) {
// 					if ($r->type2 == "V") {
// 						$thumb2 = explode(".", $r->file2);
// 						$thum2 = $thumb2[0] . ".jpg";
// 						//$thum=substr($r->file, 0, -3)."jpg";
// 						$file2 = Storage::url("videos/" . $r->user_id2 . "/" . $r->file2);
// 						$thumb_file2 = Storage::url("videos/" . $r->user_id2 . "/thumb/" . $thum2);
// 					} else {
// 						$file2 = Storage::url("photos/" . $r->user_id2 . "/" . $r->file2);
// 						$thumb_file2 = "";
// 					}
// 				}
// 				$added_on = $r->added_on;
// 				$data_liked_users['users'] = array();
// 				if ($r->likes > 0) {
// 					$data_liked_users['users'][] = array("post_id" => $r->post_id, "like_id" => 0, "user_id" => $r->lkuser_id, "username" => $r->lkusername, "liked_on" => '', "profile_pic" => '');
// 					// 	$rs_liked_users = DB::table('post_likes as l')
// 					// 		->Join('users as u', 'l.user_id', '=', 'u.user_id')
// 					// 		->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
// 					// 		->where('l.post_id', $r->post_id);
// 					// 	// ->orderBy('comment_id','desc');

// 					// 	$rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
// 					// 		//->skip($offset) 
// 					// 		->paginate(2);
// 					// 	//->get();
// 					// 	//print_r($res);
// 					// 	$total_liked_users = $rs_liked_users->total();

// 					// 	if (!$rs_liked_users->isEmpty()) {

// 					// 		foreach ($rs_liked_users as $l) {
// 					// 			if ($l->profile_pic == "") {
// 					// 				if ($l->gender == "M") {
// 					// 					$p_liked = secure_asset('assets/images/avatar-man.png');
// 					// 				} else if ($l->gender == "F") {
// 					// 					$p_liked = secure_asset('assets/images/avatar-woman.png');
// 					// 				} else {
// 					// 					$p_liked = secure_asset('assets/images/profile.png');
// 					// 				}
// 					// 			} else {
// 					// 				$p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
// 					// 			}

// 					// 			$liked_on = ($l->like_on);

// 					// 			$data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
// 					// 		}
// 					// 	}
// 				}

// 				$data_comment['comment'] = array();

// 				if ($r->comments > 0) {
// 					if (stripos($r->cprofile_pic, 'https://') !== false) {

// 						$p_comment = $r->cprofile_pic;
// 					} else {
// 						if ($r->cprofile_pic == "") {
// 							if ($r->cgender == "M") {
// 								$p_comment = secure_asset('assets/images/avatar-man.png');
// 							} else if ($r->cgender == "F") {
// 								$p_comment = secure_asset('assets/images/avatar-woman.png');
// 							} else {
// 								$p_comment = secure_asset('assets/images/profile.png');
// 							}
// 						} else {
// 							$p_comment = Storage::url("profile_pic/" . $r->cuser_id . "/" . $r->cprofile_pic);
// 						}
// 					}
// 					$data_comment['comment'][] = array("comment_id" => $r->ccomment_id, "user_id" => $r->cuser_id, "username" => $r->cusername, "comment" => $r->ccomment, "comment_on" => $r->ccomment_on, "profile_pic" => $p_comment, "parent_id" => 0, "post_id" => $r->post_id);

// 					// 	$rs_comments = DB::table('post_comments as c')
// 					// 		->Join('users as u', 'c.user_id', '=', 'u.user_id')
// 					// 		->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
// 					// 		->where('c.post_id', $r->post_id)
// 					// 		->where('c.parent_id', 0);
// 					// 	// ->orderBy('comment_id','desc');

// 					// 	$rs_comments = $rs_comments->orderBy('comment_id', 'desc')
// 					// 		->offset(0)
// 					// 		->limit(2)
// 					// 		->get();
// 					// 	//->get();
// 					// 	//print_r($res);

// 					// 	foreach ($rs_comments as $c) {
// 					// 		if ($c->profile_pic == "") {
// 					// 			if ($c->gender == "M") {
// 					// 				$p_comment = secure_asset('assets/images/avatar-man.png');
// 					// 			} else if ($c->gender == "F") {
// 					// 				$p_comment = secure_asset('assets/images/avatar-woman.png');
// 					// 			} else {
// 					// 				$p_comment = secure_asset('assets/images/profile.png');
// 					// 			}
// 					// 		} else {
// 					// 			$p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
// 					// 		}

// 					// 		$comment_on = $c->comment_on;


// 					// 		$data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id, "post_id" => $r->post_id);
// 					// 	}
// 				}
// 				$data_comment['comment'] = array_reverse($data_comment['comment']);
// 				if ($r->shared_post_id == 0) {
// 					$aspect_ratio = $r->aspect_ratio;
// 					$sig = md5($r->post_id . "*FilmsDream@1290");
// 				} else {
// 					$aspect_ratio = $r->aspect_ratio2;
// 					$sig = md5($r->post_id2 . "*FilmsDream@1290");
// 				}
// 				$s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'user_id' => $r->user_id, 'user_id2' => $r->user_id2, 'file1' => $r->file, 'username' => $r->username, 'username2' => $r->username2, 'file' => $file, 'file2' => $file2, 'thumb' => $thumb_file, 'thumb2' => $thumb_file2, 'title' => $r->title, 'title2' => $r->title2, 'added_on' => $added_on, 'shared_added_on' => $r->shared_added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'profile_pic2' => $p2, 'type' => $r->type, 'type2' => $r->type2, 'cat_id' => $r->cat_id, 'cat_name' => $r->cat_name, 'post_id' => $r->post_id, 'post_id2' => $r->post_id2, 'sig' => $sig, 'aspect_ratio' => number_format($aspect_ratio, 1), 'isFollowing' => $r->isFollowing, 'isFav' => $r->isFav, 'rp_id' => $r->rp_id, 'challenge_id' => $r->challenge_id, 'challenge_tag' => $r->challenge_tag);
// 				array_push($data, $s);
// 				if ($i == 3 || $i == 10) {

// 					if ($login_id > 0) {
// 						$user = DB::table("users")
// 							->select(DB::raw('*'))
// 							->where("user_id", $login_id)
// 							->first();
// 						$country = $user->country;
// 						$state = $user->state;
// 						if (strtolower($country) == "usa") {
// 							$country = "United States";
// 						}
// 					} else {
// 						$country = "United States";
// 						$state = '';
// 					}

// 					//     $res = DB::table("wall_ads")
// 					//                 ->join('posts','posts.ad_id','wall_ads.id')
// 					//         ->select(DB::raw('wall_ads.*'))
// 					//         ->where("wall_ads.active",1)
// 					//         ->where('posts.type','A')
// 					//         ->whereRaw(DB::raw(" (wall_ads.countries like '%".$country."%' or wall_ads.countries like '%All Countries%')" ))
// 					//         ->whereRaw(DB::raw(" (wall_ads.states like '%".$state."%' or IFNULL(wall_ads.states,'')='')" ))
// 					//         ->whereRaw(DB::raw("wall_ads.active=1 and '".date("Y-m-d")."' between wall_ads.start_date and wall_ads.expiry_date"))
// 					//         //->whereRaw(DB::raw("ad_type in ('M', 'M') "))
// 					// 		->orderBy(DB::raw("rand()"))
// 					//         ->first();

// 					// $sql2="select ad.*, l.like_id as like_id,rp.id as rp_id,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type

// 					//                             		from posts as p 
// 					//                             		join wall_ads as ad on p.ad_id=ad.ad_id
// 					//                             		left join post_likes as l on l.post_id = p.post_id and l.user_id = ".$login_id."
// 					//                             		left join posts as p2 on p2.post_id  = p.shared_post_id
// 					//                             		left join users as u2 on p2.user_id = u2.user_id
// 					//                             		left join reports as rp on p.post_id = rp.post_id and rp.user_id = ".$login_id."
// 					//                             		where  rp.id is null and  p.show_on_wall=1 and p.type='A' ";

// 					$res = DB::table('posts as p')
// 						->select(DB::raw("ad.*, p.post_id as post_id, l.like_id as like_id,rp.id as rp_id,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type,
//             						lpl.user_id as lkuser_id,lplu.username as lkusername,
//                 					lpc.user_id as cuser_id,lpcu.username as cusername,lpc.comment_id as ccomment_id,lpc.comment_on as ccomment_on,
//                 					lpc.comment as ccomment,lpcu.profile_pic as cprofile_pic,lpcu.gender as cgender,ch.tag as challenge_tag,p.challenge_id"))
// 						->join('wall_ads as ad', 'p.ad_id', 'ad.ad_id', function ($join) use ($login_id) {
// 							$join->whereRaw(DB::raw("active=1 and '" . date("Y-m-d") . "' between start_date and expiry_date"));
// 							// ->where("l.user_id", $login_id);
// 						})
// 						->leftJoin('post_likes as l', function ($join) use ($login_id) {
// 							$join->on('l.post_id', 'p.post_id')
// 								->where("l.user_id", $login_id);
// 						})
// 						->leftJoin('posts as p2', 'p2.post_id', 'p.shared_post_id')
// 						->leftJoin('users as u2', 'p2.user_id', 'u2.user_id')
// 						->leftJoin('reports as rp', function ($join) use ($login_id) {
// 							$join->on('p.post_id', 'rp.post_id')
// 								->where("rp.user_id", $login_id);
// 						})
// 						->leftJoin('last_post_likes as lpl', 'lpl.post_id', 'p.post_id')
// 						->leftJoin('users as lplu', 'lplu.user_id', 'lpl.user_id')
// 						->leftJoin('last_post_comments as lpc', 'lpc.post_id', 'p.post_id')
// 						->leftJoin('users as lpcu', 'lpcu.user_id', 'lpc.user_id')
// 						->leftJoin('challenges as ch', 'ch.id', 'p.challenge_id')
// 						->whereRaw(DB::raw("rp.id is null and  p.show_on_wall=1 and p.type='A' and p.active=1 and ad.active=1"))->inRandomOrder()->first();


// 					if ($res) {

// 						$r = $res;

// 						$data_liked_users['users'] = array();

// 						if ($r->likes > 0) {
// 							$data_liked_users['users'][] = array("post_id" => $r->post_id, "like_id" => 0, "user_id" => $r->lkuser_id, "username" => $r->lkusername, "liked_on" => '', "profile_pic" => '');
// 							// 			$rs_liked_users = DB::table('post_likes as l')
// 							// 				->Join('users as u', 'l.user_id', '=', 'u.user_id')
// 							// 				->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
// 							// 				->where('l.post_id', $r->post_id);
// 							// 			// ->orderBy('comment_id','desc');

// 							// 			$rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
// 							// 				//->skip($offset) 
// 							// 				->paginate(2);
// 							// 			//->get();
// 							// 			//print_r($res);
// 							// 			$total_liked_users = $rs_liked_users->total();

// 							// 			if (!$rs_liked_users->isEmpty()) {

// 							// 				foreach ($rs_liked_users as $l) {
// 							// 					if ($l->profile_pic == "") {
// 							// 						if ($l->gender == "M") {
// 							// 							$p_liked = secure_asset('assets/images/avatar-man.png');
// 							// 						} else if ($l->gender == "F") {
// 							// 							$p_liked = secure_asset('assets/images/avatar-woman.png');
// 							// 						} else {
// 							// 							$p_liked = secure_asset('assets/images/profile.png');
// 							// 						}
// 							// 					} else {
// 							// 						$p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
// 							// 					}

// 							// 					$liked_on = ($l->like_on);

// 							// 					$data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
// 							// 				}
// 							// 			}
// 						}

// 						$data_comment['comment'] = array();

// 						if ($r->comments > 0) {
// 							if (stripos($r->cprofile_pic, 'https://') !== false) {

// 								$p_comment = $r->cprofile_pic;
// 							} else {
// 								if ($r->cprofile_pic == "") {
// 									if ($r->cgender == "M") {
// 										$p_comment = secure_asset('assets/images/avatar-man.png');
// 									} else if ($r->cgender == "F") {
// 										$p_comment = secure_asset('assets/images/avatar-woman.png');
// 									} else {
// 										$p_comment = secure_asset('assets/images/profile.png');
// 									}
// 								} else {
// 									$p_comment = Storage::url("profile_pic/" . $r->cuser_id . "/" . $r->cprofile_pic);
// 								}
// 							}
// 							$data_comment['comment'][] = array("comment_id" => $r->ccomment_id, "user_id" => $r->cuser_id, "username" => $r->cusername, "comment" => $r->ccomment, "comment_on" => $r->ccomment_on, "profile_pic" => $p_comment, "parent_id" => 0, "post_id" => $r->post_id);

// 							// 			$rs_comments = DB::table('post_comments as c')
// 							// 				->Join('users as u', 'c.user_id', '=', 'u.user_id')
// 							// 				->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
// 							// 				->where('c.post_id', $r->post_id)
// 							// 				->where('c.parent_id', 0);
// 							// 			// ->orderBy('comment_id','desc');

// 							// 			$rs_comments = $rs_comments->orderBy('comment_id', 'desc')
// 							// 				->offset(0)
// 							// 				->limit(2)
// 							// 				->get();
// 							// 			//->get();
// 							// 			//print_r($res);

// 							// 			foreach ($rs_comments as $c) {
// 							// 				if ($c->profile_pic == "") {
// 							// 					if ($c->gender == "M") {
// 							// 						$p_comment = secure_asset('assets/images/avatar-man.png');
// 							// 					} else if ($c->gender == "F") {
// 							// 						$p_comment = secure_asset('assets/images/avatar-woman.png');
// 							// 					} else {
// 							// 						$p_comment = secure_asset('assets/images/profile.png');
// 							// 					}
// 							// 				} else {
// 							// 					$p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
// 							// 				}

// 							// 				$comment_on = $c->comment_on;


// 							// 				$data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id, "post_id" => $r->post_id);
// 							// 			}
// 						}
// 						$data_comment['comment'] = array_reverse($data_comment['comment']);



// 						$ad_type = $res->ad_type;
// 						$ad_title1 = $res->title1;
// 						$ad_description1 = $res->description1;
// 						$ad_link1 = $res->link1;
// 						$ad_file1 = "";
// 						if ($res->file1 != "") {
// 							$ad_file1 = Storage::url("banners/" . $res->file1);
// 						}

// 						$ad_title2 = $res->title2;
// 						$ad_description2 = $res->description2;
// 						$ad_link2 = $res->link2;
// 						$ad_file2 = "";
// 						if ($res->file2 != "") {
// 							$ad_file2 = Storage::url("banners/" . $res->file2);
// 						}

// 						$ad_title3 = $res->title3;
// 						$ad_description3 = $res->description3;
// 						$ad_link3 = $res->link3;
// 						$ad_file3 = "";
// 						if ($res->file3 != "") {
// 							$ad_file3 = Storage::url("banners/" . $res->file3);
// 						}

// 						$ad_title4 = $res->title4;
// 						$ad_description4 = $res->description4;
// 						$ad_link4 = $res->link4;
// 						$ad_file4 = "";
// 						if ($res->file4 != "") {
// 							$ad_file4 = Storage::url("banners/" . $res->file4);
// 						}

// 						$ad_title5 = $res->title5;
// 						$ad_description5 = $res->description5;
// 						$ad_link5 = $res->link5;
// 						$ad_file5 = "";
// 						if ($res->file5 != "") {
// 							$ad_file5 = Storage::url("banners/" . $res->file5);
// 						}

// 						$views = $res->views + 1;
// 						$up_data = array("views" => $views);

// 						DB::table('wall_ads')
// 							->where('ad_id', $res->ad_id)
// 							->update($up_data);

// 						if ($r->shared_post_id == 0) {
// 							$aspect_ratio = 1;
// 							$sig = md5($r->post_id . "*FilmsDream@1290");
// 						} else {
// 							$aspect_ratio = 1;
// 							$sig = md5($r->post_id2 . "*FilmsDream@1290");
// 						}

// 						$s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'type' => 'A', 'post_id' => $r->post_id, 'ad_type' => $ad_type, 'ad_title1' => $ad_title1, 'ad_description1' => $ad_description1, 'ad_link1' => $ad_link1, 'ad_file1' => $ad_file1, 'ad_title2' => $ad_title2, 'ad_description2' => $ad_description2, 'ad_link2' => $ad_link2, 'ad_file2' => $ad_file2, 'ad_title3' => $ad_title3, 'ad_description3' => $ad_description3, 'ad_link3' => $ad_link3, 'ad_file3' => $ad_file3, 'ad_title4' => $ad_title4, 'ad_description4' => $ad_description4, 'ad_link4' => $ad_link4, 'ad_file4' => $ad_file4, 'ad_title5' => $ad_title5, 'ad_description5' => $ad_description5, 'ad_link5' => $ad_link5, 'ad_file5' => $ad_file5, 'likes' => $r->likes, 'views' => $r->views, 'comments' => $r->comments, 'shares' => $r->shares, 'sig' => $sig, 'challenge_id' => $r->challenge_id, 'challenge_tag' => $r->challenge_tag);
// 						// $s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'type' => 'A', 'post_id' => $r->post_id, 'ad_type' => $ad_type, 'ad_title1' => $ad_title1, 'ad_description1' => $ad_description1, 'ad_link1' => $ad_link1, 'ad_file1' => $ad_file1, 'ad_title2' => $ad_title2, 'ad_description2' => $ad_description2, 'ad_link2' => $ad_link2, 'ad_file2' => $ad_file2, 'ad_title3' => $ad_title3, 'ad_description3' => $ad_description3, 'ad_link3' => $ad_link3, 'ad_file3' => $ad_file3, 'ad_title4' => $ad_title4, 'ad_description4' => $ad_description4, 'ad_link4' => $ad_link4, 'ad_file4' => $ad_file4, 'ad_title5' => $ad_title5, 'ad_description5' => $ad_description5, 'ad_link5' => $ad_link5, 'ad_file5' => $ad_file5, 'likes' => $r->likes, 'views' => $r->views, 'comments' => $r->comments, 'shares' => $r->shares, 'sig' => $sig);
// 						array_push($data, $s);
// 					}
// 				}
// 				// }
// 			}
// 		} else {
// 			//   $data=array('warning'=>'Sorry..! No record found.');
// 			$data = array();
// 		}

// 		$response = array("status" => "success", 'msg' => 'Wall Post List', 'content' => $data, 'total_records' => $total_records);


// 		return response()->json($response);
// 		//}
// 	}

	public function wall_info_with_ad_post(Request $request)
	{
	   
		ini_set("serialize_precision", 1);
		if (auth()->guard('api')->user()) {
			$login_id = auth()->guard('api')->user()->user_id;
		} else {
			$login_id = 0;
		}
		$blocked_user_res = DB::table('blocked_users')
			->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
			->where('blocked_by', $login_id)
			->first();
		$blocked_user_res2 = DB::table('blocked_users')
			->select(DB::raw('ifnull(group_concat(blocked_by),0) as user_id'))
			->where('user_id', $login_id)
			->first();

		/* echo $blocked_res;
			  exit;*/
		/* $res=DB::table('users as  u')
                    ->Join('posts as p','u.user_id','=','p.user_id')f
                     ->leftJoin('post_likes as l', function ($join)use ($request){
	                        $join->on('l.post_id','=','p.post_id')
	                            ->where('l.user_id',$request->user_id);
	                        })
                    ->leftJoin('categories as c','u.cat_id','=','c.cat_id')
                    ->select(DB::raw('l.like_id as like_id,u.user_id as user_id,u.username as username,u.profile_pic as profile_pic,c.cat_id as cat_id,c.category as cat_name,p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type'))
                    ->where('deleted','0');*/

		// 		$strSql = " select * from ( select l.like_id as like_id,rp.id as rp_id, u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,p.aspect_ratio,p2.aspect_ratio as aspect_ratio2,GROUP_CONCAT(c.cat_id) as cat_id,GROUP_CONCAT(c.category) as cat_name,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p2.added_on as shared_added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type ,case when f.follower_id IS NULL then 0 else 1 end as isFollowing,case when fav.fav_id IS NULL then 0 else 1 end as isFav
		//         		from users as u
		//         		join posts as p on u.user_id = p.user_id 
		//         		left join post_likes as l on l.post_id = p.post_id and l.user_id = " . $login_id . "
		//         		left join followers as f on f.user_id=u.user_id and f.following_id = " . $login_id . "
		//         		left join favorite_users as fav on fav.user_id=u.user_id and fav.added_by = " . $login_id . "
		//         		left join posts as p2 on p2.post_id  = p.shared_post_id
		//         		left join users as u2 on p2.user_id = u2.user_id
		//         		left join categories as c on FIND_IN_SET(c.cat_id, u.cat_id) > 0
		//         		left join reports as rp on p.post_id = rp.post_id and rp.user_id = " . $login_id . "
		//         		where  rp.id is null and  u.deleted = 0 and p.show_on_wall=1  and p.active=1 and p.type!='A'";
		config()->set('database.connections.mysql.strict', false);
		DB::reconnect();
		$strSql = " select * from ( select l.like_id as like_id,rp.id as rp_id, u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,p.aspect_ratio,
					p2.aspect_ratio as aspect_ratio2,u.cat_id,'' as cat_name,u2.user_id as user_id2, u2.username as username2,
					u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2,
					p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p2.added_on as shared_added_on,p.likes as likes,p.views as views,
					p.comments as comments,p.shares as shares,p.type as type ,case when f.follower_id IS NULL then 0 else 1 end as isFollowing,
					case when fav.fav_id IS NULL then 0 else 1 end as isFav,
					lpl.user_id as lkuser_id,lplu.username as lkusername,
					lpc.user_id as cuser_id,lpcu.username as cusername,lpc.comment_id as ccomment_id,lpc.comment_on as ccomment_on,
					lpc.comment as ccomment,lpcu.profile_pic as cprofile_pic,lpcu.gender as cgender,
					ch.tag as challenge_tag,p.challenge_id";

		if (isset($request->challenge_id)) {
			$strSql = $strSql . ", ((CASE WHEN count(DISTINCT ps.user_id) > 0 THEN count(DISTINCT ps.user_id) * 4 ELSE 0 END) +
						(CASE WHEN count(DISTINCT pl.user_id) > 0 THEN count(DISTINCT pl.user_id) * 2 ELSE 0 END) +
						(CASE WHEN count(DISTINCT pv.user_id) > 0 THEN count(DISTINCT pv.user_id) * 1 ELSE 0 END) +
						(CASE WHEN count(DISTINCT pc.user_id) > 0 THEN count(DISTINCT pc.user_id) * 3 ELSE 0 END)) as total,
						CASE WHEN cw.challenge_id IS NOT NULL THEN 1 ELSE 0 END AS is_winner,
						CASE WHEN count(DISTINCT ps.user_id) > 0 THEN count(DISTINCT ps.user_id) ELSE 0 END as challenge_shares,
						CASE WHEN count(DISTINCT pl.user_id) > 0 THEN count(DISTINCT pl.user_id) ELSE 0 END as challenge_likes,
						CASE WHEN count(DISTINCT pv.user_id) > 0 THEN count(DISTINCT pv.user_id) ELSE 0 END as challenge_views,
						CASE WHEN count(DISTINCT pc.user_id) > 0 THEN count(DISTINCT pc.user_id) ELSE 0 END as challenge_comments

						";
		}

		$strSql = $strSql . " from users as u
        		join posts as p on u.user_id = p.user_id 
				left join last_post_likes as lpl on lpl.post_id = p.post_id
				left join users as lplu on lplu.user_id = lpl.user_id
				left join last_post_comments as lpc on lpc.post_id = p.post_id
				left join users as lpcu on lpcu.user_id = lpc.user_id
        		left join post_likes as l on l.post_id = p.post_id and l.user_id = " . $login_id . "
        		left join followers as f on f.user_id=u.user_id and f.following_id = " . $login_id . "
        		left join favorite_users as fav on fav.user_id=u.user_id and fav.added_by = " . $login_id . "
        		left join posts as p2 on p2.post_id  = p.shared_post_id
        		left join users as u2 on p2.user_id = u2.user_id
        		left join reports as rp on p.post_id = rp.post_id and rp.user_id = " . $login_id . "
				left join challenges as ch on ch.id = p.challenge_id and p.challenge_approved=1";
		if (isset($request->challenge_id)) {
			$strSql = $strSql . "  join challenges as chal on chal.id = p.challenge_id 
			            left join post_comments as pc on pc.post_id = p.post_id and pc.comment_on <= chal.end_date
						left join post_shares as ps on ps.post_id = p.post_id and ps.share_on <= chal.end_date
						left join post_likes as pl on pl.post_id = p.post_id and pl.like_on <= chal.end_date
						left join post_views as pv on pv.post_id = p.post_id and pv.view_on <= chal.end_date
						left join challenge_winners as cw on cw.challenge_id=p.challenge_id and cw.user_id=p.user_id";
			$strSql = $strSql . " where  rp.id is null and u.deleted = 0 and p.active=1 and p.type!='A' and u.active=1";
		} else {
			$strSql = $strSql . " where  rp.id is null and u.deleted = 0 and p.show_on_wall=1 and p.active=1 and p.type!='A' and u.active=1"; 
		}
		// dd($strSql);
		if ($request->shared) {
			// $strSql = $strSql." and p.shared_post_id > 0";
		} else {
			$strSql = $strSql . " and p.type!='S'";
		}
// 		if (!isset($request->challenge_id)) {
// 		$strSql = $strSql . " and p.challenge_id=0";
// 		}
        // $strSql=$strSql.' and u.user_id=22163';
        
		if (isset($request->challenge_id)) {
			if (isset($request->search) && $request->search != "") {
				//  >whereRaw("((p.title like '%" . $request->search . "%') or (u.username like '%" . $request->search . "%') or (u.first_name like '%" . $request->search . "%') or (u.last_name like '%" . $request->search . "%'))");
				$strSql = $strSql . " and ((p.title like '%" . $request->search . "%') or (u.username like '%" . $request->search . "%') or (u.first_name like '%" . $request->search . "%') or (u.last_name like '%" . $request->search . "%'))";
			}
		} else {
			if (isset($request->post_ids)) {
				if ($request->post_ids != "") {
					$post_ids = trim($request->post_ids, ",");
					$strSql = $strSql . " and p.post_id not in (" . $post_ids . ")";
				}
			}


			$where_gender = "";
			if (isset($request->gender) && $request->gender != "") {
				$gender = substr($request->gender, 1);
				$strSql = $strSql . " and u.gender ='" . $gender . "'";
			}

			$where_cat = "";

			if (isset($request->category) && $request->category != "") {
				$category = substr($request->category, 1);
				$cat_arr = explode(",", $category);
				foreach ($cat_arr as $val) {
					$where_cat = $where_cat . " or (CONCAT(',',u.cat_id,',') like '%," . $val . ",%')";
				}
				$strSql = $strSql . " and (" . substr($where_cat, 3) . ")";
			}

			$where_age = "";
			if (isset($request->age) && $request->age != "") {
				$age = substr($request->age, 1);
				$age_arr = explode(",", $age);
				foreach ($age_arr as $val) {
					$val_arr = explode("-", $val);
					$where_age = $where_age . " or (round(DATEDIFF(CURRENT_DATE(),u.dob) / 365) between " . $val_arr[0] . " and " . $val_arr[1] . ")";
				}
				$strSql = $strSql . " and (" . substr($where_age, 3) . ")";
			}

			$where_loc = "";
			if (isset($request->location) && $request->location != "") {
				$location = substr($request->location, 1);
				$loc_arr = explode(",", $location);
				foreach ($loc_arr as $val) {
					$where_loc = $where_loc . ' or (u.country ="' . $val . '")';
				}
				$strSql = $strSql . " and (" . substr($where_loc, 3) . ")";
			}

			$where_lan = "";
			if (isset($request->language) && $request->language != "") {
				$language = substr($request->language, 1);
				$lan_arr = explode(",", $language);
				foreach ($lan_arr as $val) {
					$where_lan = $where_lan . ' or (u.language like "%' . $val . '%")';
				}
				$strSql = $strSql . " and (" . substr($where_lan, 3) . ")";
			}

			$where_key = "";
			if (isset($request->keyword) && $request->keyword != "") {
				$key_arr = explode(",", $request->keyword);
				foreach ($key_arr as $val) {
					$where_key = $where_key . ' or (u.first_name like "%' . $val . '%") or (u.last_name like "%' . $val . '%") or (c.category like "%' . $val . '%") or (u.state like "%' . $val . '%") or (u.country like "%' . $val . '%")';
				}
				$strSql = $strSql . " and (" . substr($where_key, 3) . ")";
			}
		}
		//$total_records=$res->count();
		if ($blocked_user_res->user_id == 0) {
		} else {
			$blocked_res = $blocked_user_res->user_id;
			//$blocked_res=explode(',',$blocked_res);
			$strSql = $strSql . " and p.user_id not in(" . $blocked_res . ")";
		}
		if ($blocked_user_res2->user_id == 0) {
		} else {
			$blocked_res2 = $blocked_user_res2->user_id;
			//$blocked_res2=explode(',',$blocked_res2);
			$strSql = $strSql . " and p.user_id not in(" . $blocked_res2 . ")";
		}
		$res2 = array();
		if (isset($request->follow) && $request->follow == "true") {
		    
			$following_user_res = DB::table('followers')
				->select(DB::raw('ifnull(group_concat(user_id),0) as user_id'))
				->where('following_id', $login_id)
				->first();
				
// 			if(isset($request->test) && $request->test == 1 ) {
//     	        dd($following_user_res->user_id);
//     	    }
			if ($following_user_res->user_id == '') {
				$data = array('warning' => 'Sorry..! No record found.');
				$response = array("status" => "success", 'msg' => 'Candidate List filtered successfully', 'content' => $data);
				return response()->json($response);
			} else {
				$following_res = $following_user_res->user_id;
				//$res2=explode(',',$following_res);
				$strSql = $strSql . " and p.user_id in(" . $following_res . ")";
			}
		}

		if (isset($request->challenge_id)) {
			$strSql = $strSql . " and p.challenge_approved=1 and p.challenge_id=$request->challenge_id";
			$strSql = $strSql . " group by p.post_id order by is_winner desc, cw.position asc, total desc";
			$strSql = $strSql . " ) as T1 limit 20";
		} else {
			//$strSql = $strSql . " group by fav.fav_id,f.follower_id,u2.user_id,rp.id, u2.gender,u.gender,u2.username, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p2.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio,p2.aspect_ratio,lpl.user_id,lplu.username,lpc.user_id,lpcu.username,lpc.comment_id,lpc.comment_on,lpc.comment,lpcu.profile_pic,lpcu.gender ";
			$strSql = $strSql . " group by fav.fav_id,f.follower_id,u2.user_id,rp.id, u2.gender,u.gender,u2.username, u2.profile_pic, p.shared_post_id, p2.post_id, p2.type, p2.file, p2.title, like_id, u.user_id, u.username, u.profile_pic, p.post_id, p.file, p.title, p.added_on, p2.added_on, p.likes, p.views, p.comments, p.shares, p.type,p.aspect_ratio,p2.aspect_ratio";
			// 			$strSql = $strSql." order by p.comments desc";
			$strSql = $strSql . " order by p.post_id desc";
			$strSql = $strSql . " limit 200 ) as T1 order by rand() limit 20";
		}
// 		if (isset($request->test)) {
// 		    echo($strSql);
// 		    exit;
// 		}
		
		$res = DB::select(DB::raw($strSql));
				// dd($res);
		if (!isset($request->page) && $request->page == "") {
			$page = 1;
		} else {
			$page = $request->page;
		}
		config()->set('database.connections.mysql.strict', true);
		DB::reconnect();
		$total_records = 0;
		$data = array();
		if ($res) {
			$total_records = count($res);
			$i = 0;
			foreach ($res as $r) {
			 //   if (isset($request->test)) {
    			    if($r->cat_id!="") {
    			        $catIds = explode(",",$r->cat_id);
    			        if(count($catIds) > 0) {
    			            $catIdsSql = DB::table("categories")->select(DB::raw("GROUP_CONCAT(DISTINCT category) as cat_name"))->whereIn("cat_id", $catIds)->first();  
    			            if($catIdsSql) {
    			                $r->cat_name = $catIdsSql->cat_name;
    			            }
    			        }
    			    }
			 //   }
			    
			    
				// if($i>2 || $page>1 || $r->type!="V"){
				$i++;
				if ($r->profile_pic == "") {
					if ($r->gender == "M") {
						$p = secure_asset('assets/images/avatar-man.png');
					} else if ($r->gender == "F") {
						$p = secure_asset('assets/images/avatar-woman.png');
					} else {
						$p = secure_asset('assets/images/profile.png');
					}
				} else {
					if (stripos($r->profile_pic, 'https://') !== false) {
						$p = $r->profile_pic;
					} else {
						$p = Storage::url("profile_pic/" . $r->user_id . "/" . $r->profile_pic);
					}
				}
				$p2 = "";
				if ($r->shared_post_id > 0) {
					if ($r->profile_pic2 == "") {
						if ($r->gender2 == "M") {
							$p2 = secure_asset('assets/images/avatar-man.png');
						} else if ($r->gender2 == "F") {
							$p2 = secure_asset('assets/images/avatar-woman.png');
						} else {
							$p2 = secure_asset('assets/images/profile.png');
						}
					} else {
						if (stripos($r->profile_pic2, 'https://') !== false) {
							$p2 = $r->profile_pic2;
						} else {
							$p2 = Storage::url("profile_pic/" . $r->user_id2 . "/" . $r->profile_pic2);
						}
					}
				}
				if ($r->type == "V") {
					$thumb = explode(".", $r->file);
					$thum = $thumb[0] . ".jpg";
					//$thum=substr($r->file, 0, -3)."jpg";
					$file = Storage::url("videos/" . $r->user_id . "/" . $r->file);
					$thumb_file = Storage::url("videos/" . $r->user_id . "/thumb/" . $thum);
				} else {
					$file = Storage::url("photos/" . $r->user_id . "/" . $r->file);
					$thumb_file = "";
				}
				$file2 = "";
				$thumb_file2 = "";
				if ($r->shared_post_id > 0) {
					if ($r->type2 == "V") {
						$thumb2 = explode(".", $r->file2);
						$thum2 = $thumb2[0] . ".jpg";
						//$thum=substr($r->file, 0, -3)."jpg";
						$file2 = Storage::url("videos/" . $r->user_id2 . "/" . $r->file2);
						$thumb_file2 = Storage::url("videos/" . $r->user_id2 . "/thumb/" . $thum2);
					} else {
						$file2 = Storage::url("photos/" . $r->user_id2 . "/" . $r->file2);
						$thumb_file2 = "";
					}
				}
				$added_on = $r->added_on;
				$data_liked_users['users'] = array();
				if ($r->likes > 0) {
					$data_liked_users['users'][] = array("post_id" => $r->post_id, "like_id" => 0, "user_id" => $r->lkuser_id, "username" => $r->lkusername, "liked_on" => '', "profile_pic" => '');
					// 	$rs_liked_users = DB::table('post_likes as l')
					// 		->Join('users as u', 'l.user_id', '=', 'u.user_id')
					// 		->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
					// 		->where('l.post_id', $r->post_id);
					// 	// ->orderBy('comment_id','desc');

					// 	$rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
					// 		//->skip($offset) 
					// 		->paginate(2);
					// 	//->get();
					// 	//print_r($res);
					// 	$total_liked_users = $rs_liked_users->total();

					// 	if (!$rs_liked_users->isEmpty()) {

					// 		foreach ($rs_liked_users as $l) {
					// 			if ($l->profile_pic == "") {
					// 				if ($l->gender == "M") {
					// 					$p_liked = secure_asset('assets/images/avatar-man.png');
					// 				} else if ($l->gender == "F") {
					// 					$p_liked = secure_asset('assets/images/avatar-woman.png');
					// 				} else {
					// 					$p_liked = secure_asset('assets/images/profile.png');
					// 				}
					// 			} else {
					// 				$p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
					// 			}

					// 			$liked_on = ($l->like_on);

					// 			$data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
					// 		}
					// 	}
				}

				$data_comment['comment'] = array();

				if ($r->comments > 0) {
					if (stripos($r->cprofile_pic, 'https://') !== false) {

						$p_comment = $r->cprofile_pic;
					} else {
						if ($r->cprofile_pic == "") {
							if ($r->cgender == "M") {
								$p_comment = secure_asset('assets/images/avatar-man.png');
							} else if ($r->cgender == "F") {
								$p_comment = secure_asset('assets/images/avatar-woman.png');
							} else {
								$p_comment = secure_asset('assets/images/profile.png');
							}
						} else {
							$p_comment = Storage::url("profile_pic/" . $r->cuser_id . "/" . $r->cprofile_pic);
						}
					}
					$data_comment['comment'][] = array("comment_id" => $r->ccomment_id, "user_id" => $r->cuser_id, "username" => $r->cusername, "comment" => $r->ccomment, "comment_on" => $r->ccomment_on, "profile_pic" => $p_comment, "parent_id" => 0, "post_id" => $r->post_id);

					// 	$rs_comments = DB::table('post_comments as c')
					// 		->Join('users as u', 'c.user_id', '=', 'u.user_id')
					// 		->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
					// 		->where('c.post_id', $r->post_id)
					// 		->where('c.parent_id', 0);
					// 	// ->orderBy('comment_id','desc');

					// 	$rs_comments = $rs_comments->orderBy('comment_id', 'desc')
					// 		->offset(0)
					// 		->limit(2)
					// 		->get();
					// 	//->get();
					// 	//print_r($res);

					// 	foreach ($rs_comments as $c) {
					// 		if ($c->profile_pic == "") {
					// 			if ($c->gender == "M") {
					// 				$p_comment = secure_asset('assets/images/avatar-man.png');
					// 			} else if ($c->gender == "F") {
					// 				$p_comment = secure_asset('assets/images/avatar-woman.png');
					// 			} else {
					// 				$p_comment = secure_asset('assets/images/profile.png');
					// 			}
					// 		} else {
					// 			$p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
					// 		}

					// 		$comment_on = $c->comment_on;


					// 		$data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id, "post_id" => $r->post_id);
					// 	}
				}
				$data_comment['comment'] = array_reverse($data_comment['comment']);
				if ($r->shared_post_id == 0) {
					$aspect_ratio = $r->aspect_ratio;
					$sig = md5($r->post_id . "*FilmsDream@1290");
				} else {
					$aspect_ratio = $r->aspect_ratio2;
					$sig = md5($r->post_id2 . "*FilmsDream@1290");
				}
				$s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'user_id' => $r->user_id, 'user_id2' => $r->user_id2, 'file1' => $r->file, 'username' => $r->username, 'username2' => $r->username2, 'file' => $file, 'file2' => $file2, 'thumb' => $thumb_file, 'thumb2' => $thumb_file2, 'title' => $r->title, 'title2' => $r->title2, 'added_on' => $added_on, 'shared_added_on' => $r->shared_added_on, 'likes' => $r->likes, 'comments' => $r->comments, 'shares' => $r->shares, 'views' => $r->views, 'profile_pic' => $p, 'profile_pic2' => $p2, 'type' => $r->type, 'type2' => $r->type2, 'cat_id' => $r->cat_id, 'cat_name' => $r->cat_name, 'post_id' => $r->post_id, 'post_id2' => $r->post_id2, 'sig' => $sig, 'aspect_ratio' => number_format($aspect_ratio, 1), 'isFollowing' => $r->isFollowing, 'isFav' => $r->isFav, 'rp_id' => $r->rp_id, 'challenge_id' => $r->challenge_id, 'challenge_tag' => $r->challenge_tag);
				if (isset($request->challenge_id)) {
					$s['challenge_shares'] = $r->challenge_shares;
					$s['challenge_likes'] = $r->challenge_likes;
					$s['challenge_views'] = $r->challenge_views;
					$s['challenge_comments'] = $r->challenge_comments;
					$s['total_points'] = $r->total;
				}
				array_push($data, $s);
				if($request->challenge_id){
				    
				}else{
				if ($i == 3 || $i == 10) {

					if ($login_id > 0) {
						$user = DB::table("users")
							->select(DB::raw('*'))
							->where("user_id", $login_id)
							->first();
						$country = $user->country;
						$state = $user->state;
						if (strtolower($country) == "usa") {
							$country = "United States";
						}
					} else {
						$country = "United States";
						$state = '';
					}

					//     $res = DB::table("wall_ads")
					//                 ->join('posts','posts.ad_id','wall_ads.id')
					//         ->select(DB::raw('wall_ads.*'))
					//         ->where("wall_ads.active",1)
					//         ->where('posts.type','A')
					//         ->whereRaw(DB::raw(" (wall_ads.countries like '%".$country."%' or wall_ads.countries like '%All Countries%')" ))
					//         ->whereRaw(DB::raw(" (wall_ads.states like '%".$state."%' or IFNULL(wall_ads.states,'')='')" ))
					//         ->whereRaw(DB::raw("wall_ads.active=1 and '".date("Y-m-d")."' between wall_ads.start_date and wall_ads.expiry_date"))
					//         //->whereRaw(DB::raw("ad_type in ('M', 'M') "))
					// 		->orderBy(DB::raw("rand()"))
					//         ->first();

					// $sql2="select ad.*, l.like_id as like_id,rp.id as rp_id,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type

					//                             		from posts as p 
					//                             		join wall_ads as ad on p.ad_id=ad.ad_id
					//                             		left join post_likes as l on l.post_id = p.post_id and l.user_id = ".$login_id."
					//                             		left join posts as p2 on p2.post_id  = p.shared_post_id
					//                             		left join users as u2 on p2.user_id = u2.user_id
					//                             		left join reports as rp on p.post_id = rp.post_id and rp.user_id = ".$login_id."
					//                             		where  rp.id is null and  p.show_on_wall=1 and p.type='A' ";

					$res = DB::table('posts as p')
						->select(DB::raw("ad.*, p.post_id as post_id, l.like_id as like_id,rp.id as rp_id,u2.user_id as user_id2, u2.username as username2, u2.profile_pic as profile_pic2,u2.gender as gender2, p.shared_post_id, p2.post_id as post_id2, p2.type as type2, p2.file as file2,p2.title as title2, p.post_id as post_id,p.file as file,p.title as title,p.added_on as added_on,p.likes as likes,p.views as views,p.comments as comments,p.shares as shares,p.type as type,
            						lpl.user_id as lkuser_id,lplu.username as lkusername,
                					lpc.user_id as cuser_id,lpcu.username as cusername,lpc.comment_id as ccomment_id,lpc.comment_on as ccomment_on,
                					lpc.comment as ccomment,lpcu.profile_pic as cprofile_pic,lpcu.gender as cgender,ch.tag as challenge_tag,p.challenge_id"))
						->join('wall_ads as ad', 'p.ad_id', 'ad.ad_id', function ($join) use ($login_id) {
							$join->whereRaw(DB::raw("active=1 and '" . date("Y-m-d") . "' between start_date and expiry_date"));
							// ->where("l.user_id", $login_id);
						})
						->leftJoin('post_likes as l', function ($join) use ($login_id) {
							$join->on('l.post_id', 'p.post_id')
								->where("l.user_id", $login_id);
						})
						->leftJoin('posts as p2', 'p2.post_id', 'p.shared_post_id')
						->leftJoin('users as u2', 'p2.user_id', 'u2.user_id')
						->leftJoin('reports as rp', function ($join) use ($login_id) {
							$join->on('p.post_id', 'rp.post_id')
								->where("rp.user_id", $login_id);
						})
						->leftJoin('last_post_likes as lpl', 'lpl.post_id', 'p.post_id')
						->leftJoin('users as lplu', 'lplu.user_id', 'lpl.user_id')
						->leftJoin('last_post_comments as lpc', 'lpc.post_id', 'p.post_id')
						->leftJoin('users as lpcu', 'lpcu.user_id', 'lpc.user_id')
						->leftJoin('challenges as ch', 'ch.id', 'p.challenge_id')
						->whereRaw(DB::raw("rp.id is null and  p.show_on_wall=1 and p.type='A' and p.active=1 and ad.active=1"))->inRandomOrder()->first();


					if ($res) {

						$r = $res;

						$data_liked_users['users'] = array();

						if ($r->likes > 0) {
							$data_liked_users['users'][] = array("post_id" => $r->post_id, "like_id" => 0, "user_id" => $r->lkuser_id, "username" => $r->lkusername, "liked_on" => '', "profile_pic" => '');
							// 			$rs_liked_users = DB::table('post_likes as l')
							// 				->Join('users as u', 'l.user_id', '=', 'u.user_id')
							// 				->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,l.like_on,l.like_id,l.post_id'))
							// 				->where('l.post_id', $r->post_id);
							// 			// ->orderBy('comment_id','desc');

							// 			$rs_liked_users = $rs_liked_users->orderBy('like_id', 'desc')
							// 				//->skip($offset) 
							// 				->paginate(2);
							// 			//->get();
							// 			//print_r($res);
							// 			$total_liked_users = $rs_liked_users->total();

							// 			if (!$rs_liked_users->isEmpty()) {

							// 				foreach ($rs_liked_users as $l) {
							// 					if ($l->profile_pic == "") {
							// 						if ($l->gender == "M") {
							// 							$p_liked = secure_asset('assets/images/avatar-man.png');
							// 						} else if ($l->gender == "F") {
							// 							$p_liked = secure_asset('assets/images/avatar-woman.png');
							// 						} else {
							// 							$p_liked = secure_asset('assets/images/profile.png');
							// 						}
							// 					} else {
							// 						$p_liked = Storage::url("profile_pic/" . $l->user_id . "/" . $l->profile_pic);
							// 					}

							// 					$liked_on = ($l->like_on);

							// 					$data_liked_users['users'][] = array("post_id" => $l->post_id, "like_id" => $l->like_id, "user_id" => $l->user_id, "username" => $l->username, "liked_on" => $liked_on, "profile_pic" => $p_liked);
							// 				}
							// 			}
						}

						$data_comment['comment'] = array();

						if ($r->comments > 0) {
							if (stripos($r->cprofile_pic, 'https://') !== false) {

								$p_comment = $r->cprofile_pic;
							} else {
								if ($r->cprofile_pic == "") {
									if ($r->cgender == "M") {
										$p_comment = secure_asset('assets/images/avatar-man.png');
									} else if ($r->cgender == "F") {
										$p_comment = secure_asset('assets/images/avatar-woman.png');
									} else {
										$p_comment = secure_asset('assets/images/profile.png');
									}
								} else {
									$p_comment = Storage::url("profile_pic/" . $r->cuser_id . "/" . $r->cprofile_pic);
								}
							}
							$data_comment['comment'][] = array("comment_id" => $r->ccomment_id, "user_id" => $r->cuser_id, "username" => $r->cusername, "comment" => $r->ccomment, "comment_on" => $r->ccomment_on, "profile_pic" => $p_comment, "parent_id" => 0, "post_id" => $r->post_id);

							// 			$rs_comments = DB::table('post_comments as c')
							// 				->Join('users as u', 'c.user_id', '=', 'u.user_id')
							// 				->select(DB::raw('u.user_id as user_id,u.username as username,u.gender,u.profile_pic as profile_pic,c.comment as comment,c.comment_id as comment_id,c.comment_on as comment_on,c.parent_id as parent_id'))
							// 				->where('c.post_id', $r->post_id)
							// 				->where('c.parent_id', 0);
							// 			// ->orderBy('comment_id','desc');

							// 			$rs_comments = $rs_comments->orderBy('comment_id', 'desc')
							// 				->offset(0)
							// 				->limit(2)
							// 				->get();
							// 			//->get();
							// 			//print_r($res);

							// 			foreach ($rs_comments as $c) {
							// 				if ($c->profile_pic == "") {
							// 					if ($c->gender == "M") {
							// 						$p_comment = secure_asset('assets/images/avatar-man.png');
							// 					} else if ($c->gender == "F") {
							// 						$p_comment = secure_asset('assets/images/avatar-woman.png');
							// 					} else {
							// 						$p_comment = secure_asset('assets/images/profile.png');
							// 					}
							// 				} else {
							// 					$p_comment = Storage::url("profile_pic/" . $c->user_id . "/" . $c->profile_pic);
							// 				}

							// 				$comment_on = $c->comment_on;


							// 				$data_comment['comment'][] = array("comment_id" => $c->comment_id, "user_id" => $c->user_id, "username" => $c->username, "comment" => $c->comment, "comment_on" => $comment_on, "profile_pic" => $p_comment, "parent_id" => $c->parent_id, "post_id" => $r->post_id);
							// 			}
						}
						$data_comment['comment'] = array_reverse($data_comment['comment']);



						$ad_type = $res->ad_type;
						$ad_title1 = $res->title1;
						$ad_description1 = $res->description1;
						$ad_link1 = $res->link1;
						$ad_file1 = "";
						if ($res->file1 != "") {
							$ad_file1 = Storage::url("banners/" . $res->file1);
						}

						$ad_title2 = $res->title2;
						$ad_description2 = $res->description2;
						$ad_link2 = $res->link2;
						$ad_file2 = "";
						if ($res->file2 != "") {
							$ad_file2 = Storage::url("banners/" . $res->file2);
						}

						$ad_title3 = $res->title3;
						$ad_description3 = $res->description3;
						$ad_link3 = $res->link3;
						$ad_file3 = "";
						if ($res->file3 != "") {
							$ad_file3 = Storage::url("banners/" . $res->file3);
						}

						$ad_title4 = $res->title4;
						$ad_description4 = $res->description4;
						$ad_link4 = $res->link4;
						$ad_file4 = "";
						if ($res->file4 != "") {
							$ad_file4 = Storage::url("banners/" . $res->file4);
						}

						$ad_title5 = $res->title5;
						$ad_description5 = $res->description5;
						$ad_link5 = $res->link5;
						$ad_file5 = "";
						if ($res->file5 != "") {
							$ad_file5 = Storage::url("banners/" . $res->file5);
						}

						$views = $res->views + 1;
						$up_data = array("views" => $views);

						DB::table('wall_ads')
							->where('ad_id', $res->ad_id)
							->update($up_data);

						if ($r->shared_post_id == 0) {
							$aspect_ratio = 1;
							$sig = md5($r->post_id . "*FilmsDream@1290");
						} else {
							$aspect_ratio = 1;
							$sig = md5($r->post_id2 . "*FilmsDream@1290");
						}

						$s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'type' => 'A', 'post_id' => $r->post_id, 'ad_type' => $ad_type, 'ad_title1' => $ad_title1, 'ad_description1' => $ad_description1, 'ad_link1' => $ad_link1, 'ad_file1' => $ad_file1, 'ad_title2' => $ad_title2, 'ad_description2' => $ad_description2, 'ad_link2' => $ad_link2, 'ad_file2' => $ad_file2, 'ad_title3' => $ad_title3, 'ad_description3' => $ad_description3, 'ad_link3' => $ad_link3, 'ad_file3' => $ad_file3, 'ad_title4' => $ad_title4, 'ad_description4' => $ad_description4, 'ad_link4' => $ad_link4, 'ad_file4' => $ad_file4, 'ad_title5' => $ad_title5, 'ad_description5' => $ad_description5, 'ad_link5' => $ad_link5, 'ad_file5' => $ad_file5, 'likes' => $r->likes, 'views' => $r->views, 'comments' => $r->comments, 'shares' => $r->shares, 'sig' => $sig, 'challenge_id' => $r->challenge_id, 'challenge_tag' => $r->challenge_tag);
						// $s = array('shared_post_id' => $r->shared_post_id, 'liked_users' => $data_liked_users['users'], 'user_comments' => $data_comment['comment'], 'like_id' => $r->like_id, 'type' => 'A', 'post_id' => $r->post_id, 'ad_type' => $ad_type, 'ad_title1' => $ad_title1, 'ad_description1' => $ad_description1, 'ad_link1' => $ad_link1, 'ad_file1' => $ad_file1, 'ad_title2' => $ad_title2, 'ad_description2' => $ad_description2, 'ad_link2' => $ad_link2, 'ad_file2' => $ad_file2, 'ad_title3' => $ad_title3, 'ad_description3' => $ad_description3, 'ad_link3' => $ad_link3, 'ad_file3' => $ad_file3, 'ad_title4' => $ad_title4, 'ad_description4' => $ad_description4, 'ad_link4' => $ad_link4, 'ad_file4' => $ad_file4, 'ad_title5' => $ad_title5, 'ad_description5' => $ad_description5, 'ad_link5' => $ad_link5, 'ad_file5' => $ad_file5, 'likes' => $r->likes, 'views' => $r->views, 'comments' => $r->comments, 'shares' => $r->shares, 'sig' => $sig);
						array_push($data, $s);
					}
				}
				}
				// }
			}
		} else {
			//   $data=array('warning'=>'Sorry..! No record found.');
			$data = array();
		}

		$response = array("status" => "success", 'msg' => 'Wall Post List', 'content' => $data, 'total_records' => $total_records);


		return response()->json($response);
	}
	
	public function unique_user_id()
	{
		$characters = "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		$string     = "";

		for ($p = 0; $p < 15; $p++) {
			$string .= $characters[mt_rand(0, strlen($characters) - 1)];
		}

		$uniques_user_id_res = DB::table("unique_users_ids")->select("unique_token")->where('unique_token', $string)->first();
		if ($uniques_user_id_res) {
			$this->unique_user_id();
		} else {
			DB::table('unique_users_ids')->insert(['unique_token' => $string]);
		}

		$response = array("status" => "success", 'unique_id' => $string);
		return response()->json($response);
	}
}
