<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;
use App\Http\Controllers\Controller;
use Hash;
use Auth;
use App\Models\Admin;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Route;
use DateTime;
use DatePeriod;
use DateInterval;


class AdminController extends Controller
{   
    public function __construct()
    {
       
    }
  
    public function index(){
       
        $candidates=DB::table('users')->where('user_type', '=', 'C')->where('active','1')->count();
       
        $producers=DB::table('users')->where('user_type', '=', 'P')->where('active','1')->count();
       
        $viewers=DB::table('users')->where('user_type', '=', 'V')->where('active','1')->count();
       
       /* $pending_payments=DB::table('payments')->where('payment_status', '=', 'P')->count();*/
        $pending_candidates = DB::table('users')
                                ->select(DB::raw('users.*'))
                                ->where('active','0')
                                ->where('user_type', 'C')
                                ->orderBy('user_id','DESC')
                                ->limit(5)
                                ->get();
                               
        $pending_producers = DB::table('users')
                                ->select(DB::raw('users.*'))
                                ->where('active','0')
                                ->where('user_type', 'P')
                                ->orderBy('user_id','DESC')
                                ->limit(5)
                                ->get();
                                
        $pending_viewers = DB::table('users')
                                ->select(DB::raw('users.*'))
                                ->where('active','0')
                                ->where('user_type', 'V')
                                ->orderBy('user_id','DESC')
                                ->limit(5)
                                ->get();
                                
       /* $recent_payments = DB::table('payments')
                                ->join('users','users.user_id','=','payments.user_id')
                                ->select(DB::raw('payments.*,users.*'))
                                ->orderBy('payment_id','DESC')
                                ->limit(5)
                                ->get();*/
        
        $now = date('Y-m');
        $d_arr=array();
        for($x = 11; $x >= 0; $x--) {
            $tm = date('Y-m', strtotime($now . " -$x month"));
            $d_arr[$tm]=0;
             }
        $register = DB::table('users')
                    ->select(DB::raw('count(*) as total,DATE_FORMAT(added_date, "%Y-%m") AS Mon' ))
                    ->whereRaw("DATE_FORMAT(added_date, '%Y-%m') >  $tm")
                    ->groupBy(DB::raw("Mon"))
                    ->orderby(DB::raw("CAST(Mon as SIGNED)"))
                    ->get();
        foreach($register as $data){
        	$d_arr[$data->Mon]=$data->total;
			
        }
        
        $total_photos=DB::table('posts')->where('type','P')->count();
        $total_videos=DB::table('posts')->where('type','V')->count();
        $total_msg=DB::table('message')->count();
        $total_users=DB::table('users')->count();
        
        return view("admin.dashboard",compact('candidates','producers','viewers','total_users','pending_candidates','pending_producers','pending_viewers','total_photos','total_videos','total_msg','d_arr'));
    }

    private function _get_months(){
        $start    = new DateTime(date('Y-m-d',strtotime('-1 year')));
        $start->modify('first day of this month');
        $end      = new DateTime(date('Y-m-d'));
        $end->modify('first day of next month');
        $interval = DateInterval::createFromDateString('1 month');
        $period   = new DatePeriod($start, $interval, $end);
        $month_array = array();
        foreach ($period as $dt) {
            $month_array[$dt->format("m/Y")] = 0;
        }
        return $month_array;
    }    

    public function logout(Request $request){
        Auth::guard('admin')->logout();
        $request->session()->flush();
        $request->session()->regenerate();
        return redirect(route( 'admin.login' ));
    }

    public function changePassword(){
        return view("admin.change_password");
    }

    public function updatePassword(Request $request){

        $rules = [
            'old_password'      => 'required|min:6',
            'new_password'      => 'required|min:6|different:old_password',
            'confirm_password'  => 'required|min:6|same:new_password'
        ];

        $messages = [
            'old_password.required'         => 'You cant leave old password field empty',
            'old_password.min'              => 'Old Password must be 6 characters long',
            'new_password.required'         => 'You cant leave new password field empty',
            'new_password.min'              => 'New password must be 6 characters long',
            'new_password.different'        => 'New password must be different from from old password',
            'confirm_password.required'     => 'You cant leave confirm password field empty',
            'confirm_password.min'          => 'Confirm password must be 6 characters long',
            'confirm_password.same'         => 'Confirm password must be same as the new password'
        ];


        $this->validate($request, $rules,$messages);
        $current_password = Auth::User()->password;
        if(Hash::check($request['old_password'], $current_password)){
            $admin_id = Auth::User()->admin_id;
            $admin = Admin::find($admin_id);
            $admin->password = Hash::make($request['new_password']);
            $admin->save();
            return redirect( env('ADMIN_PATH') .'/change_password')->with('success','Password changed successfully');
       }else{
         return redirect( env('ADMIN_PATH') .'/change_password')->with('error','Old Password is not correct');
       }
    }
     public function moveChatOldToNew(Request $request){

        DB::table('chat_chats')->truncate();
        DB::table('chat_conversations')->truncate();
        DB::table('chat_messages')->truncate();

        $oldChats = DB::table('message')
                        ->select('*')
						->get();

        if( $oldChats->count() > 0 ) {
            $convId = 0;
            $msgId = 0;
            foreach($oldChats as $key=>$chat) {    
                $convertsationExist = DB::table('chat_conversations')
                                        ->select('*')
                                        ->whereRaw(DB::raw(" (user_from=".$chat->from_id." and user_to=".$chat->to_id.") OR (user_from=".$chat->to_id." and user_to=".$chat->from_id.") "))
                                        ->first();
                if(!$convertsationExist){
                    $convId = DB::table('chat_conversations')->insertGetId(['user_from' => $chat->from_id , 'user_to' => $chat->to_id,'created_at' => date('Y-m-d H:i:s')]);
                }else{
                    $convId= $convertsationExist->id;
                }
                $msgId = DB::table('chat_messages')->insertGetId(['msg' => $chat->msg , 'conversation_id' => $convId,'created_at' => $chat->sent_on]);

                DB::table('chat_chats')->insertGetId(['message_id' => $msgId , 'conversation_id' => $convId,'user_id' => $chat->from_id , 'type' => 0,'created_at' => $chat->sent_on,'read_at' => $chat->read_on]);
                DB::table('chat_chats')->insertGetId(['message_id' => $msgId , 'conversation_id' => $convId,'user_id' => $chat->to_id , 'type' => 1,'created_at' => $chat->sent_on,'read_at' => $chat->read_on]);
            }
        }

        // DB::table('settings')->where('setting_id',1)->update(['migrated'=>1]);
        return response()->json(['status' => true]);
        echo "Done";
    }
}