<?php
namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\DB; 

class OrderController extends Controller
{   

    var $column_order = array(null,null, 'invoice_no','payment_date','user_id','amount','payment_status ','payment_msg','pg_transaction_id'); //set column field database for datatable orderable

    var $column_search = array('invoice_no','payment_date','users.username','users.user_id','amount','payment_status ','payment_msg','pg_transaction_id'); //set column field database for datatable searchable

    var $order = array('payment_id' => 'asc'); // default order

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($status='S')
    {
        return view("admin.orders",compact('status'));
    }

    
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($status)
    {   
        $s=$status;
        $orders = DB::table('payments')
        ->leftJoin('users', 'users.user_id', '=', 'payments.user_id')
        ->select(DB::raw('payments.*,users.username,users.first_name,users.user_id'))
        ->where('payment_status',$s)
        ->orderBy('payment_id','DESC')
        ->get();
        //dd($orders);
        
        return view("admin.orders",compact('orders','status'));
    }

    public function detail($id)
    {   
        $title='Payment Detail';
        $orders = DB::table('payments')
        ->leftJoin('users', 'users.user_id', '=', 'payments.user_id')
        ->select(DB::raw('payments.*,users.*'))
        ->where('payment_id',$id)
        ->first();

        $company = DB::table('settings')
        ->select(DB::raw('*'))
        ->where('setting_id','1')
        ->first();
        //dd($orders);
        
        return view("admin.orders-detail",compact('orders','title','company'));
    }

        /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
    public function serverProcessing(Request $request)
    {
        $currentPath = url(config('app.admin_url')).'/orders/';

        $list = $this->get_datatables($request);

        $data = array();
        $no = $request->start;
        foreach ($list as $orders) {
            $no++;
            $row = array();
            //$row[] = '<a class="view" href="'.$currentPath.'view/'.$orders->payment_id.'"><i class="fa fa-search"></i></a><a class="edit" href="'.$currentPath.$orders->payment_id.'/edit"><i class="fa fa-edit"></i></a><a class="delete deleteSelSingle" style="cursor:pointer;" data-val="'.$orders->payment_id.'"><i class="fa fa-trash"></i></a>';
            $row[] = '<div class="align-center"><input id="cb'.$no.'" name="key_m[]" class="delete_box blue-check" type="checkbox" data-val="'.$orders->payment_id.'"><label for="cb'.$no.'"></label></div>';
            $row[] = $orders->invoice_no;
            $row[] = $orders->payment_date;
            $row[] = $orders->first_name;
            $row[] = $orders->amount;
            $row[] = $orders->payment_msg;
            $row[] = $orders->pg_transaction_id;
            $row[] = $orders->payment_mode;
            
            $row[] = '<a href="'.$currentPath.'detail/'.$orders->payment_id.'" class="btn btn-primary">Detail</a>';
            $data[] = $row;
        }

        $output = array(
            "draw" => $request->draw,
            "recordsTotal" => $this->count_all($request),
            "recordsFiltered" => $this->count_filtered($request),
            "data" => $data,
        );
        echo json_encode($output);
    }

    private function _get_datatables_query($request)
    {       
        $keyword = $request->search['value'];
        $order = $request->order;
        $orderRS = DB::table('payments')
        ->leftJoin('users', 'users.user_id', '=', 'payments.user_id')
        ->select(DB::raw('payments.*,users.username,users.first_name,users.user_id'));
       
        $strWhere = "payments.payment_status='".$request->status."'";
        $strWhereOr = "";
        $i = 0;
      
        foreach ($this->column_search as $item) // loop column
        {
            if($keyword) // if datatable send POST for search{
            	$strWhereOr = $strWhereOr." $item like '%".$keyword."%' or ";
                //$candidateRS = $candidateRS->orWhere($item, 'like', '%' . $keyword . '%') ;
        }
        $strWhereOr = trim($strWhereOr, "or ");
        if($strWhereOr!=""){
	        $orderRS = $orderRS->whereRaw(DB::raw($strWhere." and (".$strWhereOr.")"));
	    }else{
			$orderRS = $orderRS->whereRaw(DB::raw($strWhere	));
		}
        
        if(isset($order)) // here order processing
        {
            $orderRS = $orderRS->orderBy($this->column_order[$request->order['0']['column']], $request->order['0']['dir']);
        } 
        else if(isset($this->order))
        {
            $orderby = $this->order;
            $orderRS = $orderRS->orderBy(key($orderby),$orderby[key($orderby)]);
        }
        return $orderRS;
    }

    function get_datatables($request)
    {
        $orderRS = $this->_get_datatables_query($request);
        if($request->length != -1){
            $orderRS = $orderRS->limit($request->length);
            if($request->start != -1){
                $orderRS = $orderRS->offset($request->start);
            }
        }
        
        $orders = $orderRS->get();
        return $orders;
    }

    function count_filtered($request)
    {
        $orderRS = $this->_get_datatables_query($request);
        return $orderRS->count();
    }

    public function count_all($request)
    {
        $orderRS = DB::table('payments')->select(DB::raw("count(*) as total"))->where('payment_status',$request->status)->first();
        return $orderRS->total;
    }

    public function delete(Request $request){
        $rec_exists = array();
        $del_error = '';
        $ids = explode(',',$request->ids);
        foreach ($ids as $id) {
            DB::table('payments')->where('payment_id', $id)->delete();
        }
        
        if($del_error == 'error'){
            $request->session()->put('error',$msg );
            return response()->json(['status' => 'error',"rec_exists"=>$rec_exists]);
        }else{
            if( count($ids) > 1){
                $msg = "Order deleted successfully";
            }else{
                $msg = "Order deleted successfully";
            }
            $request->session()->put('success', $msg);
            return response()->json(['status' => 'success',"rec_exists"=>$rec_exists]);
        }
    }

    public function copyContent($id)
    {
        $action = 'copy';
        $order = DB::table('users')->select(DB::raw("*"))->where('user_id','=',$id)->first();
        // dd($category);
        return view('admin.candidates-create',compact('id','order','action'));
    }
}
