<?php
namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\DB; 

class SettingController extends Controller
{   
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($id=1)
    {
        $action = 'edit';
        $setting = DB::table('settings')->select(DB::raw("*"))->where('setting_id','=',$id)->first();
         //dd($candidate);
        return view('admin.settings-create',compact('setting','action'));
    }

    private function _form_validation($request){
        $rules = [
            'invoice_start_from' => 'required',
            'registration_fee'     => 'required',
            'inv_comapny_name'     => 'required',
            'inv_address'     => 'required',
            'inv_email'     => 'required',
            'inv_phone' => 'required',
            'android_version' => 'required',
            'ios_version' => 'required',
            'admin_email'     => 'required',
        ];
        $messages = [
            'invoice_start_from.required' => 'You can\'t leave Invoice Start From field empty',
            'registration_fee.required'    => 'You can\'t leave Registration Fee field empty',
            'inv_comapny_name.required'    => 'You can\'t leave Invoice Comapny Name field empty',
            'inv_address.required'    => 'You can\'t leave Invoice Address field empty',
            'inv_email.required'    => 'You can\'t leave Invoice Email field empty',
            'inv_phone.required'    => 'You can\'t leave Invoice Phone field empty',
            'admin_email.required'    => 'You can\'t leave Admin Email field empty',
        ]; 
        $this->validate($request,$rules,$messages);
        $postData = array(
            'invoice_start_from' => $request->invoice_start_from,
            'registration_fee'     => $request->registration_fee,
            'inv_comapny_name' => $request->inv_comapny_name,
            'inv_address'     => $request->inv_address,
            'inv_email'     => $request->inv_email,
            'inv_phone'     => $request->inv_phone,
            'admin_email'     => $request->admin_email,            
            'android_version'     => $request->android_version,            
            'ios_version'     => $request->ios_version,            
            'enable_gifts'     => isset($request->enable_gifts) ? $request->enable_gifts : 0,
            'enable_challenges'     => isset($request->enable_challenges) ? $request->enable_challenges : 0,        
            'enable_live_stream'     => isset($request->enable_live_stream) ? $request->enable_live_stream : 0,
            'minimum_withdraw_coins'    => isset($request->minimum_withdraw_coins) ? $request->minimum_withdraw_coins : 0
            
            
        ); 
        return $postData;
    }
     /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $action = 'edit';
        $candidate = DB::table('users')->select(DB::raw("*"))->where('user_id','=',$id)->first();
         //dd($candidate);
        return view('admin.candidates-create',compact('candidate','id','action'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id=1)
    {
        $action='edit';
        $data = $this->_form_validation($request);
        DB::table('settings')->where('setting_id',$id)->update($data);
        //$msg="Update Successfully";
        return redirect( config('app.admin_url').'/settings')->with('success','Update Successfully');
    }

    public function adSettings(Request $request)
    {
        $action = 'edit';
        $id=1;
        $adSettings = DB::table('ad_settings')->select(DB::raw("*"))->first();
        
        return view('admin.ad-settings-create',compact('action','id','adSettings'));
    }

    public function adSettingUpdate(Request $request)
    {
        $adData = array();
        $adData['android_app_id'] = is_null($request->android_app_id) ? '' : $request->android_app_id;
        $adData['android_banner_app_id'] = is_null($request->android_banner_app_id) ? '' : $request->android_banner_app_id;
        $adData['android_interstitial_app_id'] = is_null($request->android_interstitial_app_id) ? '' : $request->android_interstitial_app_id;
        $adData['android_video_app_id'] = is_null($request->android_video_app_id) ? '' : $request->android_video_app_id;
        
        $adData['ios_app_id'] = is_null($request->ios_app_id) ? '' : $request->ios_app_id;
        $adData['ios_banner_app_id'] = is_null($request->ios_banner_app_id) ? '' : $request->ios_banner_app_id;
        $adData['ios_interstitial_app_id'] = is_null($request->ios_interstitial_app_id) ? '' : $request->ios_interstitial_app_id;
        $adData['ios_video_app_id'] = is_null($request->ios_video_app_id) ? '' : $request->ios_video_app_id;
        $adData['disable_inter'] = !empty($request->disable_inter) ? 1 : 0;
        $adData['disable_banner'] = !empty($request->disable_banner) ? 1 : 0;
        $adData['disable_rewarded'] = !empty($request->disable_rewarded) ? 1 : 0;
        
        if(!is_null($request->interstitial_show_on)) {
            if( count($request->interstitial_show_on) >0 ) {
                $adData['interstitial_show_on'] = implode(",",$request->interstitial_show_on);
            } else {
                $adData['interstitial_show_on'] = '';
            }
        } else {
            $adData['interstitial_show_on'] = '';
        }
        
        if(!is_null($request->banner_show_on)) {
            if( count($request->banner_show_on) >0 ) {
                $adData['banner_show_on'] = implode(",",$request->banner_show_on);
            } else {
                $adData['banner_show_on'] = '';
            }
        } else {
            $adData['banner_show_on'] = '';
        }
        
        if(!is_null($request->video_show_on)) {
            if( count($request->video_show_on) >0 ) {
                $adData['video_show_on'] = implode(",",$request->video_show_on);
            } else {
                $adData['video_show_on'] = '';
            }
        } else {
            $adData['video_show_on'] = '';
        }

        DB::table('ad_settings')->updateOrInsert(
        ['ad_setting_id' => 1],
        $adData);
        $msg="Ad Update Successfully";
        return redirect( config("app.admin_url").'/ads-settings')->with('success','Ads Update Successfully');
    }
}
