<?php
namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\Storage; 
use Illuminate\Support\Facades\DB; 

class WallAdsController extends Controller
{   

    var $column_order = array(null,null, 'title','added_on','expiry_date','banner'); //set column field database for datatable orderable

    var $column_search = array('title','added_on','expiry_date','banner'); //set column field database for datatable searchable

    var $order = array('added_on' => 'desc'); // default order

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct(){
        $this->middleware('auth');
    }
    public function index($active=1){
        $wall_ads = DB::table('wall_ads')
        ->select(DB::raw('*'))
        ->orderBy('added_on','DESC')
        ->get();
        return view("admin.wall_ads",compact('wall_ads','active'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */


    private function _form_validation($request, $is_edit){
    	if($is_edit==1){

	        $rules = [
	            'title' => 'required',
	            'start_date'     => 'required',
	            'expiry_date'     => 'required',
	            //'password' => 'required',
	            'ad_type'     => 'required',
	            'active'     => 'required',
	            'banner'          => 'image|mimes:jpeg,png,jpg,gif',
	            'video'          => 'video|mimes:mp4',
	            'banner_1'          => 'image|mimes:jpeg,png,jpg,gif',
	            'banner_2'          => 'image|mimes:jpeg,png,jpg,gif',
	            'banner_3'          => 'image|mimes:jpeg,png,jpg,gif',
	            'banner_4'          => 'image|mimes:jpeg,png,jpg,gif',
	            'banner_5'          => 'image|mimes:jpeg,png,jpg,gif',
	            //'zipcode'     => 'required',
	        ];

	        $messages = [
	            'tilte.required' => 'You can\'t leave Title field empty',
	            'start_date.required'    => 'You can\'t leave Start Date field empty',
	            'expiry_date.required'    => 'You can\'t leave End Date field empty',
	            'active.required'    => 'You can\'t leave Active field empty',
	        ];

	        $this->validate($request,$rules,$messages);
	        
		}else{
			
			if($request->ad_type=="B"){
		        $rules = [
		            'title' => 'required',
		            'start_date'     => 'required',
		            'expiry_date'     => 'required',
		            //'password' => 'required',
		            'active'     => 'required',
		            'ad_type'     => 'required',
		            'banner'          => 'required|image|mimes:jpeg,png,jpg,gif',
		            //'zipcode'     => 'required',
		        ];
		    }elseif($request->ad_type=="V"){
		        $rules = [
		            'vid_title' => 'required',
		            'start_date'     => 'required',
		            'expiry_date'     => 'required',
		            //'password' => 'required',
		            'active'     => 'required',
		            'ad_type'     => 'required',
		            'video'          => 'mimes:mp4',
		            //'zipcode'     => 'required',
		        ];
		    }elseif($request->ad_type=="M"){
		        $rules = [
		            'title_1' => 'required',
		            'start_date'     => 'required',
		            'expiry_date'     => 'required',
		            //'password' => 'required',
		            'active'     => 'required',
		            'ad_type'     => 'required',
		            'banner_1'          => 'required|image|mimes:jpeg,png,jpg,gif',
		            //'zipcode'     => 'required',
		        ];

			}else{
		        $rules = [
		            'title' => 'required',
		            'start_date'     => 'required',
		            'expiry_date'     => 'required',
		            //'password' => 'required',
		            'active'     => 'required',
		            'ad_type'     => 'required',
		            //'zipcode'     => 'required',
		        ];
			}
	        $messages = [
	            'tilte.required' => 'You can\'t leave Title field empty',
	            'start_date.required'    => 'You can\'t leave Start Date field empty',
	            'expiry_date.required'    => 'You can\'t leave End Date field empty',
	            //'password.required'    => 'You can\'t leave Password field empty',
	            'active.required'    => 'You can\'t leave Active field empty',
	            //'zipcode.required'    => 'You can\'t leave Zipcode field empty',
	        ]; 
	        $this->validate($request,$rules,$messages);
	        
		}
		if(is_array($request->state)){
			$state = implode(",", $request->state);
		}else{
			$state = "";
		}

		if(is_array($request->country)){
			$country = implode(",", $request->country);
		}else{
			$country = "";
		}

        $postData = array(
            'title1' => $request->title_1,
            'link1'     => $request->link_1,
            'description1' => $request->description_1,
            'title2' => $request->title_2,
            'link2'     => $request->link_2,
            'description2' => $request->description_2,
            'title3' => $request->title_3,
            'link3'     => $request->link_3,
            'description3' => $request->description_3,
            'title4' => $request->title_4,
            'link4'     => $request->link_4,
            'description4' => $request->description_4,
            'title5' => $request->title_5,
            'link5'     => $request->link_5,
            'description5' => $request->description_5,
            'start_date'     => $request->start_date,
            'expiry_date'  => $request->expiry_date,
            'ad_type'     => $request->ad_type,
            //'password'     => Hash::make($request->password),
            'countries' => $country,
            'states' => $state,
            'active'     => $request->active,
            'added_on'     => date("Y-m-d H:i:s"),
        ); 			
        if($request->ad_type=="B"){
			$postData['title1'] = $request->title;
			$postData['link1'] = $request->link;
			$postData['description1'] = $request->description;
		}
        if($request->ad_type=="V"){
			$postData['title1'] = $request->vid_title;
			$postData['link1'] = $request->vid_link;
			$postData['description1'] = $request->vid_description;
		}
		
        return $postData;
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = $this->_form_validation($request, 0); 
        if($request->ad_type=="B"){
			
			if($request->hasFile('banner')) {
	            $path = "banners";
	            $filenametostore = $request->file('banner')->store($path);
	          
	            Storage::setVisibility($filenametostore, 'public');
	            $fileArray = explode('/',$filenametostore);
	            $fileName = array_pop($fileArray); 
	            $data['file1'] = $fileName;
	            
			}
		}
        if($request->ad_type=="V"){
			
			if($request->hasFile('video')) {
	            $path = "banners";
	            $filenametostore = $request->file('video')->store($path);
	          
	            Storage::setVisibility($filenametostore, 'public');
	            $fileArray = explode('/',$filenametostore);
	            $fileName = array_pop($fileArray);
	            $data['file1'] = $fileName;
	            
			}
		}

        if($request->ad_type=="M"){
			for($i=1;$i<=5;$i++){
				if($request->hasFile('banner_'.$i)) {
		            $path = "banners";
		            $filenametostore = $request->file('banner_'.$i)->store($path);
		          
		            Storage::setVisibility($filenametostore, 'public');
		            $fileArray = explode('/',$filenametostore);
		            $fileName = array_pop($fileArray);
		            $data['file'.$i] = $fileName;
				}
			}
		}
        DB::table('wall_ads')->insert($data);
        return redirect( config('app.admin_url').'/wall_ads')->with('success','Ad submitted successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($active=1){
        $wall_ads = DB::table('wall_ads')
        ->select(DB::raw('*'))
        ->orderBy('added_on','DESC')
        ->get();
        return view("admin.wall_ads",compact('active','wall_ads'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id){
        $action = 'edit';
        $countryRS = DB::table('countries')->select(DB::raw("*"))->get();
        $stateRS = DB::table('states')->select(DB::raw("*"))->get();
        $wall_ads = DB::table('wall_ads')->select(DB::raw("*"))->where('ad_id','=',$id)->first();
        // dd($category);
        return view('admin.wall_ad_create',compact('wall_ads','id','action', 'countryRS', 'stateRS'));
    }

    public function add(){
        $action = 'add';
        $id = 0;
        $countryRS = DB::table('countries')->select(DB::raw("*"))->get();
        $stateRS = DB::table('states')->select(DB::raw("*"))->get();
        // dd($category);
        return view('admin.wall_ad_create',compact('id','action', 'countryRS', 'stateRS'));
    }

    public function view($id){
        $action = 'view';
        $wall_ads = DB::table('wall_ads')->select(DB::raw("*"))->where('ad_id','=',$id)->first();
        $countryRS = DB::table('countries')->select(DB::raw("*"))->get();
        $stateRS = DB::table('states')->select(DB::raw("*"))->get();
         //dd($candidate);
        return view('admin.wall_ad_create',compact('wall_ads','id','action','language', 'countryRS', 'stateRS'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = $this->_form_validation($request, 1);
        if($request->ad_type=="B"){
			
			if($request->hasFile('banner')) {
	            $path = "banners";
	            $filenametostore = $request->file('banner')->store($path);
	          
	            Storage::setVisibility($filenametostore, 'public');
	            $fileArray = explode('/',$filenametostore);
	            $fileName = array_pop($fileArray); 
	            $data['file1'] = $fileName;
	            
			}
		}
        if($request->ad_type=="V"){
			
			if($request->hasFile('video')) {
	            $path = "banners";
	            $filenametostore = $request->file('video')->store($path);
	          
	            Storage::setVisibility($filenametostore, 'public');
	            $fileArray = explode('/',$filenametostore);
	            $fileName = array_pop($fileArray);
	            $data['file1'] = $fileName;
	            
			}
		}

        if($request->ad_type=="M"){
			for($i=1;$i<=5;$i++){
				if($request->hasFile('banner_'.$i)) {
		            $path = "banners";
		            $filenametostore = $request->file('banner_'.$i)->store($path);
		          
		            Storage::setVisibility($filenametostore, 'public');
		            $fileArray = explode('/',$filenametostore);
		            $fileName = array_pop($fileArray);
		            $data['file'.$i] = $fileName;
				}
			}
		}
        
        DB::table('wall_ads')->where('ad_id',$id)->update($data);
        return redirect( env('ADMIN_URL').'/wall_ads')->with('success','Ad details updated successfully');
    }

    public function inactive($id)
    {   
        DB::table('wall_ads')->where('ad_id',$id)->update(array('active' => '0'));
        return redirect( env('ADMIN_URL').'/wall_ads')->with('success','Ad Inactivated');
    }

    public function active($id)
    {   
        DB::table('wall_ads')->where('ad_id',$id)->update(array('active' => '1'));
        return redirect( env('ADMIN_URL').'/wall_ads')->with('success','Ad Activated');
    }


    public function serverProcessing(Request $request)
    {
        $currentPath = url(config('app.admin_url')).'/wall_ads/';
        $list = $this->get_datatables($request);

        $data = array();
        $no = $request->start;
        foreach ($list as $wall_ads) {
            $no++;
            switch($wall_ads->ad_type){
				case "B":
					$type = "Single Banner";
				break;
				case "V":
					$type = "Video";
				break;
				case "M":
					$type = "Multiple Banner";
				break;
			}
            $row = array();
            // $row[] = '<a class="view" href="'.$currentPath.'view/'.$wall_ads->ad_id.'"><i class="fa fa-search"></i></a><a class="edit" href="'.$currentPath.$wall_ads->ad_id.'/edit"><i class="fa fa-edit"></i></a><a class="copy" href="'.$currentPath.'copy/'.$wall_ads->ad_id.'"><i class="fa fa-copy"></i></a><a class="delete deleteSelSingle" style="cursor:pointer;" data-val="'.$wall_ads->ad_id.'"><i class="fa fa-trash"></i></a>';
            $row[] = '<a class="view" href="'.$currentPath.'view/'.$wall_ads->ad_id.'"><i class="fa fa-search"></i></a><a class="edit" href="'.$currentPath.'edit/'.$wall_ads->ad_id.'"><i class="fa fa-edit"></i></a><a class="delete deleteSelSingle" style="cursor:pointer;" data-val="'.$wall_ads->ad_id.'"><i class="fa fa-trash"></i></a>';
            $row[] = '<div class="align-center"><input id="cb'.$no.'" name="key_m[]" class="delete_box blue-check" type="checkbox" data-val="'.$wall_ads->ad_id.'"><label for="cb'.$no.'"></label></div>';
            $row[] = $wall_ads->title1;
            // $row[] = $producer->last_name;
            $row[] = $wall_ads->added_on;
            $row[] = $wall_ads->start_date;
            $row[] = $wall_ads->expiry_date;
            $row[] = $wall_ads->countries;
            $row[] = $wall_ads->states;
            $row[] = $type;
            if($wall_ads->ad_type=="V"){
	            $row[] = '<video height="50" src="'.Storage::url("banners/".$wall_ads->file1).'"/>';
			}else{
	            $row[] = '<img height="50" src="'.Storage::url("banners/".$wall_ads->file1).'">';
			}
            $row[] = $wall_ads->views;
            $row[] = $wall_ads->clicks;
            //$row[] = $producer->city;
            //$row[] = $wall_ads->zipcode;
            if($wall_ads->active==1){
                $row[] = '<a class="btn btn-success" href="'.$currentPath.'inactive/'.$wall_ads->ad_id.'" onclick="return confirm(\'Are you sure, you want to inactivate this ad?\')">Active</a>';
            }else{
                $row[] = '<a class="btn btn-danger" href="'.$currentPath.'active/'.$wall_ads->ad_id.'" onclick="return confirm(\'Are you sure, you want to activate this ad?\')">Inactive</a>';
            }
            //$row[] = '<a href="#" class="btn btn-primary">Change Password</a>';
            $data[] = $row;
        }

        $output = array(
            "draw" => $request->draw,
            "recordsTotal" => $this->count_all($request),
            "recordsFiltered" => $this->count_filtered($request),
            "data" => $data,
        );
        echo json_encode($output);
    }

    private function _get_datatables_query($request)
    {            
        $keyword = $request->search['value'];
        $order = $request->order;
        $wall_adsRS = DB::table('wall_ads')
        ->select(DB::raw("*"));
        $strWhere = " 1=1 ";
        
        $strWhereOr = "";
        $i = 0;

        foreach ($this->column_search as $item) // loop column
        {
            if($keyword) // if datatable send POST for search{
            	$strWhereOr = $strWhereOr." $item like '%".$keyword."%' or ";
                //$candidateRS = $candidateRS->orWhere($item, 'like', '%' . $keyword . '%') ;
        }
        $strWhereOr = trim($strWhereOr, "or ");
        if($strWhereOr!=""){
	        $wall_adsRS = $wall_adsRS->whereRaw(DB::raw($strWhere." and (".$strWhereOr.")"));
	    }else{
			$wall_adsRS = $wall_adsRS->whereRaw(DB::raw($strWhere	));
		}

        
        if(isset($order)) // here order processing
        {
            $wall_adsRS = $wall_adsRS->orderBy($this->column_order[$request->order['0']['column']], $request->order['0']['dir']);
        } 
        else if(isset($this->order))
        {
            $orderby = $this->order;
            $wall_adsRS = $wall_adsRS->orderBy(key($orderby),$orderby[key($orderby)]);
        }
        return $wall_adsRS;
    }

    function get_datatables($request)
    {
        $wall_adsRS = $this->_get_datatables_query($request);
        if($request->length != -1){
            $wall_adsRS = $wall_adsRS->limit($request->length);
            if($request->start != -1){
                $wall_adsRS = $wall_adsRS->offset($request->start);
            }
        }
        
        $wall_ads = $wall_adsRS->get();
        return $wall_ads;
    }

    function count_filtered($request)
    {
        $wall_adsRS = $this->_get_datatables_query($request);
        return $wall_adsRS->count();
    }

    public function count_all($request)
    {
        $wall_adsRS = DB::table('wall_ads')->select(DB::raw("count(*) as total"))->first();
        return $wall_adsRS->total;
    }

    public function delete(Request $request){
        $rec_exists = array();
        $del_error = '';
        $ids = explode(',',$request->ids);
        foreach ($ids as $id) {
            DB::table('wall_ads')->where('ad_id', $id)->delete();
        }
        
        if($del_error == 'error'){
            $request->session()->put('error',$msg );
            return response()->json(['status' => 'error',"rec_exists"=>$rec_exists]);
        }else{
            if( count($ids) > 1){
                $msg = "Ad deleted successfully";
            }else{
                $msg = "Ad deleted successfully";
            }
            $request->session()->put('success', $msg);
            return response()->json(['status' => 'success',"rec_exists"=>$rec_exists]);
        }

    }

}
