<?php

namespace App\Http\Controllers;

use FFMpeg\FFProbe;
use FFMpeg as FFMpeg;
use Illuminate\Http\File;
use Illuminate\Http\Request;
use FFMpeg\Format\Video\X264;
use App\Helpers\Common\Functions;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Crypt;
use Illuminate\Support\Facades\Storage;
use App\GifCreator;
use FFMpeg\Coordinate\TimeCode;
use Intervention\Image\ImageManagerStatic as Image;
use App\Jobs\SendNotificationJob;
use App\Jobs\PostLikeJob;
use App\Jobs\PostViewJob;
use App\Jobs\PostLike3DaysJob;
use App\Jobs\PostLike2DaysJob;
use App\Jobs\PostLike4DaysJob;
use App\Jobs\PostLike1DaysJob;
use App\Jobs\Post4DaysViewJob;
use App\Jobs\Post3DaysViewJob;
use App\Jobs\Post2DaysViewJob;
use App\Jobs\Post1DaysViewJob;
// use Notification;
use Illuminate\Support\Facades\Notification;
use App\Notifications\UserNotification;
use App\Mail\Admin\SendMail;
use App\Models\User;
use Mail;

class IndexController extends Controller
{

  public function __construct() {}


  public function index(Request $request)
  {
    $id = $request->id;

    return '<script>
   (function() {
     var app = {
       launchApp: function() {
         window.location.replace("filmsdream://filmsdream.com?id=' . $id . '");
         this.timer = setTimeout(this.openWebApp, 100);
       },
   
       openWebApp: function() {
         window.location.replace("' . route("view-post", Crypt::encrypt($id)) . '");
       }
     };
   
     app.launchApp();
   })();
   </script>';
  }

  public function viewPost($id, Request $request)
  {

    // dd(Crypt::encrypt($id));
    $id = Crypt::decrypt($id);
    // dd($id);


    $res = DB::table('posts as p')
      ->select(DB::raw('p.file as file,p.type,p.user_id,u.username,p.title,u.profile_pic as user_dp'))
      ->leftJoin('users as u', 'u.user_id', '=', 'p.user_id')
      ->where('post_id', $id)
      ->first();

    if ($res) {

      $file = $res->file;
      $type = $res->type;
      $user_id = $res->user_id;
      $title = $res->title;
      $thumb = '';
      if ($res->type == 'V') {
        $video = explode('.', $res->file);
        $thumb = $video[0] . '.jpg';
      }
      $username = $res->username;
      $user_dp = $res->user_dp;
      return view('view-post', compact('file', 'thumb', 'user_id', 'username', 'type', 'user_dp', 'title'));
    }
  }

  public function showPost(Request $request)
  {
    //   dd(base64_encode($request->id));
    $id = base64_decode($request->id);

    $res = DB::table('posts as p')
      ->select(DB::raw('p.file as file,p.type,p.user_id,u.username,p.title'))
      ->leftJoin('users as u', 'u.user_id', '=', 'p.user_id')
      ->where('post_id', $id)
      ->first();
    if ($res) {
      $file = $res->file;
      $type = $res->type;
      $user_id = $res->user_id;
      $title = $res->title;
      $thumb = '';
      if ($res->type == 'V') {
        $video = explode('.', $res->file);
        $thumb = $video[0] . '.jpg';
      }
      $username = $res->username;
      return view('show-post', compact('file', 'thumb', 'user_id', 'username', 'title', 'id', 'type'));
    }
  }

  public function showVideoWeb(Request $request)
  {

    $video_id = $request->video_id;
    $id = $video_id;
    // $video_id = str_ireplace("yfmtythd84n4h", "", $video_de);
    $video_res = DB::table('videos as v')
      ->select(DB::raw('v.video,v.thumb,v.user_id,u.username,v.title,v.description'))
      ->leftJoin('users as u', 'u.user_id', '=', 'v.user_id')
      ->where('video_id', $video_id)
      ->first();
    //   dd(secure_url('storage/videos/'.$user_id.'/thumb/'.$thumb));
    if ($video_res) {
      $video = $video_res->video;
      $thumb = $video_res->thumb;
      $user_id = $video_res->user_id;
      $title = ($video_res->title != "") ? $video_res->title : "";
      $description = $video_res->description;
      $username = $video_res->username;
      return view('show-video', compact('video', 'thumb', 'user_id', 'username', 'description', 'title', 'id'));
    }
  }

  public function front()
  {
    $videos = DB::table('videos')
      ->select('user_id', 'video_id', 'video', 'thumb', 'gif', 'total_likes', 'total_comments', 'total_views')
      ->orderBy('total_likes')->orderBy('total_views')
      ->where(['active' => 1, 'enabled' => 1])
      ->where('video_id', '>=', 145)
      ->get()->take(5);
    // dd($videos);
    return view('home', compact('videos'));
  }

  public function videoInfo($videoId)
  {

    $video = DB::table('videos as v')
      ->join('users as u', 'u.user_id', 'v.user_id')
      ->select('v.total_views', 'u.username')
      ->where('v.video_id', $videoId)
      ->first();
    $comments = DB::table('comments as c')
      ->join('users as u', 'u.user_id', 'c.user_id')
      ->select('u.username', 'c.comment_id', 'c.comment')
      ->where(['c.active' => 1, 'c.video_id' => $videoId])
      ->get();
    $comment_html = view('partials.comments', ['comments' => $comments])->render();

    return response()->json(['success' => true, 'video' => $video, 'comment_html' => $comment_html]);
  }

  public function videoViewed($videoId)
  {

    DB::table('videos')
      ->increment('total_views');

    //change the user_id as per the logged in user via the auth()->guard() or not logged in user set to 0
    $uniqueViewExists = DB::table('video_views')
      ->where(['user_id' => 1, 'video_id' => $videoId, 'viewed_on' => date('Y-m-d')])
      ->exists();

    //set unique id as per cookie/loggedin user
    if (!$uniqueViewExists) {
      DB::table('video_views')
        ->insert(['user_id' => 1, 'video_id' => $videoId, 'viewed_on' => date('Y-m-d'), 'unique_id' => 1]);
    }

    return response()->json(['success' => true]);
  }


  public function test2()
  {
    $ffprobe = FFMpeg\FFProbe::create();
    $streamsCount = $ffprobe
      ->streams('C:\Users\unify1\Downloads\test2.mp4')
      ->count();

    dd($streamsCount);
  }

  public function test()
  {
    $ffmpeg = FFMpeg\FFMpeg::create();
    $ffprobe = FFMpeg\FFProbe::create();

    //       $streamCount = $ffprobe->streams(asset('video.mp4'))->audios()->count();
    // // dd($streamCount);
    //             if ($streamCount > 0) {
    //                 $video = $ffmpeg->open(asset('video.mp4'));
    //                 $audio_format = new FFMpeg\Format\Audio\Mp3();

    //                 $video->save($audio_format, 'testAudio.mp3');
    //             }

    //             $advancedMedia = $ffmpeg->openAdvanced(array(asset('water.png'), asset('TikTok.mp4')));
    //             $advancedMedia->filters()
    //                 // ->custom('[1:v]', 'overlay=W-w-5:5', '[v]');
    //                 ->custom('[1:v]scale=720:-2,', 'overlay=W-w-5:H-h-5', '[v]');
    //             $advancedMedia
    //                 ->map(array('1:v', '[v]'), new X264('aac', 'libx264'), 'testvideo.mp4');
    //             $advancedMedia->save();


    $advancedMedia = $ffmpeg->openAdvanced(array(asset('water.png'), asset('TikTok.mp4')));

    $advancedMedia->filters()
      ->custom('[1:v]scale=720:-2,', 'overlay=W-w-5:H-h-5', '[v]');

    $advancedMedia
      ->map(array('1:a', '[v]'), new X264('aac', 'libx264'), 'testvideo.mp4');

    $advancedMedia->save();
    dd(444);
    // $videoFileName=$this->CleanFileNameMp4($request->file('video')->getClientOriginalName());
    //       $video=new File(storage_path('app/public/video.mp4'));
    //           Storage::putFileAs("public", $video,'s3video.mp4');
    //           Storage::setVisibility('public/s3video.mp4', 'public');
    // dd(Storage::url('public/s3video.mp4'));
    $timeFolder = time();
    // Functions::ffmpegUpload(asset('video.mp4'),storage_path('app/public/videos/5/video.mp4'),asset('audio.mp3'),storage_path('app/public/sounds/5/'.$timeFolder.'.mp3'),asset('water.png'),'s3','public/videos/5/video.mp4','public/sounds/5/'.$timeFolder.'.mp3');

    $uploadStatus = Functions::ffmpegUpload(asset('video.mp4'), storage_path('app/public/videos/5/Testvideo.mp4'), '', storage_path('app/public/sounds/5/' . $timeFolder . '.mp3'), storage_path('app/public/videos/5/thumb/' . $timeFolder . '.jpg'), asset('water.png'), '', '', '', '', '', '', '');
  }

  public function send_notification()
  {
    $users = DB::table('users')->where('new_app_user', 0)->where('player_id', '!=', '')->get();
    foreach ($users as $user) {
      $userData = [];
      $userData['player_id'] = $user->player_id;
      $userData['email'] = $user->email;
      SendNotificationJob::dispatch($userData);
    }
  }

  public function sendChallengeNotification()
  {
    $users = DB::table('users')->where('active', 1)
      ->where('deleted', 0)
      ->where('user_id', 16677)
      ->where('fcm_token', '!=', '')->get();

    $challenge = DB::table('challenges')->first();
    $title = $challenge->title;
    $message = "Films Dream has started a new Challenge️ Show off your talent and creativity for a chance to WIN amazing rewards.
        Don't wait to join the challenge. Big rewards are waiting for you. join and enjoy.";
    foreach ($users as $user) {
      $fcmTokens = [$user->fcm_token];

      $not_data['created_on'] = date("Y-m-d H:i:s");
      $not_data['sent_to'] = $user->user_id;
      $not_data['title'] = $title;
      $not_data['page_name'] = "challenge-detail";
      $not_data['post_id'] = $challenge->id;
      $not_data['sent_by'] = 0;
      DB::table('notifications')->insert($not_data);
      try {
        $image = '';
        // dd($user);
        // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
        $param = ['id' => strval($challenge->id), 'type' => 'challenge', 'page' => '/challenge-detail', 'image' => $image, 'to_id' => strval($user->user_id), 'from_id' => "0"];
        // Notification::send($users, new UserNotification('sss', 'sssss', $image, $param, $fcmTokens));
        $user = User::where('user_id', $user->user_id)->first();
        $user->notify(new UserNotification($title, $message, $image, $param));
      } catch (\Exception $e) {
        // dd($e);
      }
    }

    echo 'done';
    exit;
  }


  public function postLike()
  {
    $lastWeek = date('Y-m-d', strtotime("-4 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->where('added_on', '<', $lastWeek)
      ->where('type', '!=', 'A')
      // ->limit(25)
      ->orderBy('post_id', 'desc')
      ->get();

    $sql = " select user_id,username from users where active=1 and user_id NOT IN ( select user_id as ids from post_likes where like_on >= DATE_SUB(NOW(),INTERVAL 1 YEAR) )
              and user_id NOT IN ( select user_id as ids from post_comments where comment_on >= DATE_SUB(NOW(),INTERVAL 1 YEAR))
              and user_id NOT IN ( select user_id as ids from post_views where view_on >= DATE_SUB(NOW(),INTERVAL 1 YEAR)) order by rand() ";

    $records = DB::select(DB::raw($sql));


    $chunks = $posts->chunk(200);

    foreach ($chunks as $chunk) {

      PostLikeJob::dispatch($chunk, $records);
    }
    // foreach ($posts as $post) {
    //   $limit = rand(100, 500);
    //   $users = array();
    //   foreach( array_rand($records, $limit) as $k ) {
    //     $users[] = $records[$k];
    //   }

    //   PostLikesJob::dispatch($post,$users);

    //   // dd($count);
    // }
    dd('success');
  }

  public function postView()
  {
    $lastWeek = date('Y-m-d', strtotime("-4 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->orderBy('post_id', 'desc')
      ->where('added_on', '<', $lastWeek)
      ->where('type', '!=', 'A')
      ->get();

    foreach ($posts as $post) {

      PostViewJob::dispatch($post);

      // dd($count);
    }
    dd('success');
  }

  public function postLikeDaysWise()
  {
    $lastWeek = date('Y-m-d', strtotime("-3 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->where('added_on', $lastWeek)
      ->where('type', '!=', 'A')
      // ->limit(25)
      ->orderBy('post_id', 'desc')
      ->get();

    $sql = " select user_id,username from users where active=1 and user_id NOT IN ( select user_id as ids from post_likes where like_on >= DATE_SUB(NOW(),INTERVAL 1 YEAR) )
              and user_id NOT IN ( select user_id as ids from post_comments where comment_on >= DATE_SUB(NOW(),INTERVAL 1 YEAR))
              and user_id NOT IN ( select user_id as ids from post_views where view_on >= DATE_SUB(NOW(),INTERVAL 1 YEAR)) order by rand() ";

    $records = DB::select(DB::raw($sql));


    $chunks = $posts->chunk(200);

    foreach ($chunks as $chunk) {

      PostLikeJob::dispatch($chunk, $records);
    }
    // foreach ($posts as $post) {
    //   $limit = rand(100, 500);
    //   $users = array();
    //   foreach( array_rand($records, $limit) as $k ) {
    //     $users[] = $records[$k];
    //   }

    //   PostLikesJob::dispatch($post,$users);

    //   // dd($count);
    // }
    dd('success');
  }

  public function postLike4DaysWise()
  {
    $lastWeek = date('Y-m-d', strtotime("-4 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      // ->limit(25)
      ->orderBy('post_id', 'desc')
      ->get();

    $sql = " select user_id,username from users where active=1 and user_id IN ( 208,213,231,60,191,192,193,194,195,220,221,222,218,219,79,80,198,206,108,109,187,188,189,197,119,223,224,125,225,226,227,228,229,230,232,136,137,138,141,233,234,235,147,236,149,150,151,152,153,154,217,216,155,186,160,190,162,238,239,240,241,171,172,173,174,199,202,203,204,205,185,237,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,301,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,419,420,421,422,423,424,425,426) order by rand() ";

    $records = DB::select(DB::raw($sql));


    // $chunks = $posts->chunk(200);

    //   foreach ($chunks as $chunk) {

    PostLike4DaysJob::dispatch($posts, $records);
    // }

    dd('success');
  }

  public function postLike3DaysWise()
  {
    $lastWeek = date('Y-m-d', strtotime("-3 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      // ->limit(25)
      ->orderBy('post_id', 'desc')
      ->get();

    $sql = " select user_id,username from users where active=1 and user_id IN ( 208,213,231,60,191,192,193,194,195,220,221,222,218,219,79,80,198,206,108,109,187,188,189,197,119,223,224,125,225,226,227,228,229,230,232,136,137,138,141,233,234,235,147,236,149,150,151,152,153,154,217,216,155,186,160,190,162,238,239,240,241,171,172,173,174,199,202,203,204,205,185,237,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,301,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,419,420,421,422,423,424,425,426) order by rand() ";

    $records = DB::select(DB::raw($sql));


    // $chunks = $posts->chunk(200);

    //   foreach ($chunks as $chunk) {

    PostLike3DaysJob::dispatch($posts, $records);
    // }

    dd('success');
  }

  public function postLike2DaysWise()
  {
    $lastWeek = date('Y-m-d', strtotime("-2 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      // ->limit(25)
      ->orderBy('post_id', 'desc')
      ->get();

    $sql = " select user_id,username from users where active=1 and user_id IN ( 208,213,231,60,191,192,193,194,195,220,221,222,218,219,79,80,198,206,108,109,187,188,189,197,119,223,224,125,225,226,227,228,229,230,232,136,137,138,141,233,234,235,147,236,149,150,151,152,153,154,217,216,155,186,160,190,162,238,239,240,241,171,172,173,174,199,202,203,204,205,185,237,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,301,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,419,420,421,422,423,424,425,426) order by rand() ";

    $records = DB::select(DB::raw($sql));


    // $chunks = $posts->chunk(200);

    //   foreach ($chunks as $chunk) {

    PostLike2DaysJob::dispatch($posts, $records);
    // }

    dd('success');
  }


  public function postLike1DaysWise()
  {
    $lastWeek = date('Y-m-d', strtotime("-1 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      // ->limit(25)
      ->orderBy('post_id', 'desc')
      ->get();

    $sql = " select user_id,username from users where active=1 and user_id IN ( 208,213,231,60,191,192,193,194,195,220,221,222,218,219,79,80,198,206,108,109,187,188,189,197,119,223,224,125,225,226,227,228,229,230,232,136,137,138,141,233,234,235,147,236,149,150,151,152,153,154,217,216,155,186,160,190,162,238,239,240,241,171,172,173,174,199,202,203,204,205,185,237,242,243,244,245,246,247,248,249,250,251,252,253,254,255,256,257,258,259,260,261,262,263,264,265,266,267,268,269,270,271,272,273,274,301,275,276,277,278,279,280,281,282,283,284,285,286,287,288,289,290,291,292,293,294,295,296,297,298,299,300,302,303,304,305,306,307,308,309,310,311,312,313,314,315,316,317,318,319,320,321,322,323,324,325,326,327,328,329,330,331,332,333,334,335,336,337,338,339,340,341,342,343,344,345,346,347,348,349,350,351,352,353,354,355,356,357,358,359,360,361,362,363,364,365,366,367,368,369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387,388,389,390,391,392,393,394,395,396,397,398,399,400,401,402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417,418,419,420,421,422,423,424,425,426) order by rand() ";

    $records = DB::select(DB::raw($sql));


    // $chunks = $posts->chunk(200);

    //   foreach ($chunks as $chunk) {

    PostLike1DaysJob::dispatch($posts, $records);
    // }

    dd('success');
  }

  public function post4DaysView()
  {
    $lastWeek = date('Y-m-d', strtotime("-4 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->orderBy('post_id', 'desc')
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      ->get();

    foreach ($posts as $post) {

      Post4DaysViewJob::dispatch($post);

      // dd($count);
    }
    dd('success');
  }

  public function post3DaysView()
  {
    $lastWeek = date('Y-m-d', strtotime("-3 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->orderBy('post_id', 'desc')
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      ->get();

    foreach ($posts as $post) {

      Post3DaysViewJob::dispatch($post);

      // dd($count);
    }
    dd('success');
  }

  public function post2DaysView()
  {
    $lastWeek = date('Y-m-d', strtotime("-2 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->orderBy('post_id', 'desc')
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      ->get();

    foreach ($posts as $post) {

      Post2DaysViewJob::dispatch($post);

      // dd($count);
    }
    dd('success');
  }

  public function post1DaysView()
  {
    $lastWeek = date('Y-m-d', strtotime("-1 day"));

    $posts = DB::table('posts')
      ->where('show_on_wall', 1)
      ->orderBy('post_id', 'desc')
      ->where('added_on', 'like', '%' . $lastWeek . '%')
      ->where('type', '!=', 'A')
      ->get();

    foreach ($posts as $post) {

      Post1DaysViewJob::dispatch($post);

      // dd($count);
    }
    dd('success');
  }

  public function adViews(Request $request)
  {

    $posts = DB::table('posts')
      ->where('type', 'A')
      ->where('ad_id', '>', 0)
      ->get();

    foreach ($posts as $post) {
      $likes = DB::table('post_likes')
        ->select(DB::raw('post_id,user_id'))
        ->where('post_id', $post->post_id)
        ->get();

      foreach ($likes as $row) {
        $record = [
          'post_id' => $post->post_id,
          'user_id' => $row->user_id
        ];
        DB::table('post_views')->insert($record);
      }
      $views_count = $likes->count();
      DB::table('posts')->where('post_id', $post->post_id)
        ->update(['views' => $views_count]);
    }

    dd('success');
  }

  public function challenegeResult()
  {
    $challenges = DB::table('challenges')
      ->where('end_date', '<=', date('Y-m-d 00:00:00'))
      ->where('result_declared', 0)
      ->get();

    foreach ($challenges as $challenge) {
      $id = $challenge->id;
      \Log::info('challenge ' . $id);
      $first_price = $challenge->first_price;
      $second_price = $challenge->second_price;
      $third_price = $challenge->third_price;
      $coins = $challenge->price;
      config()->set('database.connections.mysql.strict', false);
      DB::reconnect();
      $posts = DB::table('posts as p')
        ->select(DB::raw('p.post_id as post_id,p.likes as likes,p.views as views,
        					p.comments as comments,p.shares as shares,p.type as type,
        					u.user_id as user_id,
                  CASE WHEN p.shares > 0 THEN p.shares * 4 ELSE 0 END AS total_shares,
                  CASE WHEN p.likes > 0 THEN p.likes * 3 ELSE 0 END AS total_likes,
                  CASE WHEN p.views > 0 THEN p.views * 2 ELSE 0 END AS total_views,
                  CASE WHEN p.comments > 0 THEN p.comments * 1 ELSE 0 END AS total_comments,
           ((CASE WHEN count(DISTINCT ps.user_id) > 0 THEN count(DISTINCT ps.user_id) * 4 ELSE 0 END) +
            (CASE WHEN count(DISTINCT pl.user_id) > 0 THEN count(DISTINCT pl.user_id) * 2 ELSE 0 END) +
            (CASE WHEN count(DISTINCT pv.user_id) > 0 THEN count(DISTINCT pv.user_id) * 1 ELSE 0 END) +
            (CASE WHEN count(DISTINCT pc.user_id) > 0 THEN count(DISTINCT pc.user_id) * 3 ELSE 0 END)) as total
                    '))->leftJoin('users as u', 'u.user_id', 'p.user_id')
        ->join('challenges as c', 'c.id', 'p.challenge_id')

        ->leftJoin('post_comments as pc', function ($q) {
          $q->on('pc.post_id', 'p.post_id');
          $q->on("pc.comment_on", '<=', 'c.end_date');
          // $q->groupBy('pc.user_id');
        })

        ->leftJoin('post_shares as ps', function ($q) {
          $q->on('ps.post_id', 'p.post_id');
          $q->on("ps.share_on", '<=', 'c.end_date');
          // $q->groupBy('ps.user_id');
        })

        ->leftJoin('post_likes as pl', function ($q) {
          $q->on('pl.post_id', 'p.post_id');
          $q->on("pl.like_on", '<=', 'c.end_date');
          // $q->groupBy('pl.user_id');
        })

        ->leftJoin('post_views as pv', function ($q) {
          $q->on('pv.post_id', 'p.post_id');
          $q->on("pv.view_on", '<=', 'c.end_date');
          // $q->groupBy('pv.user_id');
        })


        ->where('p.challenge_id', $id)
        ->where('p.challenge_approved', 1)
        ->groupBy('p.post_id');
      $videos = $posts->get();
      $posts = $posts->orderBy('total', 'desc')
        ->limit(4)->get();

      config()->set('database.connections.mysql.strict', true);
      DB::reconnect();

      $first = 0;
      $second = 0;
      $third = 0;
      $forth = 0;

      $records = DB::table('wallet_history')->where('challenge_id', $id)->where('type', 'D')->get();

      if ($records->count() >= $challenge->min_required_users) {
        $winner_data = array();

        //first
        if (isset($posts[0])) {
          $first = $posts[0]->total;
        }

        // second
        if (isset($posts[1])) {
          $second = $posts[1]->total;
        }

        // third
        if (isset($posts[2])) {
          $third = $posts[2]->total;
        }

        //fourth
        if (isset($posts[3])) {
          $forth = $posts[3]->total;
        }


        if ($first > $second) {
          if ($second > $third) {
            if ($third > $forth) {
              //first
              if (isset($posts[0])) {
                // $first_user = DB::table('users')->where('user_id', $posts[0]->user_id)->increment('wallet_amount', $first_price);
                $first = $posts[0]->total;

                $data1['user_id'] = $posts[0]->user_id;
                $data1['challenge_id'] = $id;
                $data1['position'] = 1;
                $data1['win_amount'] = $first_price;
                $data1['created_at'] = date('Y-m-d H:i:s');
                $data1['updated_at'] = date('Y-m-d H:i:s');

                array_push($winner_data, $data1);

                DB::table('wallet_history')->insert([
                  'challenge_id' => $id,
                  'coins' => $first_price,
                  'amount' => 0,
                  'raw_amount' => '',
                  'type' => 'C',
                  'status' => 'Credited',
                  'user_id' => $posts[0]->user_id,
                  'created_at' => date('Y-m-d H:i:s'),
                  'updated_at' => date('Y-m-d H:i:s')
                ]);

                $user = User::where('user_id', $posts[0]->user_id)->first();
                $wallet_amount = $user->wallet_amount + $first_price;
                DB::table('users')->where('user_id', $posts[0]->user_id)->update(['wallet_amount' => $wallet_amount]);

                $title =  $challenge->title . ": You won first price.";
                $message = $challenge->title . " result declared.";
                $fcmTokens = [$user->fcm_token];

                $not_data['created_on'] = date("Y-m-d H:i:s");
                $not_data['sent_to'] = $user->user_id;
                $not_data['title'] = $title;
                $not_data['page_name'] = "challenge-detail";
                $not_data['post_id'] = $posts[0]->post_id;
                $not_data['sent_by'] = 0;
                DB::table('notifications')->insert($not_data);
                try {
                  $image = '';
                  // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
                  $param = ['id' => $id, 'type' => 'challenge', 'page' => '/challenge-detail', 'image' => $image, 'to_id' => $user->user_id, 'from_id' => 0];
                  // Notification::send(null, new UserNotification($title, $message, $image, $param, $fcmTokens));
                  $user->notify(new UserNotification($title, $message, $image, $param));
                } catch (\Exception $e) {
                  // dd($e);
                }
              }

              // second
              if (isset($posts[1])) {
                // $second_user = DB::table('users')->where('user_id', $posts[1]->user_id)->increment('wallet_amount', $second_price);
                $second = $posts[1]->total;
                $data2['user_id'] = $posts[1]->user_id;
                $data2['challenge_id'] = $id;
                $data2['position'] = 2;
                $data2['win_amount'] = $second_price;
                $data2['created_at'] = date('Y-m-d H:i:s');
                $data2['updated_at'] = date('Y-m-d H:i:s');

                array_push($winner_data, $data2);

                DB::table('wallet_history')->insert([
                  'challenge_id' => $id,
                  'coins' => $second_price,
                  'amount' => 0,
                  'raw_amount' => '',
                  'type' => 'C',
                  'status' => 'Credited',
                  'user_id' => $posts[1]->user_id,
                  'created_at' => date('Y-m-d H:i:s'),
                  'updated_at' => date('Y-m-d H:i:s')
                ]);

                $user = User::where('user_id', $posts[1]->user_id)->first();
                $wallet_amount = $user->wallet_amount + $second_price;
                DB::table('users')->where('user_id', $posts[1]->user_id)->update(['wallet_amount' => $wallet_amount]);

                $title =  $challenge->title . ": You won second price.";
                $message = $challenge->title . " result declared.";
                $fcmTokens = [$user->fcm_token];

                $not_data['created_on'] = date("Y-m-d H:i:s");
                $not_data['sent_to'] = $user->user_id;
                $not_data['title'] = $title;
                $not_data['page_name'] = "challenge-detail";
                $not_data['post_id'] = $posts[1]->post_id;
                $not_data['sent_by'] = 0;
                DB::table('notifications')->insert($not_data);
                try {
                  $image = '';
                  // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
                  $param = ['id' => $id, 'type' => 'challenge', 'page' => '/challenge-detail', 'image' => $image, 'to_id' => $user->user_id, 'from_id' => 0];
                  // Notification::send(null, new UserNotification($title, $message, $image, $param, $fcmTokens)); 
                  $user->notify(new UserNotification($title, $message, $image, $param));
                } catch (\Exception $e) {
                }
              }

              // third
              if (isset($posts[2])) {
                // $third_user = DB::table('users')->where('user_id', $posts[2]->user_id)->increment('wallet_amount', $third_price);
                $third = $posts[2]->total;
                $data3['user_id'] = $posts[2]->user_id;
                $data3['challenge_id'] = $id;
                $data3['position'] = 3;
                $data3['win_amount'] = $third_price;
                $data3['created_at'] = date('Y-m-d H:i:s');
                $data3['updated_at'] = date('Y-m-d H:i:s');

                array_push($winner_data, $data2);

                DB::table('wallet_history')->insert([
                  'challenge_id' => $id,
                  'coins' => $third_price,
                  'amount' => 0,
                  'raw_amount' => '',
                  'type' => 'C',
                  'status' => 'Credited',
                  'user_id' => $posts[2]->user_id,
                  'created_at' => date('Y-m-d H:i:s'),
                  'updated_at' => date('Y-m-d H:i:s')
                ]);

                $user = User::where('user_id', $posts[2]->user_id)->first();
                $wallet_amount = $user->wallet_amount + $third_price;
                DB::table('users')->where('user_id', $posts[2]->user_id)->update(['wallet_amount' => $wallet_amount]);


                $title = $challenge->title . ": You won third price.";
                $message = $challenge->title . " result declared.";
                $fcmTokens = [$user->fcm_token];

                $not_data['created_on'] = date("Y-m-d H:i:s");
                $not_data['sent_to'] = $user->user_id;
                $not_data['title'] = $title;
                $not_data['page_name'] = "challenge-detail";
                $not_data['post_id'] = $posts[2]->post_id;
                $not_data['sent_by'] = 0;
                DB::table('notifications')->insert($not_data);
                try {
                  $image = '';
                  // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
                  $param = ['id' => $id, 'type' => 'challenge', 'page' => '/challenge-detail', 'image' => $image, 'to_id' => $user->user_id, 'from_id' => 0];
                  // Notification::send(null, new UserNotification($title, $message, $image, $param, $fcmTokens));
                  $user->notify(new UserNotification($title, $message, $image, $param));
                } catch (\Exception $e) {
                }
              }

              if (count($winner_data) > 0) {
                DB::table('challenge_winners')->insert($winner_data);
              }
              DB::table('challenges')->where('id', $id)->update(['result_declared' => 1]);
              exit;
            }
          }
        }

        // in case of tie

        if ($challenge->tie == 0) {
          $endDate = $challenge->end_date;
          $end_date = date('Y-m-d H:i:s', strtotime('+1 day', strtotime($endDate)));
          DB::table('challenges')->where('id', $id)->update(['end_date' => $end_date, 'tie' => 1]);

          foreach ($records as $record) {
            $user = DB::table('users')->where('user_id', $record->user_id)->first();
            $title =  $challenge->title . ": Challenge has been tied.";
            $message = $challenge->title . " challenge has been tied, due to this the deadline has been extended by one day.";
            $fcmTokens = [$user->fcm_token];

            $not_data['created_on'] = date("Y-m-d H:i:s");
            $not_data['sent_to'] = $user->user_id;
            $not_data['title'] = $title;
            $not_data['page_name'] = "challenge-detail";
            $not_data['post_id'] = $id;
            $not_data['sent_by'] = 0;
            DB::table('notifications')->insert($not_data);
            try {
              $image = '';
              // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
              $param = ['id' => $id, 'type' => 'challenge', 'page' => '/challenge-detail', 'image' => $image, 'to_id' => $user->user_id, 'from_id' => 0];
              // Notification::send(null, new UserNotification($title, $message, $image, $param, $fcmTokens));
              $user = User::where('user_id', $user->user_id)->first();
              $user->notify(new UserNotification($title, $message, $image, $param));
            } catch (\Exception $e) {
            }
          }
        } else {
          DB::table('challenges')->where('id', $id)->update(['tie' => 2]);
          foreach ($records as $record) {
            $user = DB::table('users')->where('user_id', $record->user_id)->first();
            $title =  $challenge->title . ": Challenge has been tied.";
            $message = $challenge->title . " challenge has been tied again, result will be announced by admin soon.";
            $fcmTokens = [$user->fcm_token];

            $not_data['created_on'] = date("Y-m-d H:i:s");
            $not_data['sent_to'] = $user->user_id;
            $not_data['title'] = $title;
            $not_data['page_name'] = "challenge-detail";
            $not_data['post_id'] = $id;
            $not_data['sent_by'] = 0;
            DB::table('notifications')->insert($not_data);
            try {
              $image = '';
              // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
              $param = ['id' => $id, 'type' => 'challenge', 'page' => '/challenge-detail', 'image' => $image, 'to_id' => $user->user_id, 'from_id' => 0];
              // Notification::send(null, new UserNotification($title, $message, $image, $param, $fcmTokens));
              $user = User::where('user_id', $user->user_id)->first();
              $user->notify(new UserNotification($title, $message, $image, $param));
            } catch (\Exception $e) {
            }
          }
        }
      } else {

        // refund
        foreach ($records as $record) {
          $type = 'C';
          DB::table('wallet_history')->insert([
            'challenge_id' => $id,
            'coins' => $coins,
            'amount' => 0,
            'raw_amount' => '',
            'type' => $type,
            'status' => 'Your coins have been refunded back for the challenge ' . $challenge->title . ' due to the reason : minimum of participants did not join.',
            'user_id' => $record->user_id,
            'created_at' => date('Y-m-d H:i:s'),
            'updated_at' => date('Y-m-d H:i:s')
          ]);

          $user = DB::table('users')->where('user_id', $record->user_id)->first();
          $wallet_amount = $user->wallet_amount + $coins;
          DB::table('users')->where('user_id', $record->user_id)->update(['wallet_amount' => $wallet_amount]);

          $title =  $challenge->title . ": coins refunded.";
          $message = "Your coins have been refunded back for the challenge '.$challenge->title.' due to the reason : minimum of participants did not join.";
          $fcmTokens = [$user->fcm_token];

          $not_data['created_on'] = date("Y-m-d H:i:s");
          $not_data['sent_to'] = $user->user_id;
          $not_data['title'] = $title;
          $not_data['page_name'] = "challenge-detail";
          $not_data['post_id'] = $id;
          $not_data['sent_by'] = 0;
          DB::table('notifications')->insert($not_data);
          try {
            $image = '';
            // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
            $param = ['id' => $id, 'type' => 'challenge', 'page' => '/challenge-detail', 'image' => $image, 'to_id' => $user->user_id, 'from_id' => 0];
            // Notification::send(null, new UserNotification($title, $message, $image, $param, $fcmTokens));
            $user = User::where('user_id', $user->user_id)->first();
            $user->notify(new UserNotification($title, $message, $image, $param));
          } catch (\Exception $e) {
          }
        }

        DB::table('challenges')->where('id', $id)->update(['result_declared' => 2]); // canceled
        exit;
      }
    }
  }

  public function sendCoin()
  {
    $users = DB::table('users')->where('active', 1)
      ->where('deleted', 0)
      ->where('coin_sent', 0)
      ->where('user_id', 16677)
      ->get();

    foreach ($users as $user) {
      DB::table('wallet_history')->insert([
        'coins' => 100,
        'type' => 'C',
        'status' => 'You have received bonus coins from the Films Dream Admin',
        'user_id' => $user->user_id,
        'created_at' => date('Y-m-d H:i:s'),
        'updated_at' => date('Y-m-d H:i:s')
      ]);


      DB::table('users')->where('user_id', $user->user_id)->increment('wallet_amount', 100);
      DB::table('users')->where('user_id', $user->user_id)->update(['coin_sent' => 1]);
      // send notification
      $not_data['created_on'] = date("Y-m-d H:i:s");
      $not_data['sent_to'] = $user->user_id;
      $not_data['title'] = config('app.company_name') . " sent you 100 coins";
      $not_data['page_name'] = "my-gifts";
      $not_data['post_id'] = 0;
      $not_data['sent_by'] = 0;
      DB::table('notifications')->insert($not_data);


      $mailBody = "<b>Dear " . $user->username . ",<b><br /> <br />
            Welcome to " . config('app.company_name') . "! We're excited to have you as part of our community.. <br />
    		
    		As a token of our appreciation for joining us, we're giving you 100 coins to use in the app. 
    		These coins can be used to send gifts to your friends and loved ones within the app. 
    		What's more, the gifts they receive can be redeemed for real money! <br />
    		<br />
    		
    		Spread joy and earn real rewards with [App Name]! Here's how it works:
    		<br />
    		Use your 100 coins to send gifts to friends and family.<br />
    		They receive your thoughtful gifts and can redeem them for real money.<br />
    		<br />
    		Claim your 100 coins now.<br />
    		Thank you for choosing " . config('app.company_name') . ". We can't wait to see the joy you bring to others!<br /><br />
    		Best regards, <br />" . config('app.company_name');

      $array = array('subject' => "Welcome to " . config('app.company_name') . "! Here's 100 coins to get you started 🎁", 'view' => 'emails.email', 'body' => $mailBody);

      try {
        Mail::to($user->email)->send(new SendMail($array));
      } catch (\Exception $e) {
      }

      try {
        if ($user->fcm_token && $user->fcm_token != "" && $user->fcm_token != null) {
          $title = "100 COINS RECEIVED";
          $message = config('app.company_name') . " sent you 100 coins";
          $fcmTokens = [$user->fcm_token];
          $image = '';
          // $image = asset(Storage::url('gifts')) . '/' . $gift->icon;
          $param = ['id' => -1, 'type' => 'wallet', 'page' => '/my-wallet', 'image' => $image, 'to_id' => $user->user_id, 'from_id' => 0];
          // Notification::send(null, new UserNotification($title, $message, $image, $param, $fcmTokens));
          $user = User::where('user_id', $user->user_id)->first();
          $user->notify(new UserNotification($title, $message, $image, $param));
        }
      } catch (\Exception $e) {
      }
    }

    dd(666);
    //   dd($users->count());
  }
}
