<?php

namespace App\Http\Controllers;

use App\Models\Service;
use App\Models\PageFont;

class ServicesPageController extends Controller
{
    /**
     * This function returns service listing / service detail
     */
    public function index($alias = NULL)
    {
        $fonts = PageFont::where('page', 'service')->first();

        if ($alias == NULL) {
            $services = Service::latest()->where('services.active', 1)->paginate(9);

            return view('services.index', compact('services', 'fonts'));
        } else {
            // Open service detail page.
            $service = Service::where('alias', $alias)->first();
            $recent_services = Service::latest()->take(3)->select('id', 'name', 'alias', 'image', 'created_at')->get();

            return view('services.detail', compact('service', 'recent_services', 'fonts'));
        }
    }
}
