<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasOne;

class Appointment extends Model
{
    use HasFactory;

    public function slot(): BelongsTo
    {
        return $this->belongsTo(AppointmentSlot::class,'slot_id');
    }
    public function service(): BelongsTo
    {
        return $this->belongsTo(AppointmentService::class,'service_id');
    }

    public function staff(): HasOne
    {
        return $this->hasOne(BookedAppointmentSlot::class,'appointment_id');
    }

    public function booked_appointment(): HasOne
    {
        return $this->hasOne(BookedAppointmentSlot::class,'appointment_id');
    }

    public function user() {
        return $this->belongsTo(User::class, 'user_id');
    }

    public function payment(): HasOne
    {
        return $this->hasOne(Payment::class,'appointment_id');
    }

}
