<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;

class AppointmentService extends Model
{
    use HasFactory;
    public function staff(): BelongsToMany
    {
        return $this->belongsToMany(User::class, AppointmentServiceStaff::class, 'service_id', 'user_id');
    }

    public function category(): BelongsTo
    {
        return $this->belongsTo(AppointmentServiceCategory::class,'cat_id');
    }

    public function time(): BelongsTo
    {
        return $this->belongsTo(Duration::class,'duration','duration');
    }

}
