<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasManyThrough;

class Product extends Model
{
    use HasFactory;

    // public function categories(): HasMany
    // {
    //     return $this->hasMany(ProductCategory::class);
    // }

    public function categories()
    {
        return $this->belongsToMany(Category::class, 'product_categories', 'product_id', 'cat_id');
    }

    public function seasons()
    {
        return $this->belongsToMany(Season::class, 'product_seasons', 'product_id', 'season_id');
    }

    public function variations(): HasMany
    {
        return $this->hasMany(ProductVariation::class);
    }

    public function sizes(): BelongsToMany
    {
        return $this->belongsToMany(Size::class, ProductSize::class, 'product_id', 'size_id');
    }

    public function normal_sizes(): BelongsToMany
    {
        return $this->belongsToMany(Size::class, ProductSize::class, 'product_id', 'size_id');
    }

    public function plus_sizes(): BelongsToMany
    {
        return $this->belongsToMany(Size::class, ProductSize::class, 'product_id', 'size_id');
    }

    public function brand(): BelongsTo
    {
        return $this->belongsTo(Brand::class);
    }

    public function fabric(): BelongsTo
    {
        return $this->belongsTo(Fabric::class);
    }
    public function silhouette(): BelongsTo
    {
        return $this->belongsTo(Silhouette::class);
    }

}
