<?php

use Illuminate\Foundation\Application;
use Illuminate\Foundation\Configuration\Exceptions;
use Illuminate\Foundation\Configuration\Middleware;
use Symfony\Component\HttpFoundation\Response;

return Application::configure(basePath: dirname(__DIR__))
    ->withRouting(
        web: __DIR__.'/../routes/web.php',
        commands: __DIR__.'/../routes/console.php',
        health: '/up',
    )
    ->withMiddleware(function (Middleware $middleware) {
        //
         $middleware->validateCsrfTokens(except: [
            'test'
        ]);
    })
    ->withExceptions(function (Exceptions $exceptions) {
          $exceptions->respond(function (Response $response) {
            if ($response->getStatusCode() === 404) {
                return response()->view('not-found');
            }
     
            return $response;
        });
    })->create();
