<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

return new class extends Migration
{
    public function up(): void
    {
        if (!Schema::hasTable('users')) {
            Schema::create('users', function (Blueprint $table) {
                $table->id();
                $table->char('utype', 1)->default('U')->comment('U for user, S for staff');
                $table->string('first_name')->default('');
                $table->string('last_name')->default('');
                $table->string('email')->default('');
                $table->string('phone')->default('');
                $table->string('address')->default('');
                $table->string('zipcode')->default('');
                $table->integer('city_id')->default(0);
                $table->integer('state_id')->default(0);
                $table->integer('country_id')->default(0);
                $table->string('image')->default('');
                $table->time('in_time')->nullable();
                $table->time('out_time')->nullable();
                $table->tinyInteger('active')->default(1);
                $table->timestamps();
            });
        }
    }

    public function down(): void
    {
        Schema::dropIfExists('users');
    }
};
