<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('categories')) {
            Schema::create('categories', function (Blueprint $table) {
                $table->id();
                $table->string('name',225)->default('');
                $table->string('image',225)->default('');
                $table->string('alias',225)->default('');
                $table->text('description')->nullable();
                $table->integer('rank')->default(0);
                $table->tinyInteger('active')->default(0);
                $table->integer('parent_id')->default(0);
                $table->string('meta_title',225)->default('');
                $table->string('meta_keyword',225)->default('');
                $table->text('meta_description')->nullable();
                $table->string('og_title',225)->default('');
                $table->text('og_description')->nullable();
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('categories');
    }
};
