<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('blog_categories')) {
            Schema::create('blog_categories', function (Blueprint $table) {
                $table->id();
                $table->string('title')->default('');
                $table->string('alias')->default('');
                $table->string('image')->nullable();
                $table->text('description')->nullable();
                $table->string('meta_title')->nullable();
                $table->string('meta_keyword')->nullable();
                $table->text('meta_description')->nullable();
                $table->string('og_title')->nullable();
                $table->text('og_description')->nullable();
                $table->smallInteger('rank')->nullable();
                $table->tinyInteger('active')->default(1);
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('blog_categories');
    }
};
