<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('sliders')) {
            Schema::create('sliders', function (Blueprint $table) {
                $table->id();
                $table->string('image');
                $table->string('sub_image')->nullable();
                $table->string('title');
                $table->string('subtitle')->nullable();
                $table->string('tagline')->nullable();
                $table->string('button_text')->nullable();
                $table->string('button_link')->nullable();
                $table->smallInteger('rank')->nullable();
                $table->tinyInteger('active')->default(1);
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('sliders');
    }
};
