<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('settings')) {
            Schema::create('settings', function (Blueprint $table) {
                $table->id();
                $table->string('logo')->default('');
                $table->string('mobile_logo')->default('');
                $table->string('phone')->nullable();
                $table->string('facebook')->nullable();
                $table->string('instagram')->nullable();
                $table->string('pinterest')->nullable();
                $table->string('tiktok')->nullable();
                $table->string('x')->nullable();
                $table->string('linkedIn')->nullable();
                $table->text('page_404_content')->nullable();
                $table->string('page_404_image')->default('');
                $table->string('size_chart')->default('');
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('settings');
    }
};
