<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('products')) {
            Schema::create('products', function (Blueprint $table) {
                $table->id();
                $table->string('product_code',100)->default('');
                $table->text('description')->nullable();
                $table->integer('neckline_id')->default(0)->index();
                $table->integer('fabric_id')->default(0)->index();
                $table->integer('silhouette_id')->default(0)->index();
                $table->integer('brand_id')->default(0)->index();
                $table->string('meta_title',225)->default('');
                $table->string('meta_keywords',225)->default('');
                $table->text('meta_description')->nullable();
                $table->string('og_title',225)->default('');
                $table->text('og_description')->nullable();
                $table->integer('rank')->default(0);
                $table->tinyInteger('active')->default(1);
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('products');
    }
};
