<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('product_variations')) {
            Schema::create('product_variations', function (Blueprint $table) {
                $table->id();
                $table->integer('product_id')->default(0)->index()->index();
                $table->integer('color_id')->default(0)->index();
                $table->char('visible_type',1)->default('I')->comment("I:image, V:video");
                $table->string('image',225)->default('');
                $table->string('video',225)->default('');
                $table->text('description')->nullable();
                $table->float('price')->default(0)->nullable();
                $table->float('discounted_price')->default(0)->nullable();
                $table->integer('rank')->default(0);
                $table->tinyInteger('active')->default(0);
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('product_variations');
    }
};
