<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('homepage_sections')) {
            Schema::create('homepage_sections', function (Blueprint $table) {
                $table->id();
                $table->string('name')->default('');

                $table->string('cover_image')->default('');
                $table->string('cover_video')->default('');
                $table->char('video_or_image', 1)->default('V')->comment('V for video, I for image');

                $table->string('image_1')->default('');
                $table->string('image_url_1')->default('#');
                $table->string('image_text_1')->default('');
                $table->string('image_price_1')->default('');

                $table->string('image_2')->default('');
                $table->string('image_url_2')->default('#');
                $table->string('image_text_2')->default('');
                $table->string('image_price_2')->default('');

                $table->string('image_3')->default('');
                $table->string('image_url_3')->default('#');
                $table->string('image_text_3')->default('');
                $table->string('image_price_3')->default('');

                $table->string('image_4')->default('');
                $table->string('image_url_4')->default('#');
                $table->string('image_text_4')->default('');
                $table->string('image_price_4')->default('');

                $table->string('image_5')->default('');
                $table->string('image_url_5')->default('#');
                $table->string('image_text_5')->default('');
                $table->string('image_price_5')->default('');

                $table->string('logo')->default('');
                $table->string('logo_url')->default('#');

                $table->string('button_text_1')->default('');
                $table->string('button_url_1')->default('#');

                $table->string('heading')->default('');
                $table->text('content')->nullable();

                $table->string('tagline')->default('');

                $table->tinyInteger('active')->default(1);

                $table->string('services')->default('');
                $table->string('products')->default('');
                $table->string('testimonials')->default('');

                $table->string('sub_heading_1')->default('');
                $table->string('sub_heading_2')->default('');
                $table->string('sub_heading_3')->default('');
                $table->string('sub_heading_4')->default('');

                $table->text('sub_content_1')->nullable();
                $table->text('sub_content_2')->nullable();
                $table->text('sub_content_3')->nullable();
                $table->text('sub_content_4')->nullable();

                $table->string('url_1')->default('#');
                $table->string('url_2')->default('#');
                $table->string('url_3')->default('#');
                $table->string('url_4')->default('#');

                $table->tinyInteger('order')->default(0);

                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('homepage_sections');
    }
};
