<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('booked_appointment_slots')) {
            Schema::create('booked_appointment_slots', function (Blueprint $table) {
                $table->id();
                $table->integer('appointment_id')->default(0)->index();
                $table->integer('user_id')->default(0)->index();
                $table->integer('slot_id')->default(0)->index();
                $table->date('date')->nullable();
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('booked_appointment_slots');
    }
};
