<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasTable('appointments')) {
            Schema::create('appointments', function (Blueprint $table) {
                $table->id();
                $table->string('quote_number')->default('');
                $table->integer('user_id')->default(0)->index();
                $table->date('wedding_date')->nullable();
                $table->integer('no_of_guests')->default(0);
                $table->tinyInteger('first_try_bridal_dress')->default(1)->comment('0:no, 1:yes');
                $table->string('size_in_womenswear')->default('');
                $table->string('hear_about_us')->default('');
                $table->integer('day_id')->default(0)->index();
                $table->integer('slot_id')->default(0)->index();
                $table->integer('service_id')->default(0)->index();
                $table->date('date')->nullable();
                $table->float('price', 8, 2)->nullable();
                $table->char('status', 1)->default('P')->comment('P for Pending,A:approved, C for Cancelled, R for Rejected');
                $table->date('previous_date')->nullable();
                $table->string('previous_quote_number')->default('');
                $table->char('type', 2)->default('FV')->comment('FV:first visit, FU: follow up');
                $table->timestamps();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('appointments');
    }
};
