<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('appointment_services', function (Blueprint $table) {
            $table->id();
            $table->string('image')->default('');
            $table->string('name')->default('');
            $table->integer('cat_id')->default(0)->index();
            $table->float('price',8,2)->nullable();
            $table->text('description')->nullable();
            $table->time('duration')->nullable();
            $table->time('buffer_time')->nullable();
            $table->integer('rank')->default(0);
            $table->tinyInteger('active')->default(1);
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('appointment_services');
    }
};
