<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        if (!Schema::hasColumn('payments', 'transaction_id')) {
            Schema::table('payments', function (Blueprint $table) {
                $table->string('transaction_id')->default('');
            });
        }

        if (!Schema::hasColumn('payments', 'first_name')) {
            Schema::table('payments', function (Blueprint $table) {
                $table->string('first_name')->default('');
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->string('last_name')->default('');
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->string('email')->default('');
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->string('phone')->default('');
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->string('post_code')->default('');
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->text('address')->nullable();
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->integer('country_id')->default(0)->index();
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->integer('state_id')->default(0)->index();
            });
            Schema::table('payments', function (Blueprint $table) {
                $table->integer('city_id')->default(0)->index();
            });
        }
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        //
    }
};
