<?php

namespace Database\Seeders;

use Carbon\Carbon;
use Illuminate\Database\Seeder;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\Console\Seeds\WithoutModelEvents;

class DurationSeeder extends Seeder
{
    /**
     * Run the database seeds.
     */
    public function run(): void
    {
        $durations = [];
        
        for ($hours = 0; $hours <= 12; $hours++) {
            for ($minutes = 0; $minutes < 60; $minutes += 30) {
                if ($hours == 0 && $minutes == 0) {
                    continue; // skip 0h 0m
                }
                
                $label = ($hours > 0 ? $hours . 'h ' : '') . ($minutes > 0 ? $minutes . 'm' : '');
                $label = trim($label); // trim any leading or trailing whitespace
                
                $time = sprintf('%02d:%02d:00', $hours, $minutes);
                
                $durations[] = [
                    'label' => $label,
                    'duration' => $time,
                    'created_at' => Carbon::now(),
                    'updated_at' => Carbon::now(),
                ];
            }
        }

        DB::table('durations')->insert($durations);
    }
}
