@extends('admin.layouts.admin')

@section('content')
    <section class="pc-container">
        <div class="pc-content">
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item" aria-current="page">Appointment</li>
                            </ul>
                        </div>
                        <div class="col-md-12">
                            <div class="page-header-title">
                                <h2 class="mb-0">Dashboard</h2>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row pt-0">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <div class="row mb-4">
                                <div class="col-md-12">
                                    <button id="today" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('today')">Today</button>
                                    <button id="yesterday" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('yesterday')">Yesterday</button>
                                    <button id="tomorrow" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('tomorrow')">Tomorrow</button>
                                    <button id="last-week" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('last-week')">Last Week</button>
                                    <button id="this-week" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('this-week')">This Week</button>
                                    <button id="next-week" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('next-week')">Next Week</button>
                                    <button id="this-month" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('this-month')">This Month</button>
                                    <button id="this-year" class="duration-button btn btn-outline-secondary rounded-0" onclick="fetch('this-year')">This Year</button>
                                    {{-- <button class="btn btn-outline-secondary rounded-0">Custom</button> --}}
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-3">
                                    <div class="card rounded-0 bg-blue-100">
                                        <div class="card-body">
                                            <div class="row">
                                                <div class="col-md-6 col-xl-2">
                                                    <img src="{{ asset('admin/images/icons/user.png') }}" alt="" class="img-fluid">
                                                </div>
                                                <div class="col-md-6 cols-xl-10">
                                                    <div class="f-28">{{ $total_appointments }}</div>
                                                    <div>APPOINTMENTS</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="col-md-3">
                                    <div class="card rounded-0 bg-cyan-100">
                                        <div class="card-body">
                                            <div class="row">
                                                <div class="col-md-6 col-xl-2">
                                                    <img src="{{ asset('admin/images/icons/clock.png') }}" alt="" class="img-fluid">
                                                </div>
                                                <div class="col-md-6 cols-xl-10">
                                                    <div class="f-28">{{ $total_duration }} hrs</div>
                                                    <div>DURATION</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="col-md-3">
                                    <div class="card rounded-0 bg-green-100">
                                        <div class="card-body">
                                            <div class="row">
                                                <div class="col-md-6 col-xl-2">
                                                    <img src="{{ asset('admin/images/icons/payment.png') }}" alt="" class="img-fluid">
                                                </div>
                                                <div class="col-md-6 cols-xl-10">
                                                    <div class="f-28">${{ $total_revenue ? number_format($total_revenue, 2) : 0 }}</div>
                                                    <div>REVENUE</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="col-md-3">
                                    <div class="card rounded-0 bg-red-100">
                                        <div class="card-body">
                                            <div class="row">
                                                <div class="col-md-6 col-xl-2">
                                                    <img src="{{ asset('admin/images/icons/user-plus.png') }}" alt="" class="img-fluid">
                                                </div>
                                                <div class="col-md-6 cols-xl-10">
                                                    <div class="f-28">{{ $new_customers }}</div>
                                                    <div>NEW CUSTOMERS</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-6 col-xl-3">
                                    <div class="bg-orange-100">
                                        <div class="pt-3 px-3">
                                            <h6>QUICK STATS</h6>
                                        </div>
                                        <table class="table table-borderless">
                                            <tr>
                                                <td>
                                                    <img src="{{ asset('admin/images/icons/pending.png') }}" alt="" class="img-fluid">
                                                    &nbsp;
                                                    PENDING
                                                </td>
                                                <td class='text-end f-18'>
                                                    {{ $pending }}
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    <img src="{{ asset('admin/images/icons/tick.png') }}" alt="" class="img-fluid">
                                                    &nbsp;
                                                    APPROVED
                                                </td>
                                                <td class='text-end f-18'>
                                                    {{ $approved }}
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    <img src="{{ asset('admin/images/icons/close.png') }}" alt="" class="img-fluid">
                                                    &nbsp;
                                                    CANCELLED
                                                </td>
                                                <td class='text-end f-18'>
                                                    {{ $cancelled }}
                                                </td>
                                            </tr>
                                            <tr>
                                                <td>
                                                    <img src="{{ asset('admin/images/icons/rejected.png') }}" alt="" class="img-fluid">
                                                    &nbsp;
                                                    REJECTED
                                                </td>
                                                <td class='text-end f-18'>
                                                    {{ $rejected }}
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                </div>
                                <div class="col-md-6 col-xl-9">
                                    <div class="bg-gray-200">
                                        <div class="table-responsive">
                                            @isset($appointments)
                                                @if (count($appointments) > 0)
                                                    <table class="table">
                                                        <tr>
                                                            <th>Customer</th>
                                                            <th>Staff</th>
                                                            <th>Service</th>
                                                            <th>Date</th>
                                                            <th>Slot</th>
                                                        </tr>
                                                        @foreach ($appointments as $item)
                                                            <tr>
                                                                <td>{{ ($item->user) ? $item->user->first_name : '' }}</td>
                                                                <td>{{ ($item->staff->user) ? $item->staff->user->first_name : '' }}</td>
                                                                <td>{{ $item->service->name }}</td>
                                                                <td>{{ $item->date }}</td>
                                                                <td>{{ $item->slot->from_time }} - {{ $item->slot->to_time }}</td>
                                                            </tr>
                                                        @endforeach
                                                    </table>
                                                @else
                                                    <p class="text-da">No record found!</p>
                                                @endif
                                            @endisset
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

    <script>
        function fetch(duration) {

            var url = "{{ route('admin.appointment-dashboard', ['duration' => 'arg1']) }}";
            url = url.replace('arg1', duration);

            window.location.href = url;
        }

        function getQueryParam(param) {
            const urlParams = new URLSearchParams(window.location.search);
            return urlParams.get(param);
        }

        $(document).ready(function() {
            $('.duration-button').removeClass('btn-primary');
            let x = getQueryParam('duration');
            if(x==null){
                x='today';
            }
            $('#' + x).addClass('btn-primary')
        });

    </script>
@endsection
