@extends('admin.layouts.admin')

<script src='https://cdn.jsdelivr.net/npm/fullcalendar@6.1.14/index.global.min.js'></script>

@section('content')
    <section class="pc-container">
        <div class="pc-content">
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item" aria-current="page">
                                    <a href="{{ route('admin.appointments') }}">Appointments</a>
                                </li>
                                <li class="breadcrumb-item" aria-current="page">
                                    <a href="{{ route('admin.appointment-calendar') }}">Calendar</a>
                                </li>
                            </ul>
                        </div>
                        <div class="col-md-12">
                            <div class="page-header-title">
                                <h2 class="mb-0">#{{ $appointment->id }}</h2>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row pt-0">
                <div class="col-md-6">
                    <div class="card">
                        <div class="card-body">
                            <div class="row f-24">
                                <div class="col-md-12">
                                    <div class="row">
                                        <div class="col-md-10">
                                            <table class="table table-borderless fw-medium">
                                                <tr>
                                                    <td class="w-25">Date</td>
                                                    <td>
                                                        {{ $appointment->date }}
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td class="w-25">Timing</td>
                                                    <td>
                                                        {{ substr($appointment->slot->from_time, 0, 5) }} - {{ substr($appointment->slot->to_time, 0, 5) }}
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td>Slot</td>
                                                    <td>
                                                        {{ $appointment->slot->name }}
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td>Service</td>
                                                    <td>
                                                        {{ $appointment->service->name }}
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td>Status</td>
                                                    <td>
                                                        @switch($appointment->status)
                                                            @case('P')
                                                                <span class="badge bg-primary">Pending</span>
                                                                @break
                                                            @case('S')
                                                                <span class="badge bg-success">Successfull</span>
                                                                @break
                                                            @case('C')
                                                                <span class="badge bg-danger">Cancelled</span>
                                                                @break
                                                            @default

                                                        @endswitch
                                                    </td>
                                                </tr>
                                            </table>
                                        </div>
                                        <div class="col-md-2">
                                            <div class="d-flex justify-content-end">
                                                <a href="{{ route("admin.edit-appointment", ["id" => $appointment->id ]) }}" class="btn btn-primary rounded-0">Edit</a>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="row mt-5">
                                <div class="col-md-6">
                                    <div class="fw-medium">
                                        <h4>Customer</h4>
                                        <hr>
                                        {{ $appointment->user->first_name }} {{ $appointment->user->last_name }}
                                        <br>
                                        {{ $appointment->user->email }}
                                        <br>
                                        {{ $appointment->user->phone }}
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="fw-medium">
                                        <h4>Staff</h4>
                                        <hr>
                                        {{ $appointment->staff->user->first_name }} {{ $appointment->staff->user->last_name }}
                                        <br>
                                        {{ $appointment->staff->user->email }}
                                        <br>
                                        {{ $appointment->staff->user->phone }}
                                    </div>
                                </div>
                            </div>

                            <div class="row mt-5">
                                <div class="col-md-12">
                                    <div class="d-flex justify-content-end">
                                        <a href="{{ route("admin.appointment-calendar") }}" class="btn btn-outline-secondary rounded-0">CLOSE</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>

    @push('scripts')
        <script>
            $(document).ready(function() {


                calendar.render();
            })
        </script>
    @endpush
@endsection
