@extends('admin.layouts.admin')
@section('content')
<section class="pc-container">
    <div class="pc-content">
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <li class="breadcrumb-item">
                                <a href="{{ route('admin.appointmentPrice') }}">{{ $title }}</a>
                            </li>
                        </ul>
                    </div>
                    <div class="col-md-12">
                        <div class="page-header-title">
                            <h3 class="mb-0">{{ $title }}</h3>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <form class="" role="form" id="edit_form" action="{{ route('admin.appointmentPrice.update') }}" method="post" enctype="multipart/form-data">
            @csrf
            <div class="row pt-0">
                @if ($message = Session::get('success'))
                <div class="col-sm-12">
                    <div class="alert alert-success alert-dismissible fade show" role="alert">
                        <strong>{{ $message }}</strong>
                        <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                    </div>
                </div>
                @endif
                <div class="col-md-8">
                    <div class="card">
                        <div class="card-header">
                            <h5>{{ $title }}</h5>
                        </div>
                        <div class="card-body pt-2">
                            <table class="table table-xl ">
                                <tr>
                                    <th>Day</th>
                                    <th>Price</th>
                                    <th>Active</th>
                                </tr>
                                @foreach($records as $key=>$record)
                                <tr>
                                    <td>
                                        <input type="hidden" name="day[]" value="{{ $record->id }}" />
                                        <label>{{ $record->day }}</label>
                                    </td>
                                    <td>
                                        @php $price='' @endphp
                                        @if(isset($record->appointment_day_price))
                                        @php $price=$record->appointment_day_price->price @endphp
                                        @endif
                                        <input type="number" name="price[]" class="form-control" value="{{ $price }}" />
                                    </td>
                                    <td>
                                        @php $active=0 @endphp
                                        @if(isset($record->appointment_day_price) && $record->appointment_day_price->active>0)
                                        @php $active=1 @endphp
                                        @endif
                                        <div class="form-check form-switch custom-switch-v1 ">
                                            <input type="hidden" name="active[]" class="visible_active" value="{{$active}}" />
                                            <input type="checkbox" class="form-check-input input-primary active_toggle" id="activeCheckbox{{$key}}" value='1' {!! ($active==1) ? 'checked' : '' !!}>
                                            <label class="form-check-label" for="activeCheckbox{{$key}}">Active</label>
                                        </div>
                                    </td>
                                </tr>
                                @endforeach
                            </table>
                        </div>
                    </div>
                    <div class="row my-5">
                        <div class="col-6">
                            <button class="btn btn-primary" type="submit">Submit</button>
                        </div>
                    </div>
                </div>
            </div>

        </form>
</section>
@endsection
@push('scripts')
<script>
    //visible_toggle
    $(document).on('change', '.active_toggle', function() {
        const isChecked = $(this).is(":checked");
        if (isChecked) {
            $(this).parent().find('.visible_active').val(1);
        } else {
            $(this).parent().find('.visible_active').val(0);
        }
    });
</script>
@endpush