@extends('admin.layouts.admin')
@section('content')
<style>
    .img-bg {
        padding-bottom: 150px;
    }

    .upload__img-wrap {
        height: 150px;

    }
</style>
<section class="pc-container">
    <div class="pc-content">
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{{ route('admin.dashboard') }}">Home</a></li>
                            <li class="breadcrumb-item">
                                <a href="{{ route('admin.countries') }}">Countries</a>
                            </li>
                            <li class="breadcrumb-item" aria-current="page">Country</li>
                        </ul>
                    </div>
                    <!-- <div class="col-md-12">
                        <div class="page-header-title">
                            <h3 class="mb-0">Color</h3>
                        </div>
                    </div> -->
                </div>
            </div>
        </div>
        <div>
            @if ($errors->any())
            <div class="alert alert-danger">
                <ul>
                    @foreach ($errors->all() as $error)
                    <li>
                        {{ $error }}
                    </li>
                    @endforeach
                </ul>
            </div>
            @endif
        </div>
        @if($action == 'Edit')
        <form class="" role="form" id="edit_form" action="{{ route('admin.countries.update',$record->id) }}" method="post" enctype="multipart/form-data">
            @else
            <form class="" method="POST" id="add_form" action="{{ route('admin.countries.store') }}" enctype="multipart/form-data">
                @endif
                @csrf
                <div class="row pt-0">
                    <div class="col-md-6">
                        @if(isset($record->id))
                        @php $id=$record->id @endphp
                        @else
                        @php $id=0; @endphp
                        @endif
                        <div class="card">
                            <div class="card-header">
                                <h5>{{ $title }}</h5>
                            </div>
                            <div class="card-body pt-2">
                                <div class="row">
                                  
                                    <div class="col-md-12 col-sm-12 col-12 form-group">
                                        @if(isset($record->name))
                                        @php $name=$record->name @endphp
                                        @elseif(old('name'))
                                        @php $name=old('name'); @endphp
                                        @else
                                        @php $name=''; @endphp
                                        @endif

                                        <label class="form-label">Name <span class="text-danger">*</span></label>
                                        <input required name="name" type="text" class="form-control" placeholder="Type" value="{{ $name }}">
                                    </div>

                                    <div class="col-md-12 col-sm-12 col-12 form-group">
                                        @if(isset($record->code))
                                        @php $code=$record->code @endphp
                                        @elseif(old('code'))
                                        @php $code=old('code'); @endphp
                                        @else
                                        @php $code=''; @endphp
                                        @endif

                                        <label class="form-label">Code <span class="text-danger">*</span></label>
                                        <input required name="code" type="text" class="form-control" placeholder="Code" value="{{ $code }}">
                                    </div>

                                    <div class="col-md-12 col-sm-12 col-12" data-bs-toggle="tooltip">
                                        @if(isset($record->active))
                                        @php $active=$record->active @endphp
                                        @elseif(old('active'))
                                        @php $active=old('active'); @endphp
                                        @else
                                        @php $active=1; @endphp
                                        @endif
                                        <div class="form-check form-switch custom-switch-v1 mt-2 ">
                                            <input name="active" type="checkbox" class="form-check-input input-primary" id="activeCheckbox" value='1' {!! ($active==1) ? 'checked' : '' !!}>
                                            <label class="form-check-label" for="activeCheckbox">Active</label>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="row my-5">
                        <div class="col-6">
                            <button class="btn btn-primary" type="submit">Submit</button>
                        </div>
                    </div>
                </div>
            </form>
    </div>
</section>
@endsection