@extends('admin.layouts.admin')

@section('content')
    <section class="pc-container">
        <div class="pc-content">
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item">Content</li>
                                <li class="breadcrumb-item" aria-current="page">
                                    <a href="{{ route('admin.countries') }}">Countries</a>
                                </li>
                                <li class="breadcrumb-item" aria-current="page">Edit</li>
                            </ul>
                        </div>
                        <div class="col-md-12">
                            <div class="page-header-title">
                                <h2 class="mb-0">Country</h2>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row pt-0">
                <div class="col-md-12 col-xl-6">
                    <div class="card">
                        <div class="card-body">
                            <div>
                                @if ($errors->any())
                                    <div class="alert alert-danger">
                                        <ul>
                                            @foreach ($errors->all() as $error)
                                                <li>
                                                    {{ $error }}
                                                </li>
                                            @endforeach
                                        </ul>
                                    </div>
                                @endif
                            </div>
                            <form action="{{ route('admin.update-country') }}" method="post" class="form-data">
                                @csrf

                                <input type="hidden" name="id" value="{{ $country->id }}">

                                <div class="row">
                                    <div class="form-group col-md-12">
                                        <label class="form-label">Name <span class="text-danger">*</span></label>
                                        <input required name="name" type="text" maxlength="100" class="form-control" placeholder="Name e.g. Canada" value="{{ old('name', $country->name) }}">
                                    </div>
                                    <div class="form-group col-md-4">
                                        <label class="form-label">Code <span class="text-danger">*</span></label>
                                        <input required name="code" type="text" maxlength="10" class="form-control" placeholder="Code e.g. CA" value="{{ old('code', $country->code) }}">
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="form-check form-switch custom-switch-v1">
                                            <input name="active" type="checkbox" class="form-check-input input-primary" id="activeCheckbox" value='1' @checked(old('active', $country->active))>
                                            <label class="form-check-label" for="activeCheckbox">Active</label>
                                        </div>
                                        <input type="submit" value="Save" class="btn btn-primary m-t-20 m-b-20" data-bs-toggle="tooltip" data-bs-original-title="Save changes">
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
    </section>
@endsection
