@extends('admin.layouts.admin')

@section('content')

    <script src="{{ asset('admin/js/plugins/apexcharts.min.js') }}"></script>

    <div class="pc-container">
        <div class="pc-content">
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item">Dashboard</li>
                            </ul>
                        </div>
                        <div class="col-md-12">
                            <div class="page-header-title">
                                <h3 class="mb-0">Dashboard</h3>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row pt-0">
                <div class="col-md-6 col-xxl-3">
                    <a href="#">
                        <div class="card">
                            <div class="card-body">
                                <div class="d-flex align-items-center">
                                    <div class="flex-shrink-0">
                                        <div class="avtar avtar-s bg-light-primary">
                                            <img src="{{ asset('admin/images/icons/employee.png') }}" alt="" class="img-fluid dash-icon">
                                        </div>
                                    </div>
                                    <div class="flex-grow-1 ms-3">
                                        <h6 class="mb-0">Staff</h6>
                                    </div>
                                </div>
                                <div class="bg-body p-3 pb-2 mt-3 rounded">
                                    <div class="mt-3 row align-items-center">
                                        <div class="col-7">
                                            <div id="staff-graph"></div>
                                        </div>
                                        <div class="col-5">
                                            <h5 class="mb-1" data-bs-toggle="tooltip" data-bs-original-title="Total staff">
                                                {{ isset($staffCount) ? $staffCount : '' }}
                                            </h5>
                                            <p class="text-primary mb-0"><i class="ti ti-arrow-up-right"></i>
                                                <span data-bs-toggle="tooltip" data-bs-original-title="New joinee this month">
                                                    {{ isset($staffCountNew) ? $staffCountNew : 0 }}
                                                </span>
                                            </p>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12 border-top pb-2"></div>
                                        <div class="col-md-6">
                                            {{ $active_staff_count }} Active
                                        </div>
                                        <div class="col-md-6 text-end">
                                            {{ $inactive_staff_count }} Inactive
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </a>
                </div>

                <div class="col-md-6 col-xxl-3">
                    <a href="#">
                        <div class="card">
                            <div class="card-body">
                                <div class="d-flex align-items-center">
                                    <div class="flex-shrink-0">
                                        <div class="avtar avtar-s bg-light-primary">
                                            <img src="{{ asset('admin/images/icons/user.png') }}" alt="" class="img-fluid dash-icon">
                                        </div>
                                    </div>
                                    <div class="flex-grow-1 ms-3">
                                        <h6 class="mb-0">Customers</h6>
                                    </div>
                                </div>
                                <div class="bg-body p-3 pb-2 mt-3 rounded">
                                    <div class="mt-3 row align-items-center">
                                        <div class="col-7">
                                            <div id="users-graph"></div>
                                        </div>
                                        <div class="col-5">
                                            <h5 class="mb-1" data-bs-toggle="tooltip" data-bs-original-title="Total users">
                                                {{ $usersCount }}
                                            </h5>
                                            <p class="text-warning mb-0"><i class="ti ti-arrow-up-right"></i>
                                                <span data-bs-toggle="tooltip"
                                                    data-bs-original-title="New users this month">
                                                    {{ $usersCountNew }}
                                                </span>
                                            </p>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12 border-top pb-2"></div>
                                        <div class="col-md-6">
                                            {{ $active_users_count }} Active
                                        </div>
                                        <div class="col-md-6 text-end">
                                            {{ $inactive_users_count }} Inactive
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </a>
                </div>

                <div class="col-md-6 col-xxl-3">
                    <a href="#">
                        <div class="card">
                            <div class="card-body">
                                <div class="d-flex align-items-center">
                                    <div class="flex-shrink-0">
                                        <div class="avtar avtar-s bg-light-success">
                                            <img src="{{ asset('admin/images/icons/appointment.png') }}" alt="" class="img-fluid dash-icon">
                                        </div>
                                    </div>
                                    <div class="flex-grow-1 ms-3">
                                        <h6 class="mb-0">Appointments</h6>
                                    </div>
                                </div>
                                <div class="bg-body p-3 pb-2 mt-3 rounded">
                                    <div class="mt-3 row align-items-center">
                                        <div class="col-7">
                                            <div id="appointments-graph"></div>
                                        </div>
                                        <div class="col-5">
                                            <h5 class="mb-1" data-bs-toggle="tooltip" data-bs-original-title="Total appointments">
                                                {{ $appointmentsCount }}
                                            </h5>
                                            <p class="text-success mb-0"><i class="ti ti-arrow-up-right"></i>
                                                <span data-bs-toggle="tooltip" data-bs-original-title="New appointments this month">
                                                    {{ $appointmentsCountNew }}
                                                </span>
                                            </p>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12 border-top pb-2"></div>
                                        <div class="col-md-6">
                                            Today: {{ $today_appointments_count }}
                                        </div>
                                        <div class="col-md-6 text-end">
                                            &nbsp;
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </a>
                </div>

                <div class="col-md-6 col-xxl-3">
                    <a href="#">
                        <div class="card">
                            <div class="card-body">
                                <div class="d-flex align-items-center">
                                    <div class="flex-shrink-0">
                                        <div class="avtar avtar-s bg-light-warning">
                                            <img src="{{ asset('admin/images/icons/dollar.png') }}" alt="" class="img-fluid dash-icon">
                                        </div>
                                    </div>
                                    <div class="flex-grow-1 ms-3">
                                        <h6 class="mb-0">Payments</h6>
                                    </div>
                                </div>
                                <div class="bg-body p-3 pb-2 mt-3 rounded">
                                    <div class="mt-3 row align-items-center">
                                        <div class="col-7">
                                            <div id="payments-graph"></div>
                                        </div>
                                        <div class="col-5">
                                            <h5 class="mb-1" data-bs-toggle="tooltip" data-bs-original-title="Total payments">
                                                {{ $paymentsCount }}
                                            </h5>
                                            <p class="text-danger mb-0"><i class="ti ti-arrow-up-right"></i>
                                                <span data-bs-toggle="tooltip"
                                                    data-bs-original-title="New payments this month">
                                                    {{ $paymentsCountNew }}
                                                </span>
                                            </p>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-12 border-top pb-2"></div>
                                        <div class="col-md-6">
                                            Today: {{ $today_payments_count }}
                                        </div>
                                        <div class="col-md-6 text-end">
                                            &nbsp;
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </a>
                </div>
            </div>

            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <div class="d-flex justify-content-between">
                                <div>
                                    <h5 class="mb-0">Appointments</h5>
                                </div>
                                <div>
                                    <a href="{{ route('admin.appointments') }}" data-bs-toggle="tooltip"
                                        data-bs-original-title="View all appointments">View all</a>
                                </div>
                            </div>
                        </div>
                        <div class="card-body">
                            <div class="row border-bottom">
                                <div class="col-md-8 col-xl-9">
                                    <div id="appointments-chart"></div>
                                </div>

                                <div class="col-md-4 col-xl-3">
                                    <ul class="list-group list-group-flush">
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-chart-bar f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-12">
                                                            <p class="text-muted mb-1">Total Appointments</p>
                                                            <h6 id="total-appointments" class="mb-0">
                                                                {{ $totalAppointments }}
                                                            </h6>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-shopping-cart f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-12">
                                                            <p class="text-muted mb-1">Pending Appointments</p>
                                                            <h6 id="pending-appointments" class="mb-0">
                                                                {{ $pendingAppointments }}
                                                            </h6>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-check f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-12">
                                                            <p class="text-muted mb-1">Completed</p>
                                                            <h6 id="completed-appointments" class="mb-0">
                                                                {{ $completedAppointments }}
                                                            </h6>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-cut f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-12">
                                                            <p class="text-muted mb-1">Cancelled</p>
                                                            <h6 id="cancelled-appointments" class="mb-0">
                                                                {{ $cancelledAppointments }}
                                                            </h6>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                    </ul>
                                </div>
                            </div>
                            <div class="row">
                                <div class="table-responsive">
                                    <table class="table table-hover table-borderless mb-0">
                                        <thead>
                                            <tr>
                                                <th>Date</th>
                                                <th>Slot</th>
                                                <th>Customer</th>
                                                <th>Staff</th>
                                                <th>Service</th>
                                                <th>Status</th>
                                            </tr>
                                        </thead>
                                        @if (is_countable($appointments))
                                            @foreach ($appointments as $record)
                                                <tr>
                                                    <td>
                                                        {{ date('Y-m-d', strtotime($record->date)) }}
                                                    </td>
                                                    <td>
                                                        {{ $record->slot->from_time }} - {{ $record->slot->to_time }}
                                                    </td>
                                                    <td>
                                                        {{ $record->user->first_name }} {{ $record->user->last_name }}
                                                    </td>
                                                    <td>
                                                        {{ $record->staff->user ? $record->staff->user->first_name : '' }} {{ $record->staff->user ? $record->staff->user->last_name : '' }}
                                                    </td>
                                                    <td>
                                                        {{ $record->service->name }}
                                                    </td>
                                                    <td>
                                                        @switch($record->status)
                                                            @case('P')
                                                                <label class="badge bg-light-primary">
                                                                    Pending
                                                                </label>
                                                                @break
                                                            @case('A')
                                                                <label class="badge bg-light-primary">
                                                                    Approved
                                                                </label>
                                                                @break
                                                            @case('R')
                                                                <label class="badge bg-light-success">
                                                                    Rejected
                                                                </label>
                                                                @break
                                                            @case('C')
                                                                <label class="badge bg-light-danger">
                                                                    Cancelled
                                                                </label>
                                                                @break
                                                            @default
                                                                @break
                                                        @endswitch
                                                    </td>
                                                </tr>
                                            @endforeach
                                        @endif
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            {{-- Payments --}}
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <div class="d-flex justify-content-between">
                                <div>
                                    <h5 class="mb-0">Payments</h5>
                                </div>
                                <div>
                                    <a href="#" data-bs-toggle="tooltip"
                                        data-bs-original-title="View all payments">View all</a>
                                </div>
                            </div>
                        </div>
                        <div class="card-body">
                            <div class="row border-bottom">
                                <div class="col-md-8 col-xl-9">
                                    <div id="payments-chart"></div>
                                </div>

                                <div class="col-md-4 col-xl-3">
                                    <ul class="list-group list-group-flush">
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-chart-bar f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-6">
                                                            <p class="text-muted mb-1">Total Payments</p>
                                                            <h6 id="total-payments" class="mb-0">
                                                                {{ $totalPayments }}
                                                            </h6>
                                                        </div>
                                                        <div class="col-6 text-end">
                                                            <h6 id="total-payments-sum" class="mb-1 f-18">
                                                                ${{ $totalPaymentsSum }}
                                                            </h6>
                                                            {{-- <p class="text-danger mb-0"><i
                                                                    class="ti ti-arrow-down-left"></i> 30.6%</p> --}}
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-shopping-cart f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-6">
                                                            <p class="text-muted mb-1">Pending</p>
                                                            <h6 id="pending-payments" class="mb-0">
                                                                {{ $pendingPayments }}
                                                            </h6>
                                                        </div>
                                                        <div class="col-6 text-end">
                                                            <h6 id="pending-payments-sum" class="mb-1 f-18">
                                                                ${{ $pendingPaymentsSum }}
                                                            </h6>
                                                            {{-- <p class="text-success mb-0"><i
                                                                    class="ti ti-arrow-up-right"></i> 30.6%</p> --}}
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-check f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-6">
                                                            <p class="text-muted mb-1">Completed</p>
                                                            <h6 id="completed-payments" class="mb-0">
                                                                {{ $completedPayments }}
                                                            </h6>
                                                        </div>
                                                        <div class="col-6 text-end">
                                                            <h6 id="completed-payments-sum" class="mb-1 f-18">
                                                                ${{ $completedPaymentsSum }}
                                                            </h6>
                                                            {{-- <p class="text-warning mb-0"><i
                                                                    class="ti ti-arrows-left-right"></i> 5%</p> --}}
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                        <li class="list-group-item">
                                            <div class="d-flex align-items-center">
                                                <div class="flex-shrink-0">
                                                    <div class="avtar avtar-s bg-light-secondary">
                                                        <i class="ti ti-cut f-20"></i>
                                                    </div>
                                                </div>
                                                <div class="flex-grow-1 ms-3">
                                                    <div class="row g-1">
                                                        <div class="col-6">
                                                            <p class="text-muted mb-1">Cancelled</p>
                                                            <h6 id="cancelled-payments" class="mb-0">
                                                                ${{ $cancelledPayments }}
                                                            </h6>
                                                        </div>
                                                        <div class="col-6 text-end">
                                                            <h6 id="cancelled-payments-sum" class="mb-1 f-18">
                                                                ${{ $cancelledPaymentsSum }}
                                                            </h6>
                                                            {{-- <p class="text-success mb-0"><i
                                                                    class="ti ti-arrow-up-right"></i> 10.6%</p> --}}
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </li>
                                    </ul>
                                </div>
                            </div>
                            <div class="row">
                                <div class="table-responsive">
                                    <table class="table table-hover table-borderless mb-0">
                                        <thead>
                                            <tr>
                                                <th>Appointment ID</th>
                                                <th>Amount</th>
                                                <th>Payment Type</th>
                                                <th>Status</th>
                                                <th>Date & Time</th>
                                            </tr>
                                        </thead>
                                        @if (is_countable($payments))
                                            @foreach ($payments as $record)
                                                <tr>
                                                    <td>
                                                        {{ $record->appointment_id }}
                                                    </td>
                                                    <td>
                                                        {{ number_format($record->amount, 2) }}
                                                    </td>
                                                    <td>
                                                        @switch($record->status)
                                                            @case('C')
                                                                Cash
                                                                @break
                                                            @case('S')
                                                                Stripe
                                                                @break
                                                            @default
                                                                @break
                                                        @endswitch
                                                    </td>
                                                    <td>
                                                        @switch($record->status)
                                                            @case('P')
                                                                <label class="badge bg-light-primary">
                                                                    Pending
                                                                </label>
                                                                @break
                                                            @case('S')
                                                                <label class="badge bg-light-success">
                                                                    Completed
                                                                </label>
                                                                @break
                                                            @case('F')
                                                                <label class="badge bg-light-danger">
                                                                    Cancelled
                                                                </label>
                                                                @break
                                                            @default
                                                                @break
                                                        @endswitch
                                                    </td>
                                                    <td>
                                                        {{ $record->created_at }}
                                                    </td>
                                                </tr>
                                            @endforeach
                                        @endif
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            {{-- Staff --}}
            <div class="row pt-0">
                <div class="col-sm-12">
                    <div class="card">
                        <div class="card-body pt-2">
                            <div class="d-flex justify-content-between pt-2 pb-1 border-bottom">
                                <div>
                                    <h6 class="text-indigo-400 fw-medium">Recent Staff</h6>
                                </div>
                                <div>
                                    <a href="{{ route('admin.staff') }}">View all</a>
                                </div>
                            </div>

                            <div class="table-responsive">
                                <table class="table table-hover table-borderless mb-0">
                                    <thead>
                                        <tr>
                                            <th>Photo</th>
                                            <th>Name</th>
                                            <th>Phone</th>
                                            <th>Email</th>
                                            <th>Address</th>
                                            <th>City</th>
                                            <th>Country</th>
                                            <th class="text-end">Status</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @if (is_countable($staff))
                                            @foreach ($staff as $record)
                                                <tr>
                                                    <td>
                                                        <img src="{{ asset(Storage::url('public/staff/' . $record->image)) }}" alt="" class="img-fluid rounded rounded-circle thumb-sm">
                                                    </td>
                                                    <td>
                                                        {{ $record ? $record->first_name : '' }} {{ $record ? $record->last_name : '' }}
                                                    </td>
                                                    <td>
                                                        <a class="text-decoration-none text-dark" href="tel:+{{ $record->phone }}">
                                                            {{ $record->phone }}
                                                        </a>
                                                    </td>
                                                    <td>
                                                        <a class="text-decoration-none text-dark" href="mailto::{{ $record->email }}">
                                                            {{ $record->email }}
                                                        </a>
                                                    </td>
                                                    <td>
                                                        {{ $record->address }}
                                                    </td>
                                                    <td>
                                                        {{ $record->city ? $record->city->name : '' }}
                                                    </td>
                                                    <td>
                                                        {{ $record->country ? $record->country->name : '' }}
                                                    </td>
                                                    <td class="text-end">
                                                        @if ($record->active == '1')
                                                            <label class="badge bg-light-success">Active</label>
                                                        @else
                                                            <label
                                                                class="badge bg-light-secondary">Inactive</label>
                                                        @endif
                                                    </td>
                                                </tr>
                                            @endforeach
                                        @endif
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            {{-- Users --}}
            <div class="row pt-0">
                <div class="col-sm-12">
                    <div class="card">
                        <div class="card-body pt-2">
                            <div class="d-flex justify-content-between pt-2 pb-1 border-bottom">
                                <div>
                                    <h6 class="text-indigo-400 fw-medium">Recent Users</h6>
                                </div>
                                <div>
                                    <a href="{{ route('admin.customers') }}">View all</a>
                                </div>
                            </div>

                            <div class="table-responsive">
                                <table class="table table-hover table-borderless mb-0">
                                    <thead>
                                        <tr>
                                            <th>Photo</th>
                                            <th>Name</th>
                                            <th>Phone</th>
                                            <th>Email</th>
                                            <th>Address</th>
                                            <th>City</th>
                                            <th>Country</th>
                                            <th class="text-end">Status</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @if (is_countable($users))
                                            @foreach ($users as $record)
                                                <tr>
                                                    <td>
                                                        <img src="{{ asset(Storage::url($record->image)) }}" alt="" class="img-fluid rounded rounded-circle thumb-sm">
                                                    </td>
                                                    <td>
                                                        {{ $record ? $record->first_name : '' }} {{ $record ? $record->last_name : '' }}
                                                    </td>
                                                    <td>
                                                        <a class="text-decoration-none text-dark" href="tel:+{{ $record->phone }}">
                                                            {{ $record->phone }}
                                                        </a>
                                                    </td>
                                                    <td>
                                                        <a class="text-decoration-none text-dark" href="mailto::{{ $record->email }}">
                                                            {{ $record->email }}
                                                        </a>
                                                    </td>
                                                    <td>
                                                        {{ $record->address }}
                                                    </td>
                                                    <td>
                                                        {{ $record->city ? $record->city->name : '' }}
                                                    </td>
                                                    <td>
                                                        {{ $record->country ? $record->country->name : '' }}
                                                    </td>
                                                    <td class="text-end">
                                                        @if ($record->active == '1')
                                                            <label class="badge bg-light-success">Active</label>
                                                        @else
                                                            <label
                                                                class="badge bg-light-secondary">Inactive</label>
                                                        @endif
                                                    </td>
                                                </tr>
                                            @endforeach
                                        @endif
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script>
        var appointmentsChart;
        var paymentsChart;

        function renderTopChart(chartName, chartTitle, chartData) {
            let options = {
                chart: {
                    type: 'bar',
                    height: 50,
                    sparkline: {
                        enabled: true
                    }
                },
                colors: ['#4680FF'],
                series: [{
                    name: chartTitle,
                    data: chartData
                }],
                xaxis: {
                    categories: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "sep", "Oct", "Nov", "Dec"]
                },
                tooltip: {
                    fixed: {
                        enabled: false
                    },
                    y: {
                        formatter: function (value) {
                            return parseInt(value, 10);
                        },
                        title: {
                            formatter: function(seriesName) {
                                return '';
                            }
                        }
                    },
                    marker: {
                        show: false
                    }
                }
            };

            let chart = new ApexCharts(document.querySelector('#' + chartName), options);

            chart.render();
        }

        function fetchAppointmentsChart() {
            $.ajax({
                url: '{{ route('admin.dashboard-appointment-chart') }}',
                method: 'GET',
                dataType: 'json',
                success: function(data) {
                    const yValues = data.map(item => item.y);
                    const maxY = Math.max(...yValues);

                    const options = {
                        chart: {
                            type: 'bar',
                            height: 350,
                            toolbar: {
                                show: false,
                            },
                        },
                        series: [{
                            name: 'Appointments',
                            data: data.map(item => ({
                                x: new Date(item.x).getTime(),
                                y: item.y,
                                fillColor: item.color
                            }))
                        }],
                        xaxis: {
                            type: 'datetime',
                            categories: data.map(item => new Date(item.x).getTime()),
                        },
                        yaxis: {
                            min: 0,
                            max: maxY,
                            tickAmount: maxY + 1,
                            forceNiceScale: true,
                            labels: {
                                formatter: function(val) {
                                    return Math.floor(val);
                                }
                            }
                        },
                        plotOptions: {
                            bar: {
                                columnWidth: '50%',
                                borderRadius: 4
                            }
                        },
                        tooltip: {
                            x: {
                                format: 'dd MMM yyyy'
                            }
                        }
                    };

                    if (data.length > 0) {
                        options.fill = {
                            opacity: 1,
                            colors: data.map(item => item.fillColor)
                        };
                    }

                    if (appointmentsChart) {
                        appointmentsChart.updateOptions(options);
                    } else {
                        appointmentsChart = new ApexCharts(document.querySelector("#appointments-chart"), options);
                        appointmentsChart.render();
                    }
                },
                error: function(xhr, status, error) {
                    console.error('Error fetching data:', error);
                }
            });
        }

        function fetchPaymentsChart() {
            $.ajax({
                url: '{{ route('admin.dashboard-payments-chart') }}',
                method: 'GET',
                data: $('#filter-form-2').serialize(),
                dataType: 'json',
                success: function(data) {
                    const maxYValue = Math.max(...data.map(item => item.y));
                    const tickAmount = maxYValue / 50 + 1;

                    const options = {
                        chart: {
                            height: 350,
                            type: 'area',
                            toolbar: {
                                show: false,
                            },
                        },
                        series: [{
                            name: 'Appointments',
                            data: data.map(item => ({
                                x: new Date(item.x).getTime(),
                                y: item.y
                            }))
                        }],
                        xaxis: {
                            type: 'datetime',
                            categories: data.map(item => new Date(item.x).getTime()),
                        },
                        yaxis: {
                            min: 0,
                            max: maxYValue,
                            tickAmount: tickAmount,
                            labels: {
                                formatter: function(value) {
                                    return value.toFixed(0);
                                }
                            }
                        },
                        fill: {
                            type: 'gradient',
                            gradient: {
                                shadeIntensity: 1,
                                opacityFrom: 0.7,
                                opacityTo: 0.9,
                                stops: [0, 100]
                            }
                        },
                        stroke: {
                            width: 2,
                            curve: 'smooth'
                        },
                        markers: {
                            size: 6,
                            strokeWidth: 0,
                            hover: {
                                sizeOffset: 3
                            }
                        },
                        tooltip: {
                            x: {
                                format: 'dd MMM yyyy'
                            }
                        }
                    };

                    const paymentsChart = new ApexCharts(document.querySelector("#payments-chart"), options);
                    paymentsChart.render();
                },
                error: function(xhr, status, error) {
                    console.error('Error fetching data:', error);
                }
            });
        }

        $(document).ready(function() {
            renderTopChart('staff-graph', 'Staff', {{ Js::from($staffGraphTop) }});
            renderTopChart('users-graph', 'Users', {{ Js::from($usersGraphTop) }});
            renderTopChart('appointments-graph', 'Appointments', {{ Js::from($appointmentsGraphTop) }});
            renderTopChart('payments-graph', 'Payments', {{ Js::from($paymentsGraphTop) }});

            fetchAppointmentsChart();
            fetchPaymentsChart();
        });
    </script>

@endsection
