@extends('admin.layouts.admin')

@section('content')
    <section class="pc-container">
        <div class="pc-content">
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item">
                                    Content
                                </li>
                                <li class="breadcrumb-item" aria-current="page">
                                    <a href="{{ route('admin.faqs') }}">FAQs</a>
                                </li>
                                <li class="breadcrumb-item" aria-current="page">Edit Question {{ $faq->id }}</li>
                            </ul>
                        </div>
                        <div class="col-md-12">
                            <div class="page-header-title">
                                <h2 class="mb-0">FAQ</h2>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row pt-0">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <div>
                                @if ($errors->any())
                                    <div class="alert alert-danger">
                                        <ul>
                                            @foreach ($errors->all() as $error)
                                                <li>
                                                    {{ $error }}
                                                </li>
                                            @endforeach
                                        </ul>
                                    </div>
                                @endif
                            </div>
                            <form action="{{ route('admin.update-faq') }}" method="post" class="form-data">
                                @csrf
                                <input type="hidden" name="id" value="{{ $faq->id }}">
                                <div class="row">
                                    <div class="form-group col-md-12">
                                        <label class="form-label">Question <span class="text-danger">*</span></label>
                                        <input required name="question" type="text" class="form-control" placeholder="Question" value="{{ old('question', $faq->question) }}" autofocus>
                                    </div>
                                    <div class="form-group col-md-12">
                                        <label class="form-label">Answer <span class="text-danger">*</span></label>
                                        <textarea required name="answer" class="form-control ckeditor" placeholder="Answer">{!! old('answer', $faq->answer) !!}</textarea>
                                    </div>
                                    <div class="form-group col-md-2">
                                        <label class="form-label">Sort Order</label>
                                        <input name="sort_order" type="number" min="1" max="99999" class="form-control" placeholder="Sort order" value="{{ old('sort_order', $faq->sort_order) }}">
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <input type="submit" value="Save" class="btn btn-primary m-t-20 m-b-20" data-bs-toggle="tooltip" data-bs-original-title="Save changes">
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
    </section>
@endsection
