@extends('admin.layouts.admin')

@section('content')
<section class="pc-container">
    <div class="pc-content">
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <li class="breadcrumb-item"><a href="{{ route('admin.dashboard') }}">Home</a></li>
                            <li class="breadcrumb-item" aria-current="page">
                                <a href="{{ route('admin.faqs') }}">FAQs</a>
                            </li>
                            <li class="breadcrumb-item" aria-current="page">{{ $title }}</li>
                        </ul>
                    </div>
               
                </div>
            </div>
        </div>

        <div class="row pt-0">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h5>{{ $title }}</h5>
                    </div>
                    <div class="card-body">
                        <div>
                            @if ($errors->any())
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                    <li>
                                        {{ $error }}
                                    </li>
                                    @endforeach
                                </ul>
                            </div>
                            @endif
                        </div>
                        @if($action == 'Edit')
                        <form action="{{ route('admin.update-faq') }}" method="post" class="form-data">
                            @else
                        <form action="{{ route('admin.store-faq') }}" method="post" class="form-data">
                            @endif
                            @csrf
                            @if(isset($record->id))
                            @php $id=$record->id @endphp
                            @else
                            @php $id=0; @endphp
                            @endif
                            <input type="hidden" name="id" value="{{ $id }}">
                            <div class="row">
                                <div class="form-group col-md-12">
                                    @if(isset($record->question))
                                    @php $question=$record->question @endphp
                                    @elseif(old('question'))
                                    @php $question=old('question'); @endphp
                                    @else
                                    @php $question=''; @endphp
                                    @endif
                                    <label class="form-label">Question <span class="text-danger">*</span></label>
                                    <input required name="question" type="text" class="form-control" placeholder="Question" value="{{ $question }}" autofocus>
                                </div>
                                <div class="form-group col-md-12">
                                    @if(isset($record->answer))
                                    @php $answer=$record->answer @endphp
                                    @elseif(old('answer'))
                                    @php $answer=old('answer'); @endphp
                                    @else
                                    @php $answer=''; @endphp
                                    @endif
                                    <label class="form-label">Answer <span class="text-danger">*</span></label>
                                    <textarea required name="answer" class="form-control ckeditor" placeholder="Answer">{!! $answer !!}</textarea>
                                </div>
                                <div class="form-group col-md-2">
                                    @if(isset($record->sort_order))
                                    @php $sort_order=$record->sort_order @endphp
                                    @elseif(old('sort_order'))
                                    @php $sort_order=old('sort_order'); @endphp
                                    @else
                                    @php $sort_order=''; @endphp
                                    @endif
                                    <label class="form-label">Sort Order</label>
                                    <input name="sort_order" type="number" min="1" max="99999" class="form-control" placeholder="Sort order" value="{{ $sort_order }}">
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12">
                                    <input type="submit" value="Save" class="btn btn-primary m-t-20 m-b-20" data-bs-toggle="tooltip" data-bs-original-title="Save changes">
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
</section>
@endsection