@extends('admin.layouts.admin')

@section('content')
    <section class="pc-container">
        <div class="pc-content">
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item">
                                    Content
                                </li>
                                <li class="breadcrumb-item" aria-current="page">
                                    <a href="{{ route('admin.fonts') }}">Fonts</a>
                                </li>
                                <li class="breadcrumb-item" aria-current="page">New</li>
                            </ul>
                        </div>
                        <div class="col-md-12">
                            <div class="page-header-title">
                                <h2 class="mb-0">Fonts</h2>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row pt-0">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <div>
                                @if ($errors->any())
                                    <div class="alert alert-danger">
                                        <ul>
                                            @foreach ($errors->all() as $error)
                                                <li>
                                                    {{ $error }}
                                                </li>
                                            @endforeach
                                        </ul>
                                    </div>
                                @endif
                            </div>
                            <form action="{{ route('admin.store-font') }}" method="post" class="form-data" enctype="multipart/form-data">
                                @csrf
                                <div class="row">
                                    <div class="col-md-4">
                                        <div class="row">
                                            <div class="form-group col-md-12">
                                                <label class="form-label">File</label>
                                                <input name="file" class="form-control" type="file" accept=".ttf,.otf,.otc,.ttc" data-bs-original-title="Select font file, for example: Roboto.ttf" data-bs-toggle="tooltip">
                                            </div>
                                            <div class="form-group col-md-12">
                                                <label class="form-label">Name<span class="text-danger">*</span></label>
                                                <input required name="name" type="text" class="form-control" placeholder="Font Name" value="{{ old('name') }}" data-bs-original-title="Font name, for example: Roboto" data-bs-toggle="tooltip" autofocus>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-md-12">
                                        <input type="submit" value="Save" class="btn btn-primary m-t-20 m-b-20" data-bs-toggle="tooltip" data-bs-original-title="Save changes">
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
    </section>
@endsection
