@extends('admin.layouts.admin')

@section('content')
<div class="pc-container">
    <div class="pc-content">
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <li class="breadcrumb-item" aria-current="page">Reports</li>
                            <li class="breadcrumb-item" aria-current="page">
                                <a href="{{ route('admin.payments') }}">Payments</a>
                            </li>
                            <li class="breadcrumb-item" aria-current="page">Payment Details</li>
                        </ul>
                    </div>
                    <div class="col-md-12">
                        <div class="page-header-title">
                            <h2 class="mb-0">#{{ $payment->id }}</h2>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="row pt-0">
            <div class="col-sm-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row px-2">
                            <div class="col-md-3 shadow border p-3 bg-instagram text-white">
                                <div class="fw-medium f-18 mb-2">
                                    Customer
                                </div>
                                @if($payment->appointment->user)
                                {{ $payment->appointment->user->first_name }} {{ $payment->appointment->user->last_name }}
                                @endif
                            </div>
                            <div class="col-md-3 shadow border p-3 bg-teal-500 text-white">
                                <div class="fw-medium f-18 mb-2">
                                    Staff
                                </div>
                                @if($payment->appointment->staff->user)
                                {{ $payment->appointment->staff->user->first_name }} {{ $payment->appointment->staff->user->last_name }}
                                @endif
                            </div>
                            <div class="col-md-3 shadow border p-3 bg-linkedin text-white">
                                <div class="fw-medium f-18 mb-2">
                                    Service
                                </div>
                                {{ $payment->appointment->service->name }}
                            </div>
                            <div class="col-md-3 shadow border p-3 bg-gray-700 text-white">
                                <div class="fw-medium f-18 mb-2">
                                    Date & Time
                                </div>
                                {{ $payment->created_at }}
                            </div>
                        </div>
                        <div class="row my-4">
                            <div class="col-md-12">
                                <div class="table-responsive border">
                                    <table class="table table-borderless">
                                        <tr class="table-secondary">
                                            <th>Customer</th>
                                       
                                            <th>Status</th>
                                        </tr>
                                        <tr>
                                            <td>
                                                <img src="{{ asset(Storage::url($payment->appointment->user->image)) }}" alt="" class="img-fluid thumb-1 rounded rounded-circle">
                                                @if($payment->appointment->user)
                                                {{ $payment->appointment->user->first_name }} {{ $payment->appointment->user->last_name }}
                                                @endif
                                            </td>
                                          
                                            <td>
                                                @if ($payment->status == '1')
                                                <img src="{{ asset('admin/images/icons/tick.png') }}" alt="" class="img-fluid">
                                                @else
                                                -
                                                @endif
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                        </div>
                        <div class="row px-2">
                            <div class="col-md-4 col-lg-3 p-4 payment-details-summary rounded">
                                <div>
                                    <h5>Payment Details</h5>
                                    <table class="table table-borderless fw-medium f-16">
                                        <tr>
                                            <td>Service Price</td>
                                            <td>{{$payment->appointment->service->price}}</td>
                                        </tr>
                                        <tr>
                                            <td>Discount</td>
                                            <td>0</td>
                                        </tr>
                                    </table>
                                </div>
                                <div>
                                    <hr>
                                </div>
                                <div>
                                    <h5>Payment Details</h5>
                                    <table class="table table-borderless fw-medium f-16">
                                        <tr>
                                            <td>Total</td>
                                            <td></td>
                                        </tr>
                                        <tr>
                                            <td>Paid</td>
                                            <td class="text-success"></td>
                                        </tr>
                                        <tr>
                                            <td>Due</td>
                                            <td class="text-danger"></td>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection