@extends('admin.layouts.admin')
@section('content')
<!-- [ Main Content ] start -->
<div class="pc-container">
    <div class="pc-content">
        <!-- [ breadcrumb ] start -->
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <li class="breadcrumb-item"><a href="{{ route('admin.dashboard') }}">Home</a></li>
                            <li class="breadcrumb-item"><a href="{{ route('admin.products') }}">{{ $title }}</a></li>
                            <li class="breadcrumb-item" aria-current="page">List</li>
                        </ul>
                    </div>

                </div>
            </div>
        </div>
        <!-- [ breadcrumb ] end -->

        <!-- [ Main Content ] start -->
        <div class="row">
            @if ($message = Session::get('success'))
            <div class="col-sm-12">
                <div class="alert alert-success alert-dismissible fade show" role="alert">
                    <strong>{{ $message }}</strong>
                    <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                </div>
            </div>
            @endif

            <!-- [ sample-page ] start -->
            <div class="col-sm-12">
                <div class="card ">
                    <div class="card-header">
                        <div class="row">
                            <div class="col-md-6">
                                <h3 class="float-start">{{ $title }}</h3>
                            </div>
                            <div class="col-md-6 col-12 ps-0">
                                <div class="d-flex justify-content-between">
                                    <div></div>
                                    <div>
                                        <div class="text-end ">
                                            <a href="{{ route('admin.products.create') }}" class="btn btn-primary">
                                                <i class="ti ti-plus f-18"></i> Add Product
                                            </a>
                                            &nbsp;&nbsp;
                                            <a href="javascript:void(0)" class="btn btn-primary  " data-bs-toggle="collapse" data-bs-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample">
                                                Font
                                            </a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-12">
                                <div class="collapse border p-3 mt-3" id="collapseExample">
                                    <div class="row">
                                        <div class="col-md-3 mb-3">
                                            <label class="form-label">Code</label>
                                            <select class="select2" name="font1">
                                                @include('admin.includes.font-select')
                                            </select>
                                        </div>
                                        <div class="col-md-3 mb-3">
                                            <label class="form-label">Category</label>
                                            <select class="select2" name="font2">
                                                @include('admin.includes.font-select')
                                            </select>
                                        </div>
                                        <div class="col-md-3 mb-3">
                                            <label class="form-label">Price</label>
                                            <select class="select2" name="font3">
                                                @include('admin.includes.font-select')
                                            </select>
                                        </div>
                                        <div class="col-md-3 mb-3">
                                            <label class="form-label">Appointment Button</label>
                                            <select class="select2" name="font4">
                                                @include('admin.includes.font-select')
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-md-3 mb-3">
                                            <label class="form-label">Features</label>
                                            <select class="select2" name="font5">
                                                @include('admin.includes.font-select')
                                            </select>
                                        </div>
                                        <div class="col-md-3 mb-3">
                                            <label class="form-label">Description</label>
                                            <select class="select2" name="font6">
                                                @include('admin.includes.font-select')
                                            </select>
                                        </div>
                                        <div class="col-md-3 mb-3">
                                            <label class="form-label">Filters</label>
                                            <select class="select2" name="font7">
                                                @include('admin.includes.font-select')
                                            </select>
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="col-md-12 mt-3 d-flex justify-content-end">
                                            <button class="btn btn-outline-secondary ms-2 mb-1 rounded-0" data-bs-toggle="tooltip" data-bs-original-title="Save fonts." onclick="saveFonts()">Save</button>
                                            <button class="btn btn-outline-secondary ms-2 mb-1 rounded-0" data-bs-toggle="modal" data-bs-target="#confirmReset">Reset</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                        <div class="card-body">
                            <div class="dt-responsive table-responsive">
                                <table id="jsource-table" class="table  table-bordered nowrap"> </table>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- [ sample-page ] end -->
            </div>
            <!-- [ Main Content ] end -->


        </div>
    </div>
    @endsection
    @push('scripts')

    <script type="text/javascript">
        var table = $('#jsource-table').DataTable({
            ajax: "{{ route('admin.products') }}",
            processing: true,
            serverSide: true,
            deferRender: true,
            columns: [{
                    title: '#',
                    data: 'id',
                    name: 'id',
                },
                // {
                //     title: 'Image',
                //     data: 'image',
                //     name: 'image',
                // },
                {
                    title: 'Product Code',
                    data: 'product_code',
                    name: 'product_code',
                },
                {
                    title: 'Active',
                    data: 'active',
                    name: 'active',
                    orderable: false,
                    searchable: false
                },
                {
                    title: 'Action',
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
        });

        $(document).on('click', '.deleteSelSingle', function(e) {
            e.preventDefault();
            text = 'you want to delete ?';
            const swalWithBootstrapButtons = Swal.mixin({
                customClass: {
                    confirmButton: 'btn btn-success',
                    cancelButton: 'btn btn-danger'
                },
                buttonsStyling: false
            });
            swalWithBootstrapButtons
                .fire({
                    title: 'Are you sure?',
                    text: text,
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonText: 'Yes',
                    cancelButtonText: 'No',
                    reverseButtons: true
                })
                .then((result) => {
                    if (result.isConfirmed) {
                        var favorite = [];
                        favorite.push($(this).attr('data-val'));
                        var ids = favorite.join(",");
                        $.ajax({
                            url: "{{ route('admin.products.destroy') }}",
                            type: 'POST',
                            data: {
                                "ids": ids
                            },
                            success: function(res) {
                                if (res.status == true) {
                                    url = "{{ route('admin.products') }}";
                                    window.location.href = url;
                                }
                            }
                        });
                    } else if (result.dismiss === Swal.DismissReason.cancel) {
                        if (val == 0) {
                            $(this).prop('checked', false);
                        } else {
                            $(this).prop('checked', true);
                        }
                        swalWithBootstrapButtons.fire('Cancelled', '', 'error');
                    }
                });
        });

        // active
        $(document).on('click', '.active_item', function() {
            val = $(this).attr('data-value');
            name = $(this).attr('data-name');
            id = $(this).attr('data-id');
            text = name + '! You want to deactivate ?';

            if (val == 0) {
                text = name + '! You want to activate ?';
            }
            const swalWithBootstrapButtons = Swal.mixin({
                customClass: {
                    confirmButton: 'btn btn-success',
                    cancelButton: 'btn btn-danger'
                },
                buttonsStyling: false
            });
            swalWithBootstrapButtons
                .fire({
                    title: 'Are you sure?',
                    text: text,
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonText: 'Yes',
                    cancelButtonText: 'No',
                    reverseButtons: true
                })
                .then((result) => {
                    if (result.isConfirmed) {
                        $.ajax({
                            url: "{{ route('admin.categories.updateActive') }}",
                            type: 'POST',
                            data: {
                                id: id,
                                value: val
                            },
                            success: function(res) {
                                if (res.status == true) {
                                    swalWithBootstrapButtons.fire('Updated!', res.msg, 'success');

                                }
                            }
                        });


                    } else if (result.dismiss === Swal.DismissReason.cancel) {
                        if (val == 0) {
                            $(this).prop('checked', false);
                        } else {
                            $(this).prop('checked', true);
                        }
                        swalWithBootstrapButtons.fire('Cancelled', '', 'error');
                    }
                });
        });
    </script>

    <script>
        function saveFonts() {
            let data = {
                'font1': $('select[name="font1"]').val(),
                'font2': $('select[name="font2"]').val(),
                'font3': $('select[name="font3"]').val(),
                'font4': $('select[name="font4"]').val(),
                'font5': $('select[name="font5"]').val(),
                'font6': $('select[name="font6"]').val(),
                'font7': $('select[name="font7"]').val(),
            };

            let url = "{{ route('admin.update-page-fonts') }}";

            $.ajax({
                type: 'POST',
                url: url,
                data: {
                    'page': 'product',
                    'data': data,
                },
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                success: function(data) {
                    window.location.href = "{{ route('admin.products') }}";
                }
            });
        }

        function resetFonts() {
            let url = "{{ route('admin.reset-page-fonts') }}";

            $.ajax({
                type: 'POST',
                url: url,
                data: {
                    'page': 'product',
                },
                headers: {
                    'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
                },
                success: function(data) {
                    window.location.href = "{{ route('admin.products') }}";
                }
            });
        }

        $(document).ready(function() {
            $('select[name="font1"]').val('{{$fonts->font1}}').trigger('change');
            $('select[name="font2"]').val('{{$fonts->font2}}').trigger('change');
            $('select[name="font3"]').val('{{$fonts->font3}}').trigger('change');
            $('select[name="font4"]').val('{{$fonts->font4}}').trigger('change');
            $('select[name="font5"]').val('{{$fonts->font5}}').trigger('change');
            $('select[name="font6"]').val('{{$fonts->font6}}').trigger('change');
            $('select[name="font6"]').val('{{$fonts->font6}}').trigger('change');

            for (let i = 1; i <= 6; i++) {
                $(`select[name="font${i}"]`).select2({
                    placeholder: 'Change font',
                    allowClear: true
                });
            }
        });
    </script>
    @endpush