@extends('admin.layouts.admin')
@section('content')
<section class="pc-container">
    <div class="pc-content">
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <li class="breadcrumb-item"><a href="{{ route('admin.dashboard') }}">Home</a></li>
                            <li class="breadcrumb-item">
                                <a href="{{ route('admin.products') }}">Products</a>
                            </li>
                            <li class="breadcrumb-item" aria-current="page">Product</li>
                        </ul>
                    </div>
                    <div class="col-md-12">
                        <div class="page-header-title">
                            <h3 class="mb-0">Product</h3>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        @if($action == 'Edit')
        <form class="" role="form" id="productForm" action="{{ route('admin.products.update',$record->id) }}" method="post" enctype="multipart/form-data">

            @else
            <form class="" method="POST" id="productForm" action="{{ route('admin.products.store') }}" enctype="multipart/form-data">
                @endif
                @csrf
                <div class="row pt-0">
                    <div class="col-md-12">
                        @if(isset($record->id))
                        @php $id=$record->id @endphp
                        @else
                        @php $id=0; @endphp
                        @endif
                        <div class="card">
                            <div class="card-header">
                                <h5>{{ $title }}</h5>
                            </div>
                            <div class="card-body pt-2">
                                <div class="row">
                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->product_code))
                                        @php $product_code=$record->product_code @endphp
                                        @elseif(old('product_code'))
                                        @php $product_code=old('product_code'); @endphp
                                        @else
                                        @php $product_code=''; @endphp
                                        @endif

                                        <label class="form-label">Product Code <span class="text-danger">*</span></label>
                                        <input required name="product_code" type="text" class="form-control" placeholder="Product Code" value="{{ $product_code }}">
                                    </div>

                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        <?php //dd($categories); 
                                        ?>
                                        @if(isset($record->categories))
                                        @php $cat_ids=$record->categories->pluck('id')->toArray() @endphp
                                        @elseif(old('cat_ids'))
                                        @php $cat_ids=old('cat_ids'); @endphp
                                        @else
                                        @php $cat_ids=[]; @endphp
                                        @endif
                                        <label class="form-label">Categories</label>
                                        <select class="form-control select2" name="cat_ids[]" multiple>
                                            <option value="">-- Select --</option>
                                            @foreach($categories as $category)
                                            <option value="{{ $category->id }}" {!! in_array($category->id,$cat_ids) ? 'selected' : '' !!}>{{ $category->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->seasons))
                                        @php $season_ids=$record->seasons->pluck('id')->toArray() @endphp
                                        @elseif(old('season_ids'))
                                        @php $season_ids=old('season_ids'); @endphp
                                        @else
                                        @php $season_ids=[]; @endphp
                                        @endif
                                        <label class="form-label">Seasons</label>
                                        <select class="form-control select2" name="season_ids[]" multiple>
                                            <option value="">-- Select --</option>
                                            @foreach($seasons as $season)
                                            <option value="{{ $season->id }}" {!! in_array($season->id,$season_ids) ? 'selected' : '' !!}>{{ $season->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->fabric_id))
                                        @php $fabric_id = $record->fabric_id @endphp
                                        @elseif(old('fabric_id'))
                                        @php $fabric_id = old('fabric_id'); @endphp
                                        @else
                                        @php $fabric_id = 0; @endphp
                                        @endif
                                        <label class="form-label">Fabric</label>
                                        <select class="form-control select2" name="fabric_id">
                                            <option value="">-- Select --</option>
                                            @foreach($fabrics as $fabric)
                                            <option value="{{ $fabric->id }}" {!! ($fabric_id==$fabric->id) ? 'selected' : '' !!}>{{ $fabric->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->neckline_id ))
                                        @php $neckline_id =$record->neckline_id @endphp
                                        @elseif(old('neckline_id '))
                                        @php $neckline_id =old('neckline_id '); @endphp
                                        @else
                                        @php $neckline_id =0; @endphp
                                        @endif
                                        <label class="form-label">Neckline</label>
                                        <select class="form-control select2" name="neckline_id">
                                            <option value="">-- Select --</option>
                                            @foreach($necklines as $neckline)
                                            <option value="{{ $neckline->id }}" {!! ($neckline_id==$neckline->id) ? 'selected' : '' !!}>{{ $neckline->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->silhouette_id))
                                        @php $silhouette_id = $record->silhouette_id @endphp
                                        @elseif(old('silhouette_id'))
                                        @php $silhouette_id = old('silhouette_id'); @endphp
                                        @else
                                        @php $silhouette_id = 0; @endphp
                                        @endif
                                        <label class="form-label">Silhouette</label>
                                        <select class="form-control select2" name="silhouette_id">
                                            <option value="">-- Select --</option>
                                            @foreach($silhouettes as $silhouette)
                                            <option value="{{ $silhouette->id }}" {!! ($silhouette_id==$silhouette->id) ? 'selected' : '' !!}>{{ $silhouette->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>

                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->brand_id ))
                                        @php $brand_id =$record->brand_id @endphp
                                        @elseif(old('brand_id '))
                                        @php $brand_id =old('brand_id '); @endphp
                                        @else
                                        @php $brand_id =0; @endphp
                                        @endif
                                        <label class="form-label">Designer</label>
                                        <select class="form-control select2" name="brand_id">
                                            <option value="">-- Select --</option>
                                            @foreach($brands as $brand)
                                            <option value="{{ $brand->id }}" {!! ($brand_id==$brand->id) ? 'selected' : '' !!}>{{ $brand->name }}</option>
                                            @endforeach
                                        </select>
                                    </div>




                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->rank))
                                        @php $rank=$record->rank @endphp
                                        @elseif(old('rank'))
                                        @php $rank=old('rank'); @endphp
                                        @else
                                        @php $rank=''; @endphp
                                        @endif
                                        <label class="form-label">Rank </label>
                                        <input name="rank" type="number" class="form-control" placeholder="Item Rank" value="{{ $rank }}">
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-12" data-bs-toggle="tooltip">
                                        @if(isset($record->active))
                                        @php $active=$record->active @endphp
                                        @elseif(old('active'))
                                        @php $active=old('active'); @endphp
                                        @else
                                        @php $active=1; @endphp
                                        @endif
                                        <div class="form-check form-switch custom-switch-v1 mt-4 pt-3">
                                            <input name="active" type="checkbox" class="form-check-input input-primary" id="activeCheckbox" value='1' {!! ($active==1) ? 'checked' : '' !!}>
                                            <label class="form-check-label" for="activeCheckbox">Active</label>
                                        </div>
                                    </div>
                                    <!-- </div> -->
                                    <!-- </div> -->
                                </div>

                                <div class="col-md-12 col-sm-12 col-12 form-group">
                                    @if(isset($record->description))
                                    @php $description=$record->description @endphp
                                    @elseif(old('description'))
                                    @php $description=old('description'); @endphp
                                    @else
                                    @php $description=''; @endphp
                                    @endif
                                    <label class="form-label">Description </label>
                                    <textarea name="summary" class="form-control ckeditor" placeholder="Description">{!! $description !!}</textarea>
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-12 col-md-6">
                                <div class="card">
                                    <div class="card-header">
                                        <h5>Product Sizes</h5>
                                    </div>
                                    <div class="card-body pt-2">

                                        <div class="row">

                                            <div class="col-md-6 col-sm-6 col-12 form-group">
                                                @php $from_id=0 @endphp
                                                @if(isset($record) && count($record->normal_sizes)>0)
                                                @php $from_id=$record->normal_sizes->first()->id @endphp
                                                @endif
                                                <label class="form-label">From</label>
                                                <select class="form-control" name="from_size">
                                                    <option value="">--Select--</option>
                                                    @foreach($sizes as $size)
                                                    <option value="{{ $size->id }}" {!! ($from_id==$size->id) ? 'selected' : '' !!}>{{ $size->size }}</option>
                                                    @endforeach
                                                </select>
                                            </div>

                                            <div class="col-md-6 col-sm-6 col-12 form-group">
                                                @php $to_id=0 @endphp
                                                @if(isset($record) && count($record->normal_sizes)>0)
                                                @php $to_id=$record->normal_sizes->last()->id @endphp
                                                @endif
                                                <label class="form-label">To</label>
                                                <select class="form-control" name="to_size">
                                                    <option value="">--Select--</option>
                                                    @foreach($sizes as $size)
                                                    <option value="{{ $size->id }}" {!! ($to_id==$size->id) ? 'selected' : '' !!}>{{ $size->size }}</option>
                                                    @endforeach
                                                </select>
                                            </div>
                                        </div>
                                        <!-- </div>
                                </div> -->
                                    </div>
                                </div>
                            </div>

                            <div class="col-12 col-md-6">
                                <div class="card">
                                    <div class="card-header">
                                        <h5>Product Plus Sizes</h5>
                                    </div>
                                    <div class="card-body pt-2">

                                        <div class="row">

                                            <div class="col-md-6 col-sm-6 col-12 form-group">
                                                @php $from_plus_id=0 @endphp
                                                @if(isset($record) && count($record->plus_sizes)>0)
                                                @php $from_plus_id=$record->plus_sizes->first()->id @endphp
                                                @endif
                                                <label class="form-label">From</label>
                                                <select class="form-control" name="from_plus_size">
                                                    <option value="">--Select--</option>
                                                    @foreach($plus_sizes as $size)
                                                    <option value="{{ $size->id }}" {!! ($from_plus_id==$size->id) ? 'selected' : '' !!}>{{ $size->size }}</option>
                                                    @endforeach
                                                </select>
                                            </div>

                                            <div class="col-md-6 col-sm-6 col-12 form-group">
                                                @php $to_plus_id=0 @endphp
                                                @if(isset($record) && count($record->plus_sizes)>0)
                                                @php $to_plus_id=$record->plus_sizes->last()->id @endphp
                                                @endif
                                                <label class="form-label">To</label>
                                                <select class="form-control" name="to_plus_size">
                                                    <option value="">--Select--</option>
                                                    @foreach($plus_sizes as $size)
                                                    <option value="{{ $size->id }}" {!! ($to_plus_id==$size->id) ? 'selected' : '' !!}>{{ $size->size }}</option>
                                                    @endforeach
                                                </select>
                                            </div>
                                        </div>
                                        <!-- </div>
                                </div> -->
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card">
                            <div class="card-header">
                                <h5>Product SEO Detail</h5>
                            </div>
                            <div class="card-body pt-2">
                                <div class="row">
                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->meta_title))
                                        @php $meta_title=$record->meta_title @endphp
                                        @elseif(old('meta_title'))
                                        @php $meta_title=old('meta_title'); @endphp
                                        @else
                                        @php $meta_title=''; @endphp
                                        @endif
                                        <label class="form-label">Meta Title</label>
                                        <input name="meta_title" type="text" class="form-control" placeholder="Meta Title" value="{{ $meta_title }}">
                                    </div>

                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->meta_keywords))
                                        @php $meta_keywords=$record->meta_keywords @endphp
                                        @elseif(old('meta_keywords'))
                                        @php $meta_keywords=old('meta_keywords'); @endphp
                                        @else
                                        @php $meta_keywords=''; @endphp
                                        @endif
                                        <label class="form-label">Meta Keyword</label>
                                        <input name="meta_keywords" type="text" class="form-control" placeholder="Meta Keyword" value="{{ $meta_keywords }}">
                                    </div>
                                    <div class="col-md-4 col-sm-6 col-12 form-group">
                                        @if(isset($record->og_title))
                                        @php $og_title=$record->og_title @endphp
                                        @elseif(old('og_title'))
                                        @php $og_title=old('og_title'); @endphp
                                        @else
                                        @php $og_title=''; @endphp
                                        @endif
                                        <label class="form-label">OG Title</label>
                                        <input name="og_title" type="text" class="form-control" placeholder="OG Title" value="{{ $og_title }}">
                                    </div>

                                    <div class="col-md-6 col-sm-12 col-12 form-group">
                                        @if(isset($record->meta_description))
                                        @php $meta_description=$record->meta_description @endphp
                                        @elseif(old('meta_description'))
                                        @php $meta_description=old('meta_description'); @endphp
                                        @else
                                        @php $meta_description=''; @endphp
                                        @endif
                                        <label class="form-label">Meta Description </label>
                                        <textarea name="meta_description" class="form-control ckeditor" placeholder="Meta Description">{!! $meta_description !!}</textarea>
                                    </div>

                                    <div class="col-md-6 col-sm-12 col-12 form-group">
                                        @if(isset($record->og_description))
                                        @php $og_description=$record->og_description @endphp
                                        @elseif(old('og_description'))
                                        @php $og_description=old('og_description'); @endphp
                                        @else
                                        @php $og_description=''; @endphp
                                        @endif
                                        <label class="form-label">OG Description </label>
                                        <textarea name="og_description" class="form-control ckeditor" placeholder="OG Description">{!! $og_description !!}</textarea>
                                    </div>

                                </div>
                            </div>
                        </div>

                        <div class="productCard">
                            @if(isset($record))
                            @foreach($record->variations as $variation)
                            @include('admin.product.product_variation',['title'=>'New Variation','colors'=>$colors,'record'=>$variation])
                            @endforeach
                            @else
                            @include('admin.product.product_variation',['title'=>'New Variation','colors'=>$colors])
                            @endif
                        </div>
                    </div>
                    <div class="col-12 product_bottom px-3">
                        <div class="row ">
                            <div class="col-6">
                                <button type="button" class="btn btn-primary" id="addMoreVariation">Add More</button>
                            </div>
                            <div class="col-6 text-end">
                                <button class="btn btn-primary" type="submit">Submit</button>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
</section>
@endsection
@push('scripts')
<script src="https://code.jquery.com/ui/1.13.0/jquery-ui.js"></script>
<script>
    $(document).ready(function() {

        var imgWrap = "";
        var imgArray = [];

        $(document).on('change', '.upload__inputfile', function(e) {
            var imgWrap = "";
            var imgArray = [];
            if ($(this).attr('data-id') == 'video_file' && $(this).attr('data-id')!==undefined) {

                var source = $(this).parents('.upload__box').find('video source');
                source[0].src = URL.createObjectURL(this.files[0]);
                source.parent()[0].load();

                // $(this).parents('.upload__box').find('video source').attr('src', URL.createObjectURL(this.files[0]))
                // $(this).parents('.upload__box').find('video')[0].load()

            } else {

                imgWrap = $(this).parents('.upload__box').find('.upload__img-wrap');
                var maxLength = $(this).attr('data-max_length');
                console.log(maxLength);
                var files = e.target.files;
                var filesArr = Array.prototype.slice.call(files);
                var iterator = 0;

                console.log('filesArr ' + filesArr);
                filesArr.forEach(function(f, index) {
                    console.log('lenght arr');
                    console.log(imgArray);
                    var len = 0;
                    for (var i = 0; i < imgArray.length; i++) {
                        if (imgArray[i] !== undefined) {
                            len++;
                        }
                    }
                    console.log('len '+len);
                    if (len > maxLength) {
                        return false;
                    } else {
                        imgArray.push(f);
                        console.log('aaaaaaaa');
                        var reader = new FileReader();
                        reader.onload = function(e) {
                            console.log(f.type);
                            // if (f.type == 'application/pdf') {
                            //     var html = "<div class='upload__img-box'><div style='background-image: url(" + e.target.result + ")' data-number='" + $(".upload__img-close").length + "' data-file='" + f.name + "' class='img-bg' ><div class='upload__img-close' data-type='I'></div><img  src='https://cdn-icons-png.flaticon.com/128/337/337946.png'></div></div>";

                            // } else {
                            var html = "<div class='upload__img-box'><div style='background-image: url(" + e.target.result + ")' data-number='" + $(".upload__img-close").length + "' data-file='" + f.name + "' class='img-bg'><div class='upload__img-close' data-type='I'></div></div></div>";

                            // }
                            // imgWrap.append(html);
                            imgWrap.html(html);
                            iterator++;
                        }
                        reader.readAsDataURL(f);
                    }
                    // }
                });
                // });
            }
        });

        $('body').on('click', ".upload__img-close", function(e) {
            if (confirm('Are you sure you want to delete ?')) {
                var file = $(this).parent().data("file");
                var id = $(this).attr('data-id');
                var file_type = $(this).attr('data-type');
                that = this;
                // For some browsers, `attr` is undefined; for others,
                // `attr` is false.  Check for both.
                if (typeof id !== 'undefined' && id !== false) {
                    $.ajax({
                        url: "{{ route('admin.products.removeFile') }}",
                        type: 'POST',
                        data: {
                            // _method: 'DELETE',
                            id: id,
                            type: file_type
                        },
                        success: function(res) {
                            if (res.status == true) {

                            }
                        }
                    });
                }
                for (var i = 0; i < imgArray.length; i++) {
                    if (imgArray[i].name === file) {
                        imgArray.splice(i, 1);
                        break;
                    }
                }
                $(this).parentsUntil('.row').find('.old_image').val('');
                console.log($(this).parentsUntil('.row').find('.old_image').val());
                $(this).parent().parent().remove();
                $(this).parent().children().remove();
            }
        });


        $(document).on('change', '.upload__listImages', function(e) {
            variation = $(this).parents('.multipleImages');
            imgWrap = $(this).parents('.multipleImages').find('.imageListId');
            that = this;
            console.log('imgWrap ', imgWrap);
            // var maxLength = $(this).attr('data-max_length');

            var files = e.target.files;
            var filesArr = Array.prototype.slice.call(files);
            var iterator = 0;

            console.log('filesArr ' + filesArr);
            filesArr.forEach(function(f, index) {
                // console.log('f ' ,  f);
                var len = 0;
                for (var i = 0; i < imgArray.length; i++) {
                    if (imgArray[i] !== undefined) {
                        len++;
                    }
                }

                imgArray.push(f);

                var reader = new FileReader();
                reader.onload = function(e) {
                    console.log(f.type);
                    key = parseInt(imgWrap.find('.listitemClass').length) + 1;
                    var html = "<div data-id='imageNo" + key + "' class='listitemClass'>" +
                        "<img class='main-img' src=" + e.target.result + " alt=''>" +
                        "<img src=\'{{ asset('admin/images/doted.gif')}}\' class='loading-img' />" +
                        "<div class='upload__listimg-close' data-id='0'></div>" +
                        "</div>";
                    imgWrap.append(html);
                    iterator++;
                }
                reader.readAsDataURL(f);


            });
            var formData = new FormData();
            for (var i = 0; i < files.length; i++) {
                formData.append('files[]', files[i]);
            }

            $.ajax({
                type: 'POST',
                url: "{{ route('admin.products.uploadListImage') }}", // URL to send the request to
                data: formData,
                contentType: false, // Prevent jQuery from overriding the content type
                processData: false, // Prevent jQuery from processing the data
                success: function(response) {
                    if (response.status == true) {
                        console.log(response.images);
                        if ($(that).parents('.multipleImages').find('.list_images').val() != "") {
                            val = $(that).parents('.multipleImages').find('.list_images').val();
                            $(that).parents('.multipleImages').find('.list_images').val(val + ',' + response.images);
                        } else {
                            $(that).parents('.multipleImages').find('.list_images').val(response.images);
                        }


                        images = $(that).parents('.multipleImages').find('.list_images').val().split(",");
                        console.log(images);
                        imagesArr = $(that).parents('.multipleImages').find('.listitemClass');
                        $.each(imagesArr, function(index, item) {
                            console.log(index);
                            $(this).find('.main-img').attr('data-image', images[index]);
                            $(this).find('.loading-img').hide();
                        });
                        sortVariationImages();
                    }
                },
                error: function(xhr, status, error) {
                    $('#response').html('<p>An error occurred: ' + error + '</p>');
                }
            });
        });

    });

    $(document).on('click', '.variation_delete', function() {
        var id = $(this).attr('data-id');
        that = this;

        text = 'you want to delete ?';
        const swalWithBootstrapButtons = Swal.mixin({
            customClass: {
                confirmButton: 'btn btn-success',
                cancelButton: 'btn btn-danger'
            },
            buttonsStyling: false
        });
        swalWithBootstrapButtons
            .fire({
                title: 'Are you sure?',
                text: text,
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Yes',
                cancelButtonText: 'No',
                reverseButtons: true
            })
            .then((result) => {
                if (result.isConfirmed) {
                 
                    $.ajax({
                        url: "{{ route('admin.products.deleteVariation') }}",
                        type: 'POST',
                        data: {
                            id: id
                        },
                        success: function(res) {
                            if (res.status == true) {
                                $(that).parents('.card').remove();
                            }
                        }
                    });
                }
            });
    });

    $(function() {
        sortVariationImages();
    });

    // jquery sorting on list images
    function sortVariationImages() {
        $(".imageListId").sortable({
            update: function(event, ui) {
                getIdsOfImages(event, this);
            } //end update        
        });
    }

    function getIdsOfImages(ev, that) {
        $(that).parents('.multipleImages').find('.list_images').val('');
        updateListImages(that);
    }

    function updateListImages(that) {
        var values = [];
        imageArray = [];
        $(that).find('.listitemClass').each(function(index) {
            values.push($(this).attr("data-id").replace("imageNo", ""));
            console.log($(this).find(".main-img").attr('data-image'));
            imageArray.push($(this).find(".main-img").attr('data-image'));
        });
        console.log(JSON.stringify(imageArray));
        $(that).parents('.multipleImages').find('.list_images').val(imageArray);
    }

    // add new variation
    $(document).on('click', '#addMoreVariation', function() {
        $.ajax({
            type: "GET",
            url: "{{ route('admin.products.addMoreVariation') }}",
            success: function(response) {
                $('.productCard').append(response);
                $('.visible_toggle').bootstrapToggle();
                $('.active_check').bootstrapToggle();
                length = $('.ckeditor').length;
                $('.ckeditor:last-child').attr('id', 'ckeditor' + length);
                CKEDITOR.replace('ckeditor' + length);
                sortVariationImages();

            }
        });
    });

    // on/off active variation action 
    $(document).on('change', '.active_check', function() {
        const isChecked = $(this).is(":checked");
        if (isChecked) {
            $(this).parent().parent().find('.variation_active').val(1);
        } else {
            $(this).parent().parent().find('.variation_active').val(0);
        }
    });

    //visible_toggle
    $(document).on('change', '.visible_toggle', function() {
        const isChecked = $(this).is(":checked");
        if (isChecked) {
            $(this).parent().parent().find('.visible_active').val(1);
        } else {
            $(this).parent().parent().find('.visible_active').val(0);
        }
    });

    $(document).on('click', '.upload__listimg-close', function() {
        that = $(this).parents('.imageListId');
        id = $(this).attr('data-id');
        it = this;
        text = 'you want to delete ?';
        const swalWithBootstrapButtons = Swal.mixin({
            customClass: {
                confirmButton: 'btn btn-success',
                cancelButton: 'btn btn-danger'
            },
            buttonsStyling: false
        });
        swalWithBootstrapButtons
            .fire({
                title: 'Are you sure?',
                text: text,
                icon: 'warning',
                showCancelButton: true,
                confirmButtonText: 'Yes',
                cancelButtonText: 'No',
                reverseButtons: true
            })
            .then((result) => {
                if (result.isConfirmed) {
                    $.ajax({
                        url: "{{ route('admin.products.deleteListImage') }}",
                        type: 'POST',
                        data: {
                            "id": id
                        },
                        success: function(res) {
                            if (res.status == true) {
                                $(it).parent().remove();
                                updateListImages(that);
                            }
                        }
                    });
                } else if (result.dismiss === Swal.DismissReason.cancel) {
                    swalWithBootstrapButtons.fire('Cancelled', '', 'error');
                }
            });


    })
</script>
@endpush