@extends('admin.layouts.admin')
@section('content')
    <!-- [ Main Content ] start -->
    <div class="pc-container">
        <div class="pc-content">
            <!-- [ breadcrumb ] start -->
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item"><a href="{{ route('admin.dashboard') }}">Home</a></li>
                                <li class="breadcrumb-item"><a href="{{ route('admin.services') }}">{{ $title }}</a></li>
                            </ul>
                        </div>
                    </div>
                </div>
            </div>
            <!-- [ breadcrumb ] end -->

            <!-- [ Main Content ] start -->
            <div class="row">
                @if ($message = Session::get('success'))
                    <div class="col-sm-12">
                        @if(Session::has('message'))
                            <p id="cust-alt" class="alert {{ Session::get('alert-class', 'alert-info') }} flash-msg">{{ Session::get('message') }}</p>
                        @endif
                    </div>
                @endif

                <!-- [ sample-page ] start -->
                <div class="col-sm-12">
                    <div class="card ">
                        <div class="card-header">
                            <div class="row">
                                <div class="col-md-12">
                                    <h3 class="float-start">{{ $title }}</h3>
                                </div>
                            </div>

                            <div class="row mt-3">
                                <div class="col-md-12 ps-0">
                                    <div class="d-flex justify-content-between">
                                        <div></div>
                                        <div class="page-fonts-container">
                                            <div class="text-end mb-1">
                                                <a href="{{ route('admin.add-service') }}" class="btn btn-primary  ms-2 mb-1">
                                                    <i class="ti ti-plus f-18"></i> Add Service
                                                </a>
                                                &nbsp;&nbsp;&nbsp;&nbsp;
                                                <a href="javascript:void(0)" class="btn btn-primary  ms-2 mb-1" data-bs-toggle="collapse" data-bs-target="#collapseExample" aria-expanded="false" aria-controls="collapseExample">
                                                    Font
                                                </a>
                                            </div>

                                            <div class="collapse border p-3 mt-3" id="collapseExample">
                                                <div class="row">
                                                    <div class="col-md-6 mb-3">
                                                        <label class="form-label">Title</label>
                                                        <select class="select2" name="font1">
                                                            @include('admin.includes.font-select')
                                                        </select>
                                                    </div>
                                                    <div class="col-md-6 mb-3">
                                                        <label class="form-label">Content</label>
                                                        <select class="select2" name="font2">
                                                            @include('admin.includes.font-select')
                                                        </select>
                                                    </div>
                                                </div>

                                                <div class="row">
                                                    <div class="col-md-12 mt-3 d-flex justify-content-end">
                                                        <button class="btn btn-outline-secondary ms-2 mb-1 rounded-0" data-bs-toggle="tooltip" data-bs-original-title="Save fonts." onclick="saveFonts()">Save</button>
                                                        <button class="btn btn-outline-secondary ms-2 mb-1 rounded-0" data-bs-toggle="modal" data-bs-target="#confirmReset">Reset</button>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-body">
                            <div class="dt-responsive table-responsive">
                                <table id="jsource-table" class="table  table-bordered nowrap"> </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div id="confirmReset" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="confirmResetTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title text-dark" id="confirmResetTitle">Reset Fonts</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <p>Are you sure to reset all fonts to their original/default values for this page?</p>
                    <p class="text-warning text-orange-600">Note that this action is not reversible.</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-success" data-bs-dismiss="modal">No</button>
                    <a role="button" onclick="resetFonts()" class="btn btn-danger text-white" data-bs-dismiss="modal">Yes</a>
                </div>
            </div>
        </div>
    </div>

@endsection

@push('scripts')
    <script type="text/javascript">
        var table = $('#jsource-table').DataTable({
            ajax: "{{ route('admin.services') }}",
            processing: true,
            serverSide: true,
            deferRender: true,
            order: [
                [0, 'desc']
            ],
            columns: [{
                    title: '#',
                    data: 'id',
                    name: 'id',
                    visible: false,
                },
                {
                    title: 'Name',
                    data: 'name',
                    name: 'name',
                },
                {
                    title: 'Alias',
                    data: 'alias',
                    name: 'alias',
                },
                {
                    title: 'Created At',
                    data: 'created_at',
                    name: 'created_at',
                },
                {
                    title: 'Action',
                    data: 'action',
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
        });

        $(document).on('click', '.deleteSelSingle', function(e) {
            e.preventDefault();
            text = 'you want to delete ?';
            const swalWithBootstrapButtons = Swal.mixin({
                customClass: {
                    confirmButton: 'btn btn-success',
                    cancelButton: 'btn btn-danger'
                },
                buttonsStyling: false
            });
            swalWithBootstrapButtons
                .fire({
                    title: 'Are you sure?',
                    text: text,
                    icon: 'warning',
                    showCancelButton: true,
                    confirmButtonText: 'Yes',
                    cancelButtonText: 'No',
                    reverseButtons: true
                })
                .then((result) => {
                    if (result.isConfirmed) {
                        var favorite = [];
                        favorite.push($(this).attr('data-val'));
                        var ids = favorite.join(",");
                        $.ajax({
                            url: "{{ route('admin.services.destroy') }}",
                            type: 'POST',
                            data: {
                                "ids": ids
                            },
                            success: function(res) {
                                if (res.status == true) {
                                    url = "{{ route('admin.services') }}";
                                    window.location.href = url;
                                }
                            }
                        });
                    } else if (result.dismiss === Swal.DismissReason.cancel) {
                        if (val == 0) {
                            $(this).prop('checked', false);
                        } else {
                            $(this).prop('checked', true);
                        }
                        swalWithBootstrapButtons.fire('Cancelled', '', 'error');
                    }
                });
        });
    </script>

    <script>
        function saveFonts() {
            let data = {
                'font1': $('select[name="font1"]').val(),
                'font2': $('select[name="font2"]').val(),
            };

            let url = "{{ route('admin.update-page-fonts') }}";

            $.ajax({
                type: 'POST',
                url: url,
                data: {
                    'page': 'service',
                    'data': data,
                },
                headers: {'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')},
                success: function(data) {
                    window.location.href = '{{ route('admin.services') }}';
                }
            });
        }

        function resetFonts() {
            let url = "{{ route('admin.reset-page-fonts') }}";

            $.ajax({
                type: 'POST',
                url: url,
                data: {
                    'page': 'service',
                },
                headers: {'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')},
                success: function(data) {
                    window.location.href = '{{ route('admin.services') }}';
                }
            });
        }

        $(document).ready(function() {
            $('select[name="font1"]').val('{{$fonts->font1}}').trigger('change');
            $('select[name="font2"]').val('{{$fonts->font2}}').trigger('change');

            for (let i = 1; i <= 2; i++) {
                $(`select[name="font${i}"]`).select2({
                    placeholder: 'Change font',
                    allowClear: true
                });
            }
        });
    </script>
@endpush
