@extends('admin.layouts.admin')

@section('content')
<section class="pc-container">
    <div class="pc-content">
        <div class="page-header">
            <div class="page-block">
                <div class="row align-items-center">
                    <div class="col-md-12">
                        <ul class="breadcrumb">
                            <li class="breadcrumb-item" aria-current="page">
                                <a href="{{ route('admin.sliders') }}">Sliders</a>
                            </li>
                            <li class="breadcrumb-item" aria-current="page">Edit</li>
                        </ul>
                    </div>
                    <!-- <div class="col-md-12">
                        <div class="page-header-title">
                            <h2 class="mb-0">Slider</h2>
                        </div>
                    </div> -->
                </div>
            </div>
        </div>

        <div class="row pt-0">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h5>{{ $title }}</h5>
                    </div>
                    <div class="card-body">
                        <div>
                            @if ($errors->any())
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                    <li>
                                        {{ $error }}
                                    </li>
                                    @endforeach
                                </ul>
                            </div>
                            @endif
                        </div>
                        @if($action == 'Edit')
                        <form action="{{ route('admin.sliders.update',$record->id) }}" method="post" enctype="multipart/form-data" class="form-data">
                            @else
                            <form action="{{ route('admin.sliders.store') }}" method="post" enctype="multipart/form-data" class="form-data">
                                @endif

                                @csrf
                                @if(isset($record->id))
                                @php $id=$record->id @endphp
                                @else
                                @php $id=0; @endphp
                                @endif

                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="row">
                                            <div class="form-group col-md-12">
                                                <label class="form-label">Image <span class="text-danger">*</span></label>
                                                <input name="image" class="form-control" type="file" accept="image/jpg, image/jpeg, image/png, image/webp" onchange="loadFile_1(event)">
                                            </div>
                                            <div class="col-md-12">
                                                <div class="d-flex">

                                                    @if(isset($record->image))
                                                    @php $image=$record->image @endphp
                                                    @php $imageUrl=$record->image @endphp
                                                    @elseif(old('image'))
                                                    @php $image=old('image');
                                                    $imageUrl=""; @endphp
                                                    @else
                                                    @php $image='';
                                                    $imageUrl="" @endphp
                                                    @endif

                                                    @if ($imageUrl=="")
                                                    <img class="img-fluid image-preview" src="" alt="" id="output-1">
                                                    @else
                                                    <a href="{{ $imageUrl }}" target="_blank">
                                                        <img class="img-fluid image-preview" src="{{ $imageUrl }}" alt="" id="output-1">
                                                    </a>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-md-6">
                                        <div class="row">
                                            <div class="form-group col-md-12">
                                                <label class="form-label">Sub Image <span class="text-danger">*</span></label>
                                                <input name="sub_image" class="form-control" type="file" accept="image/jpg, image/jpeg, image/png, image/webp" onchange="loadFile_2(event)">
                                            </div>

                                            <div class="col-md-12">
                                                <div class="d-flex">
                                                    @if(isset($record->sub_image) && $record->sub_image!="")
                                                    @php $image=$record->sub_image @endphp
                                                    @php $imageUrl=$record->sub_image @endphp
                                                    @elseif(old('sub_image'))
                                                    @php $image=old('sub_image'); 
                                                    $imageUrl=""; @endphp
                                                    @else
                                                    @php $image='';
                                                    $imageUrl="" @endphp
                                                    @endif

                                                    @if ($imageUrl == "")
                                                    <img class="img-fluid image-preview" src="" alt="sub image" id="output-2">
                                                    @else
                                                    <a href="{{ $imageUrl }}" target="_blank">
                                                        <img class="img-fluid image-preview" src="{{ $imageUrl }}" alt="" id="output-2">
                                                    </a>
                                                    @endif
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="row mt-2">
                                    <div class="form-group col-md-12">
                                        @if(isset($record->title))
                                        @php $title=$record->title @endphp
                                        @elseif(old('title'))
                                        @php $title=old('title'); @endphp
                                        @else
                                        @php $title=''; @endphp
                                        @endif
                                        <label class="form-label">Title <span class="text-danger">*</span></label>
                                        <input required name="title" type="text" class="form-control" maxlength="191" placeholder="Title" value="{{ $title }}">
                                    </div>

                                    <div class="form-group col-md-6">
                                        @if(isset($record->subtitle))
                                        @php $subtitle=$record->subtitle @endphp
                                        @elseif(old('subtitle'))
                                        @php $subtitle=old('subtitle'); @endphp
                                        @else
                                        @php $subtitle=''; @endphp
                                        @endif
                                        <label class="form-label">Subtitle</label>
                                        <input name="subtitle" type="text" class="form-control" maxlength="191" placeholder="Title" value="{{ $subtitle }}">
                                    </div>

                                    <div class="form-group col-md-6">
                                        @if(isset($record->tagline))
                                        @php $tagline=$record->tagline @endphp
                                        @elseif(old('tagline'))
                                        @php $tagline=old('tagline'); @endphp
                                        @else
                                        @php $tagline=''; @endphp
                                        @endif
                                        <label class="form-label">Tagline</label>
                                        <input name="tagline" type="text" class="form-control" maxlength="191" placeholder="Tagline" value="{{ $tagline }}">
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="form-group col-md-6">
                                        @if(isset($record->button_text))
                                        @php $button_text=$record->button_text @endphp
                                        @elseif(old('button_text'))
                                        @php $button_text=old('button_text'); @endphp
                                        @else
                                        @php $button_text=''; @endphp
                                        @endif
                                        <label class="form-label">Button Text</label>
                                        <input name="button_text" type="text" class="form-control" maxlength="50" placeholder="Text on button" value="{{ $button_text }}">
                                    </div>

                                    <div class="form-group col-md-6">
                                        @if(isset($record->button_link))
                                        @php $button_link=$record->button_link @endphp
                                        @elseif(old('button_link'))
                                        @php $button_link=old('button_link'); @endphp
                                        @else
                                        @php $button_link=''; @endphp
                                        @endif
                                        <label class="form-label">Button Link</label>
                                        <input name="button_link" type="text" class="form-control" placeholder="URL" value="{{ $button_link }}">
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="form-group col-md-2">
                                        @if(isset($record->rank))
                                        @php $rank=$record->rank @endphp
                                        @elseif(old('rank'))
                                        @php $rank=old('rank'); @endphp
                                        @else
                                        @php $rank=0; @endphp
                                        @endif
                                        <label class="form-label">Rank</label>
                                        <input name="rank" type="number" min="0" class="form-control" placeholder="Rank" value="{{ $rank }}">
                                    </div>
                                </div>

                                <div class="row">

                                    <div class="col-md-12 col-sm-12 col-12" data-bs-toggle="tooltip">
                                        @if(isset($record->active))
                                        @php $active=$record->active @endphp
                                        @elseif(old('active'))
                                        @php $active=old('active'); @endphp
                                        @else
                                        @php $active=1; @endphp
                                        @endif
                                        <div class="form-check form-switch custom-switch-v1 mt-2 ">
                                            <input name="active" type="checkbox" class="form-check-input input-primary" id="activeCheckbox" value='1' {!! ($active==1) ? 'checked' : '' !!}>
                                            <label class="form-check-label" for="activeCheckbox">Active</label>
                                        </div>

                                        <input type="submit" value="Save" class="btn btn-primary m-t-20 m-b-20" data-bs-toggle="tooltip" data-bs-original-title="Save changes">
                                    </div>
                                </div>
                            </form>
                    </div>
                </div>
            </div>
        </div>
</section>

<script>
    var loadFile_1 = function(event) {
        var output_1 = document.getElementById('output-1');
        output_1.src = URL.createObjectURL(event.target.files[0]);
        output_1.onload = function() {
            URL.revokeObjectURL(output_1.src) // free memory
        }
    };

    var loadFile_2 = function(event) {
        var output_2 = document.getElementById('output-2');
        output_2.src = URL.createObjectURL(event.target.files[0]);
        output_2.onload = function() {
            URL.revokeObjectURL(output_2.src) // free memory
        }
    };
</script>

@endsection