@extends('admin.layouts.admin')

@section('content')
    <section class="pc-container">
        <div class="pc-content">
            <div class="page-header">
                <div class="page-block">
                    <div class="row align-items-center">
                        <div class="col-md-12">
                            <ul class="breadcrumb">
                                <li class="breadcrumb-item">
                                    Content
                                </li>
                                <li class="breadcrumb-item" aria-current="page">
                                    <a href="{{ route('admin.testimonials') }}">Testimonials</a>
                                </li>
                                <li class="breadcrumb-item" aria-current="page">Edit</li>
                            </ul>
                        </div>
                        <div class="col-md-12">
                            <div class="page-header-title">
                                <h2 class="mb-0">Testimonial</h2>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="row pt-0">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <div>
                                @if ($errors->any())
                                    <div class="alert alert-danger">
                                        <ul>
                                            @foreach ($errors->all() as $error)
                                                <li>
                                                    {{ $error }}
                                                </li>
                                            @endforeach
                                        </ul>
                                    </div>
                                @endif
                            </div>
                            <form action="{{ route('admin.update-testimonial') }}" method="post" class="form-data">
                                @csrf
                                <input type="hidden" name="id" value="{{ $testimonial->id }}">

                                <div class="row">
                                    <div class="form-group col-md-12">
                                        <label class="form-label">Name <span class="text-danger">*</span></label>
                                        <input required name="name" type="text" class="form-control" placeholder="Name" value="{{ old('name', $testimonial->name) }}">
                                    </div>

                                    <div class="form-group col-md-3 col-xl-2">
                                        <label class="form-label">Rating <span class="text-danger">*</span></label>
                                        <input required name="rating" type="number" min="0" class="form-control" placeholder="Rating" value="{{ old('rating', $testimonial->rating) }}">
                                    </div>

                                    <div class="form-group col-md-12">
                                        <label class="form-label">Content <span class="text-danger">*</span></label>
                                        <textarea required name="content" class="form-control ckeditor" placeholder="Content">{!! old('content', $testimonial->content) !!}</textarea>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-md-12">
                                        <div class="form-check form-switch custom-switch-v1">
                                            <input name="active" type="checkbox" class="form-check-input input-primary" id="activeCheckbox" value='1' @checked(old('active', $testimonial->active))>
                                            <label class="form-check-label" for="activeCheckbox">Active</label>
                                        </div>
                                        <input type="submit" value="Save" class="btn btn-primary m-t-20 m-b-20" data-bs-toggle="tooltip" data-bs-original-title="Save changes">
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
    </section>
@endsection
