@extends('layouts.page')

@section('content')
    <section class="intenal-heading">
        <div class="container">
            <div class="row">
                <div class="blog-head">
                    <h2>Our Blog</h2>
                    <a href="{{ route('homepage') }}">Home</a>> <span>Our Blog</span>
                </div>
            </div>
        </div>
    </section>

    <section class="blog-main">
        <div class="container">
            <div class="row">
                <!--blog-list start-->
                <div class="col-xxl-9 col-xl-9 col-lg-8 col-md-6 col-sm-12 col-12">
                    <div class="blog-heading">
                        <h6 class="font-{{ $fonts->font1 }}">{{ date('F d, Y', strtotime($blog->created_at)) }} <span>POST BY ADMIN</span></h6>
                        <h2 class="blog-detail-head font-{{ $fonts->font2 }}">{{ $blog->title }}</h2>
                    </div>
                    <img class="img-fluid" src="{{ asset(Storage::url($blog->image)) }}" alt="">
                    <div class="blog-main-content font-{{ $fonts->font3 }}">
                        {!! $blog->description !!}
                    </div>
                </div>
                <div class="col-xxl-3 col-xl-3 col-lg-4 col-md-6 col-sm-12 col-12">
                    <div class="prod-main blog-list-main blog-right-side">
                        {{-- <div class="blog-search">
                            <input type="text" class="form-control" placeholder="Search" id="">
                            <i class="fa fa-search"></i>
                        </div> --}}
                        <h4 class="font-{{ $fonts->font5 }}">Recent Posts</h4>

                        @foreach ($recent_posts as $post)
                            <div class="recent-post">
                                <div class="row">
                                    <div class="col-4">
                                        <a href="{{ route('blog', ['alias' => $post->alias]) }}">
                                            <img class="img-fluid" src="{{ asset(Storage::url($post->image)) }}" alt="">
                                        </a>
                                    </div>
                                    <div class="col-8">
                                        <h3 class="font-{{ $fonts->font6 }}"><a href="{{ route('blog', ['alias' => $post->alias]) }}">{{ $post->title }}</a></h3>
                                        <p class="font-{{ $fonts->font7 }}">{{ date('F d, Y', strtotime($post->created_at)) }}</p>
                                    </div>
                                </div>
                            </div>
                        @endforeach

                        <div class="categories-rightside">
                            <h4 class="font-{{ $fonts->font5 }}">Categories</h4>
                            <ul>
                                @foreach ($blog_categories as $cat)
                                    <li class="font-{{ $fonts->font8 }}">
                                        <a href="{{ route('blog', ['category' => $cat->alias]) }}">
                                            <i class="fa fa-angle-right"></i>{{ $cat->title }}
                                        </a>
                                    </li>
                                @endforeach
                            </ul>
                        </div>
                        <div class="tag-rightside">
                            <h4 class="font-{{ $fonts->font5 }}">Tags</h4>

                            @foreach ($tags as $tag)
                                <a href="#" class="font-{{ $fonts->font9 }}">{{ $tag }}</a>
                            @endforeach
                        </div>
                    </div>
                </div>
                <!--blog-list end-->
            </div>
        </div>
    </section>
@endsection
