@extends('layouts.page')

@section('content')

    <section class="intenal-heading">
        <div class="container">
            <div class="row">
                <div class="blog-head">
                    <h2>Our Blog</h2>
                    <a href="{{ route('homepage') }}">Home</a>> <span>Our Blog</span>
                </div>
            </div>
        </div>
    </section>

    <section class="blog-main">
        <div class="container">
            <div class="row">
                @foreach ($blogs as $item)
                    <div class="col-xxl-4 col-xl-4 col-lg-4 col-md-6 col-sm-12 col-12">
                        <div class="prod-main blog-list-main">
                            <div class="blog-pic">
                                <a href="{{ route('blog', ['alias' => $item->alias]) }}">
                                    <img class="img-fluid" src="{{ asset(Storage::url($item->image)) }}">
                                </a>
                            </div>
                            <div class="blog-heading">
                                <h6 class="font-{{ $fonts->font1 }}">{{ date('F d, Y', strtotime($item->created_at)) }} <span>POST BY ADMIN</span></h6>

                                <h2 class="blog-main-head font-{{ $fonts->font2 }}">
                                    <a href="{{ route('blog', ['alias' => $item->alias]) }}">{{ $item->title }}</a>
                                </h2>

                                <div class="font-{{ $fonts->font3 }}">
                                    {!! Str::limit($item->description, 180) !!}
                                </div>

                                <a class="font-{{ $fonts->font4 }}" href="{{ route('blog', ['alias' => $item->alias]) }}">Read more</a>
                            </div>
                        </div>
                    </div>
                @endforeach

                <div>
                    {{ $blogs->onEachSide(4)->links() }}
                </div>
            </div>
        </div>
    </section>

@endsection
