@extends('layouts.page')

@section('content')

    <section class="blog-main">
        <div class="container">
            <div class="row">
                <div class="col-md-12">
                    <div class="my-5 text-center">
                        {!! $top_content !!}
                    </div>
                </div>
            </div>

            <div class="row">
                @foreach ($data as $item)
                    <div class="col-xxl-4 col-xl-4 col-lg-4 col-md-6 col-sm-12 col-12">
                        <div class="prod-main blog-list-main">
                            <div class="blog-pic">
                                <a href="{{ route('coming', ['alias' => $item->alias]) }}">
                                    <img class="img-fluid" src="{{ asset(Storage::url($item->image)) }}">
                                </a>
                            </div>
                            <div class="blog-heading ">
                                <h2 class="blog-main-head">
                                    <a href="{{ route('coming', ['alias' => $item->alias]) }}">{{ $item->title }}</a>
                                </h2>

                                {!! Str::limit($item->description, 130) !!}
                            </div>
                        </div>
                    </div>
                @endforeach

                <div class="d-flex justify-content-center">
                    {{ $data->onEachSide(4)->links() }}
                </div>
            </div>

            <div class="row">
                <div class="col-md-12">
                    <div class="mt-5 mb-2 text-center">
                        {!! $top_content !!}
                    </div>
                </div>
            </div>
        </div>
    </section>

@endsection
