<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <title>{{ $title ?? 'Welcome to Angelic Bridal' }}</title>

    <link rel="stylesheet" type="text/css" href="{{ asset('css/bootstrap.min.css') }}"/>

    <!-- main -->
    <link rel="stylesheet" type="text/css" href="{{ asset('css/main.css') }}"/>
    <link rel="stylesheet" type="text/css" href="{{ asset('css/responsive.css') }}"/>
    <link rel="stylesheet" type="text/css" href="{{ asset('css/font-awesome.min.css') }}"/>
    <link rel="stylesheet" type="text/css" href="{{ asset('css/internal.css') }}"/>
    <link rel="stylesheet" type="text/css" href="{{ asset('css/price-slider.css') }}"/>
    <link rel="stylesheet" type="text/css" href="{{ asset('css/owl.carousel.min.css') }}"/>
    <link rel="stylesheet" type="text/css" href="{{ asset('css/owl.theme.default.min.css') }}"/>

    <!-- main slider -->
    <link rel="stylesheet" type="text/css" href="{{ asset('css/slider/demo.css') }}" />
    <link rel="stylesheet" type="text/css" href="{{ asset('css/slider/style.css') }}" />

    <noscript>
        <link rel="stylesheet" type="text/css" href="{{ asset('css/slider/noscript.css') }}" />
    </noscript>

    <!-- main slider end -->
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>

    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Karla:ital,wght@0,200..800;1,200..800&display=swap" rel="stylesheet">

    <meta name="csrf-token" content="{{ csrf_token() }}">
</head>

<body>
    @include('includes.topbar')

    @yield('content')

    @include('includes.contact')
    
    @include('includes.footer')

    <script src="{{ asset('js/jquery.min.js') }}"></script>
    <script src="{{ asset('js/bootstrap.bundle.min.js') }}"></script>

    <script>
        function openNav() {
            document.getElementById("mySidenav").style.left = "0px";
        }

        function closeNav() {
            document.getElementById("mySidenav").style.left = "-350";
        }

        function openFilter() {
            document.getElementById("mobfilter").style.left = "0px";
        }

        function closeFilter() {
            document.getElementById("mobfilter").style.left = "-350";
        }

        $(window).scroll(function(){
            if($(this).scrollTop() < 10){
                $('.navbar-main').removeClass('sticky')
            }
            height=$('#main-topbar').outerHeight();
            if($(this).scrollTop() > height){
                if(!$('.navbar-main').hasClass('sticky')){
                    $('.navbar-main').addClass('sticky')
                }
            } else{
                // $('.navbar-main').removeClass('sticky')
            }
        });
    </script>

    <script>
        $(document).on('click','.mob-search-ra',function(){
            if($('.mob-search').hasClass('d-none')){
                $('.mob-search').removeClass('d-none');
                $('.mob-search').addClass('d-block');
            }else{
                $('.mob-search').removeClass('d-block');
                $('.mob-search').addClass('d-none');
            }
        });

        $(document).on('click','.close-search',function(){
            $('.mob-search').removeClass('d-block');
            $('.mob-search').addClass('d-none');
        });
    </script>


    <script src="{{ asset('js/price-slider.js') }}"></script>

    @include('includes.home-sliders')
    @include('includes.main-slider-js')

    @stack('scripts')

</body>
</html>
