<?php

use App\Models\Coming;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Request;
use App\Http\Controllers\FaqsController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\PayPalController;
use App\Models\AppointmentServiceCategory;
use App\Http\Controllers\PaymentController;
use App\Http\Controllers\BlogPageController;
use App\Http\Controllers\HomepageController;
use App\Http\Controllers\Admin\FaqController;
use App\Http\Controllers\Admin\BlogController;
use App\Http\Controllers\Admin\CityController;
use App\Http\Controllers\Admin\FontController;
use App\Http\Controllers\Admin\PageController;
use App\Http\Controllers\ComingPageController;
use App\Http\Controllers\Admin\BrandController;
use App\Http\Controllers\Admin\ColorController;
use App\Http\Controllers\Admin\StaffController;
use App\Http\Controllers\Admin\StateController;
use App\Http\Controllers\ContactPageController;
use App\Http\Controllers\Admin\ComingController;
use App\Http\Controllers\Admin\FabricController;
use App\Http\Controllers\Admin\ReportController;
use App\Http\Controllers\Admin\SeasonController;
use App\Http\Controllers\Admin\SliderController;
use App\Http\Controllers\ServicesPageController;
use App\Http\Controllers\Admin\CountryController;
use App\Http\Controllers\Admin\ProductController;
use App\Http\Controllers\Admin\ServiceController;
use App\Http\Controllers\Admin\CategoryController;
use App\Http\Controllers\Admin\CustomerController;
use App\Http\Controllers\Admin\NecklineController;
use App\Http\Controllers\Admin\PaymentsController;
use App\Http\Controllers\Admin\SettingsController;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\Auth\LoginController;
use App\Http\Controllers\Admin\ComingSoonController;
use App\Http\Controllers\Admin\SilhouetteController;
use App\Http\Controllers\Admin\AppointmentController;
use App\Http\Controllers\Admin\TestimonialController;
use App\Http\Controllers\Admin\BlogCategoryController;
use App\Http\Controllers\Admin\ProductModelController;
use App\Http\Controllers\Admin\HomepageSectionsController;
use App\Http\Controllers\Admin\AppointmentServiceController;
use App\Http\Controllers\ProductController as WebProductController;
use App\Http\Controllers\Admin\AppointmentServiceCategoryController;
use App\Http\Controllers\AppointmentController as WebAppointmentController;

Route::get('/getCountries', [IndexController::class, 'getCountries'])->name('getCountries');
Route::get('/getStates', [IndexController::class, 'getStates'])->name('getStates');
Route::get('/getCities', [IndexController::class, 'getCities'])->name('getCities');


Route::prefix('secureAdminArea')->name('admin.')->group(function () {
    Route::post('ckeditor/upload', [DashboardController::class, 'uploadfile'])->name('ckeditor.upload');
    Route::get('/', [LoginController::class, 'showLoginForm'])->name('login');
    Route::post('/login', [LoginController::class, 'login'])->name('loginSubmit');

    Route::middleware(['auth:admin'])->group(function () {
        Route::get('/logout', [LoginController::class, 'logout'])->name('logout');

        Route::controller(DashboardController::class)->group(function () {
            Route::get('/dashboard', 'index')->name('dashboard');
            Route::get('/dashboard-appointment-chart', 'appointment_chart')->name('dashboard-appointment-chart');
            Route::get('/dashboard-payments-chart', 'payments_chart')->name('dashboard-payments-chart');
        });

        Route::controller(HomepageSectionsController::class)->group(function () {
            Route::get('/homepage-sections', 'index')->name('homepage-sections');
            Route::get('/homepage-section/{section}', 'edit')->name('edit-homepage-section');
            Route::post('/update-homepage-section/{section}', 'update')->name('update-homepage-section');
            Route::post('/toggle-section/{section}', 'toggle_section')->name('toggle-section');
            Route::post('/fetch-cat-products/{cid}', 'cat_products')->name('fetch-cat-products');
            Route::post('/fetch-cat-blog/{cid}', 'cat_blogs')->name('fetch-cat-blogs');
            Route::post('/update-sections-order', 'update_sections_order')->name('update-sections-order');
            Route::post('/reset-fonts', 'reset_fonts')->name('reset-fonts');
        });

        Route::controller(LoginController::class)->group(function () {
            Route::get('/change-password', 'change_password')->name('change-password');
            Route::post('/update-password', 'update_password')->name('update-password');
        });

        Route::controller(CategoryController::class)->group(function () {
            Route::get('/categories', 'index')->name('categories');
            Route::get('/categories/create', 'create')->name('categories.create');
            Route::post('/categories/store', 'store')->name('categories.store');
            Route::get('/categories/edit/{id}', 'edit')->name('categories.edit');
            Route::post('/categories/update/{id}', 'update')->name('categories.update');
            Route::post('/categories/destroy', 'destroy')->name('categories.destroy');
            Route::post('/categories/update-active', 'updateActive')->name('categories.updateActive');
            Route::post('/categories/remove-file', 'removeFile')->name('categories.removeFile');
        });

        Route::controller(ColorController::class)->group(function () {
            Route::get('/colors', 'index')->name('colors');
            Route::get('/colors/create', 'create')->name('colors.create');
            Route::post('/colors/store', 'store')->name('colors.store');
            Route::get('/colors/edit/{id}', 'edit')->name('colors.edit');
            Route::post('/colors/update/{id}', 'update')->name('colors.update');
            Route::post('/colors/destroy', 'destroy')->name('colors.destroy');
            Route::post('/colors/update-active', 'updateActive')->name('colors.updateActive');
            Route::post('/colors/remove-file', 'removeFile')->name('colors.removeFile');
        });

        Route::controller(BlogController::class)->group(function () {
            Route::get('/blog/posts', 'index')->name('blog');
            Route::get('/blog', 'create')->name('add-blog');
            Route::post('/store-blog', 'store')->name('store-blog');
            Route::get('/blog/{blog}', 'edit')->name('edit-blog');
            Route::post('/update-blog', 'update')->name('update-blog');
            Route::post('/blog/destroy', 'destroy')->name('blog.destroy');
        });

        Route::controller(BlogCategoryController::class)->group(function () {
            Route::get('/blog-categories', 'index')->name('blog-categories');
            Route::get('/blog-categories/create', 'create')->name('blog-categories.create');
            Route::post('/blog-categories/store', 'store')->name('blog-categories.store');
            Route::get('/blog-categories/edit/{id}', 'edit')->name('blog-categories.edit');
            Route::post('/blog-categories/update/{id}', 'update')->name('blog-categories.update');
            Route::post('/blog-categories/destroy', 'destroy')->name('blog-categories.destroy');
            Route::post('/blog-categories/update-active', 'updateActive')->name('blog-categories.updateActive');
            Route::post('/blog-categories/remove-file', 'removeFile')->name('blog-categories.removeFile');
        });

        Route::controller(NecklineController::class)->group(function () {
            Route::get('/necklines', 'index')->name('necklines');
            Route::get('/necklines/create', 'create')->name('necklines.create');
            Route::post('/necklines/store', 'store')->name('necklines.store');
            Route::get('/necklines/edit/{id}', 'edit')->name('necklines.edit');
            Route::post('/necklines/update/{id}', 'update')->name('necklines.update');
            Route::post('/necklines/destroy', 'destroy')->name('necklines.destroy');
        });

        Route::controller(SeasonController::class)->group(function () {
            Route::get('/seasons', 'index')->name('seasons');
            Route::get('/seasons/create', 'create')->name('seasons.create');
            Route::post('/seasons/store', 'store')->name('seasons.store');
            Route::get('/seasons/edit/{id}', 'edit')->name('seasons.edit');
            Route::post('/seasons/update/{id}', 'update')->name('seasons.update');
            Route::post('/seasons/destroy', 'destroy')->name('seasons.destroy');
        });

        Route::controller(SilhouetteController::class)->group(function () {
            Route::get('/silhouettes', 'index')->name('silhouettes');
            Route::get('/silhouettes/create', 'create')->name('silhouettes.create');
            Route::post('/silhouettes/store', 'store')->name('silhouettes.store');
            Route::get('/silhouettes/edit/{id}', 'edit')->name('silhouettes.edit');
            Route::post('/silhouettes/update/{id}', 'update')->name('silhouettes.update');
            Route::post('/silhouettes/destroy', 'destroy')->name('silhouettes.destroy');
        });

        Route::controller(FaqController::class)->group(function () {
            Route::get('/faqs', 'index')->name('faqs');
            Route::get('/faq', 'create')->name('add-faq');
            Route::post('/store-faq', 'store')->name('store-faq');
            Route::get('/faq/{faq}', 'edit')->name('edit-faq');
            Route::post('/update-faq', 'update')->name('update-faq');
            Route::post('/faqs/destroy', 'destroy')->name('faqs.destroy');
        });

        Route::controller(TestimonialController::class)->group(function () {
            Route::get('/testimonials', 'index')->name('testimonials');
            Route::get('/testimonial', 'create')->name('add-testimonial');
            Route::post('/store-testimonial', 'store')->name('store-testimonial');
            Route::get('/testimonial/{testimonial}', 'edit')->name('edit-testimonial');
            Route::post('/update-testimonial', 'update')->name('update-testimonial');
            Route::post('/delete-testimonial/{testimonial}', 'delete')->name('delete-testimonial');
        });

        Route::controller(CityController::class)->group(function () {
            Route::get('/cities', 'index')->name('cities');
            Route::get('/cities/create', 'create')->name('cities.create');
            Route::post('/cities/store', 'store')->name('cities.store');
            Route::get('/cities/edit/{id}', 'edit')->name('cities.edit');
            Route::post('/cities/update/{id}', 'update')->name('cities.update');
            Route::post('/cities/destroy', 'destroy')->name('cities.destroy');
            Route::post('/cities/update-active', 'updateActive')->name('cities.updateActive');
        });

        Route::controller(StateController::class)->group(function () {
            Route::get('/states', 'index')->name('states');
            Route::get('/states/create', 'create')->name('states.create');
            Route::post('/states/store', 'store')->name('states.store');
            Route::get('/states/edit/{id}', 'edit')->name('states.edit');
            Route::post('/states/update/{id}', 'update')->name('states.update');
            Route::post('/states/destroy', 'destroy')->name('states.destroy');
            Route::post('/states/update-active', 'updateActive')->name('states.updateActive');
        });

        Route::controller(CountryController::class)->group(function () {
            Route::get('/countries', 'index')->name('countries');
            Route::get('/countries/create', 'create')->name('countries.create');
            Route::post('/countries/store', 'store')->name('countries.store');
            Route::get('/countries/edit/{id}', 'edit')->name('countries.edit');
            Route::post('/countries/update/{id}', 'update')->name('countries.update');
            Route::post('/countries/destroy', 'destroy')->name('countries.destroy');
            Route::post('/countries/update-active', 'updateActive')->name('countries.updateActive');
        });

 

        Route::controller(PaymentsController::class)->group(function () {
            Route::get('/payments', 'index')->name('payments');
            Route::get('/payment-details/{payment}', 'details')->name('payment-details');
        });

        Route::controller(ReportController::class)->group(function () {
            Route::get('/reports', 'index')->name('reports');
            Route::get('/appointment-chart', 'appointment_chart')->name('appointment-chart');
            Route::get('/appointment-chart-2', 'appointment_chart_2')->name('appointment-chart-2');
            Route::get('/appointment-chart-3', 'appointment_chart_3')->name('appointment-chart-3');
            Route::get('/appointment-chart-4', 'appointment_chart_4')->name('appointment-chart-4');
        });


        Route::controller(FabricController::class)->group(function () {
            Route::get('/fabrics', 'index')->name('fabrics');
            Route::get('/fabrics/create', 'create')->name('fabrics.create');
            Route::post('/fabrics/store', 'store')->name('fabrics.store');
            Route::get('/fabrics/edit/{id}', 'edit')->name('fabrics.edit');
            Route::post('/fabrics/update/{id}', 'update')->name('fabrics.update');
            Route::post('/fabrics/destroy', 'destroy')->name('fabrics.destroy');
            Route::post('/fabrics/update-active', 'updateActive')->name('fabrics.updateActive');
        });


        Route::controller(FontController::class)->group(function () {
            Route::get('/fonts', 'index')->name('fonts');
            Route::get('/font', 'create')->name('add-font');
            Route::post('/store-font', 'store')->name('store-font');
            Route::post('/fonts/destroy', 'destroy')->name('fonts.destroy');
            Route::post('/update-page-fonts', 'update_page_fonts')->name('update-page-fonts');
            Route::post('/reset-page-fonts', 'reset_page_fonts')->name('reset-page-fonts');
        });

 
        Route::controller(ProductModelController::class)->group(function () {
            Route::get('/models', 'index')->name('models');
            Route::get('/models/create', 'create')->name('models.create');
            Route::post('/models/store', 'store')->name('models.store');
            Route::get('/models/edit/{id}', 'edit')->name('models.edit');
            Route::post('/models/update/{id}', 'update')->name('models.update');
            Route::post('/models/destroy', 'destroy')->name('models.destroy');
            Route::post('/models/update-active', 'updateActive')->name('models.updateActive');
        });


        Route::controller(PageController::class)->group(function () {
            Route::get('/pages', 'index')->name('pages');
            Route::get('/add-page', 'create')->name('add-page');
            Route::post('/store-page', 'store')->name('store-page');
            Route::get('/edit-page/{page}', 'edit')->name('edit-page');
            Route::post('/update-page', 'update')->name('update-page');
            Route::post('/delete-page/{page}', 'delete')->name('delete-page');
        });

        Route::controller(SliderController::class)->group(function () {
            Route::get('/sliders', 'index')->name('sliders');
            Route::get('/sliders/create', 'create')->name('sliders.create');
            Route::post('/sliders/store', 'store')->name('sliders.store');
            Route::get('/sliders/edit/{id}', 'edit')->name('sliders.edit');
            Route::post('/sliders/update/{id}', 'update')->name('sliders.update');
            Route::post('/sliders/destroy', 'destroy')->name('sliders.destroy');
            Route::post('/sliders/update-active', 'updateActive')->name('sliders.updateActive');
            Route::post('/sliders/remove-file', 'removeFile')->name('sliders.removeFile');
        });

    
        Route::controller(ServiceController::class)->group(function () {
            Route::get('/services', 'index')->name('services');
            Route::get('/services/create', 'create')->name('services.create');
            Route::post('/services/store', 'store')->name('services.store');
            Route::get('/services/edit/{id}', 'edit')->name('services.edit');
            Route::post('/services/update/{id}', 'update')->name('services.update');
            Route::post('/services/destroy', 'destroy')->name('services.destroy');
            Route::post('/services/update-active', 'updateActive')->name('services.updateActive');
            Route::post('/services/remove-file', 'removeFile')->name('services.removeFile');
        });

        Route::controller(ComingController::class)->group(function () {
            Route::get('/coming-soon', 'index')->name('comingsoon');
            Route::get('/coming', 'create')->name('add-coming');
            Route::post('/store-coming', 'store')->name('store-coming');
            Route::get('/coming/{coming}', 'edit')->name('edit-coming');
            Route::post('/update-coming', 'update')->name('update-coming');
            Route::post('/delete-coming/{coming}', 'delete')->name('delete-coming');
            Route::post('/update-coming-crud', 'update_crud')->name('update-coming-crud');
        });

        Route::controller(SettingsController::class)->group(function () {
            Route::get('/settings', 'index')->name('settings');
            Route::post('/update-settings', 'update')->name('update-settings');
        });

        Route::controller(ProductController::class)->group(function () {
            Route::get('/products', 'index')->name('products');
            Route::get('/products/create', 'create')->name('products.create');
            Route::post('/products/store', 'store')->name('products.store');
            Route::get('/products/edit/{id}', 'edit')->name('products.edit');
            Route::post('/products/update/{id}', 'update')->name('products.update');
            Route::post('/products/destroy', 'destroy')->name('products.destroy');
            Route::post('/products/update-active', 'updateActive')->name('products.updateActive');
            Route::post('/products/remove-file', 'removeFile')->name('products.removeFile');
            Route::post('/products/upload-list-image', 'uploadListImage')->name('products.uploadListImage');
            Route::get('/products/add-more-variation', 'addMoreVariation')->name('products.addMoreVariation');
            Route::post('/products/delete-list-image', 'deleteListImage')->name('products.deleteListImage');
            Route::post('/products/delete-variation', 'deleteVariation')->name('products.deleteVariation');

        });

        Route::controller(BrandController::class)->group(function () {
            Route::get('/designers', 'index')->name('brands');
            Route::get('/designers/create', 'create')->name('brands.create');
            Route::post('/designers/store', 'store')->name('brands.store');
            Route::get('/designers/edit/{id}', 'edit')->name('brands.edit');
            Route::post('/designers/update/{id}', 'update')->name('brands.update');
            Route::post('/designers/destroy', 'destroy')->name('brands.destroy');
            Route::post('/designers/update-active', 'updateActive')->name('brands.updateActive');
            Route::post('/designers/remove-file', 'removeFile')->name('brands.removeFile');
        });

        Route::controller(StaffController::class)->group(function () {
            Route::get('/staff', 'index')->name('staff');
            Route::get('/staff/create', 'create')->name('staff.create');
            Route::post('/staff/store', 'store')->name('staff.store');
            Route::get('/staff/edit/{id}', 'edit')->name('staff.edit');
            Route::post('/staff/update/{id}', 'update')->name('staff.update');
            Route::post('/staff/destroy', 'destroy')->name('staff.destroy');
            Route::post('/staff/update-active', 'updateActive')->name('staff.updateActive');
            Route::post('/staff/remove-file', 'removeFile')->name('staff.removeFile');
        });

        Route::controller(CustomerController::class)->group(function () {
            Route::get('/customers', 'index')->name('customers');
            Route::get('/customers/create', 'create')->name('customers.create');
            Route::post('/customers/store', 'store')->name('customers.store');
            Route::get('/customers/edit/{id}', 'edit')->name('customers.edit');
            Route::post('/customers/update/{id}', 'update')->name('customers.update');
            Route::post('/customers/destroy', 'destroy')->name('customers.destroy');
            Route::post('/customers/update-active', 'updateActive')->name('customers.updateActive');
            Route::post('/customers/remove-file', 'removeFile')->name('customers.removeFile');
        });


        Route::controller(AppointmentServiceCategoryController::class)->group(function () {
            Route::get('/appointment-categories', 'index')->name('appointment.categories');
            Route::get('/appointment-categories/create', 'create')->name('appointment.categories.create');
            Route::post('/appointment-categories/store', 'store')->name('appointment.categories.store');
            Route::get('/appointment-categories/edit/{id}', 'edit')->name('appointment.categories.edit');
            Route::post('/appointment-categories/update/{id}', 'update')->name('appointment.categories.update');
            Route::post('/appointment-categories/destroy', 'destroy')->name('appointment.categories.destroy');
            Route::post('/appointment-categories/update-active', 'updateActive')->name('appointment.categories.updateActive');
            Route::post('/appointment-categories/remove-file', 'removeFile')->name('appointment.categories.removeFile');
        });

        Route::controller(AppointmentServiceController::class)->group(function () {
            Route::get('/appointment-services', 'index')->name('appointment.services');
            Route::get('/appointment-services/create', 'create')->name('appointment.services.create');
            Route::post('/appointment-services/store', 'store')->name('appointment.services.store');
            Route::get('/appointment-services/edit/{id}', 'edit')->name('appointment.services.edit');
            Route::post('/appointment-services/update/{id}', 'update')->name('appointment.services.update');
            Route::post('/appointment-services/staff-update/{id}', 'staffUpdate')->name('appointment.services.staffUpdate');
            Route::get('/appointment-services/get-staff', 'getStaff')->name('appointment.services.getStaff');
            Route::post('/appointment-services/timesheet-update/{id}', 'timesheetUpdate')->name('appointment.services.timesheetUpdate');
            Route::post('/appointment-services/destroy', 'destroy')->name('appointment.services.destroy');
            Route::post('/appointment-services/update-active', 'updateActive')->name('appointment.services.updateActive');
            Route::post('/appointment-services/remove-file', 'removeFile')->name('appointment.services.removeFile');
        });

        Route::controller(AppointmentController::class)->group(function () {
            Route::get('/appointments', 'index')->name('appointments');
            Route::post('/appointments/staff', 'staff')->name('appointments.staff');
            Route::post('/appointments/assign-staff', 'assignStaff')->name('appointments.assignStaff');
            Route::get('/new-appointment/{date?}', 'appointment_form')->name('new-appointment');
            Route::get('/edit-appointment/{id?}', 'edit_appointment_form')->name('edit-appointment');
            Route::post('/get-appointment-services/{category}', 'get_appointment_services')->name('get-appointment-services');
            Route::post('/get-appointment-service-staff/{service}', 'get_appointment_service_staff')->name('get-appointment-service-staff');
            Route::post('/save-customer', 'save_customer')->name('save-customer');
            Route::post('/get-customers', 'get_customers')->name('get-customers');
            Route::post('/store-appointment', 'store_appointment')->name('store-appointment');
            Route::post('/update-appointment/{id?}', 'update_appointment')->name('update-appointment');
            Route::get('appointment-calendar', 'calendar')->name('appointment-calendar');
            Route::get('get-appointments', 'appointments')->name('get-appointments');
            Route::get('appointment-details/{appointment}', 'appointment_details')->name('appointment-details');
            Route::get('/appointment-dashboard', 'dashboard')->name('appointment-dashboard');
        });
    });
});

Route::get('/privacy-policy',[IndexController::class,'privacy'])->name('privacy-policy');
Route::get('/terms',[IndexController::class,'terms'])->name('terms');
Route::get('/about', [HomepageController::class, 'about'])->name('about');
Route::get('/page/{slug}',[IndexController::class,'page'])->name('page');

Route::controller(ContactPageController::class)->group(function () {
    Route::get('/contact', 'index')->name('contact');
});

Route::controller(BlogPageController::class)->group(function () {
    Route::get('/blog/{alias?}', 'index')->name('blog');
});

Route::controller(FaqsController::class)->group(function () {
    Route::get('/faqs', 'index')->name('faqs');
});

Route::controller(ServicesPageController::class)->group(function () {
    Route::get('/services/{alias?}', 'index')->name('services');
});

Route::controller(ComingPageController::class)->group(function () {
    Route::get('/coming-soon/{alias?}', 'index')->name('coming');
});

Route::controller(HomepageController::class)->group(function () {
    Route::get('/', 'index')->name('homepage');
});

Route::controller(WebAppointmentController::class)->group(function () {
    Route::get('book-appointment', 'index')->name('bookAppointment');
    Route::get('get-slots', 'getSlots')->name('getSlots');
    Route::get('get-days', 'getDays')->name('getDays');
    Route::post('appointment-submit', 'appointmentSubmit')->name('appointmentSubmit');
    Route::get('view-cart','viewCart')->name('viewCart');
    Route::get('appointment-confirmation','appointmentConfirmation')->name('appointmentConfirmation');
    Route::post('checkout','checkout')->name('checkout');
    Route::get('submitBillingDetail','submitBillingDetail')->name('submitBillingDetail');
    Route::post('followup-appointment-submit', 'followUpAppointmentSubmit')->name('followUpAppointmentSubmit');

});

Route::controller(PayPalController::class)->group(function () {
    Route::get('create-transaction', 'createTransaction')->name('createTransaction');
    Route::get('process-transaction', 'processTransaction')->name('processTransaction');
    Route::get('success-transaction', 'successTransaction')->name('successTransaction');
    Route::get('cancel-transaction', 'cancelTransaction')->name('cancelTransaction');
});

Route::controller(PaymentController::class)->group(function () {
    Route::get('/payment', 'showPaymentForm')->name('payment.form');
    Route::post('/create-payment-intent', 'createPaymentIntent')->name('create.payment.intent');
    Route::post('/confirm-payment-intent', 'confirmPaymentIntent')->name('confirm.payment.intent');
    Route::get('/payment/success', 'paymentSuccess')->name('payment.success');
    Route::get('/payment/failure', 'paymentFailure')->name('payment.failure');
    Route::get('/payment/canceled', 'paymentCanceled')->name('payment.canceled');
});

Route::controller(WebProductController::class)->group(function () {
    Route::get('/{category}', 'index')->name('productListing');
    Route::get('/{category}/{product_code}/{variation_id?}', 'detail')->name('productDetail');

});
